﻿<?xml version="1.0" encoding="UTF-8"?>

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
<html>
 <head>
   <title>WC3Banlist Chatlog</title>
   <link type="text/css" rel="stylesheet" href="_wc3.css" media="screen" />
 </head>
 <body onload="document.location = document.location + '#bottom'">
   <div id="container">
      <div id="container2">
        <xsl:apply-templates/>
      </div>
    </div>
    <span id="bottom"/>
  </body>
</html>
</xsl:template>

<xsl:template match="channel">
<div class="channel">
  Joined channel: <span class="title"><xsl:value-of select="@title"/></span>
</div>
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="game">
<div class="game">
  <xsl:attribute name="title">Map: <xsl:value-of select="@mapname" /></xsl:attribute>
  Joined game: <span class="title"><xsl:value-of select="@title"/></span>
</div>
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="link">
  <a>
    <xsl:attribute name="href">
      <xsl:choose>
        <xsl:when test="contains(.,'://')"></xsl:when>
        <xsl:otherwise><xsl:text>http://</xsl:text></xsl:otherwise>
      </xsl:choose>
      <xsl:value-of select="." />
    </xsl:attribute>
    <xsl:value-of select="." />
  </a>
</xsl:template>

<xsl:template match="message">
<xsl:choose>
  <xsl:when test="@type='note'">
    <div class="message note">
       <xsl:attribute name="title">
         <xsl:value-of select="time" />
       </xsl:attribute> 
       <span class="nick">Note: </span><xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='error'">
    <div class="message error">
      <xsl:attribute name="title">
        <xsl:value-of select="time" />
      </xsl:attribute> 
      <span class="nick">Error: </span><xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='bneterror'">
    <div class="message bneterror">
      <xsl:attribute name="title">
        <xsl:value-of select="time" />
      </xsl:attribute> 
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='bnetinfo'">
    <div class="message bnetinfo">
      <xsl:attribute name="title">
        <xsl:value-of select="time" />
      </xsl:attribute> 
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='emotein'">
    <div class="message emotein">
      <xsl:attribute name="title">
        <xsl:value-of select="time" />
      </xsl:attribute>
      <xsl:value-of select="nick"/>
      <xsl:text> </xsl:text>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='emoteout'">
    <div class="message emoteout">
      <xsl:attribute name="title">
        <xsl:value-of select="time" />
      </xsl:attribute>
      <xsl:value-of select="nick"/>
      <xsl:text> </xsl:text>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='whisperin'">
    <div class="message whisperin">
      <xsl:attribute name="title">
        <xsl:value-of select="time" />
      </xsl:attribute>
      <span class="nick"><xsl:value-of select="nick"/> whispers: </span><xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='whisperout'">
    <div class="message whisperout">
      <xsl:attribute name="title">
        <xsl:value-of select="time" />
      </xsl:attribute>
      <span class="nick">You whisper to <xsl:value-of select="nick"/>: </span><xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:otherwise>
    <div>
      <xsl:attribute name="title">
        <xsl:value-of select="time" />
      </xsl:attribute>
      <xsl:attribute name="class">
        message <xsl:value-of select="@type" />
      </xsl:attribute>  
      <span class="nick"><xsl:value-of select="nick"/>: </span><xsl:apply-templates select="text"/>
    </div>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:transform>

