﻿<?xml version="1.0" encoding="UTF-8"?>

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
<html>
 <head>
   <title>WC3Banlist Chatlog</title>
   <link type="text/css" rel="stylesheet" href="borderline-compact.css" media="screen" />
 </head>
 <body onload="document.location = document.location + '#bottom'">
   <div id="container">
      <div id="container2">
        <xsl:apply-templates/>
      </div>
    </div>
    <span id="bottom"/>
  </body>
</html>
</xsl:template>

<xsl:template match="channel">
<div class="channel">
  <div class="title">
    Channel: <strong><xsl:value-of select="@title"/></strong>
  </div>
  <xsl:apply-templates/>
</div>
</xsl:template>

<xsl:template match="game">
<div class="game">
  <div class="title">
    <span class="map">Map: <xsl:value-of select="@mapname"/></span>
    Game: <strong><xsl:value-of select="@title"/></strong>
  </div>
  <xsl:apply-templates/>
</div>
</xsl:template>

<xsl:template match="link">
  <a>
    <xsl:attribute name="href">
      <xsl:choose>
        <xsl:when test="contains(.,'://')"></xsl:when>
        <xsl:otherwise><xsl:text>http://</xsl:text></xsl:otherwise>
      </xsl:choose>
      <xsl:value-of select="." />
    </xsl:attribute>  
    <xsl:value-of select="." />
  </a>
</xsl:template>

<xsl:template match="message">
<xsl:choose>
  <xsl:when test="@type='note'">
    <div class="message note">
      <span class="time">Received: <xsl:value-of select="time"/></span>
      <span class="nick">Note: </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='error'">
    <div class="message error">
      <span class="time">Occured: <xsl:value-of select="time"/></span>
      <span class="nick">Error: </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='bneterror'">
    <div class="message bneterror">
      <span class="time">Received: <xsl:value-of select="time"/></span> 
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='bnetinfo'">
    <div class="message bnetinfo">
      <span class="time">Received: <xsl:value-of select="time"/></span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='emotein'">
    <div class="message emotein">
      <span class="time">Received: <xsl:value-of select="time"/></span>
      <xsl:value-of select="nick"/>
      <xsl:text> </xsl:text>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='emoteout'">
    <div class="message emoteout">
      <span class="time">Sent: <xsl:value-of select="time"/></span>
      <xsl:value-of select="nick"/>
      <xsl:text> </xsl:text>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='whisperin'">
    <div class="message whisperin">
      <span class="time">Received: <xsl:value-of select="time"/></span>
      <span class="nick">From <strong><xsl:value-of select="nick"/></strong>: </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='whisperout'">
    <div class="message whisperout">
      <span class="time">Sent: <xsl:value-of select="time"/></span>
      <span class="nick">To <strong><xsl:value-of select="nick"/></strong>: </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='chatblizz'">
    <div class="message chatblizz">
      <span class="time">Received: <xsl:value-of select="time"/></span>
      <span class="nick"><strong><xsl:value-of select="nick"/></strong>: </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='chatin'">
    <div class="message chatin">
      <span class="time">Received: <xsl:value-of select="time"/></span>
      <span class="nick"><strong><xsl:value-of select="nick"/></strong>: </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='chatout'">
    <div class="message chatout">
      <span class="time">Sent: <xsl:value-of select="time"/></span>
      <span class="nick"><strong><xsl:value-of select="nick"/></strong>: </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:otherwise>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:transform>

