﻿<?xml version="1.0" encoding="UTF-8"?>

<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
<html>
 <head>
   <title>WC3Banlist Chatlog</title>
   <link type="text/css" rel="stylesheet" href="stealthbot.css" media="screen" />
 </head>
 <body onload="document.location = document.location + '#bottom'">
   <xsl:apply-templates/>
   <span id="bottom"/>
 </body>
</html>
</xsl:template>

<xsl:template match="channel">
<div class="channel">
  -- Joined channel: <span class="title"><xsl:value-of select="@title"/></span> --
</div>
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="game">
<div class="game">
  <xsl:attribute name="title">Map: <xsl:value-of select="@mapname" /></xsl:attribute>
   -- Joined game: <span class="title"><xsl:value-of select="@title"/></span> --
</div>
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="link">
  <a>
    <xsl:attribute name="href">
      <xsl:choose>
        <xsl:when test="contains(.,'://')"></xsl:when>
        <xsl:otherwise><xsl:text>http://</xsl:text></xsl:otherwise>
      </xsl:choose>
      <xsl:value-of select="." />
    </xsl:attribute>
    <xsl:value-of select="." />
  </a>
</xsl:template>

<xsl:template match="message">
<xsl:choose>
  <xsl:when test="@type='note'">
    <div class="message note">
       <span class="time">[<xsl:value-of select="time"/>] </span>
       <span class="caret">&lt;</span><span class="nick">Note</span><span class="caret">&gt; </span>
       <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='error'">
    <div class="message error">
      <span class="time">[<xsl:value-of select="time"/>] </span>
      <span class="caret">&lt;</span><span class="nick">Error</span><span class="caret">&gt; </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='bneterror'">
    <div class="message bneterror">
      <span class="time">[<xsl:value-of select="time"/>] </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='bnetinfo'">
    <div class="message bnetinfo">
      <span class="time">[<xsl:value-of select="time"/>] </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='emotein'">
    <div class="message emotein">
      <span class="time">[<xsl:value-of select="time"/>] </span>
      &lt;<span class="nick"><xsl:value-of select="nick"/> </span>
      <xsl:text> </xsl:text>
      <xsl:apply-templates select="text"/>&gt;
    </div>
  </xsl:when>
  <xsl:when test="@type='emoteout'">
    <div class="message emoteout">
      <span class="time">[<xsl:value-of select="time"/>] </span>
      &lt;<span class="nick"><xsl:value-of select="nick"/> </span>
      <xsl:text> </xsl:text>
      <xsl:apply-templates select="text"/>&gt;
    </div>
  </xsl:when>
  <xsl:when test="@type='whisperin'">
    <div class="message whisperin">
      <span class="time">[<xsl:value-of select="time"/>] </span>
      <span class="caret">&lt;From </span><span class="nick"><xsl:value-of select="nick"/></span><span class="caret">&gt; </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:when test="@type='whisperout'">
    <div class="message whisperout">
      <span class="time">[<xsl:value-of select="time"/>] </span>
      <span class="caret">&lt;To </span><span class="nick"><xsl:value-of select="nick"/></span><span class="caret">&gt; </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:when>
  <xsl:otherwise>
    <div>
      <xsl:attribute name="class">
        message <xsl:value-of select="@type" />
      </xsl:attribute>  
      <span class="time">[<xsl:value-of select="time"/>] </span>
       <span class="caret">&lt;</span><span class="nick"><xsl:value-of select="nick"/></span><span class="caret">&gt; </span>
      <xsl:apply-templates select="text"/>
    </div>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:transform>

