library HotKeyHook;

{ Stripped-down version of Assarbad's hook dll for use in the WC3Banlist project
  by Knarf (http://www.wc3banlist.de) }

{ Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. }

uses
  Windows;

{$R *.res}

const
  MMFName = 'WC3BanlistHotkeyHook_Data';
  keybmsg = 'WC3BanlistHotkeyHook_Msg';
  keysem_ready = 'WC3BanlistHotKeyHook_KeyReady';
  keysem_access = 'WC3BanlistHotKeyHook_KeyAccess';

type
  TDLLData = packed record
    ProcessID, ThreadID: DWORD;
    nCode: Integer;
    wParam: WPARAM;
    lParam: LPARAM;
  end;
  PDLLData = ^TDLLData;

  POSVersionInfoEx = ^TOSVersionInfoEx;
  TOSVersionInfoEx = packed record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformId: DWORD;
    szCSDVersion: array[0..127] of AnsiChar;
    wServicePackMajor: Word;
    wServicePackMinor: Word;
    wSuiteMask: Word;
    wProductType: Byte;
    wReserved: Byte;
  end;

  function ConvertStringSecurityDescriptorToSecurityDescriptor(
    StringSecurityDescriptor: PChar;
    StringSDRevision : DWORD;
    SecurityDescriptor : PSecurityDescriptor;
    SecurityDescriptorSize : PLongInt) : Integer;
    stdcall; external 'Advapi32.dll' name
    'ConvertStringSecurityDescriptorToSecurityDescriptorA';

var
  lpView: PDLLData;
  hMap, hAccess, hReady: THandle;
  Keyboard_HookHandle: HHOOK = 0;

function GetOSVersionInfo(var Info: TOSVersionInfoEx): Boolean;
begin
  FillChar(Info, SizeOf(TOSVersionInfoEx), 0);
  Info.dwOSVersionInfoSize := SizeOf(TOSVersionInfoEx);
  Result := GetVersionEx(TOSVersionInfo(Addr(Info)^));
  if (not Result) then
  begin
    FillChar(Info, SizeOf(TOSVersionInfoEx), 0);
    Info.dwOSVersionInfoSize := SizeOf(TOSVersionInfoEx);
    Result := GetVersionEx(TOSVersionInfo(Addr(Info)^));
    if (not Result) then
      Info.dwOSVersionInfoSize := 0;
  end;
end;


function CreateGlobals: boolean;
var
  secAttr: TSecurityAttributes;
  secDesc: Array[0..SECURITY_DESCRIPTOR_MIN_LENGTH - 1] of char;
  pSD: PSECURITY_DESCRIPTOR;
  pSacl: PACL;
  fSaclPrensent: longbool;
  fSaclDefaulted: longbool;
  vista: boolean;
  osVersion: TOSVersionInfoEx;
begin
  if GetOSVersionInfo(osVersion) and (osVersion.dwMajorVersion = 6) then vista := true else vista := false;
  secAttr.nLength := sizeof(secAttr);
  secAttr.bInheritHandle := False;
  secAttr.lpSecurityDescriptor := @secDesc;
  InitializeSecurityDescriptor(secAttr.lpSecurityDescriptor, SECURITY_DESCRIPTOR_REVISION);
  SetSecurityDescriptorDacl(secAttr.lpSecurityDescriptor, True, nil, False);
  if vista then
  begin
    ConvertStringSecurityDescriptorToSecurityDescriptor('S:(ML;;NW;;;LW)',
      1, @pSD, nil);
    pSacl := nil;
    fSaclPrensent := false;
    fSaclDefaulted := false;
    GetSecurityDescriptorSacl(pSD, fSaclPrensent, pSacl, fSaclDefaulted);
    SetSecurityDescriptorSacl(secAttr.lpSecurityDescriptor, True, pSacl, False);
  end;
  Result := False;
  hMap := CreateFileMapping(INVALID_HANDLE_VALUE, @secAttr, PAGE_READWRITE, 0,
    SizeOf(TDLLData), MMFName);
  if hMap <> 0 then
  begin
    lpView := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, SizeOf(TDLLData));
    if Assigned(lpView) then
    begin
      hReady := CreateSemaphore(@secAttr, 0, 1, keysem_ready);
      if hReady <> 0 then
      begin
        hAccess := CreateSemaphore(@secAttr, 1, 1, keysem_access);
        if hAccess <> 0 then
        begin
          Result := True
        end else
        begin
          UnmapViewOfFile(lpView);
          CloseHandle(hMap);
          CloseHandle(hReady);
        end;        
      end else
      begin
        UnmapViewOfFile(lpView);
        CloseHandle(hMap);
      end;
    end
    else
      CloseHandle(hMap);
  end;
end;

procedure FreeMMF;
begin
  UnmapViewOfFile(lpView);
  CloseHandle(hMap);
  CloseHandle(hReady);
  CloseHandle(hAccess);
end;


function KbdHookProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT;
  stdcall;
var wc3: boolean;
begin
  Result := CallNextHookEx(Keyboard_HookHandle, nCode, wParam, lParam);
  wc3 := getforegroundwindow = findwindow('Warcraft III', 'Warcraft III');
  if wc3
    and (nCode = HC_ACTION)
    and (lParam and $80000000 = $80000000)
    and (GetAsyncKeyState(VK_MENU) and $8000 = 0)
  then begin
    if WaitForSingleObject(hAccess, 0) <> WAIT_TIMEOUT then
    begin
      lpView^.nCode := nCode;
      lpView^.ProcessID := GetCurrentProcessID;
      lpView^.ThreadID := GetCurrentThreadID;
      lpView^.wParam := wParam;
      lpView^.lParam := lParam;
      ReleaseSemaphore(hReady, 1, nil);
      ReleaseSemaphore(hAccess, 1, nil);
    end;
  end;
end;

procedure DLLMain(dwReason: DWord);
begin
  case dwReason of
    DLL_PROCESS_ATTACH:
      if not CreateGlobals then
        FreeLibrary(hInstance);
    DLL_PROCESS_DETACH: FreeMMF;
  end;
end;

function InstallHook(Hwnd: Cardinal): Boolean; stdcall;
begin
  Result := False;
  if CreateGlobals then begin
    if Keyboard_HookHandle = 0 then
    begin
      Keyboard_HookHandle := SetWindowsHookEx(WH_KEYBOARD, @KbdHookProc,
        hInstance,0);
      Result := Keyboard_HookHandle <> 0;
    end;
  end;
end;

function UninstallHook: Boolean; stdcall;
begin
  Result := UnhookWindowsHookEx(Keyboard_HookHandle);
  Keyboard_HookHandle := 0;
end;

function ReturnView: Pointer; stdcall;
begin
  result := lpView;
end;


exports
  InstallHook,
  UninstallHook,
  ReturnView;


begin
  DLLProc := @DLLMain;
  DLLProc(DLL_PROCESS_ATTACH);
end.
