unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ASGSQLite3, StdCtrls, UBanlistNL, UThreadSafeSQLiteDB,
  IdComponent, ComCtrls, Contnrs;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ProgressBar1: TProgressBar;
    Button3: TButton;
    Memo1: TMemo;
    edtZeit: TEdit;
    Button4: TButton;
    btnUpload: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure btnUploadClick(Sender: TObject);
  private
    procedure OnProgress(ASender: TObject; AWorkMode: TWorkMode; AWorkCount: Integer);
    procedure OnProgressDownload(ASender: TObject; AWorkMode: TWorkMode; AWorkCount: Integer);
    procedure OnError(Sender: TObject; Error: String);
  public
  end;

var
  Form1: TForm1;
  DataBase: TWC3BanlistDatabase;
  Threads: TList;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  DataBase := TWC3BanlistDatabase.Create(nil);
  DataBase.Database := 'test.db';
  DataBase.Open;
  Threads := TList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DataBase.Close;
  DataBase.Free;
  Threads.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  pm: TBanlistNLPopulateMembers;
begin
  pm := TBanlistNLPopulateMembers.Create(DataBase);
  pm.OnError := OnError;
  pm.OnProgress := OnProgress;
  pm.Resume;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  pg: TBanlistNLPopulateGroups;
begin
  pg := TBanlistNLPopulateGroups.Create(DataBase);
  pg.OnError := OnError;
  pg.OnProgress := OnProgress;
  pg.Resume;
end;

procedure TForm1.OnProgress(ASender: TObject; AWorkMode: TWorkMode;
  AWorkCount: Integer);
begin
  ProgressBar1.Position := AWorkCount;
end;

procedure TForm1.OnError(Sender: TObject; Error: String);
begin
  MessageDlg(Error, mtError, [mbok], 0);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  dl: TBanlistNLDownload;
  m: TObjectList;
  i: Integer;
begin
  m := TObjectList.Create;
  try
    DataBase.EnumerateBanlistNLMembers(m);
    for i := 0 to m.Count-1 do
    begin
      dl := TBanlistNLDownload.Create(DataBase, TBanlistNLMember(m[i]));
      dl.OnError := OnError;
      dl.OnProgress := OnProgressDownload;
      Threads.Add(dl);
      dl.Resume;
      Memo1.Lines.Add('Download fr ' + TBanlistNLMember(m[i]).Name + ' gestartet.')
    end;
  finally
    m.Free;
  end;
end;

procedure TForm1.OnProgressDownload(ASender: TObject; AWorkMode: TWorkMode;
  AWorkCount: Integer);
begin
  with TBanlistNLDownload(ASender).User do
  begin
    memo1.Lines.Add('Download fr ' + Name + ' beendet.');
  end;
  Threads.Remove(ASender);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  edtZeit.Text := FloatToStr(Now);
end;

procedure TForm1.btnUploadClick(Sender: TObject);
var
  u: TBanlistNLUpload;
begin
  u := TBanlistNLUpload.Create(DataBase);
  u.CompressedUploads := True;
  u.OnError := OnError;
  u.OnProgress := OnProgress;
  u.Resume;
end;

end.


