unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FiveNum, PingPlotDrawer, ExtCtrls, StdCtrls;

type
  TMainForm = class(TForm)
    Image: TImage;
    CheckBox: TCheckBox;
    procedure CheckBoxClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ImageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    a: TPingPlotDrawer;
    b: TPingPlotPlayers;
    c: array of TList;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

const
  clW3Red = TColor($0303FF);
  clW3Blue = TColor($FF4200);
  clW3Cyan = TColor($B9E61C);
  clW3Purple = TColor($810054);
  clW3Yellow = TColor($01FCFF);
  clW3Orange = TColor($0E8AFE);
  clW3Green = TColor($00C020);
  clW3Pink = TColor($B05BE5);
  clW3Silver = TColor($979695);
  clW3SkyBlue = TColor($F1BF7F);
  clW3DarkGreen = TColor($466210);
  clW3Brown = TColor($042A49);

procedure TMainForm.CheckBoxClick(Sender: TObject);
var
  i: Integer;
begin
  if CheckBox.Checked then
    a.Initialize(b, pmSimple)
  else
    a.Initialize(b, pmNormal);
  for i := 0 to 11 do
    a.Data(i, c[i]);
  a.Draw(Image.ClientRect);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  col: array[0..11] of TColor;
  i: Integer;
begin
  col[0] := clW3Red;
  col[1] := clW3Blue;
  col[2] := clW3Cyan;
  col[3] := clW3Purple;
  col[4] := clW3Yellow;
  col[5] := clW3Orange;
  col[6] := clW3Green;
  col[7] := clW3Pink;
  col[8] := clW3Silver;
  col[9] := clW3SkyBlue;
  col[10] := clW3DarkGreen;
  col[11] := clW3Brown;

  Randomize;

  SetLength(b, 12);
  SetLength(c, Length(b));
  for i := 0 to 11 do
  begin
    b[i].Name := 'IHaveA15CharNik';
    b[i].Color := col[i];
    c[i] := TList.Create;
  end;
  a := TPingPlotDrawer.Create(Image.Picture.Bitmap.Canvas);
  a.Initialize(b, pmNormal);

  DoubleBuffered := true;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  Image.Picture.Bitmap.Height := ClientHeight;
  Image.Picture.Bitmap.Width := ClientWidth;
  a.Draw(Image.ClientRect);
end;

procedure TMainForm.ImageClick(Sender: TObject);
var
  i, j, r: Integer;
begin
  for i := 0 to 11 do
  begin
    c[i].Clear;
    r := Random(150)+20;
    for j := 0 to 99 do
      c[i].Add(Pointer(Random(70)+r));
    for j := 0 to 1 do
      c[i].Add(Pointer(Random(200)+r));
    a.Data(i, c[i]);
  end;
  a.Draw(Image.ClientRect);
end;

end.
