#define ConstAppVersion "3.0";
#define ConstAppVersionFile "3.0";

[Setup]
InternalCompressLevel=ultra
SolidCompression=true
VersionInfoVersion=3.0.0.35
VersionInfoCompany=WC3Banlist.de
VersionInfoDescription=Installer for WC3Banlist
Compression=lzma/ultra
AppCopyright=Copyright  2005 Danny Grobe
AppName=WC3Banlist
#emit 'AppVerName=WC3Banlist ' + ConstAppVersion;
AppMutex=WC3Banlist OneInst
PrivilegesRequired=admin
TimeStampsInUTC=true
DefaultDirName={pf}\WC3Banlist
DefaultGroupName=WC3Banlist
ShowLanguageDialog=yes
AppPublisher=Knarf
AppPublisherURL=http://www.wc3banlist.de
AppSupportURL=http://www.banlist.nl/forum/viewforum.php?f=5
AppUpdatesURL=http://www.wc3banlist.de/downloads
#emit 'AppVersion=' + ConstAppVersion;
AppID={{F1CBC6F7-D82D-4DC5-B81C-9A14F418593A}
AppContact=knarf@wc3banlist.de
AppReadmeFile={app}\help\help.html
UninstallDisplayName=WC3Banlist
WindowShowCaption=false
WindowResizable=false
WindowVisible=true
WizardImageFile=image.bmp
BackColor=clSilver
BackColor2=clWhite
WizardImageBackColor=clWhite
WizardSmallImageFile=smallimage.bmp
OutputDir=.
#emit 'OutputBaseFilename=WC3Banlist_' + ConstAppVersionFile;

[LangOptions]
TitleFontName=Trebuchet MS
WelcomeFontName=Trebuchet MS
CopyrightFontName=MS Shell Dlg

[Tasks]
Name: DesktopIcon; Description: {cm:CreateDesktopIcon}
Name: InstallWinPcap; Description: Install WinPcap 3.1 (required); Flags: restart checkedonce

[Dirs]
Name: {app}\
Name: {app}\help
Name: {app}\img
Name: {app}\sounds
Name: {app}\xml

[Files]
Source: ..\WC3Banlist.exe; DestDir: {app}\
Source: ..\WC3Banlist.res; DestDir: {app}\
Source: ..\ParseExceptions.xml; DestDir: {app}\
Source: ..\joined.dat; DestDir: {app}\
Source: ..\SFmpq.dll; DestDir: {app}\
Source: ..\SFmpq.txt; DestDir: {app}\
Source: ..\realms.dat; DestDir: {app}\
Source: ..\colors.dat; DestDir: {app}\
Source: ..\D3DX81ab.dll; DestDir: {app}\
Source: ..\dxhook.dll; DestDir: {app}\
Source: ..\HotKeyHook.dll; DestDir: {app}\
Source: ..\HotKeyHook.txt; DestDir: {app}\
Source: ..\TDA Shitlist.xml; DestDir: {app}\
Source: ..\help\commands.html; DestDir: {app}\help
Source: ..\help\help.html; DestDir: {app}\help; Flags: isreadme
Source: ..\help\external.js; DestDir: {app}\help
Source: ..\help\commands.css; DestDir: {app}\help
Source: ..\help\help.css; DestDir: {app}\help
Source: ..\help\knarf.png; DestDir: {app}\help
Source: ..\help\logo.png; DestDir: {app}\help
Source: ..\help\logoback.png; DestDir: {app}\help
Source: ..\help\shadingtop.png; DestDir: {app}\help
Source: ..\help\valid-xhtml11.png; DestDir: {app}\help
Source: ..\help\vcss.png; DestDir: {app}\help
Source: ..\img\map.jpg; DestDir: {app}\img
Source: ..\sounds\Banned player joins.wav; DestDir: {app}\sounds
Source: ..\sounds\Game countdown started.wav; DestDir: {app}\sounds
Source: ..\sounds\Info found.wav; DestDir: {app}\sounds
Source: ..\sounds\Not safelisted player joins.wav; DestDir: {app}\sounds
Source: ..\sounds\Player got banned.wav; DestDir: {app}\sounds
Source: ..\sounds\Player leaves.wav; DestDir: {app}\sounds
Source: ..\sounds\Response Sound.wav; DestDir: {app}\sounds
Source: ..\sounds\Same IP Sound.wav; DestDir: {app}\sounds
Source: ..\sounds\Whisper Sound.wav; DestDir: {app}\sounds
Source: ..\xml\_wc3.css; DestDir: {app}\xml
Source: ..\xml\_wc3.xsl; DestDir: {app}\xml
Source: ..\xml\_wc3_alt.css; DestDir: {app}\xml
Source: ..\xml\_wc3_alt.xsl; DestDir: {app}\xml
Source: ..\xml\borderline-compact.css; DestDir: {app}\xml
Source: ..\xml\debug.css; DestDir: {app}\xml
Source: ..\xml\stealthbot.css; DestDir: {app}\xml
Source: ..\xml\border1.png; DestDir: {app}\xml
Source: ..\xml\border2.png; DestDir: {app}\xml
Source: ..\xml\borderline.png; DestDir: {app}\xml
Source: ..\xml\_wc3.ttf; DestDir: {app}\xml
Source: ..\xml\_wc3b.ttf; DestDir: {app}\xml
Source: ..\xml\borderline-compact.xsl; DestDir: {app}\xml
Source: ..\xml\debug.xsl; DestDir: {app}\xml
Source: ..\xml\stealthbot.xsl; DestDir: {app}\xml
Source: WinPcap_3_1.exe; DestDir: {app}\; Flags: deleteafterinstall

[Icons]
Name: {group}\WC3Banlist; Filename: {app}\WC3Banlist.exe; WorkingDir: {app}; IconFilename: {app}\WC3Banlist.exe; Comment: Start WC3Banlist; IconIndex: 0
Name: {userdesktop}\WC3Banlist; Filename: {app}\WC3Banlist.exe; WorkingDir: {app}; IconFilename: {app}\WC3Banlist.exe; Comment: Start WC3Banlist; IconIndex: 0; Tasks: DesktopIcon
Name: {group}\{cm:UninstallProgram, WC3Banlist}; Filename: {uninstallexe}; WorkingDir: {app}

[Run]
Filename: {app}\WinPcap_3_1.exe; Parameters: -s; WorkingDir: {app}; Description: Install WinPcap 3.1 (required); StatusMsg: Running WinPcap installer...; Tasks: InstallWinPcap; Flags: hidewizard

[Code]
procedure URLLabelOnClick(Sender: TObject);
var
  ErrorCode: Integer;
begin
  ShellExec('open', 'http://www.wc3banlist.de', '', '', SW_SHOWNORMAL, ewNoWait, ErrorCode);
end;

procedure InitializeWizard();
var
  CancelButton: TButton;
  URLLabel: TNewStaticText;
begin
  CancelButton := WizardForm.CancelButton;
  URLLabel := TNewStaticText.Create(WizardForm);
  URLLabel.Caption := 'www.wc3banlist.de';
  URLLabel.Cursor := crHand;
  URLLabel.OnClick := @URLLabelOnClick;
  URLLabel.Parent := WizardForm;
  URLLabel.Font.Style := URLLabel.Font.Style + [fsUnderline];
  URLLabel.Font.Color := clBlue;
  URLLabel.Top := CancelButton.Top + CancelButton.Height - URLLabel.Height - 2;
  URLLabel.Left := WizardForm.ClientWidth - CancelButton.Left - CancelButton.Width;
end;
