unit IniFile;

//           IniFile-Unit
//           erstellt von Danny Grobe

interface
uses graphics, filectrl, windows, dialogs, SysUtils, Classes, Forms, Controls,
  stdctrls, comctrls, extctrls, uxtheme;
const
  cr: string = #13#10;
  Msg1 = 'File "%s" does not exist!';
  Msg2 = '"%s" is not a ListView file!';
type
  pfont = ^tfont;
type
  TButtonStyle = (Static, Sunken, Normal);

  TObjectRoutines = class(TObject)
  public
    procedure IniLabelMouseEnter(Sender: TObject);
    procedure IniLabelMouseLeave(Sender: TObject);
  end;

var
  SFileName, SGroupName: string;
  FileName, GroupName: string;
  defaultFont: string;
  defaultFontHandle: HGDIOBJ;
  defaultFontSize: Integer;

  tempsl: tstringlist;

  fnt: TFont;

  bfn, sgn: tstringlist;
  ConsOrg, NamesOrg, Cons, Names, Lines: TStringList;
  SPorigin: string;
  f1: text;
  f2: text;

  iniLoadListViewWidth: Boolean = True;
  iniLoadControlSize: Boolean = True;
  { ld die Gre der Steuerelemente bei alles Controls (nicht nur TPanel). Dazu mu die Controldata als Name* gespeichert werden (mit Stern) }
  iniChangeAutoSizeColumns: Boolean = True;

  MaxComboItems: integer = 10;

  TZ: Char = '|';
  BackupTZ: string;
  IniObjectRoutines: TObjectRoutines;

procedure IniOpen(a: string);
procedure AlterTZ(a: char);
procedure AlterSGN(a: string);
procedure RestoreTZ;
procedure RestoreSGN;
procedure IniBackupFileName;
procedure IniRestoreFileName;
function IniGetFileName: string;
function IniGetGroup(g: string): integer;
function IniGetItem(k: integer): string;
procedure IniAddItem(t: string);
function IniGetData(d: string): string;
procedure IniSetData(n, d: string);
function IniGetDataCount: integer;
procedure IniSave;
procedure IniAbort;
procedure IniRemove(n: string); overload;
procedure IniRemove(n: integer); overload;
procedure IniEnumerate; // Wandelt die Bezeichner der Liste in lfd. Nummern um
procedure IniClearGroup;
procedure IniDeleteGroup(g: string);
procedure IniRenameGroup(n1, n2: string);
procedure IniAssignList(s: TStringList);
function IniFindItem(n: string): integer;
function IniList: TStringList;
procedure IniLoadControlList(a: string);
procedure IniCreateControlList(CLFile: string; Form: TWinControl);
procedure IniSetSaveParameters(SFile: string; SGroup: string); overload;
procedure IniSetSaveParameters(SFile: string; SGroup: string; const t: array of
  string); overload;
procedure IniSetToLocal; overload;
// schaltet SFilename auf Windowsverzeichnis um
procedure IniSetToLocal(const t: array of string); overload;
procedure IniSetToOrigin;
// schaltet SFilename wieder auf den Ursprungspfad zurck
procedure IniSaveControlData(Form: TWinControl); overload;
procedure IniSaveControlData(Form: TWinControl; SaveCoords: Boolean); overload;
procedure IniLoadControlData(Form: TWinControl); overload;
procedure IniLoadControlData(Form: TWinControl; LoadCoords: boolean); overload;

procedure IniReadControlList(const t: array of string);
procedure IniSaveCoords(Form: TForm);
function IniLoadCoords(Form: TForm): boolean;
function IniNullen(z: integer; n: integer): string;
function IniPath: string;
function IniWinPath: string;
function IniTempPath: string; // Windows\Temp
function IniTempDir: string; // Temp-Verzeichnis
function IniPreparePath(p: string; Pfadzeichen: char): string;
function IniUser: string;
procedure IniStringAsTree(a: string; tv: ttreenodes);
function IniTreeAsString(t: ttreenodes): string;
function IniPosition(c, a: string; p: integer): integer;
{p Position, wenn p=0 dann letztes Vorkommen des Zeichens in dem String}
function IniNextPos(start: integer; substr: string; s: string): integer;
function IniPartCount(c: string; tz: char): integer;
function IniFindFiles(directory, wildcard: string; var list: tstringlist;
  clearlist, changecursor: boolean; subfolders: Boolean = true): integer;
procedure IniDirInfo(Path: string; var L: TStringlist; SubFolders: Boolean;
  Attrib: Integer);
procedure IniAddStringlist(var dest: tstringlist; q: tstringlist);
procedure IniExtractOnlyFilename(a: string; var e, p, d: string);
// e=Programmdatei mit Pfad, p=Parameter, d=Verzeichnis

function IniGetMaxLength(var t: tstringlist): integer;
function IniAsBoolean(a: string): boolean;
function IniAsValue(b: boolean): string;
procedure IniStringAsFont(a: string; fnt: TFont);
function IniFontasString(f: TFont): string;
function IniAsList(a: string): TStringlist; overload;
function IniAsList(a: string; tz: char): TStringlist; overload;
function IniAsList(s: tstrings): TStringlist; overload;
function IniAsString(t: tstringlist): string;
function IniAsStrings(t: tstringlist): tstrings;
function IniAsDlgString(t: tstringlist): string;
function IniPitchAsString(fp: tfontpitch): string;
function IniStringAsPitch(a: string): tfontpitch;
function TeilString(a: string; n: integer): string; overload;
function TeilString(a: string; n: integer; tz: char): string; overload;
function TeilString(a: string; n: integer; mitRest: boolean): string; overload;
procedure IniAddStrings(d: tstringlist; q: tstringlist);
procedure IniCenterForm(F: TForm);
function Trimmer(a: string): string;
procedure IniSaveFont(Name: string; t: pfont);
procedure IniLoadFont(Name: string; t: pfont; ErsatzFont: Tfont);
procedure BorderButton(aButton: TButton; Style: TButtonStyle);
procedure SpaltenBreite(var t: tlistview; b: integer);
procedure IniInfo(a: string);
function DirExists(d: string): boolean;
function Split(s: string; var a, b: string; c: char): boolean; overload;
procedure Split(const value: string; const delimiter: string; const sl: TStrings); overload;
function Join(s: tstringlist; con: string): string; overload;
function Join(s: tstringlist; con: string; firstIndex, lastIndex: Integer): string; overload;
function ExtractFileExtension(a: string): string;
function ComputerName: string;
procedure SetFormFont(f: TWinControl; n: string; s: Integer = -1);
function ReplaceAll(var s: string; find: string; replace: string): integer;
function Nullen(d: integer; n: integer): string;
procedure IniUnderLine(f: TFont; underline: boolean);
function MatchesPattern(s: string; pattern: string): boolean;
procedure SetSunkenButtons(f: TForm);
function IsThemeActive: Boolean;
function GetVersion: string;
function TextWidth(t: string; font: TFont; hwnd: THandle): Integer;
function TextHeight(t: string; font: TFont; hwnd: THandle): Integer;
function ExecAndWait(const FileName, Params, Directory: string;
  WindowState: Word; Wait: Boolean): Boolean; overload;
function ExecAndWait(const CmdLine: string;
  WindowState: Word; Wait: Boolean): Boolean; overload;
function ExecAndWait(const CmdLine, Directory: string;
  WindowState: Word; Wait: Boolean): Boolean; overload;
procedure IniHoverLabel(lbl: TLabel);
function IsWindowsVista: Boolean;
procedure SetVistaTreeView(const AHandle: THandle);
function GetFileSize(AFileName: String): Int64;


function MRUUpdate(t: tcombobox; key: word): boolean; overload;
// zu verwenden in der OnKeyUp-Routine eines ComboBox-Elements
procedure MRUUpdate(t: tcombobox; s: string); overload;

procedure LoadListViewFromFile(AListView: TListView; sFileName: string);
procedure SaveListViewToFile(AListView: TListView; sFileName: string);


implementation

function Split(s: string; var a, b: string; c: char): boolean;
var
  p: integer;
begin
  p := pos(c, s);
  if p = 0 then
    result := false
  else
  begin
    a := copy(s, 1, p - 1);
    b := copy(s, p + 1, length(s) - length(a) - 1);
    result := true;
  end;
end;

procedure BorderButton(aButton: TButton; Style: TButtonStyle);
var
  bx, by, bheight, bwidth: integer;
begin
  case Style of
    Static: SetWindowLong(aButton.Handle, GWL_EXSTYLE, WS_EX_STATICEDGE);
    Sunken: SetWindowLong(aButton.Handle, GWL_EXSTYLE, WS_EX_CLIENTEDGE);
    Normal: SetWindowLong(aButton.Handle, GWL_EXSTYLE, WS_EX_WINDOWEDGE);
  end;
  bx := aButton.Left;
  by := aButton.Top;
  bwidth := aButton.Width;
  bheight := aButton.Height;
  SetWindowPos(aButton.Handle, HWND_TOP, bx, by, bwidth, bheight,
    SWP_FRAMECHANGED);
end;

procedure IniOpen(a: string);
begin
  assign(f1, a);
{$I-}
  reset(f1);
{$I+}
  if ioresult <> 0 then
  begin
{$I-}
    rewrite(f1);
{$I+}
    if ioresult <> 0 then
    begin
      MessageDlg('Die Konfigurationsdatei konnte nicht erstellt werden.',
        mtError, [mbcancel], 0);
      exit;
    end;
  end;
  close(f1);
  FileName := expandfilename(a);
end;

function IniGetGroup(g: string): integer;
var
  i: integer;
  found: boolean;
  a: string;
begin
  result := 0;
  Lines.Clear;
  if filename = '' then
    exit;
  assign(f1, filename);
  reset(f1);
  i := 0;
  found := false;
  while (not eof(f1)) and (not found) do
  begin
    readln(f1, a);
    if (copy(a, 1, 1) = '[') and (uppercase(g) = uppercase(copy(a, 2, length(a)
      - 2))) then
    begin
      found := True;
      repeat
        readln(f1, a);
        if (Length(a) <= 9) or not ((length(a) > 9) and (copy(a, length(a) - 10,
          10) = '=not found')) then
        begin
          inc(i);
          Lines.Add(a);
        end;
      until (a = '') or (eof(f1));
      if a = '' then
        Lines.Delete(Lines.Count - 1);
      dec(i);
    end;
  end;
  close(f1);
  if found = false then
  begin
    append(f1);
    writeln(f1, '[' + g + ']');
    writeln(f1, '');
    close(f1);
  end;
  GroupName := g;
  IniGetGroup := i;
end;

function IniGetData(d: string): string;
var
  i, p: integer;
  a: string;
  found: boolean;
begin
  found := False;
  if Lines.Count = 0 then
  begin
    IniGetData := 'not found';
    exit;
  end;
  for i := 1 to Lines.Count do
  begin
    a := Lines[i - 1];
    p := pos('=', a);
    if uppercase(d) = uppercase(copy(a, 1, p - 1)) then
    begin
      found := true;
      IniGetData := copy(a, p + 1, length(a) - p);
    end;
  end;
  if found = false then
    IniGetData := 'not found';
end;

procedure IniSetData(n, d: string);
var
  i, p: integer;
  a: string;
begin
  if d = 'not found' then
    exit;
  for i := 1 to Lines.Count do
  begin
    a := Lines[i - 1];
    p := pos('=', a);
    if uppercase(n) = uppercase(copy(a, 1, p - 1)) then
    begin
      Lines[i - 1] := n + '=' + d;
      exit;
    end;
  end;
  Lines.Add(n + '=' + d);
end;

procedure IniSave;
var
  f2: text;
  i: integer;
  a: string;
begin
  assign(f2, initemppath + 'temp.$$$');
  rewrite(f2);
  reset(f1);
  while not eof(f1) do
  begin
    readln(f1, a);
    writeln(f2, a);
    if ('[' + uppercase(groupname) + ']' = uppercase(a)) then
    begin
      for i := 1 to Lines.Count do
      begin
        a := Lines[i - 1];
        writeln(f2, a);
      end;
      writeln(f2, '');
      repeat
        readln(f1, a);
      until a = '';
    end;
  end;
  close(f1);
  close(f2);
  deletefile(FileName);
  renamefile(initemppath + 'temp.$$$', FileName);
end;

procedure IniAbort;
begin
  GroupName := '';
end;

procedure IniRemove(n: string); overload;
var
  t: string;
  p, i: integer;
begin
  p := Lines.IndexOf(n);
  if p = -1 then
  begin
    t := IniGetData(n);
    if t = 'not found' then
      exit;
    i := Lines.IndexOf(n + '=' + t);
    if i = -1 then
      exit;
    Lines.Delete(i)
  end
  else
    Lines.Delete(p);
end;

procedure IniRemove(n: integer); overload;
begin
  lines.delete(n);
end;

function IniGetDataCount: integer;
begin
  IniGetDataCount := Lines.Count;
end;

procedure IniEnumerate;
var
  p, i: integer;
  a: string;
begin
  for i := 0 to Lines.Count - 1 do
  begin
    a := Lines[i];
    p := pos('=', a);
    Lines[i] := IntToStr(i + 1) + '=' + copy(a, p + 1, length(a) - p);
  end;
end;

function IniGetItem(k: integer): string;
begin
  IniGetItem := Lines[k];
end;

procedure IniAddItem(t: string);
begin
  try
    Lines.Add(t);
  except
    ShowMessage(inttostr(Lines.Count));
  end;
end;

procedure IniClearGroup;
begin
  Lines.Clear;
end;

procedure IniDeleteGroup(g: string);
var
  i: integer;
begin
  try
    lines.loadfromfile(sfilename);
    i := lines.indexof('[' + g + ']');
    if i = -1 then
      exit;
    lines.delete(i);
    while (i < lines.count) and (copy(lines[i], 1, 1) <> '[') do
      lines.delete(i);
    lines.SaveToFile(sfilename);
  except
  end;
end;

function IniFindItem(n: string): integer;
begin
  IniFindItem := Lines.IndexOf(n);
end;

procedure IniAssignList(s: TStringList);
begin
  Lines.Assign(s);
end;

function IniList: TStringList;
begin
  IniList := Lines;
end;

function IniAsList(a: string): TStringlist; overload;
var
  p, i: integer;
begin
  tempsl.Clear;
  p := 0;
  while p <> length(a) do
  begin
    i := p + pos(TZ, copy(a, p + 1, 20000000));
    if i > p then
      tempsl.Add(copy(a, p + 1, i - p - 1));
    if (i = p) and (i <> length(a)) then
    begin
      tempsl.Add(copy(a, p + 1, length(a) - p));
      i := length(a);
    end;
    p := i;
  end;
  result := tempsl;
end;

function IniAsList(s: tstrings): TStringlist; overload;
begin
  tempsl.assign(s);
  result := tempsl;
end;

function IniAsList(a: string; tz: char): TStringlist; overload;
begin
  altertz(tz);
  result := iniaslist(a);
  restoretz;
end;

function IniAsString;
var
  temp: TStringlist;
  i: integer;
  a: string;
begin
  temp := TStringList.Create;
  temp.Assign(t);
  if temp.count = 0 then
    a := ''
  else
  begin
    for i := 0 to temp.count - 2 do
      A := A + temp[i] + TZ;
    A := A + temp[temp.count - 1];
  end;
  Result := A;
  temp.free;
end;

function IniGetFileName: string;
begin
  result := FileName;
end;

function TeilString(a: string; n: integer; mitRest: boolean): string; overload;
var
  p, i: integer;
  b: string;
begin
  i := pos(TZ, a);
  if i = 0 then
  begin
    result := a;
    exit;
  end;
  i := 1;
  b := a;
  while i < n do
  begin
    i := i + 1;
    p := pos(TZ, b);
    b := copy(b, p + 1, 2000000);
  end;
  if mitrest or (pos(TZ, b) = 0) then
    result := b
  else
    result := copy(b, 1, pos(TZ, b) - 1);
end;

function TeilString(a: string; n: integer): string;
var
  p, i: integer;
  b: string;
begin
  i := pos(TZ, a);
  if i = 0 then
  begin
    result := a;
    exit;
  end;
  i := 1;
  b := a;
  while i < n do
  begin
    i := i + 1;
    p := pos(TZ, b);
    b := copy(b, p + 1, 2000000);
  end;
  if pos(TZ, b) = 0 then
    result := b
  else
    result := copy(b, 1, pos(TZ, b) - 1);
end;

function TeilString(a: string; n: integer; tz: char): string; overload;
begin
  altertz(tz);
  result := teilstring(a, n);
  restoretz;
end;

function IniAsBoolean(a: string): boolean;
begin
  Result := (a = '1');
end;

function IniAsValue(b: boolean): string;
begin
  if b then
    Result := '1'
  else
    Result := '0';
end;

procedure IniLoadControlList(a: string);
var
  n: string;
  i: integer;
begin
  n := IniGetFileName;
  IniOpen(a);
  IniGetGroup('ControlList');
  Cons.Clear;
  Names.Clear;
  for i := 0 to Lines.Count - 1 do
  begin
    Cons.Add(IniAsList(Lines[i])[0]);
    Names.Add(IniAsList(Lines[i])[1]);
  end;
  if n <> '' then
    IniOpen(n);
end;

procedure IniReadControlList(const t: array of string);
var
  i: integer;
begin
  Cons.Clear;
  Names.Clear;
  for i := 0 to High(t) do
  begin
    Cons.Add(IniAsList(t[i])[0]);
    Names.Add(IniAsList(t[i])[1]);
  end;
end;

procedure IniSetSaveParameters(SFile: string; SGroup: string);
begin
  SFileName := SFile;
  SGroupName := SGroup;
end;

procedure IniSetSaveParameters(SFile: string; SGroup: string; const t: array of
  string); overload;
begin
  IniSetSaveParameters(SFile, SGroup);
  inireadcontrollist(t);
end;

procedure IniBackupFileName;
begin
  bfn.add(Filename);
end;

procedure IniRestoreFileName;
begin
  if bfn.count > 0 then
  begin
    filename := bfn[bfn.count - 1];
    bfn.Delete(bfn.count - 1);
  end;
end;

procedure IniSaveControlData(Form: TWinControl);
var
  u, n, i, j, p: integer;
  c: TControl;
  a: string;
  t: TStringlist;
  l: tListItem;

begin
  IniBackupFilename;
  if SFileName = '' then
    exit;
  t := Tstringlist.create;
  IniOpen(SFileName);
  IniGetGroup(SGroupName);
  for i := 0 to (Form.ControlCount) - 1 do
  begin
    c := Form.Controls[i];
    if (c is twincontrol) then
      inisavecontroldata(c as twincontrol);
    for n := 0 to cons.count - 1 do
      if lowercase(c.name) = lowercase(cons[n]) then
      begin
        if pos('*', Names[n]) > 0 then
        begin
          a := inttostr((c as TControl).Width) + '|' + inttostr((c as
            TControl).Height);
          if c is TListView then
            for j := 0 to (c as Tlistview).columns.count - 1 do
              a := a + '|' + inttostr((c as tlistview).columns[j].width);
        end
        else if pos('#', Names[n]) > 0 then
        begin
          if c is TComboBox then
          begin
            t.assign((c as tcombobox).items);
            a := iniasstring(t);
          end;
        end
        else
        begin
          if c is TListView then
          begin
            a := inttostr((c as TListview).items.count);
            for u := 0 to (c as TListview).items.count - 1 do
            begin
              l := (c as TListView).Items[u];
              t.assign(l.subitems);
              if l.subitems.count > 0 then
                a := a + '|' + l.Caption + '|' + inttostr(l.subitems.count) + '|'
                  + iniasstring(t)
              else
                a := a + '|' + l.Caption + '|0';
            end;
            for u := 0 to (c as TListView).Columns.Count - 1 do
              a := a + '|' + inttostr((C as TListView).Columns[u].Width);
          end;
          if c is TDirectoryListbox then
            a := (c as TDirectoryListBox).Directory;
          if c is TDriveComboBox then
            a := (c as TDriveCombobox).Drive;
          if c is TEdit then
          begin
            a := '';
            if (c as Tedit).passwordchar = #0 then
              a := (c as Tedit).Text
            else
            begin
              a := (c as Tedit).Text;
              for p := 1 to length(a) do
                a[p] := chr(ord(a[p]) xor 2012);
            end;
            if a = '' then
              inisetdata(Names[n], a);
          end;
          if c is TPanel then
            a := inttostr((c as TPanel).Width) + '|' + inttostr((c as
              TPanel).Height);
          if c is TMemo then
          begin
            t.assign((c as TMemo).Lines);
            a := iniasstring(t);
          end;
          if c is TCheckbox then
            a := iniasvalue((C as TCheckbox).checked);
          if c is TButton then
            a := (c as TButton).Caption;
          if c is TLabel then
            a := (c as TLabel).Caption;
          if c is TTreeView then
            a := initreeasstring((c as ttreeview).items);
          if c is TListBox then
          begin
            t.assign((c as TListbox).items);
            a := iniasstring(t);
          end;
          if c is TComboBox then
            a := (c as TCombobox).text;
          if c is TRadioButton then
            a := iniasvalue((c as TRadioButton).Checked);
        end;
        if a <> '' then
          IniSetData(Names[n], a);
        IniSave;
      end;
  end;
  IniRestoreFileName;
  T.Free;
end;

procedure IniLoadControlData(Form: TWinControl);
var
  m, x, u, n, p, i, j: integer;
  c: TControl;
  b: boolean;
  count, count2: integer;
  a: string;
  l: tlistitem;
  t: TStringlist;
begin
  count2 := 0;
  IniBackupFilename;
  if SFileName = '' then
    exit;
  t := Tstringlist.create;
  IniOpen(SFileName);
  IniGetGroup(SGroupName);
  for i := 0 to (Form.ControlCount) - 1 do
  begin
    c := Form.Controls[i];
    if c is twincontrol then
      iniloadcontroldata(c as twincontrol);
    for n := 0 to cons.count - 1 do
      if lowercase(c.name) = lowercase(cons[n]) then
        if n > -1 then
        begin
          a := IniGetData(Names[n]);
          if a = 'not found' then
            a := ''
          else
          begin
            if (pos('*', Names[n]) > 0) and (a <> '') then
            begin
              if iniloadcontrolsize then
              begin
                (c as TControl).Width := strtoint(teilstring(a, 1));
                (c as TControl).Height := strtoint(teilstring(a, 2));
              end;
              if c is TPanel then
              begin
                (c as TControl).Width := strtoint(teilstring(a, 1));
                (c as TControl).Height := strtoint(teilstring(a, 2));
              end;
              if c is TListView then
                for j := 0 to (c as TListview).Columns.Count - 1 do
                begin
                  b := (c as TListView).Columns[j].AutoSize and
                    IniChangeAutoSizeColumns;
                  if not b then
                    (c as TListView).Columns[j].Width := strtoint(teilstring(a, 3
                      + j))
                  else
                    (c as TListView).Columns[j].MaxWidth :=
                      strtoint(teilstring(a, 3 + j));
                end;
            end
            else if (pos('#', Names[n]) > 0) and (a <> '') then
            begin
              if c is TComboBox then
                (c as tcombobox).items.assign(iniaslist(a));
            end
            else
            begin
              if c is TListView then
              begin
                (c as TListView).items.BeginUpdate;
                (c as TListView).items.clear;
                x := 1;
                count := strtoint(teilstring(a, x));
                for u := 0 to count - 1 do
                begin
                  l := (c as TListview).Items.Add;
                  inc(x);
                  l.Caption := teilstring(a, x);
                  inc(x);
                  count2 := strtoint(teilstring(a, x));
                  t.clear;
                  for m := 1 to count2 do
                    t.add(teilstring(a, x + m));
                  l.subitems.assign(t);
                  x := x + count2;
                end;
                inc(x);
                if count = 0 then
                  count2 := iniaslist(a).Count - 2;
                if iniLoadListViewWidth then
                  for m := 0 to count2 do
                    (c as TListView).Columns[m].width := strtoint(teilstring(a, x
                      + m));
                (c as TListView).items.EndUpdate;
              end;
              if c is TDriveComboBox then
                if a <> '' then
                  (c as tdrivecombobox).drive := a[1];
              if c is TDirectorylistbox then
                if a <> '' then
                  (c as tdirectorylistbox).directory := a;
              if c is TPanel then
                if a <> '' then
                begin
                  (c as TPanel).Width := strtoint(teilstring(a, 1));
                  (c as TPanel).Height := strtoint(teilstring(a, 2));
                end;
              if c is TEdit then
                if (c as Tedit).passwordchar = '' then
                  (c as Tedit).Text := a
                else
                begin
                  for p := 1 to length(a) do
                    a[p] := chr(ord(a[p]) xor 2012);
                  (c as Tedit).Text := a;
                end;
              if c is TMemo then
                (c as TMemo).Lines.Assign(iniaslist(a));
              if c is TCheckbox then
                (C as TCheckbox).checked := IniAsBoolean(a);
              if c is TButton then
                (c as TButton).Caption := a;
              if c is TLabel then
                (c as TLabel).Caption := a;
              if c is TListBox then
                (c as TListbox).items.assign(iniaslist(a));
              if c is TTreeView then
                inistringastree(a, (c as TTreeView).items);
              if c is TComboBox then
              begin
                if (c as TCombobox).Style = csDropDown then
                  (c as TCombobox).text := a;
                if (c as TComboBox).Style = csDropDownList then
                  (c as TCombobox).itemindex := (c as
                    Tcombobox).items.indexof(a);
              end;
              if c is TRadioButton then
                (c as TRadioButton).Checked := iniasboolean(a);
            end; // Ende a enthlt kein *
          end;
        end;
  end;
  IniRestoreFileName;
  T.Free;
end;

procedure IniSaveCoords(Form: TForm);
var
  a: string;
begin
  if form.WindowState <> wsNormal then
    exit;
  IniBackupFileName;
  Iniopen(SFileName);
  inigetgroup(SGroupName);
  a := inttostr(form.top) + '|' + inttostr(form.left) + '|' +
    inttostr(form.height) + '|' + inttostr(form.width);
  IniSetData(form.Name, a);
  Inisave;
  IniRestoreFileName;
end;

function IniLoadCoords(Form: TForm): boolean;
var
  a: string;
begin
  IniBackupFileName;
  Iniopen(SFileName);
  Inigetgroup(SGroupName);
  a := IniGetData(Form.Name);
  if pos('not found', a) = 0 then
  begin
    Form.Top := StrToInt(TeilString(a, 1));
    Form.Left := StrToInt(TeilString(a, 2));
    if Form.BorderStyle <> bssingle then
    begin
      Form.Height := StrToInt(TeilString(a, 3));
      Form.Width := StrToInt(TeilString(a, 4));
    end;
    result := true;
  end
  else
  begin
    form.Left := screen.Width div 2 - form.Width div 2;
    form.top := Screen.Height div 2 - form.height div 2;
    result := false;
  end;
  IniRestoreFileName;
end;

procedure IniCreateControlList(CLFile: string; Form: TWinControl);
var
  i, j, k: integer;
  c, d: tcontrol;
begin
  IniBackupFileName;
  iniopen(clfile);
  inigetgroup('ControlList');
  inicleargroup;
  for i := 0 to Form.Controlcount - 1 do
  begin
    c := form.controls[i];
    if (c is TTabControl) or (c is TGroupbox) or (c is TPanel) or (c is
      TRadioGroup) then
      d := c
    else
      d := nil;
    if d <> nil then
      k := (d as TwinControl).controlcount - 1
    else
      k := 0;
    for j := 0 to k do
    begin
      if d <> nil then
        c := (d as TwinControl).controls[j];
      iniadditem(c.Name + '|');
    end;
  end;
  inisave;
  IniRestoreFileName;
end;

function IniPath: string;
begin
  result := extractfilepath(application.exename);
  if result[length(result)] <> '\' then
    result := result + '\';
end;

function IniWinPath: string;
var
  windir: array[0..255] of char;
  i, l: integer;
begin
  result := '';
  l := getwindowsdirectory(windir, 255);
  for i := 0 to l - 1 do
    result := result + windir[i];
  result := result + '\';
end;

procedure AlterTZ(a: char);
begin
  BackupTZ := BackupTZ + ' ';
  Backuptz[length(backuptz)] := tz;
  tz := a;
end;

procedure RestoreTZ;
begin
  if backuptz = '' then
    tz := '|'
  else
  begin
    tz := Backuptz[length(backuptz)];
    setlength(Backuptz, length(backuptz) - 1);
  end;
end;

procedure AlterSGN(a: string);
begin
  sgn.add(a);
  sgroupname := a;
end;

procedure RestoreSGN;
begin
  sgroupname := sgn[sgn.count - 1];
  sgn.delete(sgn.count - 1);
end;

function IniTempPath: string;
var
  buffer: array[0..255] of char;
begin
  if GetTempPath(sizeof(buffer), @buffer) <> 0 then
    result := buffer
  else
    result := '';
end;

function IniUser: string;
var
  l: dword;
  u: array[0..255] of char;
begin
  l := 255;
  GetUserName(u, l);
  result := u;
end;

function IniPosition(c, a: string; p: integer): integer;
{p Position, wenn p=0 dann letztes Vorkommen des Zeichens in dem String}
var
  x, i: integer;
  t: string;
  p0: boolean;
begin
  i := 0;
  result := 0;
  t := a;
  if p = 0 then
  begin
    p0 := true;
    p := 255;
  end
  else
    p0 := false;
  while i < p do
  begin
    x := pos(c, t);
    if x <> 0 then
    begin
      inc(result, x);
      if i > 0 then
        inc(result, length(c) - 1);
      inc(i);
      t := copy(t, x + length(c), 1028);
    end
    else
    begin
      i := 255;
      if not p0 then
        result := 0;
    end;
  end;
end;

function IniTreeAsString(t: ttreenodes): string;
var
  l1: array[0..100] of integer;
  i, c: integer;

  function TreeNodeAsString(tn: ttreenode): string;
  var
    un: integer;
    i: integer;
  begin
    un := tn.count;
    result := '|' + tn.text + '|' + inttostr(un);
    for i := 0 to un - 1 do
      result := result + treenodeasstring(tn.item[i]);
  end;

begin
  c := -1;
  for i := 0 to t.count - 1 do
    if t[i].level = 0 then
    begin
      inc(c);
      l1[c] := i;
    end;
  result := inttostr(c + 1);
  for i := 0 to c do
    result := result + treenodeasstring(t[l1[i]]);
end;

procedure IniStringAsTree(a: string; tv: ttreenodes);
var
  c, i, p: integer;

  procedure addstringnode(par: ttreenode);
  var
    c, i: integer;
    tn: ttreenode;
  begin
    p := p + 1;
    if par = nil then
      tn := tv.add(par, teilstring(a, p))
    else
      tn := tv.addchild(par, teilstring(a, p));
    p := p + 1;
    c := strtoint(teilstring(a, p));
    for i := 1 to c do
      addstringnode(tn);
  end;

begin
  if a = '' then
    exit;
  tv.Clear;
  p := 1;
  c := strtoint(teilstring(a, p));
  for i := 1 to c do
    addstringnode(nil);
end;

function IniFindFiles(directory, wildcard: string; var list: tstringlist;
  clearlist, changecursor: boolean; subfolders: Boolean = true): integer;
var
  count: Integer;
  procedure GetAllFiles(mask: string);
  var
    search: TSearchRec;
    verz: string;
    such: string;
  begin
    such := ExtractFileName(mask);
    verz := ExtractFilePath(mask);
    verz := inipreparepath(verz, '\');
    //all files
    if FindFirst(mask, $23, search) = 0 then
    begin
      repeat
        List.Add(verz + search.Name);
        inc(count);
      until FindNext(search) <> 0;
    end;
    FindClose(search);

    //Subdirectories/ Unterverzeichnisse
    if FindFirst(verz + '*.*', fadirectory, search) = 0 then
    begin
      repeat
        if ((search.Attr and fadirectory) = fadirectory) and (search.name[1] <>
          '.') then
        begin
          if subfolders then
            GetAllFiles(verz + search.name + '\' + such);
        end;
      until FindNext(search) <> 0;
    end;
    FindClose(search);
  end;

begin
  count := 0;
  if clearlist then
    list.clear;
  if changecursor then
    screen.Cursor := crHourGlass;
  directory := inipreparepath(directory, '\');
  GetAllFiles(directory + wildcard);
  if changecursor then
    screen.Cursor := crDefault;
  result := count;
end;

procedure IniAddStringlist(var dest: tstringlist; q: tstringlist);
var
  i: integer;
begin
  for i := 0 to q.count - 1 do
    dest.add(q[i]);
end;

procedure IniSetToLocal; // schaltet SFilename auf Windowsverzeichnis um
begin
  SPOrigin := SFilename;
  SFilename := iniwinpath + extractfilename(sfilename);
  ConsOrg.Clear;
  NamesOrg.Clear;
end;

procedure IniSetToLocal(const t: array of string);
begin
  SPOrigin := SFilename;
  SFilename := iniwinpath + extractfilename(sfilename);
  ConsOrg.assign(Cons);
  NamesOrg.Assign(Names);
  inireadcontrollist(t);
end;

procedure IniSetToOrigin;
// schaltet SFilename wieder auf den Ursprungspfad zurck
begin
  if sporigin = '' then
    exit
  else
    sfilename := sporigin;
  if consorg.Count = 0 then
    exit
  else
  begin
    cons.assign(consorg);
    names.assign(namesorg);
    consorg.Clear;
    namesorg.clear;
  end;
end;

function IniAsStrings(t: tstringlist): tstrings;
begin
  result := tstrings(t);
end;

function IniPreparePath(p: string; Pfadzeichen: char): string;
begin
  if length(p) > 0 then
    if p[length(p)] <> pfadzeichen then
      p := p + pfadzeichen;
  result := p;
end;

procedure IniLoadControlData(Form: TWinControl; LoadCoords: boolean); overload;
begin
  iniloadcontroldata(Form);
  if loadcoords then
    iniloadcoords(form as tform);
end;

procedure IniSaveControlData(Form: TWinControl; SaveCoords: Boolean); overload;
begin
  inisavecontroldata(Form);
  if savecoords then
    inisavecoords(form as tform);
end;

function IniPartCount(c: string; tz: char): integer;
var
  i: integer;
begin
  if length(c) = 0 then
  begin
    result := 0;
    exit
  end;
  i := 1;
  while iniposition(c, tz, i) > 0 do
    i := i + 1;
  result := i;
end;

function MRUUpdate(t: tcombobox; key: word): boolean; overload;
var
  a: string;
  i: integer;
begin
  result := false;
  if key in [vk_back, vk_delete] then
    exit;
  a := lowercase(t.Text);
  for i := t.items.count - 1 downto 0 do
    if pos(a, lowercase(t.items[i])) = 1 then
    begin
      t.text := t.items[i];
      t.SelStart := length(t.text);
      t.SelLength := length(a) - length(t.text);
      result := true;
    end;
end;

procedure MRUUpdate(t: tcombobox; s: string); overload;
begin
  if s = '' then
    exit;
  if t.items.indexof(s) >= 0 then
    t.Items.move(t.items.indexof(s), 0)
  else
  begin
    if t.items.count > maxcomboitems - 1 then
      t.items.delete(t.items.count - 1);
    t.items.insert(0, s);
  end;
  t.ItemIndex := -1;
end;

procedure IniExtractOnlyFilename(a: string; var e, p, d: string);
// e=Programmdatei mit Pfad, p=Parameter, d=Verzeichnis
var
  n, i: integer;
begin
  e := '';
  p := '';
  d := '';
  if a = '' then
    exit;
  i := 0;
  n := 0;
  while ininextpos(i + 1, '.', a) <> 0 do
  begin
    i := ininextpos(i + 1, '.', a);
    n := ininextpos(i + 1, ' ', a);
    if n > 0 then
      e := copy(a, 1, n - 1)
    else
      e := a;
    if fileexists(e) then
      break;
  end;
  if not fileexists(e) then
    exit;
  if n > 0 then
    p := copy(a, n + 1, 255);
  try
    d := extractfilepath(e);
  except d := '';
  end;
end;

function IniNextPos(start: integer; substr: string; s: string): integer;
var
  i: integer;
  a: string;
begin
  a := copy(s, start, 255);
  i := pos(substr, a);
  if i > 0 then
    result := start + i - 1
  else
    result := 0;
end;

function IniAsDlgString(t: tstringlist): string;
var
  i: integer;
begin
  result := '';
  for i := 0 to t.count - 2 do
    result := result + t[i] + cr;
  result := result + t[t.count - 1];
end;

function IniNullen;
var
  i: integer;
begin
  result := '';
  for i := 1 to n - length(inttostr(z)) do
    result := result + '0';
  result := result + inttostr(z);
end;

procedure IniDirInfo(Path: string; var L: TStringlist; SubFolders: Boolean;
  Attrib: Integer);
var
  f: TSearchRec;
  procedure SaveAttrib;
  var
    a: string;
  begin
    a := Path + f.Name + '|' + inttostr(f.size) + '|';
    if (f.Attr and faarchive) = faarchive then
      a := a + 'A';
    if (f.Attr and fahidden) = fahidden then
      a := a + 'H';
    if (f.Attr and fareadonly) = fareadonly then
      a := a + 'R';
    if (f.Attr and fadirectory) = fadirectory then
      a := a + 'D';
    if (f.Attr and fasysfile) = fasysfile then
      a := a + 'S';
    l.Add(a);
  end;
  procedure ListFiles;
  begin
    if findfirst(Path + '*.*', Attrib, f) = 0 then
      repeat
        SaveAttrib;
      until findnext(f) <> 0;
  end;

begin
  Path := inipreparepath(Path, '\');
  ListFiles;
  if FindFirst(Path + '*.*', fadirectory, f) = 0 then
  begin
    repeat
      if (f.Name[1] <> '.') and ((f.attr and fadirectory) = fadirectory) then
      begin
        SaveAttrib;
        if subfolders then
          IniDirInfo(Path + f.Name, l, subfolders, attrib);
      end;
    until FindNext(f) <> 0;
  end;
end;

function IniGetMaxLength(var t: tstringlist): integer;
var
  w, i: integer;
begin
  w := 0;
  for i := 0 to t.count - 1 do
    if length(t[i]) > w then
      w := length(t[i]);
  result := w;
end;

procedure IniAddStrings(d: tstringlist; q: tstringlist);
var
  i: integer;
begin
  for i := 0 to q.count - 1 do
    d.Add(q[i]);
end;

procedure IniCenterForm(F: TForm);
var
  w, h: integer;
begin
  w := f.Width;
  h := f.Height;
  f.Left := (screen.Width - w) div 2;
  f.top := (screen.height - h) div 2;
end;

function IniFontasString(f: TFont): string;
var
  a: string;
  b: boolean;
begin
  a := inttostr(f.charset) + '|';
  a := a + inttostr(f.color) + '|';
  a := a + inttostr(f.height) + '|';
  a := a + f.name + '|';
  a := a + inipitchasstring(f.pitch) + '|';
  a := a + inttostr(f.size) + '|';
  if fsbold in f.Style then
    b := true
  else
    b := false;
  a := a + iniasvalue(b) + '|';
  if fsitalic in f.Style then
    b := true
  else
    b := false;
  a := a + iniasvalue(b) + '|';
  if fsunderline in f.Style then
    b := true
  else
    b := false;
  a := a + iniasvalue(b) + '|';
  if fsstrikeout in f.Style then
    b := true
  else
    b := false;
  a := a + iniasvalue(b);
  result := a;
end;

procedure IniStringAsFont(a: string; fnt: TFont);
begin
  fnt.Charset := strtoint(teilstring(a, 1));
  fnt.Color := strtoint(teilstring(a, 2));
  fnt.Height := strtoint(teilstring(a, 3));
  fnt.Name := teilstring(a, 4);
  fnt.Pitch := inistringaspitch(teilstring(a, 5));
  fnt.Size := strtoint(teilstring(a, 6));
  fnt.Style := [];
  if teilstring(a, 7) = '1' then
    fnt.Style := fnt.style + [fsbold];
  if teilstring(a, 8) = '1' then
    fnt.Style := fnt.style + [fsitalic];
  if teilstring(a, 9) = '1' then
    fnt.Style := fnt.style + [fsunderline];
  if teilstring(a, 10) = '1' then
    fnt.Style := fnt.style + [fsstrikeout];
end;

function IniPitchAsString(fp: tfontpitch): string;
begin
  if fp = fpdefault then
    result := 'fpDefault';
  if fp = fpfixed then
    result := 'fpFixed';
  if fp = fpvariable then
    result := 'fpVariable';
end;

function IniStringAsPitch(a: string): tfontpitch;
begin
  result := fpdefault;
  if a = 'fpdefault' then
    result := fpDefault;
  if a = 'fpfixed' then
    result := fpFixed;
  if a = 'fpvariable' then
    result := fpVariable;
end;

procedure IniSaveFont(Name: string; t: pfont);
begin
  IniBackupFileName;
  Iniopen(SFileName);
  inigetgroup(SGroupName);
  IniSetData(Name, inifontasstring(t^));
  Inisave;
  IniRestoreFileName;
end;

procedure IniLoadFont(Name: string; t: pfont; ErsatzFont: Tfont);
var
  f: string;
begin
  IniBackupFileName;
  Iniopen(SFileName);
  inigetgroup(SGroupName);
  f := InigetData(Name);
  if f = 'not found' then
  begin
    t^.assign(ersatzfont)
  end
  else
    inistringasfont(f, t^);
  IniRestoreFileName;
end;

procedure IniRenameGroup(n1, n2: string);
begin
  inigetgroup(n2);
  inigetgroup(n1);
  Groupname := n2;
  inisave;
  inideletegroup(n1);
end;

function Trimmer(a: string): string;
var
  i: integer;
begin
  while pos(#0, a) > 0 do
    delete(a, pos(#0, a), 1);
  a := trim(a);
  i := 1;
  while i < length(a) do
    if (a[i + 1] = ' ') and (a[i] = ' ') then
      delete(a, i, 1)
    else
      inc(i);
  result := a;
end;

procedure IniInfo(a: string);
begin
  messagedlg(a, mtinformation, [mbok], 0);
end;

procedure SpaltenBreite(var t: tlistview; b: integer);
var
  i: integer;
begin
  for i := 0 to t.Columns.count - 1 do
    t.columns[i].width := b;
end;

function DirExists(d: string): boolean;
var
  a: string;
begin
  a := getcurrentdir;
  result := setcurrentdir(d);
  setcurrentdir(a);
end;

function ExtractFileExtension(a: string): string;
var
  b: string;
  i: integer;
begin
  b := '';
  i := length(a);
  if pos('.', a) <> 0 then
    while a[i] <> '.' do
    begin
      b := a[i] + b;
      dec(i);
    end;
  result := b;
end;

function IniTempDir: string;
var
  Buffer: array[0..MAX_PATH] of Char;
begin
  GetTempPath(SizeOf(Buffer) - 1, Buffer);
  Result := StrPas(Buffer);
end;

function ComputerName: string;
var
  buffer: array[0..MAX_COMPUTERNAME_LENGTH + 1] of Char;
  Size: Cardinal;
begin
  Size := MAX_COMPUTERNAME_LENGTH + 1;
  Windows.GetComputerName(@buffer, Size);
  Result := StrPas(buffer);
end;

procedure SaveListViewToFile(AListView: TListView; sFileName: string);
var
  idxItem, idxSub, IdxImage: Integer;
  F: TFileStream;
  sText: string;
  W, ItemCount, SubCount: Word;
  MySignature: array[0..2] of Char;
begin
  //Initialization
  with AListView do
  begin
    ItemCount := 0;
    SubCount := 0;
    //****
    MySignature := 'LVF';
    //  ListViewFile
    F := TFileStream.Create(sFileName, fmCreate or fmOpenWrite);
    F.Write(MySignature, SizeOf(MySignature));

    if Items.Count = 0 then
      // List is empty
      ItemCount := 0
    else
      ItemCount := Items.Count;
    F.Write(ItemCount, SizeOf(ItemCount));

    if Items.Count > 0 then
    begin
      for idxItem := 1 to ItemCount do
      begin
        with Items[idxItem - 1] do
        begin
          //Save subitems count
          SubCount := Subitems.Count;
          F.Write(SubCount, SizeOf(SubCount));
          //Save Data
          F.Write(Data, sizeof(Pointer));
          //Save ImageIndex
          IdxImage := ImageIndex;
          F.Write(IdxImage, SizeOf(IdxImage));
          //Save Caption
          sText := Caption;
          w := Length(sText);
          F.Write(w, SizeOf(w));
          if w > 0 then
            F.Write(sText[1], w);
          if SubCount > 0 then
          begin
            for idxSub := 0 to SubItems.Count - 1 do
            begin
              //Save Item's subitems
              sText := SubItems[idxSub];
              w := Length(sText);
              F.Write(w, SizeOf(w));
              if w > 0 then
                F.Write(sText[1], w);
            end;
          end;
        end;
      end;
    end;
    F.Free;
  end;
end;

procedure LoadListViewFromFile(AListView: TListView; sFileName: string);
var
  F: TFileStream;
  IdxItem, IdxSubItem, IdxImage: Integer;
  W, ItemCount, SubCount: Word;
  pText: PChar;
  PTemp: PChar;
  Dat: Pointer;
  MySignature: array[0..2] of Char;
  sExeName: string;
begin
  with AListView do
  begin
    ItemCount := 0;
    SubCount := 0;

    sExeName := ExtractFileName(sFileName);

    if not FileExists(sFileName) then
    begin
      MessageBox(Handle, PChar(Format(Msg1, [sExeName])), 'I/O Error',
        MB_ICONERROR);
      Exit;
    end;

    F := TFileStream.Create(sFileName, fmOpenRead);
    F.Read(MySignature, SizeOf(MySignature));

    if MySignature <> 'LVF' then
    begin
      MessageBox(Handle, PChar(Format(Msg2, [sExeName])), 'I/O Error',
        MB_ICONERROR);
      Exit;
    end;

    F.Read(ItemCount, SizeOf(ItemCount));
    Items.BeginUpdate;
    Items.Clear;

    for idxItem := 1 to ItemCount do
    begin
      with Items.Add do
      begin
        //Read Subcount
        F.Read(SubCount, SizeOf(SubCount));
        //Read Data
        F.Read(Dat, SizeOf(pointer));
        Data := Dat;
        //Read imageindex
        F.Read(IdxImage, SizeOf(IdxImage));
        ImageIndex := IdxImage;
        //Read the Caption
        F.Read(w, SizeOf(w));
        if w > 0 then begin
          pText := StrAlloc(w + 1);
          pTemp := StrAlloc(w + 1);
          F.Read(pTemp^, W);
          StrLCopy(pText, pTemp, W);
          Caption := StrPas(pText);
          StrDispose(pTemp);
          StrDispose(pText);
        end else
          Caption := '';
        if SubCount > 0 then
        begin
          for idxSubItem := 1 to SubCount do
          begin
            F.Read(w, SizeOf(w));
            if w > 0 then begin
              pText := StrAlloc(w + 1);
              pTemp := StrAlloc(w + 1);
              F.Read(pTemp^, W);
              StrLCopy(pText, pTemp, W);
              Items[idxItem - 1].SubItems.Add(StrPas(pText));
              StrDispose(pTemp);
              StrDispose(pText);
            end else
              Items[idxItem - 1].SubItems.Add('');
          end;
        end;
      end;
    end;
    Items.EndUpdate;
    F.Free;
  end;
end;

procedure Split(const value: string; const delimiter: string; const sl: TStrings); overload;
var
  dx: integer;
  ns: string;
  txt: string;
  delta: integer;
begin
  delta := Length(delimiter);
  txt := value + delimiter;
  sl.BeginUpdate;
  sl.Clear;
  try
    while Length(txt) > 0 do
    begin
      dx := Pos(delimiter, txt);
      ns := Copy(txt, 0, dx - 1);
      sl.Add(ns);
      txt := Copy(txt, dx + delta, MaxInt);
    end;
  finally
    sl.EndUpdate;
  end;
end;

function Join(s: tstringlist; con: string): string;
var
  i: integer;
  a: string;
begin
  a := '';
  if s.count > 0 then
  begin
    for i := 0 to s.count - 2 do
      a := a + s[i] + con;
    a := a + s[s.count - 1];
  end;
  result := a;
end;

function Join(s: tstringlist; con: string; firstIndex, lastIndex: Integer): string;
var
  i: integer;
  a: string;
begin
  a := '';
  if s.count > 0 then
  begin
    for i := firstIndex to lastIndex - 1 do
      a := a + s[i] + con;
    a := a + s[lastIndex];
  end;
  result := a;
end;


// ausgenommen sind steuerelemente mit tag = 99
// s = -1 lsst die Schriftgre unverndern

procedure SetFormFont(f: TWinControl; n: string; s: Integer = -1);
var
  i: Integer;
  c: TControl;

  procedure SetFont(c: TControl);
  begin
    if c.Tag = 99 then
      exit;
    if (c is TForm) and not (c as TForm).ParentFont then
    begin
      (c as TForm).Font.Name := n;
      if s <> -1 then (c as TForm).Font.Size := s;
    end;
    if (c is TEdit) and not (c as TEdit).ParentFont then
    begin
      (c as TEdit).Font.Name := n;
      if s <> -1 then (c as TEdit).Font.Size := s;
    end;
    if (c is TComboBox) and not (c as TComboBox).ParentFont then
    begin
      (c as TComboBox).Font.Name := n;
      if s <> -1 then (c as TComboBox).Font.Size := s;
    end;
    if (c is TLabel) and not (c as TLabel).ParentFont then
      with c as TLabel do begin
        Font.Name := n;
        if s <> -1 then Font.Size := s;
        if AutoSize then begin
          AutoSize := false;
          AutoSize := true;
        end;
      end;
    if (c is TButton) and not (c as TButton).ParentFont then
    begin
      (c as TButton).Font.Name := n;
      if s <> -1 then (c as TButton).Font.Size := s;
    end;
    if (c is TCheckBox) then
      with TCheckBox(c) do begin
        if not ParentFont then
        begin
          Font.Name := n;
          if s <> -1 then Font.Size := s;
        end;
        Width := TextWidth(Caption, Font, ParentWindow) + 19;
      end;
    if (c is TGroupBox) and not (c as TGroupBox).ParentFont then
      with (c as TGroupBox).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
    if (c is TRadioButton) and not (c as TRadioButton).ParentFont then
      with (c as TRadioButton).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
    if (c is TListBox) and not (c as TListBox).ParentFont then
      with (c as TListBox).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
    if (c is TRadioGroup) and not (c as TRadioGroup).ParentFont then
      with (c as TRadioGroup).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
    if (c is TRadioButton) and not (c as TRadioButton).ParentFont then
      with (c as TRadioButton).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
    if (c is TListView) and not (c as TListView).ParentFont then
      with (c as TListView).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
    if (c is TPageControl) and not (c as TPageControl).ParentFont then
      with (c as TPageControl).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
    if (c is TMemo) and not (c as TMemo).ParentFont then
      with (c as TMemo).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
    if (c is TStatusbar) and not (c as TStatusBar).ParentFont then
      with (c as TStatusbar).Font do
      begin
        Name := n;
        if s <> -1 then Size := s;
      end;
  end;

begin
  if n = '' then exit;
  SetFont(f);
  with f do
    for i := 0 to ControlCount - 1 do
    begin
      try
        c := controls[i];
      except
        raise Exception.Create('Index of control list out of bounds.');
      end;
      if c is TWinControl then
        SetFormFont(c as TWinControl, n, s);
      SetFont(c);
    end;
end;

function ReplaceAll(var s: string; find: string; replace: string): integer;
var
  p: integer;
  a, b: string;
begin
  result := 0;
  a := '';
  b := s;
  p := pos(find, b);
  while p > 0 do
  begin
    inc(result);
    a := a + copy(b, 1, p - 1) + replace;
    delete(b, 1, p + length(find) - 1);
    p := pos(find, b);
  end;
  s := a + b;
end;

function Nullen(d: integer; n: integer): string;
begin
  result := inttostr(d);
  while length(result) < n do
    result := '0' + result;
end;

function MatchesPattern(s: string; pattern: string): boolean;
var j, last: integer;
  p: TStringlist;
  b: boolean;
begin
  p := TStringlist.Create;
  Split(pattern, '*', p);
  b := true;
  last := 0;
  for j := 0 to p.Count - 1 do
  begin
    if (j = 0) and (p[0] <> '') and (pos(p[0], s) <> 1) then begin
      b := false;
      break;
    end;
    if (j > 0) and (p[j] <> '') and (pos(p[j], s) <= last) then begin
      b := false;
      break;
    end;
    if (j = p.Count - 1) and (p[j] <> '') and (copy(s, length(s) - length(p[j]) + 1, length(p[j])) <> p[j]) then begin
      b := false;
      break;
    end;
  end;
  result := b;
  p.Free;
end;

procedure IniUnderLine(f: TFont; underline: boolean);
begin
  if underline then
    f.Style := f.Style + [fsUnderLine]
  else
    f.Style := f.Style - [fsUnderLine];
end;

// if tag = 1 then sunken

procedure SetSunkenButtons(f: TForm);
  procedure ParseFormForButtons(wc: TWinControl);
  var i: Integer;
  begin
    for i := 0 to wc.ControlCount - 1 do
    begin
      if wc.Controls[i] is TButton then
        if wc.Controls[i].Tag = 1 then
          BorderButton(TButton(wc.Controls[i]), sunken);
      if wc.Controls[i] is TWinControl then
        ParseFormForButtons(TWinControl(wc.Controls[i]));
    end;
  end;
begin
  if not IsThemeActive then
    ParseFormForButtons(f);
end;

function IsThemeActive: Boolean;
// Returns True if the user uses XP style
const
  themelib = 'uxtheme.dll';
type
  TIsThemeActive = function: BOOL; stdcall;
var
  IsThemeActive: TIsThemeActive;
  huxtheme: HINST;
begin
  Result := False;
  // Check if XP or later Version
  if (Win32Platform = VER_PLATFORM_WIN32_NT) and
    (((Win32MajorVersion = 5) and (Win32MinorVersion >= 1)) or
    (Win32MajorVersion > 5)) then
  begin
    huxtheme := LoadLibrary(themelib);
    if huxtheme <> 0 then
    begin
      try
        IsThemeActive := GetProcAddress(huxtheme, 'IsThemeActive');
        Result := IsThemeActive;
      finally
        if huxtheme > 0 then
          FreeLibrary(huxtheme);
      end;
    end;
  end;
end;

function GetVersion: string;
var
  VerInfoSize: DWORD;
  VerInfo: Pointer;
  VerValueSize: DWORD;
  VerValue: PVSFixedFileInfo;
  Dummy: DWORD;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    Result := IntToStr(dwFileVersionMS shr 16);
    Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
    Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
    Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;

function TextWidth(t: string; font: TFont; hwnd: THandle): Integer;
var
  c: TCanvas;
begin
  c := TCanvas.Create;
  c.Handle := GetDC(hwnd);
  c.Font.Assign(font);
  result := c.TextWidth(t);
  ReleaseDC(hwnd, c.Handle);
  c.Free;
end;

function TextHeight(t: string; font: TFont; hwnd: THandle): Integer;
var
  c: TCanvas;
begin
  c := TCanvas.Create;
  c.Handle := GetDC(hwnd);
  c.Font.Assign(font);
  result := c.TextHeight(t);
  ReleaseDC(hwnd, c.Handle);
  c.Free;
end;


function ExecAndWait(const CmdLine, Directory: string;
  WindowState: Word; Wait: Boolean): Boolean;
var
  SUInfo: TStartupInfo;
  ProcInfo: TProcessInformation;
  PDirectory: PChar;
begin
  { Enclose filename in quotes to take care of
    long filenames with spaces. }
  FillChar(SUInfo, SizeOf(SUInfo), #0);
  with SUInfo do
  begin
    cb := SizeOf(SUInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := WindowState;
  end;
  if Directory <> '' then
    PDirectory := PChar(Directory)
  else
    PDirectory := nil;
  Result := CreateProcess(nil, PChar(CmdLine), nil, nil, False,
    CREATE_NEW_CONSOLE or
    NORMAL_PRIORITY_CLASS, nil,
    PDirectory,
    SUInfo, ProcInfo);
  { Wait for it to finish. }
  if Result and Wait then
    WaitForSingleObject(ProcInfo.hProcess, INFINITE);
end;

function ExecAndWait(const CmdLine: string;
  WindowState: Word; Wait: Boolean): Boolean;
begin
  result :=
    ExecAndWait(CmdLine, ExtractFilePath(Application.ExeName), WindowState, Wait);
end;

function ExecAndWait(const FileName, Params, Directory: string;
  WindowState: Word; Wait: Boolean): Boolean;
begin
  result := ExecAndWait('"' + Filename + '" ' + Params, Directory, WindowState, Wait);
end;

procedure IniHoverLabel(lbl: TLabel);
begin
  lbl.OnMouseEnter := IniObjectRoutines.IniLabelMouseEnter;
  lbl.OnMouseLeave := IniObjectRoutines.IniLabelMouseLeave;
end;

{ TObjectRoutines }

procedure TObjectRoutines.IniLabelMouseEnter(Sender: TObject);
var
  f: TFont;
begin
  f := (Sender as TLabel).Font;
  IniUnderLine(f, true);
  (Sender as TLabel).Font := f;
end;

procedure TObjectRoutines.IniLabelMouseLeave(Sender: TObject);
var
  f: TFont;
begin
  f := (Sender as TLabel).Font;
  IniUnderLine(f, false);
  (Sender as TLabel).Font := f;
end;

function IsWindowsVista: Boolean;
var
  VerInfo: TOSVersioninfo;
begin
  VerInfo.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  GetVersionEx(VerInfo);
  Result := VerInfo.dwMajorVersion >= 6;
end;

procedure SetVistaTreeView(const AHandle: THandle);
begin
  if IsWindowsVista then
    SetWindowTheme(AHandle, 'explorer', nil);
end;

function GetFileSize(AFileName: String): Int64;
var lFindData: TWin32FindData;
    lHandle  : Cardinal;
begin
  lHandle := FindFirstFile(PChar(AFileName), lFindData);
  if (lHandle <> INVALID_HANDLE_VALUE) then
  begin
    result := lFindData.nFileSizeLow;
    PCardinal(Cardinal(@result) + SizeOf(Cardinal))^ := lFindData.nFileSizeHigh;
    windows.FindClose(lHandle);
  end
  else
    result := 0;
end;




initialization
  Lines := TStringList.Create;
  Names := TStringList.Create;
  Cons := TStringList.Create;
  bfn := tstringlist.create;
  sgn := TStringlist.create;
  ConsOrg := TStringlist.create;
  NamesOrg := TStringlist.create;
  tempsl := tstringlist.create;
  defaultFontHandle := GetStockObject(DEFAULT_GUI_FONT);
  if defaultFontHandle <> 0 then
  begin
    fnt := TFont.Create;
    fnt.Handle := defaultFontHandle;
    defaultFont := fnt.Name;
    fnt.Free;
  end;
  if (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    if Win32MajorVersion >= 5 then
    begin
      if IsWindowsVista then
      begin
        defaultFontSize := 8;
      end else
      begin
        defaultFontSize := 8;
      end;
    end else
    begin
      defaultFontSize := 9;
    end;
  end;
  IniObjectRoutines := TObjectRoutines.Create;

finalization
  Lines.Free;
  Names.Free;
  Cons.Free;
  bfn.Free;
  sgn.Free;
  ConsOrg.Free;
  NamesOrg.Free;
  tempsl.Free;
  IniObjectRoutines.Free;

end.
