unit OneInst;

interface

uses windows,classes,messages,forms,sysutils;

var hAlreadyExists,mHandle:thandle;
    hMainHandle:THandle;
    MainFormName:String;

procedure SwitchToThisWindow(h1: hWnd; x: bool); stdcall;
  external user32 Name 'SwitchToThisWindow';
         {x = false: Size unchanged, x = true: normal size}

procedure InstallMutex(n:string;MainFormHandle:TForm); // close older app
function InstallMutex2(n:string;className:string;mes:Cardinal):boolean; // send message to older app
procedure DeInstallMutex;
function CheckHandle(hwnd: thandle; i: integer):bool; stdcall; export;
function ForceForegroundWindow(hwnd: THandle): Boolean;

implementation

//function ForceForegroundWindow(hwnd: THandle): Boolean;
//begin
//  SwitchToThisWindow(hwnd,true);
//end;

//function ForceForegroundWindow(hwnd: THandle): Boolean;
//  // (W) 2001 Daniel Rolf
//  // http://www.finecode.de
//  // rolf@finecode.de
//var
//  hlp: TForm;
//begin
//  hlp := TForm.Create(nil);
//  try
//    hlp.BorderStyle := bsNone;
//    hlp.SetBounds(0, 0, 1, 1);
//    hlp.FormStyle := fsStayOnTop;
//    hlp.Show;
//    mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
//    mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
//    SetForegroundWindow(hwnd);
//  finally
//    hlp.Free;
//  end;
//
//  while GetForeGroundWindow <> hwnd do sleep(100);
//end;


function ForceForegroundWindow(hwnd: THandle): Boolean;
const
  SPI_GETFOREGROUNDLOCKTIMEOUT = $2000;
  SPI_SETFOREGROUNDLOCKTIMEOUT = $2001;
var
  ForegroundThreadID: DWORD;
  ThisThreadID: DWORD;
  timeout: DWORD;
begin
  if IsIconic(hwnd) then ShowWindow(hwnd, SW_RESTORE);

//  if GetForegroundWindow = hwnd then Result := True
//  else
  begin
//     Windows 98/2000 doesn't want to foreground a window when some other
//     window has keyboard focus

    if ((Win32Platform = VER_PLATFORM_WIN32_NT) and (Win32MajorVersion > 4)) or
      ((Win32Platform = VER_PLATFORM_WIN32_WINDOWS) and
      ((Win32MajorVersion > 4) or ((Win32MajorVersion = 4) and
      (Win32MinorVersion > 0)))) then
    begin
//       Code from Karl E. Peterson, www.mvps.org/vb/sample.htm
//       Converted to Delphi by Ray Lischner
//       Published in The Delphi Magazine 55, page 16

      Result := False;
      ForegroundThreadID := GetWindowThreadProcessID(GetForegroundWindow, nil);
      ThisThreadID := GetWindowThreadPRocessId(hwnd, nil);
      if AttachThreadInput(ThisThreadID, ForegroundThreadID, True) then
      begin
        BringWindowToTop(hwnd); // IE 5.5 related hack
        SetForegroundWindow(hwnd);
        AttachThreadInput(ThisThreadID, ForegroundThreadID, False);
        Result := (GetForegroundWindow = hwnd);
      end;
      if not Result then
      begin
//         Code by Daniel P. Stasinski
        SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, @timeout, 0);
        SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(0),
          SPIF_SENDCHANGE);
        BringWindowToTop(hwnd); // IE 5.5 related hack
        SetForegroundWindow(hWnd);
        SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(timeout), SPIF_SENDCHANGE);
      end;
    end
    else
    begin
      BringWindowToTop(hwnd); // IE 5.5 related hack
      SetForegroundWindow(hwnd);
    end;

    Result := (GetForegroundWindow = hwnd);
  end;
end;

procedure DeInstallMutex;
begin
 if mHandle <> 0 then begin
  ReleaseMutex(mHandle);
  CloseHandle(mHandle);
 end;
end;

Function GetProcessID(hWindowHandle:THandle):Thandle;
var hProcessID:THandle;
begin
    { Get the process identifier for the window}
    GetWindowThreadProcessID(hWindowHandle, @hprocessID);
    result:=HProcessID;
End;

procedure InstallMutex(n:string;MainFormHandle:TForm);
var i:longint;
begin
 i:=0;
 hMainHandle:=MainFormHandle.Handle;
 MainFormName:=MainFormHandle.ClassName;
 mHandle := CreateMutex(nil, True, pchar(n));
 if GetLastError = ERROR_ALREADY_EXISTS then
 begin
  OpenMutex(SYNCHRONIZE,false,pchar(n));
  hAlreadyExists:=0;
  EnumWindows(@checkhandle,i);
  if hAlreadyExists<>0 then
  begin
   sendMessage(hAlreadyExists,WM_CLOSE,0,0);
   waitforsingleobject(mhandle,INFINITE);
   //waitforsingleobject(OpenProcess(SYNCHRONIZE,false,GetProcessID(hAlreadyExists)),2000);
  end;
 end else begin
   waitforsingleobject(mhandle,INFINITE);
 end;
end;

function InstallMutex2(n:string;className:string;mes:Cardinal):boolean;
var i:longint;
begin
 i:=0;
 hMainHandle:=0;
 MainFormName:=className;
 mHandle := CreateMutex(nil, True, pchar(n));
 if GetLastError = ERROR_ALREADY_EXISTS then
 begin
  OpenMutex(SYNCHRONIZE,false,pchar(n));
  hAlreadyExists:=0;
  EnumWindows(@checkhandle,i);
  if hAlreadyExists<>0 then
  begin
   sendmessage(hAlreadyExists,mes,0,0);
   result:=false;
   exit;
  end;
 end else begin
   waitforsingleobject(mhandle,INFINITE);
 end;
 result:=true;
end;


function CheckHandle(hwnd: thandle; i: integer):bool; stdcall; export;
var c:array[0..250] of char;
    s:string;
begin
 fillchar(c,sizeof(c),0);
 getclassname(hwnd,c,250);
 s:=c;
 result:=true;
 if (s=MainFormName) and (hwnd<>hMainHandle) then begin
  hAlreadyExists:=hwnd;
  result:=false;
 end;
end;


end.
