unit PacketKeeper;

interface

uses classes, windows, sysutils;

type

  PKPacket = record
    Size: Cardinal;
    Place: Pointer;
  end;

  PPKPacket = ^PKPacket;

  TPacketKeeper = class(TObject)
  private
    Packets: TList;
  public
    procedure MakeText(n: integer; var t: TStringlist);
    function AddPacket(buf: pointer; count: Cardinal): integer;
    constructor Create;
    destructor Destroy; override;
  end;

implementation

{ TPacketKeeper }

function TPacketKeeper.AddPacket(buf: pointer; count: Cardinal): integer;
var
  p: pointer;
  pack: ppkpacket;
begin
  GetMem(p, count);
  new(Pack);
  CopyMemory(p, buf, count);
  pack^.Size := count;
  pack^.Place := p;
  Packets.Add(pack);
  result := Packets.Count - 1;
end;

constructor TPacketKeeper.Create;
begin
  packets := TList.Create;
end;

destructor TPacketKeeper.Destroy;
var
  i: integer;
  p: ppkpacket;
begin
  for i := 0 to Packets.count - 1 do
  begin
    p := packets[i];
    FreeMem(p^.Place);
    Dispose(p);
  end;
  Packets.Free;
  inherited;
end;

procedure TPacketKeeper.MakeText(n: integer; var t: TStringlist);
var
  p: PByteArray;
  s: Integer;
  i, j: integer;
  add: integer;
  pack: ppkpacket;
  a: string;
begin
  pack := packets[n];
  s := pack^.Size;
  p := pack^.Place;
  add := 0;
  while add < s do
  begin
    a := inttohex(add, 4) + '  ';
    i := 0;
    while (i < 16) and (s >= 0) and (add < s) do
    begin
      a := a + inttohex(p[add], 2) + ' ';
      inc(i);
      inc(add);
    end;
    while (length(a) < 73) do
      a := a + ' ';
    i := (add - 1) - (add - 1) mod 16;
    j := 0;
    while (j < 8) and (i < s) do
    begin
      if p[i] in [32..127] then
        a[56 + j] := chr(p[i])
      else
        a[56 + j] := '.';
      inc(i);
      inc(j);
    end;
    while (j < 16) and (i < s) do
    begin
      if p[i] in [32..127] then
        a[57 + j] := chr(p[i])
      else
        a[57 + j] := '.';
      inc(i);
      inc(j);
    end;
    t.add(a);
  end;
end;

end.
