unit RealmThread;

interface

uses
  Classes, WC3Types, Winsock, Windows;

type
  RealmResolver = class(TThread)
  private
    { Private-Deklarationen }
  protected
    procedure Execute; override;
    procedure ResolveName(name: string);
  public
    RealmList: TStringlist;
    Realms: TThreadList;
    destructor Destroy; override;
  end;

var
  ips: array[0..100] of dword;
  ipc: integer;

implementation

{ RealmResolver }

destructor RealmResolver.Destroy;
var i: Integer;
    l: TList;
begin
  l := Realms.LockList;
  try
    for i := 0 to l.Count - 1 do
      Dispose(l[i]);
    l.Clear;
  finally
    Realms.UnlockList;
  end;
  RealmList.Free;
  inherited;
end;

procedure RealmResolver.Execute;
var
  a, r, n: string;
  p: prealm;
  i, j, k: integer;
begin
  for i := 0 to realmList.Count - 1 do
  if not Terminated then
  begin
    a := realmList[i];
    j := pos('|', a);
    if j > 0 then
    begin
      r := copy(a, 1, j - 1);
      n := copy(a, j + 1, 255);
      resolvename(n);
      for k := 0 to ipc - 1 do
      begin
        new(p);
        p^.name := r;
        p^.ip := ips[k];
        realms.Add(p);
      end;
    end;
  end;
end;

procedure RealmResolver.ResolveName(name: string);
type
  TaPInAddr = array[0..100] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe: PHostEnt;
  pptr: PaPInAddr;
  Buffer: array[0..63] of Char;
  GInitData: TWSAData;
begin
  ipc := 0;
  // check for buffer overflow
  if length(name) > 63 then
    exit;
  fillchar(buffer, 64, 0);
  copymemory(@buffer[0], @name[1], length(name));
  // get IPs of host
  WSAStartup($101, GInitData);
  phe := GetHostByName(buffer);
  if phe <> nil then
  begin
    pPtr := PaPInAddr(phe^.h_addr_list);
    while pPtr^[ipc] <> nil do
    begin
      ips[ipc] := pptr^[ipc]^.S_addr;
      inc(ipc);
    end;
  end;
  WSACleanup;
end;

end.
