unit TCPSend;

interface

uses
  Windows;

const
  Max_Message = 4068;
  Max_Packet = 4096;

type
  TPacketBuffer = array[0..Max_Packet-1] of byte;

// ????????? IP ??????
type
  T_IP_Header = record
    ip_verlen : Byte;
    ip_tos : Byte;
    ip_totallength : Word;
    ip_id : Word;
    ip_offset : Word;
    ip_ttl : Byte;
    ip_protocol : Byte;
    ip_checksum : Word;
    ip_srcaddr : LongWord;
    ip_destaddr : LongWord;
end;

// ????????? UDP ??????
type
  T_UDP_Header = record
    src_portno : Word;
    dst_portno : Word;
    udp_length : Word;
    udp_checksum : Word;
end;

PTCP_RHDR = ^TCP_RHDR;
TCP_RHDR = Packed record
  SrcPort     : WORD;
  DestPort    : WORD;
  SequenceNr  : DWORD;
  AckNumber   : DWORD;
  LenResvFlags: WORD; //length(4bits) rsvd(6bits) flags(6bits)
  WindowSize  : WORD;
  Checksum    : WORD;
  UrgentPtr   : WORD;
end;

PTCP_PHDR = ^TCP_PHDR;
TCP_PHDR = Packed Record
  SrcIP       : DWORD;
  DestIP      : DWORD;
  Zero        : Byte;
  Protocol    : Byte;
  TCPLen      : WORD;
end;

// ????????? ?????????? ????? ??? Winsock 2
u_char = Char;
u_short = Word;
u_int = Integer;
u_long = Longint;

SunB = packed record
  s_b1, s_b2, s_b3, s_b4: u_char;
end;

SunW = packed record
  s_w1, s_w2: u_short;
end;

in_addr = record
  case integer of
    0: (S_un_b: SunB);
    1: (S_un_w: SunW);
    2: (S_addr: u_long);
  end;
  TInAddr = in_addr;

Sockaddr_in = record
  case Integer of
    0: (sin_family: u_short;
    sin_port: u_short;
    sin_addr: TInAddr;
    sin_zero: array[0..7] of Char);
    1: (sa_family: u_short;
    sa_data: array[0..13] of Char)
  end;

TSockAddr = Sockaddr_in;
TSocket = u_int;

const
  WSADESCRIPTION_LEN = 256;
  WSASYS_STATUS_LEN = 128;

type
  PWSAData = ^TWSAData;
  WSAData = record // !!! also WSDATA
    wVersion: Word;
    wHighVersion: Word;
    szDescription: array[0..WSADESCRIPTION_LEN] of Char;
    szSystemStatus: array[0..WSASYS_STATUS_LEN] of Char;
    iMaxSockets: Word;
    iMaxUdpDg: Word;
    lpVendorInfo: PChar;
end;
TWSAData = WSAData;

// ?????????? ??????????? ??????? winsock 2
function closesocket(s: TSocket): Integer; stdcall;
function socket(af, Struct, protocol: Integer): TSocket; stdcall;
function sendto(s: TSocket; var Buf; len, flags: Integer; var addrto: TSockAddr;
tolen: Integer): Integer; stdcall;{}
function setsockopt(s: TSocket; level, optname: Integer; optval: PChar;
optlen: Integer): Integer; stdcall;
function inet_addr(cp: PChar): u_long; stdcall; {PInAddr;} { TInAddr }
function htons(hostshort: u_short): u_short; stdcall;
function WSAGetLastError: Integer; stdcall;
function WSAStartup(wVersionRequired: word; var WSData: TWSAData): Integer; stdcall;
function WSACleanup: Integer; stdcall;

procedure BuildHeaders(FromIP : string; iFromPort : Word; ToIP : string;
                        iToPort : Word; StrMessage : string; var Buf : TPacketBuffer;
                          var remote : TSockAddr; var iTotalSize: Word; Flags: Byte; Sequ: DWORD; Ack: DWORD);
function SendTCPPacket(FromIP : string; iFromPort : Word; ToIP : string;
iToPort : Word; StrMessage : string; Flags: Byte; Sequ: DWORD; Ack: DWORD):boolean;
function csum (var Buffer; Size: Integer):Word;

const
  AF_INET = 2; // internetwork: UDP, TCP, etc.
  IP_HDRINCL = 2; // ???????? ????????? IP ??????
  SOCK_RAW = 3; // ????????? raw-?????????

  IPPROTO_IP = 0; // dummy for IP
  IPPROTO_TCP = 6; // tcp
  IPPROTO_UDP = 17; // user datagram protocol
  IPPROTO_RAW = 255; // raw IP ?????

  INVALID_SOCKET = TSocket(not(0));
  SOCKET_ERROR = -1;

implementation

// ??????????? ??????? Winsock 2
const WinSocket = 'WS2_32.DLL';

function closesocket; external winsocket name 'closesocket';
function socket; external winsocket name 'socket';
function sendto; external winsocket name 'sendto';
function setsockopt; external winsocket name 'setsockopt';
function inet_addr; external winsocket name 'inet_addr';
function htons; external winsocket name 'htons';
function WSAGetLastError; external winsocket name 'WSAGetLastError';
function WSAStartup; external winsocket name 'WSAStartup';
function WSACleanup; external winsocket name 'WSACleanup';

//
// Function: checksum
//
// Description:
// This function calculates the 16-bit one's complement sum
// for the supplied buffer
//

function csum (var Buffer; Size: Integer):Word;
type t=array[0..1] of word;
var sum:longword;
    i:integer;
begin
  sum:=0;
  i:=0;
  while size>0 do begin
    sum:=sum+t(buffer)[i];
    inc(i);
    dec(size);
  end;

  sum:=(sum shr 16)+(sum and $FFFF);
  sum:=sum+(sum shr 16);
  result:= not(sum) and $FFFF;
end;



function CheckSum(var Buffer; Size : integer) : Word;
type
  TWordArray = array[0..1] of Word;
var
  ChkSum : LongWord;
  w : Word;
  i : Integer;
begin
  ChkSum := 0;
  i := 0;
  while Size > 1 do
  begin
    w := TWordArray(Buffer)[i];
    ChkSum := ChkSum + w;
    inc(i);
    Size := Size - SizeOf(Word);
  end;

  if Size=1 then
    ChkSum := ChkSum + Byte(TWordArray(Buffer)[i]);

  ChkSum := (ChkSum shr 16) + (ChkSum and $FFFF);
  //  ChkSum := (not ChkSum) and $FFFF;
  ChkSum := ChkSum + (Chksum shr 16);

  Result := Word(ChkSum);
end;


procedure BuildHeaders(FromIP : string; iFromPort : Word; ToIP : string;
iToPort : Word; StrMessage : string; var Buf : TPacketBuffer;
var remote : TSockAddr; var iTotalSize: Word; Flags: Byte; Sequ: DWORD; Ack: DWORD);
var
  dwFromIP : LongWord;
  dwToIP : LongWord;

  iIPVersion : Word;
  iIPSize : Word;
  ipHdr : T_IP_Header;
  tcpHdr: TCP_RHDR;
  ptcpHdr: TCP_PHDR;

  iTcpSize : Word;
  iTCPChecksumSize : Word;

  cksum : Word;

  Ptr : ^Byte;

  procedure IncPtr(Value : Integer);
  begin
    ptr := pointer(integer(ptr) + Value);
  end;

begin
  // ??????????? ip ??????

  dwFromIP := inet_Addr(PChar(FromIP));
  dwToIP := inet_Addr(PChar(ToIP));

  ptcphdr.SrcIP:=dwFromIP;
  ptcphdr.DestIP:=dwtoIP;
  ptcphdr.Zero:=0;
  ptcphdr.Protocol:=6;

  tcphdr.SrcPort:=htons(iFromPort);
  tcphdr.DestPort:=htons(iToPort);
  tcphdr.SequenceNr:=Sequ;
  tcphdr.AckNumber:=Ack;
  tcphdr.LenResvFlags:=$50 + Flags shl 8;
  tcphdr.WindowSize:=htons(64000);
  tcphdr.Checksum:=0;
  tcphdr.UrgentPtr:=0;

  iTotalSize := sizeof(iphdr) + sizeof(tcphdr) + length(StrMessage);

  iIPVersion := 4;
  iIPSize := sizeof(ipHdr) div sizeof(LongWord);
  //
  // IP version goes in the high order 4 bits of ip_verlen. The
  // IP header length (in 32-bit words) goes in the lower 4 bits.
  //
  ipHdr.ip_verlen := (iIPVersion shl 4) or iIPSize;
  ipHdr.ip_tos := 0; // IP type of service
  ipHdr.ip_totallength := htons(iTotalSize); // Total packet len
  ipHdr.ip_id := 0; // Unique identifier: set to 0
  ipHdr.ip_offset := 0; // Fragment offset field
  ipHdr.ip_ttl := 128; // ????? ????? ??????
  ipHdr.ip_protocol := $06; // Protocol(TCP)
  ipHdr.ip_checksum := 0 ; // IP checksum
  ipHdr.ip_srcaddr := dwFromIP; // Source address
  ipHdr.ip_destaddr := dwToIP; // Destination address
  //
  // ?????????????? ????????? UDP ??????
  //
  iTcpSize := sizeof(tcpHdr) + length(strMessage);
  ptcphdr.TCPLen:=htons(iTcpSize); // TCP length

  //
  // Build the UDP pseudo-header for calculating the UDP checksum.
  // The pseudo-header consists of the 32-bit source IP address,
  // the 32-bit destination IP address, a zero byte, the 8-bit
  // IP protocol field, the 16-bit UDP length, and the UDP
  // header itself along with its data (padded with a 0 if
  // the data is odd length).
  //
  iTcpChecksumSize := 0;

  ptr := @buf[0];
  FillChar(Buf, SizeOf(Buf), 0);

  // Pseudo TCP Header
  Move(ptcphdr,ptr^,SizeOf(ptcphdr));
  IncPtr(SizeOf(ptcphdr));
  iTcpChecksumSize := iTcpChecksumSize + sizeof(ptcphdr);

  // TCP Header
  Move(tcphdr,ptr^,SizeOf(tcphdr));
  IncPtr(SizeOf(tcphdr));
  iTcpChecksumSize := iTcpChecksumSize + sizeof(tcphdr);

  // Message
  Move(StrMessage[1],ptr^,Length(StrMessage));
  IncPtr(Length(StrMessage));
  iTcpChecksumSize := iTcpChecksumSize + length(StrMessage);

  if iTcpChecksumsize mod 2 = 1 then inc(iTcpCheckSumSize);

  cksum := csum(buf, iTcpChecksumSize div 2);
  tcpHdr.Checksum := cksum;

  //
  // Now assemble the IP and UDP headers along with the data
  // so we can send it
  //
  FillChar(Buf, SizeOf(Buf), 0);
  Ptr := @Buf[0];

  Move(ipHdr, ptr^, SizeOf(ipHdr)); IncPtr(SizeOf(ipHdr));
  Move(tcpHdr, ptr^, SizeOf(tcpHdr)); IncPtr(SizeOf(tcpHdr));
  Move(StrMessage[1], ptr^, length(StrMessage));

  // Apparently, this SOCKADDR_IN structure makes no difference.
  // Whatever we put as the destination IP addr in the IP header
  // is what goes. Specifying a different destination in remote
  // will be ignored.
  //
  remote.sin_family := AF_INET;
  remote.sin_port := htons(iToPort);
  remote.sin_addr.s_addr := dwToIP;
end;

function SendTCPPacket(FromIP : string; iFromPort : Word; ToIP : string;
iToPort : Word; StrMessage : string; Flags: Byte; Sequ: DWORD; Ack: DWORD):boolean;
var
  sh : TSocket;
  bOpt : Integer;
  ret : Integer;
  Buf : TPacketBuffer;
  Remote : TSockAddr;
  iTotalSize : Word;
  wsdata : TWSAdata;
begin
  // Startup Winsock 2
  result:=false;
  ret := WSAStartup($0002, wsdata);
  if ret<>0 then exit;
  try
    sh := Socket(AF_INET, SOCK_RAW, IPPROTO_UDP);
    if (sh = INVALID_SOCKET) then exit;

    bOpt := 1;
    ret := SetSockOpt(sh, IPPROTO_IP, IP_HDRINCL, @bOpt, SizeOf(bOpt));
    if ret = SOCKET_ERROR then exit;

    BuildHeaders( FromIP, iFromPort, ToIP, iToPort, StrMessage, Buf, Remote, iTotalSize, Flags, Sequ, Ack );

    ret := SendTo(sh, buf, iTotalSize, 0, Remote, SizeOf(Remote));
    if ret = SOCKET_ERROR then exit;

    CloseSocket(sh);
  finally
    WSACleanup;
  end;
  result:=true;
end;

end.

