unit UColorMapping;

interface

uses
  Classes, Inifile, RegExpr, SysUtils;

type
  TColorMapping = class(TObject)
  private
    map: TStringlist;
  public
    constructor Create(FileName: TFileName);
    destructor Destroy; override;
    procedure Replace(var a: string);
    function Help: string;
  end;

implementation

uses
  Unit1;

{ TColorMapping }

constructor TColorMapping.Create(FileName: TFileName);
begin
  map := TStringlist.Create;
  map.LoadFromFile(FileName);
end;

destructor TColorMapping.Destroy;
begin
  map.Free;
  inherited;
end;

function TColorMapping.Help: string;
var
  i: Integer;
  s: TStringlist;
begin
  s := TStringlist.Create;
  result := '';
  try
    for i := 0 to map.Count - 1 do
      if pos('=', map[i]) > 0 then
      begin
        Split(map[i], '=', s);
        result := result + '$' + s[0] + ' - nickname of player ' + s[1] + cr;
      end;
  finally
    s.free;
  end;
  if map.Count = 0 then
    result := 'none' + cr;
end;

procedure TColorMapping.Replace(var a: string);
var
  i: Integer;
  s: TStringlist;
begin
  s := TStringlist.Create;
  try
    for i := 0 to map.Count - 1 do
      if pos('=', map[i]) > 0 then
      begin
        Split(map[i], '=', s);
        a := ReplaceRegExpr('\$' + Trim(s[0]), a,
          WC3Banlist_Main.PlayerName(strtoint(Trim(s[1])) - 1));
      end;
  finally
    s.free;
  end;
end;

end.
