unit ULatencyPlots;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PingPlotDrawer, ExtCtrls;

type
  TfrmLatencyPlots = class(TForm)
    Image: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    PlotDrawer: TPingPlotDrawer;
  end;

var
  frmLatencyPlots: TfrmLatencyPlots;

implementation

uses unit1;

{$R *.dfm}

procedure TfrmLatencyPlots.FormCreate(Sender: TObject);
begin
  PlotDrawer := TPingPlotDrawer.Create(Image.Picture.Bitmap.Canvas);
  DoubleBuffered := true;   
end;

procedure TfrmLatencyPlots.FormDestroy(Sender: TObject);
begin
  PlotDrawer.Free;
end;

procedure TfrmLatencyPlots.FormResize(Sender: TObject);
begin
  Image.Picture.Bitmap.Height := ClientHeight;
  Image.Picture.Bitmap.Width := ClientWidth;
  PlotDrawer.Draw(Image.ClientRect);
end;

procedure TfrmLatencyPlots.FormShow(Sender: TObject);
begin
  icd.LoadCoords(self);
end;

procedure TfrmLatencyPlots.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  icd.SaveCoords(self);
end;

end.
