unit UfrmDetector;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Zniffer, StdCtrls, ComCtrls, ImgList, ExtCtrls, UPacketReceiver,
  VirtualTrees, pcap, Inifile;

  
type
  TfrmNICDetector = class(TForm)
    Panel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnDetect: TButton;
    vst: TVirtualStringTree;
    btnExit: TButton;
    ImageList: TImageList;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Refresh;
    procedure Timer1Timer(Sender: TObject);
    procedure btnDetectClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure vstGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure vstGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vstBeforeCellPaint(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      CellRect: TRect);
    procedure btnExitClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    z: TZniffer;
    count: Integer;
    detecting: boolean;
    sniffers: array of TPacketReceiver;
    { Public-Deklarationen }
  end;

implementation

uses unit1;

{$R *.dfm}

procedure TfrmNICDetector.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  SetFormFont(self, defaultFont, defaultFontSize);
  try
    z := TZniffer.Create;
    count := z.AdapterDesc.Count;
    detecting := false;
    setlength(sniffers, count);
    for i := 0 to Count - 1 do
    begin
      sniffers[i] := TPacketReceiver.Create(i);
      vst.AddChild(nil);
    end;
  except
  end;
end;

procedure TfrmNICDetector.FormDestroy(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to count - 1 do
    sniffers[i].Free;
  z.Free;
end;

procedure TfrmNICDetector.Refresh;
begin
  vst.Invalidate;
end;

procedure TfrmNICDetector.Timer1Timer(Sender: TObject);
begin
  Refresh;
end;   

procedure TfrmNICDetector.btnDetectClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to count - 1 do
    sniffers[i].sniff;
  btnDetect.Enabled := false;
  btnDetect.Caption := 'Detecting...';
end;

procedure TfrmNICDetector.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  timer1.Enabled := false;
end;

procedure TfrmNICDetector.vstGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
begin
  if Column = 0 then
    ImageIndex := 0;
end;

procedure TfrmNICDetector.vstGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
  Column: TColumnIndex; TextType: TVSTTextType; var CellText: WideString);
begin
  case Column of
    0:  CellText := z.AdapterDesc[node.index];
    1:
      begin
        if sniffers[node.Index].sniffer.Snooping then
          CellText := 'yes'
        else
          CellText := 'no';
      end;
    2:  CellText := inttostr(sniffers[node.index].trafficAny);
    3:  CellText := inttostr(sniffers[node.index].trafficPPPoE);
    4:  CellText := inttostr(sniffers[node.index].trafficTCPin);
    5:  CellText := inttostr(sniffers[node.index].trafficTCPout);
    6:  CellText := inttostr(sniffers[node.index].trafficUDPin);
    7:  CellText := inttostr(sniffers[node.index].trafficUDPout);
    8:  CellText := inttostr(sniffers[node.index].trafficWC3in);
    9:  CellText := inttostr(sniffers[node.index].trafficWC3out);
  end;
end;

procedure TfrmNICDetector.vstBeforeCellPaint(Sender: TBaseVirtualTree;
  TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  CellRect: TRect);
begin
  if (sniffers[node.index].trafficWC3out > 0) and (sniffers[node.index].trafficWC3out > 0)
  then with TargetCanvas do begin
    Brush.Color := clLime;
    FillRect(CellRect);
  end;
end;

procedure TfrmNICDetector.btnExitClick(Sender: TObject);
begin
  close;
end;

end.
