unit WC3Types;

interface

uses Windows, hookdefs, sysutils;

const

  noyes: array[0..1] of string = ('no', 'yes');
  sListType: array[0..2] of string = ('Banlist', 'Safelist', 'VIP-list');
  lvGameColors: array[0..11] of Cardinal = ($000000F8, $00F84000, $00B8E420,
    $00780050, $0000F8F8, $001088F8, $0000BC20, $00A858D8, $00909490, $00E8BC78,
    $00406010, $00002848);

type

  TGameState = (gsChat, gsLobby, gsCountDown, gsLoading, gsInGame);

  TCheckResult = (crNothing, crBan, crNote, crVIP);

  TWhisperType = (wtNote, wtIn, wtOut, wtError, wtEmoteIn, wtEmoteOut,
    wtChatOut, wtChatIn, wtBNetInfo, wtBNetError, wtChatBlizz, wtStyle, wtNull);

  TWBPosition = (wbPosBottom, wbPosTop, wbPosRight);

  TPlayerCon = record
    ip: longword;
    port: word;
    id: byte;
    name: string[30];
    connected: boolean;
  end;

  PPlayerCon = ^TPlayerCon;

  TKickCon = record
    con: PPlayerCon;
    sendADLMessage: boolean;
  end;

  PKickCon = ^TKickCon;

  IPArray = array[0..10] of longword;

  TScreenEntry = record
    w, h: integer;
    x, y: integer;
    str: string[255];
    f: TDX2DFont_Modify;
    alpha: byte;
    l: integer;
  end;

  TRealm = record
    name: string;
    ip: dword;
  end;

  PRealm = ^TRealm;

  TBanBuddiesBanlist = record
    nickname: string;
    comment: string;
    source: string;
    imageindex: integer;
    data: Pointer;
  end;

  PBanBuddiesBanlist = ^TBanBuddiesBanlist;

  PLogEntry = ^TLogEntry;
  TLogEntry = record
    text: String;
    icon: Integer;
    nick: String;
  End;

  TListType = (ltBanlist, ltSafelist, ltVipList);

  function ScoreToStr(d: double): String;
  function RatingToStr(r: Integer): String;
  function TimeToDuration(t: longword) : String;
  function CheckNicknameSpelling(n: string): boolean;
  function HTTPEncode(const AStr: string): string;

implementation

  function ScoreToStr(d: double): String;
  begin
    result := Format('%.1f',[round(d * 10) / 10]);
  end;

  function RatingToStr(r: Integer): String;
  begin
   if r = 0 then result := ''
   else if r > 0 then result := '+ '+inttostr(r) else result := '- '+inttostr(r*-1);
  end;

  function TimeToDuration;
  var
    s: longword;
  begin
    s := t div 1000;
    result := Format('%.2d:%.2d:%.2d', [s div 3600, (s mod 3600) div 60, s mod 60]);
  end;

  function CheckNicknameSpelling(n: string): boolean;
  var
    i: integer;
  begin
    if length(n) = 0 then
      result := false
    else
      result := true;
    n := lowercase(n);
    for i := 1 to length(n) do
      if not (n[i] in ['0'..'9', 'a'..'z', '.', '_', '[', ']', '(', ')', '-'])
        then
      begin
        result := false;
        break;
      end;
  end;

  function HTTPEncode(const AStr: string): string;
  const
    NoConversion = ['A'..'Z', 'a'..'z', '*', '@', '.', '_', '-'];
  var
    i: Cardinal;
    c: Char;
  begin
    result := '';
    for i := 1 to length(AStr) do
    begin
      c := AStr[i];
      if c in NoConversion then
        result := result + c
      else if c = ' ' then
        result := result + '+'
      else
        result := result + Format('%%%.2x', [Ord(c)]);
    end;
  end;

end.
