unit WebAccess;

interface

uses
  Classes, IdHTTP, ProxyInfo, IdComponent, RegExpr, SysUtils;

type
  TWebAccess = class(TThread)
  private
    { Private-Deklarationen }
  protected
    procedure Execute; override;
    procedure ShowMessage;
  public
    PlayerName: String;
  end;

var
  _message: String;
  _icon: Integer;

implementation

Uses Unit1;

{ TWebAccess }

procedure TWebAccess.Execute;
var
  idhttp1: TidHTTP;
  proxy: string;
  port: Integer;
  data: String;
  URL: String;
  re: TRegExpr;
begin
  inherited;
  idhttp1 := TidHTTP.Create(WC3Banlist_Main);
  re := TRegExpr.Create;
  // Set Proxy
  if WC3Banlist_Main.chkproxy.Checked then
  begin
    getproxyserver('http', proxy, port);
    idhttp1.ProxyParams.ProxyServer := proxy;
    idhttp1.ProxyParams.ProxyPort := port;
  end
  else
  begin
    idhttp1.ProxyParams.ProxyServer := '';
    idhttp1.ProxyParams.ProxyPort := 0;
  end;
  try
    try
      if lastRealm = 'unknown realm' then
      begin
        _icon := ICON_ERROR;
        _message := 'You''re playing on an unknown realm.';
        Synchronize(ShowMessage)
      end else
      if WC3Type = 0 then
      begin
        _icon := ICON_ERROR;
        _message := 'Unknown type of Warcraft III.';
        Synchronize(ShowMessage)
      end else
      begin
        case WC3Type of
          1: URL := 'http://www.battle.net/war3/ladder/war3-player-profile.aspx?Gateway=' +
            lastRealm + '&PlayerName=' + PlayerName;
          2: URL := 'http://www.battle.net/war3/ladder/w3xp-player-profile.aspx?Gateway=' +
            lastRealm + '&PlayerName=' + PlayerName;
        end;
        data := idhttp1.Get(URL);
        re.Expression := 'W3.(\d)\.gif';
        if re.Exec(data) then
        begin
          _icon := ICON_NOTE;
          _message := PlayerName + ' has rank '+re.Match[1]+' on '+lastRealm+'.';
        end else begin
          _icon := ICON_MESSAGE;
          _message := 'Could not find out '+PlayerName+'''s rank.';
        end;
        Synchronize(ShowMessage);
      end;
    finally
      idhttp1.Free;
      re.Free;
    end;
  except
    on e: Exception do
    begin
      _icon := ICON_ERROR;
      _message := 'Querying '+PlayerName+'''s profile failed. ('+e.Message+')';
      Synchronize(ShowMessage);
    end;
  end;
end;

procedure TWebAccess.ShowMessage;
begin
  with WC3Banlist_Main do begin
    AddMessage(_message, _icon);
    Sound(SND_RESPONSE);
  end;
end;

end.
