unit runandwait;

interface

uses
  Windows, Registry, Dialogs, Classes, SysUtils;

var
  aProcessInfo: PROCESS_INFORMATION;
  aProcessSecAttr: SECURITY_ATTRIBUTES;
  aThreadSecAttr: SECURITY_ATTRIBUTES;
  aStartupInfo: STARTUPINFO;

function RunApp(commandLine: String; Visibility: integer): integer; overload;
function RunApp(commandLine: String; Visibility: integer; dir:string): integer; overload;
procedure CloseProcessHandles;

implementation

function RunApp(commandLine: String; Visibility: integer): integer; overload;
begin
 result:=RunApp(commandLine, visibility,'');
end;

function RunApp(commandLine: String; Visibility: integer; dir:string): integer;
var
  n: Boolean;
  d:pchar;
begin
  with aProcessSecAttr do
  begin
    bInheritHandle := False;
    lpSecurityDescriptor := nil;
    nLength := sizeOf(aProcessSecAttr);
  end;

  with aThreadSecAttr do
  begin
    bInheritHandle := False;
    lpSecurityDescriptor := nil;
    nLength := sizeOf(aThreadSecAttr);
  end;

  with aStartupInfo do
  begin
    cb := sizeOf(aStartupInfo);
    lpReserved := nil;
    lpDesktop := nil;
    lpTitle := nil;
    dwX := 0;
    dwY := 0;
    dwXSize := 300;
    dwYSize := 300;
    dwXCountChars := 80;
    dwYCountChars := 25;
    dwFillAttribute := 0;
    dwFlags := STARTF_USESTDHANDLES;
    wShowWindow := VISIBILITY;
    cbReserved2 := 0;
    lpReserved2 := nil;
    hStdInput := 0;
    hStdError := 0;
    hStdOutput := 0;
  end;
  if dir<>'' then d:=pchar(dir) else d:=nil;
  n := CreateProcess(nil, @commandLine[1], nil, nil,
                     True, CREATE_NO_WINDOW + NORMAL_PRIORITY_CLASS,
                     nil,d, aStartupInfo, aProcessInfo);

  If n Then
    RunApp := aProcessInfo.hProcess
  Else 
    RunApp := -1; 
end; 

procedure CloseProcessHandles;
begin
  CloseHandle(aProcessInfo.hThread);
  CloseHandle(aProcessInfo.hProcess);
end;

end.
