unit Unit1;

{$R ExecutionLevelAdmin.res}

interface

uses
  pcap, ShellApi, Inifile, Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, winsock, StdCtrls, Zniffer, ExtCtrls, ComCtrls,
  ImgList, Buttons, MMsystem, IniObject, Menus, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, Sockets, IdSimpleServer, IdTCPServer,
  Registry, RunAndWait, SyncObjs, Unit3, TCPSend, OleCtrls, SHDocVw, ToolWin,
  Unit4, GameData, regexpr, activex, Packet32, UPacket, jpeg,
  OneInst, PlayerInfo, PacketKeeper, ProxyInfo, WC3Types, RealmThread,
  CommCtrl, Pinger, VirtualTrees, hookdefs, Raw_Ping,
  JvgPage, PhraseKeeper, JclStrings, CoolTrayIcon, HotKeyReceiver,
  XMLDoc, XMLIntf, ServerList, StringCache, UMessageCenter, Diagnosis,
  UColorMapping, UCountryCache, WebAccess, IdCustomTCPServer, IdContext,
  IdSchedulerOfThread, ULoginData, md5, UUpdateChecker, IdHTTP,
  UfrmUpdate, UReserve, URestore, madExceptVcl, AppEvnts, SelectDirectory,
  PngImage, Resources, JvNavigationPane, JvPageList, JvExControls,
  JvComponent, UListContainer, UfrmDetector, Wizard, UMapInfo, PsApi,
  PingThread, mshtml, clipbrd, imm, UAutoRefresh, UExeFromWnd, IPHLPAPI, IPRtrMib,
  UVistaFuncs, ULatency, ULatencyPlots, PingPlotDrawer, UIPToCountry;

const
  CURRENT_VERSION = '3.1 beta';

  ICON_INFO = 0;
  ICON_NETWORK = 1;
  ICON_CONFIG = 2;
  ICON_WC3 = 3;
  ICON_TFT = 4;
  ICON_WORLD = 5;
  ICON_DX = 6;
  ICON_MESSAGE = 7;
  ICON_SEARCH = 8;
  ICON_ERROR = 9;
  ICON_NOTE = 10;
  ICON_STAR = 11;

  WM_RESTORE = WM_USER + 1;
  WM_NEWVERSION = WM_USER + 3;

  BATTLE_NET_PORT = 6112;
  SND_ALERT = 0;
  SND_BAN = 1;
  SND_MISC = 2;
  SND_RESPONSE = 3;
  SND_LEAVER = 4;
  SND_SAMEIP = 5;
  SND_WHISPER = 6;
  SND_GAMESTART = 7;
  SND_SAFELIST = 8;
  SND_INFO = 9;
  SND_VIP = 10;
  _VER = '25';
  SoundEntries: array[0..10] of string =
  ( 'Banned player joins',
    'Player banned',
    'Misc Sound',
    'Response Sound',
    'Player leaves',
    'Same IP Sound',
    'Whisper Sound',
    'Game countdown started',
    'Not safelisted player joins',
    'Info found',
    'VIP joins');

  DefaultSounds: array[0..10] of string = (
    'Banned player joins.wav',
    'Player got banned.wav',
    '',
    'Response Sound.wav',
    'Player leaves.wav',
    'Same IP Sound.wav',
    'Whisper Sound.wav',
    'Game countdown started.wav',
    'Not safelisted player joins.wav',
    'Info found.wav',
    'VIP joins.wav'
  );

  WC3BANLISTCOMMANDS =
    '|/test|/ss|/screenshot|/checkchannel|/i|/info|/ban'+
    '|/unban|/uninfo|/check|/banlast|/last|/nodl|/autokick'+
    '|/ping|/from|/rank|/fromall|/pingall|/lm|/checkall'+
    '|/fromlast|/pinglast|/p|/ph|/phrase|/anyfrom|/np|/reserve'+
    '|/showreservations|/notwhispered|/sr|/nw|/rate|/refresh|/lat|/latall|';

type
  PMenuEntry = ^TMenuEntry;
  TMenuEntry = record
    caption: string;
    icon: integer;
    command: integer;
  End;

  PGameNodeData = ^TGameNodeData;
  TGameNodeData = record
    Slot: Integer;
    Nick: String;
    From: String;
    Ping: Integer;
    Latency: Cardinal;
    Deviation: Cardinal;
    Score: Double;
    Rating: Integer;
    Ban: String;
    Info: String;
    Online: String;
    HasLeft, HasWhispered, HasLostConnection, IsFriend, IsHost: Boolean;
    Color: Integer;
  End;

  TSettingsPage = record
    caption: string;
    page: TGroupBox;
  end;

  TWCScreen = record
    fg, dc: Thandle;
    c: tcanvas;
    wx: Integer;
    dx: Integer;
    entries: TList;
    loops: Cardinal;
  end;

  TWC3Banlist_Main = class(TForm)
    pages: TPageControl;
    ilBanlist: TImageList;
    tabPreferences: TTabSheet;
    open1: TOpenDialog;
    tabOnlineBanlists: TTabSheet;
    TabSheet5: TTabSheet;
    PaketTimer: TTimer;
    TabData: TTabSheet;
    Label26: TLabel;
    username: TLabel;
    Label28: TLabel;
    bnip: TLabel;
    Label27: TLabel;
    lport: TLabel;
    ilSpeedButtons: TImageList;
    save1: TSaveDialog;
    panDebug: TGroupBox;
    Label18: TLabel;
    gameport: TLabel;
    panSync: TGroupBox;
    banlistnl: TCheckBox;
    tvOptions: TTreeView;
    panMisc: TGroupBox;
    chkBanlast: TCheckBox;
    edtBanLast: TEdit;
    lblBanlistNL: TLabel;
    tabSnooping: TTabSheet;
    WarcraftWindowTimer: TTimer;
    FlickerTimer: TTimer;
    chkBuddiesList: TCheckBox;
    edtBlLogin: TEdit;
    edtBlPassword: TEdit;
    pagesBanlist: TPageControl;
    pgBlBuddyList: TTabSheet;
    panPhrases: TGroupBox;
    memoPhraseText: TMemo;
    Label21: TLabel;
    tabMessages: TTabSheet;
    Font1: TFontDialog;
    panAntiDownload: TGroupBox;
    Label33: TLabel;
    chkAntiDownload: TCheckBox;
    panNICSettings: TGroupBox;
    chkPromi: TCheckBox;
    panMessaging: TGroupBox;
    chkRunningText: TCheckBox;
    chkTransparent: TCheckBox;
    chkClipboard: TCheckBox;
    chkBringToFront: TCheckBox;
    edtFont: TEdit;
    Label35: TLabel;
    edtXSL: TEdit;
    ilSettings: TImageList;
    chkMultipleIP: TCheckBox;
    TabSheet7: TTabSheet;
    chkProxy: TCheckBox;
    webHelp: TWebBrowser;
    cbXSL: TComboBox;
    Label6: TLabel;
    Label38: TLabel;
    panCustomComments: TGroupBox;
    Label39: TLabel;
    Label40: TLabel;
    lvVariables: TListView;
    Label41: TLabel;
    lvComments: TListView;
    btnAddComment: TSpeedButton;
    btnDeleteComment: TSpeedButton;
    edtComment: TEdit;
    popPhrases: TPopupMenu;
    RemovePhrase1: TMenuItem;
    AddPhrase1: TMenuItem;
    N5: TMenuItem;
    AssignF5: TMenuItem;
    AssignF6: TMenuItem;
    AssignF7: TMenuItem;
    AssignF8: TMenuItem;
    AssignHotkey1: TMenuItem;
    AssignF2: TMenuItem;
    AssignF3: TMenuItem;
    AssignF4: TMenuItem;
    AssignF9: TMenuItem;
    Label42: TLabel;
    vstBuddy: TVirtualStringTree;
    gbPacketGeneration: TGroupBox;
    chkWinSock: TRadioButton;
    chkWinPCap: TRadioButton;
    panAutoKick: TGroupBox;
    chkAutoKick: TCheckBox;
    Label43: TLabel;
    lvAutoKick: TListView;
    btnAddAutoKickRule: TSpeedButton;
    btnDelAutoKickRule: TSpeedButton;
    Label4: TLabel;
    Label44: TLabel;
    edtAKKeyword: TEdit;
    chkAKLocal: TCheckBox;
    chkAKServerBanlists: TCheckBox;
    edtAKBB: TEdit;
    Label45: TLabel;
    edtPhraseName: TEdit;
    Label20: TLabel;
    pagesPhrases: TJvgPageControl;
    tabPhrases: TTabSheet;
    tabHotkeys: TTabSheet;
    btnPhraseInfo: TSpeedButton;
    btnDeletePhrase: TSpeedButton;
    btnAddPhrase: TSpeedButton;
    lvPhrases: TListView;
    Label46: TLabel;
    lvHotkeys: TListView;
    radGDI: TRadioButton;
    radDirectX: TRadioButton;
    RemoveHotkey1: TMenuItem;
    N6: TMenuItem;
    lblPhraseMessage: TLabel;
    chkADLWhisper: TCheckBox;
    edtADLText: TEdit;
    Label25: TLabel;
    Label48: TLabel;
    chkMinToTray: TCheckBox;
    cool: TCoolTrayIcon;
    mnuTray: TPopupMenu;
    mnuShowMain: TMenuItem;
    N7: TMenuItem;
    mnuClose: TMenuItem;
    lblServerLists: TLabel;
    lvOnlineLists: TListView;
    btnLoadFromXML: TSpeedButton;
    btnDeleteServerList: TSpeedButton;
    btnEnableServerlist: TSpeedButton;
    btnDisableServerlist: TSpeedButton;
    chkAKServerSafelists: TCheckBox;
    panError: TPanel;
    btnCloseErrorPanel: TSpeedButton;
    memoError: TMemo;
    panChatLine: TPanel;
    edtMessage: TEdit;
    panChannel: TPanel;
    panChatHeader: TPanel;
    tvChannel: TTreeView;
    ilChat: TImageList;
    btnChatmode: TSpeedButton;
    SplitterChannel: TSplitter;
    chkChatMode: TCheckBox;
    btnClearMessages: TSpeedButton;
    chkCloseOnLeaver: TCheckBox;
    radAutoCloseHostOnly: TRadioButton;
    radAutoCloseHostAndClient: TRadioButton;
    ilWarcraft: TImageList;
    btnReply: TButton;
    panParameters: TGroupBox;
    Label1: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    edtURLLogin: TEdit;
    edtURLUpload: TEdit;
    edtURLDownload: TEdit;
    MiscTimer: TTimer;
    chkFade: TCheckBox;
    chkSemiAutomaticJoin: TCheckBox;
    chkUpdate: TCheckBox;
    btnEnterLoginData: TButton;
    btnDoTransfers: TButton;
    btnSetFont: TButton;
    btnReadMore: TButton;
    lblApprovedHosts: TLabel;
    MadExceptionHandler: TMadExceptionHandler;
    chkTellSafelisted: TCheckBox;
    lblShitlist: TLabel;
    tmChatRefresh: TTimer;
    chkBackupOnlineLists: TCheckBox;
    panSounds: TGroupBox;
    panSoundInternal: TPanel;
    Label10: TLabel;
    lvSounds: TListView;
    barSound: TToolBar;
    OpenSound: TToolButton;
    EnableSound: TToolButton;
    DisableSound: TToolButton;
    HearSound: TToolButton;
    chkDoubleSlash: TCheckBox;
    panCommands: TPanel;
    webCmd: TWebBrowser;
    chkSwitchTabOnNewGame: TCheckBox;
    panDatabases: TGroupBox;
    Label11: TLabel;
    Label16: TLabel;
    Label29: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    btnAutoExportSaveTo: TSpeedButton;
    btnAutoExportRunAfterwards: TSpeedButton;
    chkCheckLocalDatabase: TCheckBox;
    chkBlBuddy: TCheckBox;
    chkBlServer: TCheckBox;
    radSafelistAll: TRadioButton;
    radSafelistEach: TRadioButton;
    edAutoExportTarget: TEdit;
    edAutoExportCommand: TEdit;
    chkSwitchToMessages: TCheckBox;
    Label23: TLabel;
    lblScreenshotLocation: TLabel;
    Label31: TLabel;
    edScreenshotDBLocation: TEdit;
    edScreenshotPattern: TEdit;
    btnScreenshotTarget: TSpeedButton;
    btnFileNamePattern: TSpeedButton;
    gbNIC: TGroupBox;
    cbNIC: TComboBox;
    btnDiagnostics: TButton;
    btnNICDetector: TButton;
    Label2: TLabel;
    Label32: TLabel;
    panGameTop: TPanel;
    Label12: TLabel;
    lblGameTimer: TLabel;
    btnGameRefresh: TButton;
    Label22: TLabel;
    lblGameTitle: TLabel;
    panTable: TPanel;
    splGameVert: TSplitter;
    splGameHoriz: TSplitter;
    Label47: TLabel;
    lblMap: TLabel;
    Label34: TLabel;
    Label51: TLabel;
    lblRealm: TLabel;
    pbLogo: TPaintBox;
    ilLog: TImageList;
    vtLog: TVirtualStringTree;
    edtNIC: TEdit;
    popLog: TPopupMenu;
    mnuLogCopy: TMenuItem;
    tabDatabase: TTabSheet;
    npDatabase: TJvNavigationPane;
    panBans: TJvNavPanelPage;
    panInfos: TJvNavPanelPage;
    panScores: TJvNavPanelPage;
    lblAddBan: TLabel;
    btnAddBan: TSpeedButton;
    btnEditBan: TSpeedButton;
    lblEditBan: TLabel;
    btnDeleteBan: TSpeedButton;
    lblDeleteBan: TLabel;
    btnExportSelectedBans: TSpeedButton;
    lblExportSelectedBans: TLabel;
    btnExportBans: TSpeedButton;
    lblExportBans: TLabel;
    btnImportBans: TSpeedButton;
    lblImportBans: TLabel;
    btnAddInfo: TSpeedButton;
    btnEditInfo: TSpeedButton;
    btnDeleteInfo: TSpeedButton;
    btnExportSelectedInfos: TSpeedButton;
    btnExportInfos: TSpeedButton;
    btnImportInfos: TSpeedButton;
    lblImportInfos: TLabel;
    lblExportInfos: TLabel;
    lblExportSelectedInfos: TLabel;
    lblDeleteInfo: TLabel;
    lblEditInfo: TLabel;
    lblAddInfo: TLabel;
    chkShowDeletedBans: TCheckBox;
    panTools: TJvNavPanelPage;
    Label63: TLabel;
    btnRestoreLocalDatabase: TButton;
    lblBanCount: TLabel;
    lblInfoCount: TLabel;
    chkShowDeletedInfos: TCheckBox;
    popInfos: TPopupMenu;
    mnuCreateInfo: TMenuItem;
    mnuEditSelectedInfo: TMenuItem;
    mnuDeleteSelectedInfos: TMenuItem;
    N3: TMenuItem;
    mnuExportSelectedInfos: TMenuItem;
    mnuExportInfos: TMenuItem;
    mnuImportInfos: TMenuItem;
    popBans: TPopupMenu;
    mnuCreateBan: TMenuItem;
    mnuEditBan: TMenuItem;
    mnuDeletedSelectedBans: TMenuItem;
    MenuItem4: TMenuItem;
    mnuExportSelectedBans: TMenuItem;
    mnuExportBans: TMenuItem;
    mnuImportBans: TMenuItem;
    panDB: TPanel;
    pgTools: TPanel;
    vtInfos: TVirtualStringTree;
    vtBans: TVirtualStringTree;
    panFilter: TPanel;
    edtFilter: TEdit;
    chkFiltered: TCheckBox;
    imgMagnifier: TImage;
    vtGame: TVirtualStringTree;
    popGame: TPopupMenu;
    mnuCreateEditBan: TMenuItem;
    mnuCreateEditInfo: TMenuItem;
    mnuPing: TMenuItem;
    mnuFrom: TMenuItem;
    N1: TMenuItem;
    mnuPingAll: TMenuItem;
    mnuFromAll: TMenuItem;
    N2: TMenuItem;
    mnuAddToFriendList: TMenuItem;
    N8: TMenuItem;
    mnuDeleteBan: TMenuItem;
    mnuDeleteInfo: TMenuItem;
    panSnoopingLeft: TPanel;
    lvLastEvents: TListView;
    lvReservations: TListView;
    Splitter3: TSplitter;
    popReserve: TPopupMenu;
    mnuDeleteReservation: TMenuItem;
    N9: TMenuItem;
    mnuClearReservations: TMenuItem;
    mnuAddFriend: TMenuItem;
    mnuAddPlayerInChannel: TMenuItem;
    mnuAddWholeChannel: TMenuItem;
    mnuAddTheWholeFriendList: TMenuItem;
    popChannel: TPopupMenu;
    mnuWhisperTo: TMenuItem;
    mnuReserveSlotForChanneler: TMenuItem;
    mnuReserveSlot: TMenuItem;
    N10: TMenuItem;
    mnuShowColorExplanations: TMenuItem;
    Label8: TLabel;
    btnResetFilter: TButton;
    panFriendlist: TGroupBox;
    Label14: TLabel;
    memoBuddies: TMemo;
    Label36: TLabel;
    gbWC3FriendList: TGroupBox;
    Label15: TLabel;
    lbWC3FriendList: TListBox;
    Label17: TLabel;
    mnuChannelToFriend: TMenuItem;
    chkPreventFlicker: TCheckBox;
    chkRefreshEvenWhenInGame: TCheckBox;
    panGames: TJvNavPanelPage;
    vtScores: TVirtualStringTree;
    vtGames: TVirtualStringTree;
    lblScoreCount: TLabel;
    lblGameCount: TLabel;
    edtNextGameID: TEdit;
    Label24: TLabel;
    Label30: TLabel;
    mnuOpenGameReview: TMenuItem;
    chkOpenReviewAfterGame: TCheckBox;
    Label64: TLabel;
    chkManageReplays: TCheckBox;
    Label19: TLabel;
    Label9: TLabel;
    Edit5: TEdit;
    lblReplayDataBaseLocation: TLabel;
    Label66: TLabel;
    edtReplayDatabase: TEdit;
    edtReplayFileNamePattern: TEdit;
    btnBrowseForReplayTarget: TSpeedButton;
    Label67: TLabel;
    edtLastReplay: TEdit;
    btnBrowseForLastReplayRoC: TSpeedButton;
    chkFirstRun: TCheckBox;
    btnEmptyRecycleBin: TSpeedButton;
    lblEmptyRecycleBin: TLabel;
    chkAlwaysUseWC3Friendlist: TCheckBox;
    chkOnlySaveReplayWhenBanned: TCheckBox;
    gbReservationsSettings: TGroupBox;
    radReservationsParse: TRadioButton;
    Label13: TLabel;
    radReservationsUseDefault: TRadioButton;
    btnEditMapList: TButton;
    edtHumanPlayerCount: TEdit;
    Label37: TLabel;
    N4: TMenuItem;
    mnuCopyNickname: TMenuItem;
    btnCopyOnlineListsError: TSpeedButton;
    memoPhraseHelp: TMemo;
    chkCollectMessages: TCheckBox;
    Label52: TLabel;
    Label53: TLabel;
    edtCleanUpDays: TEdit;
    Label54: TLabel;
    chkCleanUp: TCheckBox;
    chkEmptyRecycleBinOnShutdown: TCheckBox;
    Label55: TLabel;
    btnCleanUpScoresAndGames: TSpeedButton;
    Label56: TLabel;
    popGameEvent: TPopupMenu;
    mnuEventCopy: TMenuItem;
    mnuEventCopyNick: TMenuItem;
    mnuLogcopyNickName: TMenuItem;
    chkOptimizedPhrases: TCheckBox;
    chkAutomaticGameRefresh: TCheckBox;
    Label57: TLabel;
    tbARInterval: TTrackBar;
    edtARInterval: TEdit;
    Label58: TLabel;
    gbWinamp: TGroupBox;
    Label59: TLabel;
    Label60: TLabel;
    edtMPWindowClassName: TEdit;
    edtMPRegExp: TEdit;
    chkWinAPI: TRadioButton;
    Label61: TLabel;
    SnoopingRefresh: TTimer;
    gbPing: TGroupBox;
    lblPingTimeout: TLabel;
    edtPingTimeout: TEdit;
    btnSetPingTimeout: TButton;
    gbLatency: TGroupBox;
    Label3: TLabel;
    panBackgroundMessages: TPanel;
    webMsg: TWebBrowser;
    panTableBottom: TPanel;
    btnShowGameReview: TButton;
    btnShowLatencyPlots: TButton;
    mnuShowLatencyPlots: TMenuItem;
    chkLatencyInGame: TCheckBox;
    chkAutoLatencyPlots: TCheckBox;
    radSimplePlots: TRadioButton;
    radDetailedPlots: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure cbNICChange(Sender: TObject);
    procedure pagesChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit5KeyPress(Sender: TObject; var Key: Char);
    procedure Edit5Click(Sender: TObject);
    procedure PaketTimerTimer(Sender: TObject);
    procedure SendChatCommand(a: string);
    procedure lvSoundsChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure OpenSoundClick(Sender: TObject);
    procedure EnableSoundClick(Sender: TObject);
    procedure DisableSoundClick(Sender: TObject);
    procedure HearSoundClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnSyncClick(Sender: TObject);
    procedure tvOptionsChange(Sender: TObject; Node: TTreeNode);
    procedure lblBanlistNLClick(Sender: TObject);
    procedure FlickerTimerTimer(Sender: TObject);
    procedure WarcraftWindowTimerTimer(Sender: TObject);
    procedure btnAddPhraseClick(Sender: TObject);
    procedure lvPhrasesChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure edtPhraseNameChange(Sender: TObject);
    procedure memoPhraseTextChange(Sender: TObject);
    procedure btnDeletePhraseClick(Sender: TObject);
    procedure lvPhrasesMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnGameRefreshClick(Sender: TObject);
    procedure btnPhraseInfoClick(Sender: TObject);
    procedure lblSetFontClick(Sender: TObject);
    procedure chkWinSockClick(Sender: TObject);
    procedure lbXSLClick(Sender: TObject);
    procedure lbXSLKeyPress(Sender: TObject; var Key: Char);
    procedure memoBuddiesKeyPress(Sender: TObject; var Key: Char);
    procedure btnImportClick(Sender: TObject);
    procedure Edit4KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lvCommentsChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure btnAddCommentClick(Sender: TObject);
    procedure btnDeleteCommentClick(Sender: TObject);
    procedure edtCommentChange(Sender: TObject);
    procedure popPhrasesPopup(Sender: TObject);
    procedure AssignHotKey(Sender: TObject);
    procedure lvPhrasesResize(Sender: TObject);
    procedure lblClearMessagesMouseEnter(Sender: TObject);
    procedure lblClearMessagesMouseLeave(Sender: TObject);
    procedure lblClearMessagesClick(Sender: TObject);
    procedure lblLinkClick(Sender: TObject);
    procedure vstBuddyGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vstBuddyCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure vstBuddyHeaderClick(Sender: TVTHeader; Column: TColumnIndex;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure vstBuddyGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure lvAutoKickChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure btnDelAutoKickRuleClick(Sender: TObject);
    procedure btnAddAutoKickRuleClick(Sender: TObject);
    procedure edtAKKeywordChange(Sender: TObject);
    procedure chkAKLocalClick(Sender: TObject);
    procedure chkAKServerBanlistsClick(Sender: TObject);
    procedure edtAKBBChange(Sender: TObject);
    procedure tabHotkeysShow(Sender: TObject);
    procedure vstBuddyFreeNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode);
    procedure lvHotkeysDblClick(Sender: TObject);
    procedure radDirectXClick(Sender: TObject);
    procedure lblMoreAboutDirectXClick(Sender: TObject);
    procedure RemoveHotkey1Click(Sender: TObject);
    procedure lvChatCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure banlistnlClick(Sender: TObject);
    procedure mnuShowMainClick(Sender: TObject);
    procedure chkMinToTrayClick(Sender: TObject);
    procedure mnuCloseClick(Sender: TObject);
    procedure btnLoadFromXMLClick(Sender: TObject);
    procedure btnDeleteServerListClick(Sender: TObject);
    procedure btnEnableServerlistClick(Sender: TObject);
    procedure lvOnlineListsCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure btnCloseErrorPanelClick(Sender: TObject);
    procedure edtMessageKeyPress(Sender: TObject; var Key: Char);
    procedure btnChatmodeClick(Sender: TObject);
    procedure tvChannelDblClick(Sender: TObject);
    procedure btnDiagnosticsClick(Sender: TObject);
    procedure lblServerListsClick(Sender: TObject);
    procedure chkCloseOnLeaverClick(Sender: TObject);
    procedure btnReplyClick(Sender: TObject);
    procedure webMsgBeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure webMsgDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure MiscTimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure lblEnterLoginDataClick(Sender: TObject);
    procedure btnSetPingTimeoutClick(Sender: TObject);
    procedure chkBuddiesListClick(Sender: TObject);
    procedure webMsgImgClick(Sender: TObject);
    procedure EnableDraw;
    procedure DisableDraw;
    procedure tmChatRefreshTimer(Sender: TObject);
    procedure btnAutoExportSaveToClick(Sender: TObject);
    procedure btnAutoExportRunAfterwardsClick(Sender: TObject);
    procedure btnFileNamePatternClick(Sender: TObject);
    procedure btnScreenshotTargetClick(Sender: TObject);
    procedure lblScreenshotLocationClick(Sender: TObject);
    procedure pbLogoPaint(Sender: TObject);
    procedure vtLogGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vtLogGetNodeDataSize(Sender: TBaseVirtualTree;
      var NodeDataSize: Integer);
    procedure mnuLogCopyClick(Sender: TObject);
    procedure npDatabaseChange(Sender: TObject);
    procedure vtBansGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vtInfosGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vtBansCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure vtInfosCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure chkShowDeletedInfosClick(Sender: TObject);
    procedure chkShowDeletedBansClick(Sender: TObject);
    procedure vtBansPaintText(Sender: TBaseVirtualTree;
      const TargetCanvas: TCanvas; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType);
    procedure vtInfosPaintText(Sender: TBaseVirtualTree;
      const TargetCanvas: TCanvas; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType);
    procedure vtBansGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure vtInfosGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure btnEditBanClick(Sender: TObject);
    procedure btnDeleteBanClick(Sender: TObject);
    procedure btnAddInfoClick(Sender: TObject);
    procedure btnEditInfoClick(Sender: TObject);
    procedure btnDeleteInfoClick(Sender: TObject);
    procedure chkFilteredClick(Sender: TObject);
    procedure btnRestoreLocalDatabaseClick(Sender: TObject);
    procedure vtLogGetImageIndexEx(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer;
      var ImageList: TCustomImageList);
    procedure vtGameGetNodeDataSize(Sender: TBaseVirtualTree;
      var NodeDataSize: Integer);
    procedure vtGameBeforeCellPaint(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      CellRect: TRect);
    procedure vtGameGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure vtGameGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vtGamePaintText(Sender: TBaseVirtualTree;
      const TargetCanvas: TCanvas; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType);
    procedure lvLastEventsResize(Sender: TObject);
    procedure popGamePopup(Sender: TObject);
    procedure mnuPingAllClick(Sender: TObject);
    procedure mnuFromAllClick(Sender: TObject);
    procedure mnuPingClick(Sender: TObject);
    procedure mnuFromClick(Sender: TObject);
    procedure mnuCreateEditBanClick(Sender: TObject);
    procedure mnuCreateEditInfoClick(Sender: TObject);
    procedure vtGameDblClick(Sender: TObject);
    procedure mnuDeleteBanClick(Sender: TObject);
    procedure mnuDeleteInfoClick(Sender: TObject);
    procedure mnuClearReservationsClick(Sender: TObject);
    procedure popReservePopup(Sender: TObject);
    procedure mnuDeleteReservationClick(Sender: TObject);
    procedure mnuAddWholeChannelClick(Sender: TObject);
    procedure mnuAddTheWholeFriendListClick(Sender: TObject);
    procedure lvReservationsColumnClick(Sender: TObject;
      Column: TListColumn);
    procedure lvReservationsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuReserveSlotForChannelerClick(Sender: TObject);
    procedure popChannelPopup(Sender: TObject);
    procedure mnuShowColorExplanationsClick(Sender: TObject);
    procedure mnuAddToFriendListClick(Sender: TObject);
    procedure mnuReserveSlotClick(Sender: TObject);
    procedure lbWC3FriendListEndDrag(Sender, Target: TObject; X,
      Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure splGameVertMoved(Sender: TObject);
    procedure memoBuddiesDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure mnuChannelToFriendClick(Sender: TObject);
    procedure chkPreventFlickerClick(Sender: TObject);
    procedure btnNICDetectorClick(Sender: TObject);
    procedure vtGamesCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure vtGamesGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure vtGamesGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vtScoresGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure vtScoresCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure vtGamesDblClick(Sender: TObject);
    procedure vtScoresDblClick(Sender: TObject);
    procedure mnuOpenGameReviewClick(Sender: TObject);
    procedure lblReplayDataBaseLocationClick(Sender: TObject);
    procedure btnBrowseForReplayTargetClick(Sender: TObject);
    procedure btnBrowseForLastReplayRoCClick(Sender: TObject);
    procedure btnExportSelectedBansClick(Sender: TObject);
    procedure btnExportSelectedInfosClick(Sender: TObject);
    procedure btnImportBansClick(Sender: TObject);
    procedure btnImportInfosClick(Sender: TObject);
    procedure btnShowWizard(Sender: TObject);
    procedure btnEmptyRecycleBinClick(Sender: TObject);
    procedure btnAddBanClick(Sender: TObject);
    procedure btnEditMapListClick(Sender: TObject);
    procedure mnuCopyNicknameClick(Sender: TObject);
    procedure edtFilterChange(Sender: TObject);
    procedure vtScoresKeyPress(Sender: TObject; var Key: Char);
    procedure btnResetFilterClick(Sender: TObject);
    procedure btnCopyOnlineListsErrorClick(Sender: TObject);
    procedure btnCleanUpScoresAndGamesClick(Sender: TObject);
    procedure chkCollectMessagesClick(Sender: TObject);
    procedure lvLastEventsChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure mnuEventCopyClick(Sender: TObject);
    procedure mnuEventCopyNickClick(Sender: TObject);
    procedure lvLastEventsKeyPress(Sender: TObject; var Key: Char);
    procedure mnuLogcopyNickNameClick(Sender: TObject);
    procedure popLogPopup(Sender: TObject);
    procedure tbARIntervalChange(Sender: TObject);
    procedure chkAutomaticGameRefreshClick(Sender: TObject);
    procedure edtFileChange(Sender: TObject);
    procedure edtDirChange(Sender: TObject);
    procedure CreateParams(var Params: TCreateParams); override;
    procedure tvChannelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tvOptionsKeyPress(Sender: TObject; var Key: Char);
    procedure SnoopingRefreshTimer(Sender: TObject);
    procedure chkAntiDownloadClick(Sender: TObject);
    procedure btnShowLatencyPlotsClick(Sender: TObject);
    procedure chkLatencyInGameClick(Sender: TObject);
    procedure radSimplePlotsClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FZniffer: TZniffer;
    procedure ReadPacket(Data: pointer; recvbytes: Word; uTickCount: Int64);
    function CheckSpack(s: string; playsnd: boolean; var autokick: boolean):
      TCheckResult;
    procedure DoCommand(s: string);
    function Ban(spack: string; custom: boolean; note: boolean): boolean;
    function InMyIp(ip: string): boolean; overload;
    function SoundState(i: integer): boolean;
    function SoundFile(i: integer): string;
    procedure PingPlayer(n: string);
    procedure LoadSettingsPages;
    procedure InstallSettingsPages;
    procedure AddKickOrder(con: PPlayerCon; sendADLMessage: boolean);
    procedure BrowseForXSL;
    procedure WMRestore(var Message: TMessage); message WM_RESTORE;
    procedure WMNewVersion(var Message: TMessage); message WM_NEWVERSION;
    procedure SetFonts;
    procedure LoadPlayerInfo(f: string);
    procedure addServerList(Title, Realm, Url: string; Active: Boolean;
      BType: TListType);
    procedure loadServerList(l: TListItem);
    procedure OnServerListTransferError(Sender: TObject);
    procedure InitializeServerLists;
    procedure OnMessageChange(kind: TWhisperType);
    procedure GameOver;
    procedure WMSyscommand(var Message: TWmSysCommand); message WM_SYSCOMMAND;
  public
    FShowHoriz: Boolean;
    FShowVert: Boolean;
    Whispers: TList;
    SettingsPages: array of TSettingsPage;
    xml_messages: string;
    html_commands: string;
    html_help: string;
    function InMyIp(ip: dword): boolean; overload;
    procedure Kill(s: string);
    procedure AddMessage(s: string; ImageIndex: Integer; nick: String = '');
    procedure Sound(snd: integer);
    procedure WriteChatLine(s: string);
    procedure NewGame;
    function FindPlayerIP(var n: string): Cardinal;
    procedure SetdaMethod;
    function FindPlayer(s: string): PPlayerCon;
    procedure NavigateToWhisper;
    function IsBuddy(s: string): boolean;
    procedure AddToLog(s: string; imageIndex: Integer; nick: String = '');
    procedure AddGameEvent(s: string; nick: String = '');
    procedure ClearGameEvents;
    function DecodeIntArray(a: array of integer): string;
    function FindRealm(ip: dword): string;
    procedure InitRealmThread;
    procedure SubstituteComments(var c: string; pname: string);
    function CurrentTitleOfWinAMP: string;
    procedure PreparePhrases;
    function SubstPhrase(r: string; justInTime: Boolean): string;
    function FindPhrase(p: string): string; overload;
    function FindPhrase(hk: integer): string; overload;
    function RemoveErrorneousSubstitutions(phrase: String): String;
    procedure QueryBan(sender: TObject);
    procedure CreateBanSubmenu(parent: TMenuitem);
    procedure ClearWhispers(addFirst: boolean);
    procedure PingAll;
    procedure PingAllDone;
    function Buddy_addEntry: PBanBuddiesBanlist;
    procedure FromAll;
    procedure LatAll;
    procedure DoTests;
    function PlayerName(n: integer): string;
    function UnBan(n: string): boolean;
    function UnInfo(n: string): boolean;
    function Inject: boolean;
    function Uninject: boolean;
    procedure AddChatter(n: string);
    procedure RemoveChatter(n: string);
    procedure ClearChatters;
    procedure CheckChannel;
    procedure CheckAll;
    procedure SaveConfiguration;
    function CheckList(NickNames: TStringlist): boolean;
    function GetWindowState(h: THandle): Integer;
    procedure LeaverWhileCountdown;
    procedure GetHookPointers;
    procedure GetWarcraftType(h: THandle);
    procedure GetPlayerRank(PlayerName: string);
    procedure CheckFriendJoin(whisper: string);
    procedure CheckForUpdates;
    procedure SetPingTimeout(ms: Integer);
    function FilterWhitespaces(a: string): string;
    function NotWhispered: string;
    procedure AutoExport;
    function MakeScreenshot(comment: string): string;
    procedure CheckForImportOldDatabase;
    procedure RefreshLocalDatabase;
    procedure CountDatabaseEntries;
    procedure SetDatabaseVisibility;
    function ExecuteEditAddBanDialog(oldBan: PBan): PVirtualNode;
    function ExecuteEditAddInfoDialog(oldInfo: PInfo): PVirtualNode;
    function ExistsOnLocalBanlist(spack: String): PBan;
    function ExistsOnLocalInfoList(spack: String): PInfo;
    function IsInCurrentGame(nick: String): PGameNodeData;
    procedure RefreshReservations;
    procedure AddReservationForChanneler(Sender: TObject);
    function WC3IconIndex: Integer;
    procedure CancelServerListTransfers;
    procedure RatePlayer(nick: String; rating: Integer);
    procedure AddRating(nick: String; rating: Integer; previousScore: Integer; gameID: String);
    procedure OnGameStart;
    function MoveLastReplay: String;
    procedure CallNICDetector;
    function BrowseForWarcraftIIIDirectoy(var s: String): boolean;
    procedure SplitPhrase(p: String; commands: TStringlist; var phrase: String);
    procedure GetFreeSlotsDefaultValue(map: String);
    procedure SetHumanPlayerCountForException(mapname: String; humanPlayers: String);
    procedure CleanUpLocalDatabase(silent: boolean);
    procedure EmptyRecycleBin;
    procedure SetNewURLforServerList(newURL: String; ServerList: TServerList);
    function SubstPhraseBackwards(r: String): String;
    procedure SetAutoRefreshInterval;
    procedure Restore;
    procedure SetGameState(gs: TGameState);
    procedure ClearKickOrderList;
    procedure InitAndShowLatencyPlots;
  end;

function SendRSTPacket(ad: padapter; d: Pointer; FromIP: string; iFromPort:
  Word; ToIP: string;
  iToPort: Word; StrMessage: string; Flags: Byte; Sequ: DWORD; Ack: DWORD):
  boolean;
function FindConnection(ip: longword; port: word): PPlayerCon; overload;
function FindConnection(nick: String): PPlayerCon; overload;
function Scrolling(front: TWebBrowser): boolean;


// GLOBALS

var
  WC3Banlist_Main: TWC3Banlist_Main;
  ishost: boolean = false;
  // WinPCap Diagnosis
  adapter: padapter;
  pcapok: boolean = true;
  pcapsniffing: boolean = false;
  pcapfiltering: boolean = false;
  pcapsniffingsince: Cardinal;
  trafficTCP: boolean = false;
  trafficPPPoE: boolean = false;
  trafficWC3In: boolean = false;
  trafficWC3Out: boolean = false;
  // for BLACKLIST EXCHANGE
  exchangingBanlist: Boolean;
  entry: string;
  ver: string = '0';
  // ----------------------
  closing: boolean = false;
  myIP: IPArray;
  ipcount: word;
  exchangeip: string;
  f: NewIniFile;
  icd: IniControlData;
  pc: integer;
  cl: string;
  LastAck: DWORD = 0;
  LastSeq: DWORD = 0;
  loggedOn: Boolean = False;
  BN_IP: DWORD = 0;
  MY_IP: DWORD = 0;
  lastLeaver: string = '';
  lastJoiner: string = '';
  lastChat: string = '';
  lastHostName: String = '';
  ct: ClipThread;
  checkresult: string;
  LastHost: Longword = 0;
  scr: TWCScreen;
  cc: boolean = TRUE;
  gd: TGameData;
  mapinfo: TMapInfo;
  MarqueeFont: TFont;
  daMethod: integer = 0;
  GameStart: LongWord = 0;
  conList: Tlist;
  kickOrderList: TThreadList;
  messagesInUse: boolean = false; // stringlist in use (add/savetofile)
  loadComplete: boolean = false;
  navigating: boolean = false;
  pl: TPlayerList;
  comboKey: Word = 0;
  pk: TPacketKeeper;
  lbviewMode: Integer = 0;
  unWanted: TStringlist;
  realms: TThreadList;
  lastRealm: string = 'unknown realm';
  lastWhisperer: string = '';
  lastWhisperSender: string = '';
  lastSelectedSpack: string = '';
  lastGameTitle: string = '';
  lastMapName: string = '';
  lastMapSize: Cardinal;
  lastMessage: string = '';
  lastBannedList: TStringList;
  lastScreenShots: String = '';
  lastAutoRefreshName: String = '';
  lastGameID: String = '';
  lastGameCode: String = '';
  lastSelectedChannelPlayer: String = '';
  lastKicked: String = '';
  mnuShortcuts: array of TMenuItem;
  mnuBanSubitems: array of TMenuItem;
  ping: TPinger;
  deletedDXTexts: TList;
  phraseKeeper1: TPhraseKeeper;
  hookMode: Integer; // 0 no API hooking, 1 API hooking planned, 2 API hooked
  hookTries: Integer = -2; // -2 hook pointers need to be fetched, -1 failed
  HKReceiver: THotkeyReceiver;
  StringCache: TStringCache;
  flagChannelChangedToGame: boolean;
  HookID: THandle;
  ColorMapping: TColorMapping;
  CountryCache: TCountryCache;
  banlist: TBanlistThread;
  RealmThread: realmresolver;
  wc3open: boolean = false;
  wc3type: integer = 0;
  oldChatLine: string = '';
  refreshEnable: Boolean = true;
  forceRefresh: Boolean = false;
  latestChanges: string = '';
  latestVersion: string = '';
  slotInfo: array[0..32] of Integer;
  missingWhispers: Integer = -1;
  Reserve: TReserve;
  StartupTime: DWORD = 0;
  minimized: Boolean = false;
  res: TResources;
  ListContainer: TListContainer;
  showGameReview: Boolean = False;
  WC3Path: String = '';
  todoGetSlotCount: Boolean = False;
  todoSetHumanPlayerCountInParseExceptions: Boolean = false;
  autorefresher: TAutoRefresher;
  wasMaximized: Boolean = false;
  gameState: TGameState;
  latencyHandler: TLatencyHandler;
  latencyPlotMapping: Array[0..11] of Integer;

implementation

uses UfrmLog, Math, UfrmEditAdd, UfrmColorExplanations, UfrmGameReview,
  Variants;

{$R *.DFM}

procedure TWC3Banlist_Main.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle := Params.ExStyle and not WS_EX_TOOLWINDOW or
    WS_EX_APPWINDOW;
end;

procedure TWC3Banlist_Main.WMSyscommand(var Message: TWmSysCommand);
begin
  case (Message.CmdType and $FFF0) of
    SC_MINIMIZE:
      begin
        wasMaximized := WindowState = wsMaximized;
        ShowWindow(Handle, SW_MINIMIZE);
        if cool.MinimizeToTray then
        begin
          ShowWindowAsync(Getwindow(Handle, GW_OWNER), SW_HIDE);
          ShowWindowAsync(Handle, SW_HIDE);
          cool.IconVisible := true;
        end;
        Message.Result := 0;
      end;
    SC_RESTORE:
      begin
        ShowWindow(Handle, SW_RESTORE);
        if cool.MinimizeToTray and (WindowState = wsMinimized) then
        begin
          ShowWindowAsync(Handle, SW_SHOW);
          cool.IconVisible := false;
        end;
        if pages.ActivePage = tabMessages then
          NavigateToWhisper;
        Message.Result := 0;
      end;
  else
    inherited;
  end;
end;

function DecryptString(s: String): String;
var
  i, j: Integer;
  map: Byte;
  char: Byte;
  r: String;
begin
  i := 1;
  r := '';
  while (i <= length(s)) do
  begin
    if not Odd(Ord(s[i])) then break;
    map := Ord(s[i]) shr 1;
    inc(i);
    j := 7;
    while (j > 0) and (i <= length(s)) do
    begin
      char := Ord(s[i]);
      if not Odd(map) then dec(char);
      map := map shr 1;
      inc(i);
      dec(j);
      r := r + chr(char);
    end;
  end;
  result := r;
end;

function CompareListItemByLengthOfCaption(Item1, Item2: Pointer): Integer;
begin
  result := Length(TListItem(Item2).Caption) - Length(TListItem(Item1).Caption);
end;

function GetNodeAt(vst: TVirtualStringTree; data: Pointer): PVirtualNode;
var
  p: PVirtualNode;
  target: ^Pointer;
begin
  p := vst.GetFirst;
  while p<>nil do
  begin
    target := vst.GetNodeData(p);
    if data = target^ then
      break;
    p := vst.GetNext(p);
  end;
  result := p;
end;

procedure ScreenShot(Bild: TBitMap);
var
  c: TCanvas;
  h: THandle;
  r: TRect;
begin
  c := TCanvas.Create;
  h := FindWindow('Warcraft III', 'Warcraft III');
  if h = 0 then exit;
  c.Handle := GetWindowDC(h);
  try
    r := Rect(0, 0, Screen.Width, Screen.Height);
    Bild.Width := Screen.Width;
    Bild.Height := Screen.Height;
    Bild.Canvas.CopyRect(r, c, r);
  finally
    ReleaseDC(h, c.Handle);
    c.Free;
  end;
end;

function randomText: string;
const
  buchstaben =
    'abcdefghijklmnoprstuvwxyz1234567890!"$%&/()=?                             ';
begin
  result := '';
  while (random(100) < 90) do
    result := result + buchstaben[random(length(buchstaben)) + 1];
end;

function replace(text: string): string;
var
  i: integer;
  a: string;
begin
  a := '';
  for i := 1 to length(text) do
    case text[i] of
      '&': a := a + '&amp;';
      '<': a := a + '&lt;';
      '>': a := a + '&gt;';
      '''': a := a + '&apos;';
      '"': a := a + '&quot;';
    else
      a := a + text[i];
    end;
  result := a;
end;

function WB_ScrollTo(WB: TWebBrowser; Position: TWBPosition): Boolean;
var
  ParentW: OLEVariant;
begin
  Result := WB.Document <> nil;
  if Result then
  begin
    ParentW := WB.OleObject.Document.ParentWindow;
    case Position of
      wbPosBottom: ParentW.ScrollTo(0, ParentW.Screen.Height);
      wbPosTop: ParentW.ScrollTo(0, 0);
      wbPosRight: ParentW.ScrollTo(ParentW.Screen.Width, 0);
    end;
  end;
end;

function GetGameport: integer;
var
  Registry: TRegistry;
begin
  Registry := TRegistry.Create;
  try
    Registry.RootKey := HKEY_CURRENT_USER;
    { False, because the key shall not be created automatically }
    Registry.OpenKey('Software\Blizzard Entertainment\Warcraft III\Gameplay',
      False);
    Result := Registry.ReadInteger('netgameport');
  except
    Result := 6112;
  end;
  Registry.Free;
end;

function GetInstallPathOfWC3: String;
var
  Registry: TRegistry;
begin
  Registry := TRegistry.Create;
  try
    Registry.RootKey := HKEY_CURRENT_USER;
    { False, because the key shall not be created automatically }
    Registry.OpenKey('Software\Blizzard Entertainment\Warcraft III',
      False);
    Result := Registry.ReadString('InstallPath');
  except
    Result := '';
  end;
  Registry.Free;
end;


function GetUserName: string;
var
  Registry: TRegistry;
begin
  Registry := TRegistry.Create;
  try
    Registry.RootKey := HKEY_CURRENT_USER;
    { False, because the key shall not be created automatically }
    Registry.OpenKey('Software\Blizzard Entertainment\Warcraft III\String',
      False);
    Result := Registry.ReadString('userbnet');
  except
    Result := '';
  end;
  Registry.Free;
end;

procedure getIPs(sniffer: TZniffer; var a: iparray; var c: word);
var
  i, j, p: Integer;
  s: String;
begin
  c := 0;
  for i := 0 to sniffer.Addresses.Count - 1 do
  begin
    s := sniffer.Addresses[i];
    if s <> '' then
    begin
      a[c] := 0;
      j := 0;
      repeat
        p := pos('.', s);
        if p = 0 then
        begin
          a[c] := a[c] or (StrToInt(s) and $FF) shl j;
          inc(j, 8);
        end else
        begin
          a[c] := a[c] or (StrToInt(Copy(s, 1, p - 1)) and $FF) shl j;
          inc(j, 8);
          delete(s, 1, p);
        end;
      until j = 32;
      inc(c);
    end;
  end;
end;

function MouseProc(nCode: Integer; wParam, lParam: Longint): Longint; stdcall;
var
  szClassName: array[0..255] of Char;
  MausPos: TPoint;
const
  ie_name = 'Internet Explorer_Server';
begin
  GetCursorPos(MausPos);

  if (nCode < 0) then
    Result := CallNextHookEx(HookID, nCode, wParam, lParam)
  else if ((wParam = WM_RBUTTONDOWN) or (wParam = WM_RBUTTONUP)) then
  begin
    GetClassName(PMOUSEHOOKSTRUCT(lParam)^.HWND, szClassName,
      SizeOf(szClassName));
    if lstrcmp(@szClassName[0], @ie_name[1]) = 0 then
    begin
      Result := HC_SKIP;
    end
    else
      Result := CallNextHookEx(HookID, nCode, wParam, lParam);
  end
  else
    Result := CallNextHookEx(HookID, nCode, wParam, lParam);
end;

procedure TWC3Banlist_Main.FormCreate(Sender: TObject);
var
  i: integer;
begin
  SetVistaTreeView(tvOptions.Handle);
  SetVistaTreeView(tvChannel.Handle);
  autorefresher := TAutoRefresher.Create('localhost', GetGameport);
  res := TResources.Create;
  res.LoadFromFile(inipath + 'WC3Banlist.res');
  AddToLog('WC3Banlist Version ' + IniFile.GetVersion + ' (beta)', ICON_INFO);
  AddFontResource(PChar(ExtractFilePath(Paramstr(0)) + 'xml\_wc3.ttf'));
  AddFontResource(PChar(ExtractFilePath(Paramstr(0)) + 'xml\_wc3b.ttf'));
  Randomize;
  defaultFontSize := -1;
  SetFonts;
  SetPriorityClass(GetCurrentProcess, NORMAL_PRIORITY_CLASS);
  if not pcap.ok then
  begin
    caption :=
      'The WinPCap driver is not installed properly. Version 3.1 beta or later required. --> http://winpcap.polito.it';
    pcapok := false;
  end;

  vstBuddy.NodeDataSize := SizeOf(TBan);
  vtInfos.NodeDataSize := SizeOf(Pointer);
  vtBans.NodeDataSize := SizeOf(Pointer);
  vtGames.NodeDataSize := SizeOf(Pointer);
  vtScores.NodeDataSize := SizeOf(Pointer);

  realms := TThreadList.Create;
  InitRealmThread;

  HKReceiver := THotkeyReceiver.Create;
  mapInfo := TmapInfo.Create;
  latencyHandler := TLatencyHandler.Create;
  latencyHandler.GamePort := GetGameport;
  latencyHandler.SetMaxCount(50);

  exchangingBanlist := false;
  SetGameState(gsChat);

  // init strings
  xml_messages := inipath + 'xml\messages.xml';
  html_commands := inipath + 'help\commands.html';
  html_help := inipath + 'help\help.html';

  // load help
  webHelp.Navigate(html_help);

  // Browser anti popup hook
  HookID := SetWindowsHookEx(WH_MOUSE, MouseProc, 0, GetCurrentThreadId());

  LoadSettingsPages;
  InstallSettingsPages;

  FShowHoriz := False; // show the horiz scrollbar
  FShowVert := True; // hide vert scrollbar

  lastBannedList := TStringlist.Create;
  pl := TPlayerList.Create;
  ping := Tpinger.Create;
  phraseKeeper1 := TPhraseKeeper.Create(true);
  phraseKeeper1.Init;
  phraseKeeper1.Resume;
  pc := 0;

  // Convert old local database
  CheckForImportOldDatabase;

  f := newinifile.Create(inipath + 'wc3banlist.ini');
  f.Read;

  try
    ColorMapping := TColorMapping.Create(inipath + 'colors.dat');
  except
    AddToLog('Colors.dat is missing. Color substitutions won''t be available.', ICON_CONFIG)
  end;

  CountryCache := TCountryCache.Create;

  // create clipboard thread
  ct := ClipThread.Create(true);
  ct.Init;
  ct.Priority := tpHighest;
  ct.Resume;

  cl :=
    'edtNIC|NetworkAdapter,' +
    'chkProxy|useProxy,' +
    'banlistnl|banlist.nl,' +
    'lvSounds|Sounds,' +
    'chkBanlast|useDefaultBanlastComment,' +
    'edtBanlast|defaultBanlastComment,' +
    'chkRunningText|runningText,' +
    'chkClipboard|dontUseClipboard,' +
    'chkTransparent|useTransparentText,' +
    'chkBuddiesList|LoadBuddiesList,' +
    'edtBlLogin|BanlistLogin,' +
    'edtBlPassword|BanlistPW,' +
    'chkCheckLocalDatabase|CheckLocalDatabase,' +
    'chkBlBanlist|CheckBanlistNL,' +
    'chkBlBuddy|CheckBuddyBanlists,' +
    'edtPhrasePause|PhrasePause_ms,' +
    'chkBringToFront|DoNotBringToFrontOnWhisper,' +
    'edtFont|MarqueeFont,' +
    'chkAntiDownload|AntiDownload,' +
    'chkWinPCap|daWinPCap,' +
    'chkWinSock|daWinSock,' + 
    'chkWinAPI|daWinAPI,' +
    'chkPromi|PromisciousMode,' +
    'edtXSL|MessagesXSL,' +
    'chkP2P|Peer2PeerBanlistExchange,' +
    'memoBuddies|AntiDownloadExceptions,' +
    'chkMultipleIP|TellMultipleIPs,' +
    'chkAutoKick|AutoKick,' +
    'chkBlServer|CheckServerLists,' +
    'radSafelistAll|CheckServerSafelistsAll,' +
    'radSafelistEach|CheckServerSafeListEach,' +
    'btnViewStyle|localBanlistViewStyle,' +
    'radGDI|useGDI,' +
    'radDirectX|useDirectX,' +
    'edtWC3EXE|wc3.exe,' +
    'chkADLWhisper|AntiDLWhisper,' +
    'edtADLText|AntiDLWhisperText,' +
    'chkDoubleSlash|DoubleSlash,' +
    'chkMinToTray|MinimizeToTray,' +
    'chkChatMode|ChatMode,' +
    'chkFade|FadeOutMessages,' +
    'chkSemiAutomaticJoin|SemiAutomaticJoin,' +
    'chkUpdate|CheckForUpdates,' +
    'edtPingTimeout|PingTimeout,' +
    'chkTellSafelisted|TellSafelisted,' +
    'chkCloseOnLeaver|CloseWC3OnLeaverWhileCountdown,' +
    'edAutoExportTarget|AutoExportTarget,' +
    'edAutoExportCommand|AutoExportCommand,' +
    'chkBackupOnlineLists|BackupOnlineList,' +
    'chkSwitchToMessages|AlwaysSwitchToMessages,' +
    'chkSwitchTabOnNewGame|SwitchTabOnNewGame,' +
    'edScreenshotDBLocation|ScreenshotDatabaseLocation,' +
    'edScreenshotPattern|ScreenshotFilenamePattern,' +
    'chkShowDeletedBans|ShowDeletedBans,' +
    'chkShowDeletedInfos|ShowDeletedInfos,' +
    'panSnoopingLeft|PanelSizeSnoopingLeft*,' +
    'vtLog|PanelSizeLog*,' +
    'panChannel|PanelSizeChannel*,' +
    'lbWC3FriendList|WC3FriendList,' +
    'chkPreventFlicker|MessagingPreventFlicker,' +
    'chkRefreshEvenWhenInGame|RefreshMessagesEvenWhenInGame,' +
    'edtNextGameID|NextGameID,' +
    'chkOpenReviewAfterGame|OpenReviewAfterGame,'+
    'chkManageReplays|ManageReplays,' +
    'edtReplayDatabase|ReplayDatabaseLocation,' +
    'edtReplayFileNamePattern|ReplayFileNamePattern,' +
    'edtLastReplay|LastReplay,' +
    'chkAlwaysUseWC3Friendlist|AlwaysUseWC3sFriendList,' + 
    'chkFirstRun|FirstRun,' +
    'chkOnlySaveReplayWhenBanned|OnlySaveReplayIfSomeoneWasBanned,' +
    'radReservationsParse|ReservationsParseMap,' +
    'radReservationsUseDefault|ReservationsUseDefault,' +
    'edtHumanPlayerCount|ReservationsDefaultHumanPlayerCount,'+
    'radAutoCloseHostOnly|AutoCloseHostOnly,'+
    'radAutoCloseHostAndClient|AutoCloseHostAndClient,' +
    'chkCollectMessages|CollectFastSuccessiveMessages,' +
    'chkOptimizedPhrases|OptimizedPhrases,' +
    'chkCleanUp|DoCleanupOnShutdown,' +
    'edtCleanUpDays|DeleteGamesAndInfosOlderThanDays,' +
    'chkEmptyRecycleBinOnShutdown|EmptyRecycleBinOnShutdown,' +
    'chkAutomaticGameRefresh|AutomaticGameRefresh,' +
    'edtARInterval|GameRefreshInterval,' +
    'edtMPWindowClassName|MediaPlayerWindowClassName,' +
    'edtMPRegExp|MediaPlayerTitleRegExpr,' +
    'chkAutoLatencyPlots|AutomaticallyOpenLatencyPlots,' +
    'chkLatencyInGame|CalcLatencyInGame,'+
    'radDetailedPlots|DetailedLatencyPlots,'+
    'radSimplePlots|SimpleLatencyPlots';

  if fileexists(inipath + 'serverlists.dat') then
    LoadListViewFromFile(lvOnlineLists, inipath + 'serverlists.dat');
  if fileexists(inipath + 'pinfo.dat') then
    LoadPlayerInfo(inipath + 'pinfo.dat');
  if fileexists(inipath + 'autokick.dat') then
    LoadListViewFromFile(lvAutoKick, inipath + 'autokick.dat');
  if fileexists(inipath + 'comments.dat') then
    LoadListViewFromFile(lvComments, inipath + 'comments.dat');
  if fileexists(inipath + 'phrases.dat') then
    LoadListViewFromFile(lvPhrases, inipath + 'phrases.dat');
  PreparePhrases;

  // load local database from xml
  ListContainer := TListContainer.Create(self);
  if fileexists(inipath + 'localdb.xml') then
    try
      ListContainer.LoadFromFile(inipath + 'localdb.xml');
      RefreshLocalDatabase;
    except
      on e: Exception do
        MessageDlg('WC3Banlist has failed to load the local database (localdb.xml)!'+#13+#10+''+#13+#10+'Error message: '+ e.Message+#13+#10+''+#13+#10+'You should not try to modify this file on your own. '+#13+#10+''+#13+#10+'If it has been damaged somehow, you can try to restore your bans and infos'+#13+#10+'by clicking on "Restore local database" at Local Database --> Tools.'+#13+#10+'But only if it has been uploaded to Buddies'' Banlists (provided by www.banlsit.nl) before.', mtError, [mbOK], 0);
    end;

  // load preferences
  icd := inicontroldata.Create(f, 'Settings');
  icd.ReadControlList(cl);
  icd.LoadControlData(self);
  icd.LoadCoords(self);

  SetAutoRefreshInterval;
  tbARInterval.Position := StrToInt(edtARInterval.Text);

  SetDatabaseVisibility;
  npDatabase.ActivePage := panBans;

  chkLatencyInGameClick(nil);

  if edScreenshotDBLocation.Text = '' then
    edScreenshotDBLocation.Text := inipath + 'Screenshots';
  if edtReplayDatabase.Text = '' then
    edtReplayDatabase.Text := inipath + 'Replays';

  InitializeServerLists;

  gd := TGameData.Create;

  banlistnlClick(nil);

  MarqueeFont := TFont.Create;
  IniStringAsFont(edtFont.text, MarqueeFont);

  SetdaMethod;

  pk := TPacketKeeper.Create;
  BrowseForXSL;
  Whispers := TList.Create;
  deletedDXTexts := TList.Create;
  conList := Tlist.Create;
  kickOrderList := TThreadList.Create;
  unWanted := TStringList.Create;
  StringCache := TStringCache.Create(2000);
  Reserve := TReserve.Create;

  Open1.InitialDir := inipath + 'sounds';
  // Create sound entries
  for i := lvSounds.Items.Count to high(SoundEntries) do
    with lvSounds.Items.Add do
    begin
      Caption := SoundEntries[i];
      if (DefaultSounds[i] <> '') then
      begin
        SubItems.Add('enabled');
        SubItems.Add(inipath + 'Sounds\' + DefaultSounds[i])
      end else
      begin
        Subitems.Add('disabled');
        Subitems.Add('');
      end;
      ImageIndex := 7;
    end;

  Scr.loops := 10; // assume warcraft was running for 5 sec already

  // Initialize Zniffer
  try
    Fzniffer := TZniffer.create;
    Fzniffer.SnapLen := 65536;
    Fzniffer.OnPacket := ReadPacket;
    cbNIC.Items.assign(Fzniffer.AdapterDesc);
    Getips(FZniffer, myip, ipcount);
  except
    pcapok := false;
    Caption :=
      'WinPCap not installed properly! Version 3.1 beta or later required. http://winpcap.polito.com';
  end;

  // Load old NIC settings
  if (edtNIC.Text <> '') and (cbNIC.items.IndexOf(edtNIC.text) <> -1) then
  begin
    cbNIC.ItemIndex := cbNIC.items.IndexOf(edtNIC.text);
    cbNICChange(nil);
  end;

  // Read gameport from registry
  try
    gameport.Caption := inttostr(getgameport);
  except
    gameport.Caption := 'not found';
  end;

  // Read username from registry
  try
    username.Caption := GetUserName;
  except
  end;

  // set active pages
  pages.ActivePageIndex := 0;
  pagesBanlist.ActivePage := pgBlBuddyList;
  pagesPhrases.ActivePageIndex := 0;

  // download online banlists
  btnSyncClick(nil);

  webcmd.Navigate(html_commands);
  tvOptions.Items[0].Selected := True;

  // create array of shortcut menu items
  setlength(mnuShortCuts, 8);
  mnuShortCuts[0] := AssignF2;
  mnuShortCuts[1] := AssignF3;
  mnuShortCuts[2] := AssignF4;
  mnuShortCuts[3] := AssignF5;
  mnuShortCuts[4] := AssignF6;
  mnuShortCuts[5] := AssignF7;
  mnuShortCuts[6] := AssignF8;
  mnuShortCuts[7] := AssignF9;

  MessageCenter := TMessageCenter.Create(WC3Banlist_Main, xml_messages,
    edtXSL.Text);
  MessageCenter.OnChange := OnMessageChange;
  if not fileExists(xml_messages) then
    ClearWhispers(true);

  panChannel.Visible := chkChatMode.Checked;
  btnChatMode.Down := chkChatMode.Checked;

  SetSunkenButtons(self);

  // enable timers
  PaketTimer.Enabled := True;

  if chkUpdate.Checked then
    CheckForUpdates;

  try
    SetPingTimeout(StrToInt(edtPingTimeout.text));
  except
    edtPingTimeout.Text := '1000';
  end;

  // select Messaging mode
  radDirectXClick(nil);

  memoPhraseHelp.WordWrap := True;
  ImmAssociateContext(memoPhraseText.Handle, 0);

  // last line in OnCreate
  loadComplete := true;
end;

procedure TWC3Banlist_Main.Kill(s: string);
var
  p: pplayercon;
begin
  p := FindPlayer(s);
  if p <> nil then
  begin
    AddKickOrder(p, false);
    Sound(SND_MISC);
  end
  else
    AddMessage('Player ' + s + ' not found.', ICON_MESSAGE, s);
end;

procedure TWC3Banlist_Main.cbNICChange(Sender: TObject);
var
  E: string;
begin
  pcapsniffing := false;
  pcapfiltering := false;
  trafficTCP := false;
  trafficPPPoE := false;
  trafficWC3In := false;
  trafficWC3Out := false;
  if not pcapok then
  begin
    exit;
  end;
  if Fzniffer.Snooping then
    if not Fzniffer.Deactivate(E) then
      raise Exception.create(e);
  Fzniffer.AdapterIndex := cbNIC.ItemIndex;
  Fzniffer.Promisc := chkPromi.Checked;
  if not Fzniffer.Activate(e) then
  begin
    AddMessage('Snooping failed. Check if the WinPCap driver is installed and up to date.', ICON_ERROR);
    raise Exception.Create('Could not initialize Sniffer');
  end;
  adapter := FZniffer.FAdapter;
  pcapsniffing := true;
  pcapsniffingsince := GetTickCount;
  fzniffer.Thread.Priority := tpTimeCritical;
  // PPPoE or standard TCP
  if fzniffer.SetFilter('(ether[12:2]=0x8864) or tcp') <> 2 then
    iniinfo('Could not set WinPCap filter!')
  else
    pcapfiltering := True;
  edtNIC.Text := cbNIC.items[cbNIC.itemindex];
end;

procedure TWC3Banlist_Main.ReadPacket(Data: pointer; recvbytes: Word; uTickCount: Int64);
type
  ba = array[0..100] of byte;
  pba = ^ba;
var
  p: PPacket;
  IP: PIP_RHDR;
  TCP: PTCP_RHDR;
  seq, srcp, dstp: DWORD;
  b: pba;
  i: integer;
  tos: byte;
  raw: PByteArray;
  ipOffset, tcpOffset, tcpDataOffset, tcpSize: WORD;
  kickCon: PKickCon;
  sKillCon: MIB_TCPROW;
  useInLobby: Boolean;

  srcIP, dstIP: Cardinal;
  bugreport: TStringList;

  procedure incdword(p: pba; i: word);
  var
    u: word;
  begin
    u := (p^[3] + i) shr 8;
    p^[3] := (p^[3] + i) and $FF;
    i := u;
    u := (p^[2] + i) shr 8;
    p^[2] := (p^[2] + i) and $FF;
    i := u;
    u := (p^[1] + i) shr 8;
    p^[1] := (p^[1] + i) and $FF;
    i := u;
    p^[0] := (p^[0] + i) and $FF;
  end;

begin
  try
    // Initialize
    raw := Data;
    // find out the layer 3+4 protocol offsets
    if (raw^[12] = $08) and (raw^[13] = $00) then
    begin
      ipOffset := 14; // <--- size of a Ethernet II Header
    end
    else if (raw^[12] = $88) and (raw^[13] = $64)
      and (raw^[$0F] = 0) and (raw^[$14] = 0) and (raw^[$15] = $21) then
    begin
      ipOffset := 22;
      trafficPPPoE := true;
    end
    else
      exit; // unknown TOS field in Ethernet II Frame
    tos := raw^[IpOffset + 9];
    if tos <> 6 then
      exit; // TCP Packet?
    trafficTCP := true;
    // calc the other offsets
    tcpOffset := ipOffset + ((raw^[ipOffset] and $0F) shl 2); // + IP Header Size
    tcpDataOffset := tcpOffset + ((raw^[tcpOffset + 12] and $F0) shr 2); // + TCP Header Size
    tcpSize := raw^[ipOffset + 2] shl 8 + raw^[ipOffset + 3] + ipOffset - tcpDataOffset;
    // get IP header
    IP := @raw^[ipOffset];
    // copy IP addresses
    srcIP := ip^.SrcIP;
    dstIP := ip^.DestIP;
    // get TCP header
    TCP := @raw^[tcpOffset];
    // copy ports
    srcp := Swap(tcp^.SrcPort);
    dstp := Swap(tcp^.DestPort);
    // add packet to latency handler
    useInLobby := false;
    // using packet doesn't work. it's much higher than syn,ack-packet-latency or ping
    // if (tcpSize = 8) and (raw^[tcpDataOffset] = $F7) and (raw^[tcpDataOffset+1] = 01) then useInLobby := true;
    if assigned(latencyHandler) then
      latencyHandler.AddPacket(srcIP, dstIP, srcp, dstp, tcp^.LenResvFlags, tcp^.AckNumber, tcp^.SequenceNr, tcpSize, uTickCount, useInLobby);
    // kick per reset
    i := 0;
    try
      with kickOrderList.LockList do
      while i < Count do
      begin
        kickCon := PKickCon(items[i]);
        // packet from bad guy coming ?
        if (srcp = kickCon^.con^.port) and (kickCon^.con^.ip = srcIP) then
        begin
          CopyMemory(@Seq, @raw^[tcpOffset + 4], 4);
          b := @seq;
          incdword(b, tcpSize);
          // send ourselfes a RST packet
          if daMethod = 0 then
            sendtcppacket(IPtoStr(@srcIP), srcp, IPtoStr(@dstIP), dstp, '', $04, SEQ,
              SEQ);
          if daMethod = 1 then
            sendrstpacket(adapter, Data, IPtoStr(@srcIP), srcp, IPtoStr(@dstIP), dstp, '',
              $04, SEQ, SEQ);
          // close connection via API
          if daMethod = 2 then
          begin
            sKillCon.dwState := MIB_TCP_STATE_DELETE_TCB;
            sKillCon.dwLocalAddr := dstIP;
            sKillCon.dwLocalPort := swap(dstp);
            sKillCon.dwRemoteAddr := srcIP;
            sKillCon.dwRemotePort := swap(srcp);

            SetTcpEntry(sKillCon);

            if kickCon^.sendADLMessage then
                phraseKeeper1.Add('/w ' + kickCon^.con^.name + ' ' + edtADLText.Text + cr);
            kickCon^.con^.connected := false;
            Delete(i);
            Dispose(kickCon);
          end;
          break;
        end else
        // but guy receives RST or FIN?
        if inmyIP(srcIP) and (daMethod in [0, 1]) and
           // RST                                // FIN
          ((raw^[tcpOffset + 13] and 4 = 4) or odd(raw^[tcpOffset + 13])) and
          (dstp = kickCon^.con^.port) and (kickCon^.con^.ip = dstIP) then
        begin
          if kickCon^.sendADLMessage then
            phraseKeeper1.Add('/w ' + kickCon^.con^.name + ' ' + edtADLText.Text + cr);
          kickCon^.con^.connected := false;
          Delete(i);
          Dispose(kickCon);
          break;
        end
        else
          inc(i);
      end;
    finally
      kickOrderList.UnlockList;
    end;
    // enqueue the packet
    if tcpSize > 0 then
    begin
      // create packet
      CreatePacket(tcpSize, false, p);
      CopyMemory(p^.d, @raw^[tcpDataOffset], tcpSize);
      CopyMemory(@p^.a, @ip.srcIP, 4);
      CopyMemory(@p^.b, @ip.destIP, 4);
      p^.pa := srcp;
      p^.pb := dstp;
      p^.l := tcpSize;
      EnqueuePacket(p);
    end;
  except
    on e: Exception do
    begin
      bugreport := TStringlist.Create;
      try
        try
          bugreport.LoadFromFile(inipath + '\ErrorReport.txt');
        except
        end;
        bugreport.Add('WinPCap callback method: ' + e.Message);
        bugreport.SaveToFile(inipath + '\ErrorReport.txt');
      finally
        bugreport.Free;
      end;
    end;
  end;
end;

procedure TWC3Banlist_Main.pagesChange(Sender: TObject);
begin
  if pages.ActivePage = tabMessages then
  begin
    NavigateToWhisper;
    edtMessage.SetFocus;
  end;
end;

procedure TWC3Banlist_Main.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: integer;
  s: string;
  time: Cardinal;
begin
  if closing and exchangingBanlist then
  begin
    if MessageBox(Handle,
      'There are active transfers. If you close WC3Banlist now, they won''t complete.'
      + #13 + #10 + '' + #13 + #10 +
        'Are you sure you want to abort these transfers?',
      'Abort transfers', MB_ICONQUESTION or MB_YESNO) = mrYes then
    begin
      try
        if exchangingBanlist then
          banlist.Cancel;
      except
      end;
    end
    else
      exit;
  end;

  // Never run twice
  if closing then
    exit;
  closing := true;
  Caption := 'Shutdown initiated ...';
  Flickertimer.Enabled := false;
  WarCraftWindowTimer.Enabled := false;
  PaketTimer.Enabled := false;
  SnoopingRefresh.Enabled := false;

  if Assigned(scr.entries) then
    with scr do
    begin
      for i := 0 to entries.Count - 1 do
        Dispose(entries[i]);
      Entries.Free;
    end;

  // disable automatic injection when changing checked state
  radDirectX.Tag := 1;

  if chkCleanUp.Checked then
  begin
    Caption := 'WC3Banlist - Cleaning up games and scores...';
    Application.ProcessMessages;
    CleanUpLocalDatabase(true);
  end;

  if chkEmptyRecycleBinOnShutdown.Checked then
  begin
    Caption := 'WC3Banlist - Emptying recycle bin...';
    Application.ProcessMessages;
    EmptyRecycleBin;
  end;

  Caption := 'WC3Banlist - Saving local database to disk...';
  Application.ProcessMessages;
  SaveConfiguration;
  AutoExport;

  Caption := 'WC3Banlist - Deactivating WinPCap thread...';
  Application.ProcessMessages;
  if Fzniffer.Snooping then
    fzniffer.Deactivate(s);

  caption := 'WC3Banlist - Waiting for the program to finish its initialization ...';
  while (GetTickCount - StartupTime) < 5000 do
  begin
    Sleep(100);
    Application.ProcessMessages;
  end;

  caption := 'WC3Banlist - Waiting for in game display to stop ...';
  time := 0;
  while not cc and (time < 10000) do
  begin
    Sleep(100);
    inc(time, 100);
    Application.ProcessMessages;
  end;

  if hookMode > 0 then
  begin
    UnInject;
    hookMode := 0;
  end;

  if Assigned(MessageCenter) then
  begin
    MessageCenter.CutToSize(10);
    MessageCenter.SaveToFile;
  end;

    // Terminate server list transfers
  if Assigned(banlist) then
  begin
    Caption := 'WC3Banlist - Terminating server list transfers ...';
    Application.ProcessMessages;
    CancelServerListTransfers;
  end;

  if exchangingBanlist then
    Caption := 'WC3Banlist - Waiting for transfers to complete ...';
  while exchangingBanlist do
  begin
    Sleep(100);
    Application.ProcessMessages;
  end;

  // Terminate Buddies' Banlists tranfers
  if Assigned(banlist) then
  begin
    Caption := 'WC3Banlist - Terminating banlist transfers ...';
    Application.ProcessMessages;
    banlist.WaitFor;
  end;

  // Terminate RealmResolver
  if Assigned(RealmThread) then
  begin
    Caption := 'WC3Banlist - Terminating realm resolver ...';
    Application.ProcessMessages;
    RealmThread.Terminate;
    RealmThread.WaitFor;
    FreeAndNil(RealmThread);
  end;

  // Terminate Clipboard Thread
  if Assigned(ct) then
  begin
    Caption := 'WC3Banlist - Terminating clipboard thread ...';
    Application.ProcessMessages;
    ct.Terminate;
    ct.WaitFor;
    FreeAndNil(ct);
  end;

  // Unhook Browser Windows
  if HookID <> 0 then
  begin
    Caption := 'WC3Banlist - Unhooking webbrowser components ...';
    Application.ProcessMessages;
    UnHookWindowsHookEx(HookID);
  end;

  if Assigned(PhraseKeeper1) then
  begin
    Caption := 'WC3Banlist - Shutting down phrase manager ...';
    Application.ProcessMessages;
    PhraseKeeper1.Terminate;
    PhraseKeeper1.WaitFor;
    FreeAndNil(PhraseKeeper1);
  end;

  if Assigned(AutoRefresher) then
  begin
    Caption := 'WC3Banlist - Shutting down game refresher ...';
    autorefresher.Terminate;
    autorefresher.Trigger;
    autorefresher.WaitFor;
    autorefresher.Free;
  end;

  if Assigned(latencyHandler) then
  begin
    Caption := 'WC3Banlist - Shutting down latency tracker ...';
    Application.ProcessMessages;
    latencyHandler.Terminate;
    latencyHandler.WaitFor;
    latencyHandler.Free;
  end;

  Caption := 'WC3Banlist - Cleaning up ...';
  Application.ProcessMessages;
  RemoveFontResource(PChar(ExtractFilePath(Paramstr(0)) + 'xml\_wc3.ttf'));
  RemoveFontResource(PChar(ExtractFilePath(Paramstr(0)) + 'xml\_wc3b.ttf'));
end;

function TWC3Banlist_Main.CheckSpack(s: string; playsnd: boolean; var autokick:
  boolean): TCheckResult;
var
  i, j, SafelistCount: integer;
  clip: string;
  comment: string;
  t: tstringlist;
  p: PBanBuddiesBanlist;
  pbi: PBanInfo;
  n: PVirtualNode;
  sl: TServerList;
  b: boolean;
  info: PInfo;
  ban: PBan;

  function art(a: string): string;
  begin
    if length(a) = 0 then
      result := 'on local banlist'
    else if a[1] in ['a', 'u', 'i', 'o', 'e'] then
      result := 'an '
    else
      result := 'a ';
  end;
begin
  t := tstringlist.create;
  result := crNothing;
  autokick := false;
  // local banlist
  pbi := pl.GetBanInfo(s);
  if chkCheckLocalDatabase.Checked then
  begin
    // check infos first
    info := ExistsOnLocalInfoList(s);
    if (info <> nil) and (lowercase(info^.nick) = lowercase(s)) and not info^.deleted then
    begin
      if playsnd then
        Sound(SND_INFO);
      if info^.comment <> '' then
        t.Add('Info for ' + s + ': ' + info^.comment + '.')
      else
        t.Add(s + ' is notated.');
      if assigned(pbi) then
        pbi^.info := info^.comment;
      result := crNote;
    end;
    // check bans afterwards (because of sound overlay)
    ban := ExistsOnLocalBanlist(s);
    if Assigned(ban) and (lowercase(ban^.nick) = lowercase(s)) and not ban^.deleted then
    begin
      if playsnd then
        Sound(SND_ALERT);
      with lvAutoKick do
        for j := 0 to Items.Count - 1 do
          if
            (items[j].SubItems[0] = 'x')
            and
            ((pos(lowercase(items[j].Caption), lowercase(ban^.comment)) > 0)
            or
            (items[j].Caption = '')
            or
            (items[j].Caption = '*')
            ) then
            autokick := true;
      if ban^.comment <> '' then
      begin
        if ban^.comment[1] = '(' then
          t.add(s + ' is on local banlist ' + ban^.comment + '.')
        else
          t.Add(s + ' is ' + art(ban^.comment) + ban^.comment + '.');
      end
      else
        t.add(s + ' is on local banlist.');
      if assigned(pbi) then
        pbi^.ban := ban^.comment;
      result := crBan;
    end;
  end;

  // buddies' lists
  if assigned(pbi) then
    pbi^.onlineban := '';
  if chkBlBuddy.Checked then
  begin
    n := vstBuddy.GetFirst;
    while n <> nil do
    begin
      p := vstBuddy.GetNodeData(n);
      if (lowercase(p^.nickname) = lowercase(s)) then
      begin
        if assigned(pbi) then
        begin
          if pbi^.onlineban <> '' then pbi^.onlineban := pbi^.onlineban + ', ';
          pbi^.onlineban := pbi^.onlineban + trim(p^.comment + ' (' + p^.source + ')');
        end;
        if playsnd then
          Sound(SND_ALERT);
        if p^.comment <> '' then
          t.Add(s + ' is on ' + p^.Source + '''s banlist for being ' +
            art(p^.comment) + p^.comment + '.')
        else
          t.Add(s + ' is on ' + p^.source + '''s banlist.');
        with lvAutoKick do
          for j := 0 to items.count - 1 do
            // keyword hit
            if
              (
              (pos(lowercase(items[j].Caption), lowercase(p^.comment)) > 0)
              or
              (items[j].Caption = '')
              or
              (items[j].Caption = '*')
              )
              and // buddy hit
            ((pos(lowercase(p^.source) + ' ', lowercase(items[j].SubItems[2]) +
              ' ') > 0)
              or // wildcard hit
              (pos('* ', lowercase(items[j].SubItems[2]) + ' ') > 0)) then
              autokick := true;
        result := crBan;
      end;
      n := vstBuddy.GetNext(n);
    end;
  end;

  // online banlists
  if chkBlServer.Checked then
  begin
    for i := 0 to lvOnlineLists.Items.Count - 1 do
      if (lvOnlineLists.Items[i].SubItems[0] = noyes[1]) and
        (lvOnlineLists.Items[i].Data <> nil) then
      begin
        sl := TServerList(lvOnlineLists.Items[i].Data);
        if sl.Ready and (sl.ListType = ltBanlist) then
        begin
          p := sl.IsListed(s);
          if p <> nil then
          begin
            // update playerinfo
            if assigned(pbi) then
            begin
              if pbi^.onlineban <> '' then pbi^.onlineban := pbi^.onlineban + ', ';
              pbi^.onlineban := pbi^.onlineban + trim(p^.comment + ' (' + p^.source + ')');
            end;
            if playsnd then
              SOUND(SND_ALERT);
            if p^.comment = '' then
              t.Add(s + ' is banlisted on ' + sl.Title + '.')
            else
              t.Add(s + ' is banlisted on ' + p^.Source + ' for being ' +
                art(p^.comment) + p^.comment + '.');
            with lvAutoKick do
              for j := 0 to Items.Count - 1 do
                if
                  // server list check enabled?
                (pos('b', items[j].SubItems[1]) > 0)
                  and
                  ((pos(lowercase(items[j].Caption), lowercase(p^.comment)) > 0)
                  or
                  (items[j].Caption = '')
                  or
                  (items[j].Caption = '*')
                  ) then
                  autokick := true;
            result := crBan;
          end;
        end;
      end;
  end;

  // online safelists
  SafelistCount := 0;
  b := false;
  if chkBlServer.Checked then
  begin
    for i := 0 to lvOnlineLists.Items.Count - 1 do
      if (lvOnlineLists.Items[i].SubItems[0] = noyes[1]) and
        (lvOnlineLists.Items[i].Data <> nil) then
      begin
        sl := TServerList(lvOnlineLists.Items[i].Data);
        if sl.Ready and (sl.ListType = ltSafeList) then
        begin
          inc(SafeListCount);
          p := sl.IsListed(s);
          if p = nil then
          begin
            if radSafeListEach.Checked then
            begin
              t.add(s + ' is not safelisted on ' + sl.Title + '.');
              if playsnd then
                Sound(SND_SAFELIST);
              with lvAutoKick do
                for j := 0 to Items.Count - 1 do
                  if (pos('s', items[j].SubItems[1]) > 0) then
                    autokick := true;
              result := crBan;
            end;
          end
          else
          begin
            b := true;
            if p^.comment <> '' then
              comment := ' (' + p^.comment + ')'
            else
              comment := '';
            if chkTellSafelisted.checked or not playSnd then
              t.Add(s + ' is safelisted on ' + sl.Title + comment + '.');
            result := crNote;
          end;
        end;
      end;
  end;

  // online viplists
  if chkBlServer.Checked then
  begin
    for i := 0 to lvOnlineLists.Items.Count - 1 do
      if (lvOnlineLists.Items[i].SubItems[0] = noyes[1]) and
        (lvOnlineLists.Items[i].Data <> nil) then
      begin
        sl := TServerList(lvOnlineLists.Items[i].Data);
        if sl.Ready and (sl.ListType = ltVipList) then
        begin
          p := sl.IsListed(s);
          if p <> nil then
          begin
            // update playerinfo
            if assigned(pbi) then
            begin
              if pbi^.onlineban <> '' then pbi^.onlineban := pbi^.onlineban + ', ';
              pbi^.onlineban := pbi^.onlineban + trim(p^.comment + ' (' + p^.source + ')');
            end;
            if playsnd then
              SOUND(SND_VIP);
            if p^.comment = '' then
              t.Add('The ' + sl.Title + '-VIP ' + s +' has joined the game.')
            else
              t.Add('The VIP ' + s + ' (' + p^.comment + ') has joined the game.');
            result := crVIP;
          end;
        end;
      end;
  end;

  if radSafelistAll.Checked and (not b) and (SafeListCount > 0) then
  begin
    t.Add(s + ' is not safelisted.');
    if playsnd then
      Sound(SND_SAFELIST);
    with lvAutoKick do
      for j := 0 to Items.Count - 1 do
        if (pos('s', items[j].SubItems[1]) > 0) then
          autokick := true;
    result := crBan;
  end;

  // assemble multiple messages to one if banlisted on more than one banlist
  if t.Count > 0 then
  begin
    clip := t[t.count - 1];
    for i := t.Count - 2 downto 0 do
    begin
      clip := t[i] + ' ' + clip;
    end;
  end;
  if result in [crBan, crNote, crVIP] then
    checkresult := clip
  else if not playsnd then
    checkresult := 'No information on ' + s + '.';
  t.Free;
end;

procedure TWC3Banlist_Main.DoCommand(s: string);
var
  ip, phrase, spack, original: string;
  dummy: boolean;
  pingresult, p: integer;
  lw: Cardinal;
  doubleslash: String;
  pcon: PPlayerCon;
  function startswith(a: string): boolean;
  begin
    result := lowercase(a) = lowercase(copy(s, 1, length(a)));
    if result then
      spack := s;
    delete(spack, 1, length(a));
  end;
begin
  if chkDoubleSlash.Checked then
    doubleslash := '/' else
    doubleslash := '';
  original := s;
  // commands doing a whisper
  if startswith('/f msg ') or startswith('/f m ') or
    startswith('/friends msg ') or startswith('/friends m ') then
  begin
    MessageCenter.AddChat('Your Friends', AnsiToUtf8(spack), wtOut);
  end
  else if lowercase(copy(s, 1, 3)) = '/w ' then
  begin
    delete(s, 1, 3);
    split(s, spack, s, ' ');
    if not StringCache.AddAndCheckInList(spack + s) then
    begin
      if spack <> '' then
        MessageCenter.AddChat(spack, AnsiToUtf8(s), wtOut);
      lastwhisperer := spack;
    end;
  end
  else
  if not chkDoubleSlash.Checked or startswith('//') then
  begin
    if startswith('//') then delete(s, 1, 1);
    s := SubstPhrase(s, false);
    if Pos(#255#250, s) > 0 then
    begin
      AddMessage('There is no player with this color.', ICON_MESSAGE);
      exit;
    end;
    // other commands
    s := FilterWhitespaces(s);
    if s = '/test' then
    begin
      DoTests;
    end
    else if (s = '/ss') or startswith('/ss ') then begin
      spack := copy(s, 4, length(s) - 3);
      Sound(SND_RESPONSE);
      try
        AddMessage('Screenshot saved as ' + MakeScreenshot(spack), ICON_INFO);
      except
        on e: Exception do
          AddMessage('Taking screenshot failed: ' + e.Message, ICON_ERROR);
      end;
    end
    else if (s = '/screenshot') or startswith('/screenshot ') then begin
      spack := copy(s, 12, length(s) - 11);
      Sound(SND_RESPONSE);
      try
        AddMessage('Screenshot saved as ' + MakeScreenshot(spack), ICON_INFO);
      except
        on e: Exception do
          AddMessage('Taking screenshot failed: ' + e.Message, ICON_ERROR);
      end;
    end
    else if s = ('/checkchannel') then
      CheckChannel
    else if startswith('/i ') or startswith('/info ') then
    begin
      spack := copy(s, pos(' ', s) + 1, 255);
      if spack <> '' then
      begin
        if ban(spack, true, true) then Sound(SND_INFO);
      end;
    end
    else if copy(s, 1, 5) = '/ban ' then
    begin
      spack := copy(s, 6, 255);
      if spack <> '' then
      begin
        if ban(spack, true, false) then Sound(SND_BAN);
      end;
    end
    else if startswith('/unban ') then
    begin
      spack := copy(s, 8, 255);
      if unban(spack) then
        AddMessage(spack + ' is no longer banned now.', ICON_NOTE, spack)
      else
        AddMessage(spack + ' is not banned.', ICON_SEARCH, spack);
      Sound(SND_RESPONSE);
    end
    else if startswith('/uninfo ') then
    begin
      spack := copy(s, 9, 255);
      if uninfo(spack) then
        AddMessage('The info on ' + spack + ' has been removed.', ICON_NOTE, spack)
      else
        AddMessage('Could not find an info on ' + spack + '.', ICON_SEARCH, spack);
      Sound(SND_RESPONSE);
    end
    else if copy(s, 1, 7) = '/check ' then
    begin
      spack := copy(s, 8, 255);
      if spack <> '' then
      begin
        checkspack(spack, false, dummy);
        AddMessage(checkresult, ICON_NOTE, spack);
      end;
      Sound(SND_RESPONSE);
    end
    else if copy(s, 1, 8) = '/banlast' then
    begin
      if (lastleaver <> 'unknown') and (lastleaver <> '') then
        if length(s) > 8 then
          DoCommand(doubleslash + '/ban ' + lastleaver + ' ' + copy(s, 10, 255))
        else if (chkBanlast.Checked) and (edtBanlast.Text <> '') then
          DoCommand(doubleslash + '/ban ' + lastleaver + ' ' + edtBanlast.Text)
        else
          DoCommand(doubleslash + '/ban ' + lastleaver);
    end
    else if copy(s, 1, 5) = '/last' then
    begin
      AddMessage(lastleaver, ICON_NOTE, lastleaver);
      Sound(SND_RESPONSE);
    end
    else if copy(s, 1, 5) = '/nodl' then
    begin
      if (length(s) = 5) or (copy(s, 7, 255) = 'on') then
        chkAntiDownload.checked := true
      else if copy(s, 7, 255) = 'off' then
        chkAntiDownload.checked := false;
      Sound(SND_RESPONSE);
    end
    else if startswith('/autokick') then
    begin
      if (length(s) = 9) or (copy(s, 11, 255) = 'on') then
        chkAutoKick.Checked := true
      else if copy(s, 11, 255) = 'off' then
        chkAutoKick.Checked := false;
      Sound(SND_RESPONSE);
    end
    else if s = '/ping' then
    begin
      if LastHost = 0 then
      begin
        AddMessage('No game joined yet.', ICON_MESSAGE);
        Sound(SND_RESPONSE);
        ReleaseSemaphore(phraseKeeper1.hWaitSemaphore, 1, nil);
      end
      else
      begin
        pingResult := raw_ping.ping(LastHost);
        if pingResult < 0 then
          AddMessage('Ping to host: timed out.', ICON_NETWORK)
        else
          AddMessage('Ping to host: ' + IntToStr(pingResult) + ' ms.', ICON_NETWORK);
        ReleaseSemaphore(phraseKeeper1.hWaitSemaphore, 1, nil);
        Sound(SND_RESPONSE);
      end
    end
    else if startswith('/rank ') and (length(s) > 6) then
    begin
      spack := copy(s, 7, 255);
      GetPlayerRank(spack);
    end
    else if startswith('/ping ') and (length(s) > 6) then
    begin
      spack := copy(s, 7, 255);
      PingPlayer(spack);
      ReleaseSemaphore(phraseKeeper1.hWaitSemaphore, 1, nil);
    end
    else if s = '/from' then
    begin
      if LastHost = 0 then
      begin
        AddMessage('No game joined yet.', ICON_MESSAGE);
        ReleaseSemaphore(phraseKeeper1.hWaitSemaphore, 1, nil);
        Sound(SND_RESPONSE);
      end
      else
      begin
        ip := IPtoStr(@LastHost);
        TIPToCountry.Create(CountryCache).ResolveSingle(ip, lastHostName);
      end;
    end
    else if startswith('/from ') and (length(s) > 6) then
    begin
      spack := copy(s, 7, 255);
      lw := FindPlayerIP(spack);
      if lw <> 0 then
        TIPToCountry.Create(CountryCache).ResolveSingle(iptostr(@lw), spack)
      else
      begin
        AddMessage('Player ' + copy(s, 7, 255) + ' not found.', ICON_MESSAGE, copy(s, 7, 255));
        Sound(SND_RESPONSE);
      end;
    end
    else if (s = '/lm') and (lastMessage <> '') then
    begin
      AddMessage(lastMessage, ICON_NOTE);
    end
    else if s = '/checkall' then
      CheckAll
    else if s = '/fromall' then
      FromAll
    else if s = '/fromlast' then
    begin
      if lastJoiner = '' then
      begin
        AddMessage('No one has joined the game so far.', ICON_MESSAGE);
        Sound(SND_RESPONSE);
      end
      else
      begin
        lw := FindPlayerIP(lastjoiner);
        if lw <> 0 then
          TIPToCountry.Create(CountryCache).ResolveSingle(IPToStr(@lw), lastJoiner)
        else
        begin
          AddMessage('Player ' + lastjoiner + ' not found.', ICON_SEARCH, lastjoiner);
          Sound(SND_RESPONSE);
        end;
      end;
    end
    else if s = '/pinglast' then
    begin
      if lastJoiner = '' then
      begin
        AddMessage('No one has joined the game so far.', ICON_NETWORK);
        Sound(SND_RESPONSE);
      end
      else
        PingPlayer(lastJoiner);
    end
    else if copy(s, 1, 3) = '/p ' then
    begin
      Phrase := FindPhrase(copy(s, 4, 255));
      if Phrase <> '' then
        WriteChatLine(Phrase);
    end
    else if copy(s, 1, 4) = '/ph ' then
    begin
      Phrase := FindPhrase(copy(s, 5, 255));
      if Phrase <> '' then
        WriteChatLine(Phrase);
    end
    else if copy(s, 1, 8) = '/phrase ' then
    begin
      Phrase := FindPhrase(copy(s, 9, 255));
      if Phrase <> '' then
        WriteChatLine(Phrase);
    end
    else if copy(s, 1, 3) = '/np' then
    begin
      Sound(SND_RESPONSE);
      spack := CurrentTitleOfWinAMP;
      if spack <> '' then
        AddMessage('Now Playing: ' + spack, ICON_INFO);
    end
    else if s = '/reserve' then
    begin
      Reserve.Clear;
      AddMessage('All reservations have been cancelled.', ICON_NOTE);
      RefreshReservations;
      Sound(SND_RESPONSE);
    end
    else if startswith('/reserve ') then
    begin
      spack := copy(s, 10, 255);
      if not Reserve.Reserve(spack) then
        AddMessage('Illegal reservation pattern.', ICON_MESSAGE);
      RefreshReservations;
      Sound(SND_RESPONSE);
    end
    else if (s = '/showreservations') or (s = '/sr') then
    begin
      AddMessage(Reserve.Reservations, ICON_NOTE);
      Sound(SND_RESPONSE);
    end
    else if (s = '/notwhispered') or (s = '/nw') then
    begin
      AddMessage(NotWhispered, ICON_SEARCH);
      Sound(SND_RESPONSE);
    end
    else if (s = '/pingall') then
    begin
      PingAll;
      Sound(SND_RESPONSE);
    end
    else if startswith('/rate ') then
    begin
      delete(s, 1, 6);
      spack := s;
      p := pos(' ', spack);
      if p = 0 then
        AddMessage('You have to give a rating.', ICON_MESSAGE)
      else if (gameState <> gsInGame) then
        AddMessage('Rating is only allowed after the game has started.', ICON_MESSAGE)
      else begin
        s := copy(spack, p+1, 255);
        spack := copy(spack, 1, p-1);
        while pos('+', s)>0 do delete(s, pos('+', s), 1);
        if (s <> '-20') and (s <> '-6') and (s <> '0') and (s <> '1') and (s <> '2') and (s <> '3') then
          AddMessage('This value for rating is not allowed.', ICON_MESSAGE)
        else
          try
            RatePlayer(spack, strtoint(s));
            AddMessage('Rating for ' + spack + ' acknowledged.', ICON_NOTE, spack);
          except
            on e:Exception do
              AddMessage(e.Message, ICON_MESSAGE, spack);
          end;
      end;
      Sound(SND_RESPONSE);
    end else
    if s = '/refresh' then
    begin
      Sound(SND_RESPONSE);
      if Assigned(autorefresher) then
        autorefresher.Trigger;
    end else
    if startswith('/refresh ') then
    begin
      if copy(s, 10, 255) = 'on' then
      begin
        chkAutomaticGameRefresh.Checked := true;
        Sound(SND_RESPONSE);
      end else
      if copy(s, 10, 255) = 'off' then
      begin
        chkAutomaticGameRefresh.Checked := false;
        Sound(SND_RESPONSE);
      end;
    end else
    if s = '/latall' then
    begin
      Sound(SND_RESPONSE);
      LatAll;
      Sound(SND_RESPONSE);
    end else
    if startswith('/lat ') and (length(s) > 5) then
    begin
      Sound(SND_RESPONSE);
      if ishost then
      begin
        spack := copy(s, 6, 255);
        pcon := FindPlayer(spack);
        if pcon <> nil then
        begin
          spack := pcon^.name;
          if Assigned(latencyHandler) then
            if gameState = gsInGame then
              AddMessage(Format('Latency of %s: %d%d ms', [spack, latencyHandler.GetLatency(pcon^.ip, pcon^.port) , latencyHandler.GetStandardDeviation(pcon^.ip, pcon^.port)]), ICON_NETWORK, spack)
            else
              AddMessage(Format('Latency of %s: %d ms', [spack, latencyHandler.GetHSLatency(pcon^.ip, pcon^.port)]), ICON_NETWORK, spack)
        end else
          AddMessage('Player ' + spack + ' not found.', ICON_MESSAGE, spack);
      end else
      begin
        AddMessage('/lat is only available if you''re the host of the game.', ICON_MESSAGE);
      end;
    end else
    if s = '/latlast' then
    begin
      if FindPlayer(lastJoiner) <> nil then
        DoCommand(doubleslash + '/lat ' + lastJoiner);
    end;
  end;
end;

function TWC3Banlist_Main.Ban(spack: string; custom: boolean; note: boolean): boolean;
var
  p: integer;
  c: string;
  l: tlistitem;
  keyword: string;
  ban: PBan;
  info: PInfo;
  rest: string;
  pi: PPlayerInfo;
begin
  result := false;
  if spack = '' then
    exit;
  p := pos(' ', spack);
  if p = 0 then
    c := ''
  else
  begin
    c := copy(spack, p + 1, 255);
    spack := copy(spack, 1, p - 1);
  end;
  if not CheckNicknameSpelling(spack) then
  begin
    Sound(SND_RESPONSE);
    AddMessage(Format('Cannot ban or add an info for %s. Illegal characters found in nickname.', [spack]), ICON_ERROR, spack);
    exit;
  end;
  if length(spack) > 15 then
  begin
    Sound(SND_RESPONSE);
    if note then keyword := 'Info' else keyword := 'Ban';
    AddMessage(Format('Nicknames longer than 15 characters are not allowed. %s not created.', [keyword]), ICON_ERROR, spack);
    exit;
  end;
  if not note and (lastBannedList.IndexOf(spack) = -1) then
    lastBannedList.Add(spack);
  if custom then
  begin
    rest := '';
    p := pos(' ', c);
    if p > 0 then
    begin
      rest := copy(c, p, 255);
      keyword := copy(c, 1, p - 1);
    end
    else
      keyword := c;
    for p := 0 to lvComments.Items.Count - 1 do
    begin
      l := lvComments.items[p];
      if lowercase(l.Caption) = lowercase(keyword) then
      begin
        c := l.SubItems[0];
        // substiute variables
        SubstituteComments(c, spack);
        if rest <> '' then delete(rest, 1, 1);
        if (ReplaceAll(c, '$param', rest) = 0) then c := c + ' ' + rest;
        c := trim(c);
        break;
      end;
    end;
  end;
  pi := pl.GetPlayerInfo(spack);
  if note then begin
    new(info);
    info^.comment := c;
    info^.nick := spack;
    info^.deleted := false;
    info^.lastChange := now;
    ListContainer.infolist.AddEntry(info);
    if assigned(pi) then
    begin
      pi^.banInfo^.info := c;
      AddGameEvent(pi^.Nick + ' gets notated.', pi^.Nick);
    end;
  end else begin
    new(ban);
    ban^.comment := c;
    ban^.nick := spack;
    ban^.deleted := false;
    ban^.lastChange := now;
    ListContainer.banlist.AddEntry(ban);
    if assigned(pi) then begin
      pi^.banInfo^.ban := c;
      AddGameEvent(pi^.Nick + ' gets banned.', pi^.Nick);
    end;
  end;
  RefreshLocalDatabase;
  result := true;
end;

function TWC3Banlist_Main.InMyIp(ip: string): boolean;
var
  i: integer;
  addr: dword;
begin
  result := false;
  addr := inet_addr(pchar(ip));
  for i := 0 to ipcount - 1 do
    if (addr = myip[i]) then
    begin
      result := true;
      break;
    end;
end;

function TWC3Banlist_Main.InMyIp(ip: dword): boolean;
var
  i: integer;
begin
  result := false;
  for i := 0 to ipcount - 1 do
    if (ip = myip[i]) then
    begin
      result := true;
      break;
    end;
end;

procedure TWC3Banlist_Main.Edit5KeyPress(Sender: TObject; var Key: Char);
var
  dummy: boolean;
begin
  if key = #13 then
  begin
    key := #0;
    checkspack(edit5.Text, false, dummy);
    edit5.Text := checkresult;
    edit5.SelectAll;
  end;
end;

procedure TWC3Banlist_Main.Edit5Click(Sender: TObject);
begin
  edit5.SelectAll;
end;

procedure TWC3Banlist_Main.PaketTimerTimer(Sender: TObject);
const
  jobs: array[0..21] of string = ('Check for invalid packets', // 0
    'Downloader''s Autokick', // 1
    'Someone leaves, you''re host', // 2
    'Search for nick in current game table', // 3
    'Someone leaves, you''re client', // 4
    'You start hosting a game', // 5
    'You''re joining a game hosted by another', // 6
    'Record the ID of the just joined player', // 7
    'Playerpositions', // 8
    'Playernames', // 9
    'Someone enters a game, you''re client', // 10
    'Someone enters a game, you''re host', // 11
    'Server Command ( / )', // 12
    'Login Data like nickname, BN-Server, local port of battle.net-connection', // 13
    'Chat: client speaks', // 14
    'Chat: host speaks', // 15
    'Someone is whispering you', // 16
    'Game is starting', // 17
    'Game finished', // 18
    'Get Realm', //19
    'Process chat data', // 20
    'Get Warcraft Friend List' //21
    );
  achtsec = 8000;
  sec = 1000;
var
  i, j, k, l: integer;
  size: word;
  ip: string;
  clip: string;
  nick: string;
  text: string;
  pcon: PPlayerCon;
  autokick, b: boolean;
  chk: integer;
  t: tstringlist;
  p: TPacket;
  pp: PPacket;
  port: word;
  lw: longword;
  job: integer;
  pi: PPlayerInfo;
  li: TList;
  cr: TCheckResult;
  n: PVirtualNode;
  pgnd: PGameNodeData;
begin
  PaketTimer.Enabled := false;
  // Refresh GameTimer
  if gameState = gsInGame then
    lblGameTimer.Caption := TimeToDuration(GetTickCount - gamestart);

  while dequeuePacket(p) do
  begin
    i := 0;
    job := 0;
    try
      // Packet Loop
      if (p.Length > i) and (p.GetByte(i) in [$F7, $FF]) then
        while i + 3 < p.Length do
        begin // +3 because of size-bytes following the command code
          size := p.GetByte(i + 2) + p.GetByte(i + 3) shl 8;
          job := 0;
          // check for invalid packets
          if (size = 0) or (i + size > p.Length) or ((i + size < p.Length) and
            not (p.GetByte(i + size) in [$F7, $FF, $0])) then
          begin
            break;
          end;
          if inMyIP(p.DestIP) then
            trafficWC3In := true
          else
            trafficWC3Out := true;
          job := 1;
          // Downloader's Autokick / anti download
          if ishost and (p.GetByte(i) = $F7) and (p.GetByte(i +
            1) = $42) and (inmyip(p.DestIP)) then
          begin
            pcon := FindConnection(p.SrcIP, p.SrcPort);
            if chkAntidownload.Checked and
              (p.GetCardinal(i + 9) <> lastMapSize) and
               (pcon <> nil) and pcon^.connected and not IsBuddy(pcon^.name) then
                AddKickOrder(pcon, chkADLWhisper.checked);
          end;
          job := 2;
          // Someone leaves intentionally, you're host
          if ishost and (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $21) and
            (inmyip(p.DestIP)) then
          begin
            lw := p.SrcIP;
            port := p.SrcPort;
            pcon := FindConnection(lw, port);
            if pcon <> nil then
            begin
              nick := pcon^.name;
              k := 0;
              job := 3;
              // search for nick in current game table
              n := vtGame.GetFirst;
              while n <> nil do begin
                pgnd := vtGame.GetNodeData(n);
                if pgnd^.Nick = nick then begin
                  k := pgnd^.Slot - 1;
                  break;
                end;
                n := vtGame.GetNextSibling(n);
              end;
              // only play sound and set last leaver if nick is in current game table
              if Assigned(n) then
              begin
                AddGameEvent(nick + ' leaves.', nick);
                // only set a cross if game started already
                if not (gameState in [gsChat, gsLobby]) then
                begin
                  gd.left[k] := true;
                  Sound(SND_LEAVER);
                  lastleaver := nick;
                  if chkCloseOnLeaver.Checked and (gameState = gsCountDown) then
                    LeaverWhileCountdown;
                  if frmLatencyPlots.Visible then
                  begin
                    btnGameRefreshClick(nil);
                    InitAndShowLatencyPlots;
                  end;
                end;
              end else
                AddGameEvent(nick + ' not found in game.', nick);
            end;
          end;
          // Someone leaves/lags out and has to be removed of the teamlist
          if (gameState <> gsChat) and (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $07) then
          begin
            gd.SetLeft(p.GetByte(i + 4));
            if not (gameState in [gsChat, gsLobby]) then
              gd.SetTeamRatiosAfterLeaver;
          end;
          // Someone leaves, you're host, clients are being informed
          if ishost and (gameState <> gsChat) and (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $07) and
            inmyip(p.SrcIP) then
          begin
            k := p.GetByte(i + 4);
            nick := gd.names[k];
            if (nick<>username.caption) // own name appears if you leave as host
              and not (gameState in [gsChat, gsLobby])
              and (not gd.left[gd.GetSlotByID(k)])
              and (not gd.lostConnection[gd.GetSlotByID(k)]) then
            begin
              AddGameEvent(nick + ' has lost the connection.', nick);
              gd.lostConnection[gd.GetSlotByID(k)] := true;
              if frmLatencyPlots.Visible then
              begin
                btnGameRefreshClick(nil);
                InitAndShowLatencyPlots;
              end;
            end;
            k := 0;
            // kick the unwanted (those who have been thrown out due to being a leaver)
            while k < unWanted.Count do
              if nick = unwanted[k] then
              begin
                unWanted.Delete(k);
              end
              else
                inc(k);
          end;
          job := 4;
          // Someone leaves, you're client
          if (gameState <> gsChat) and (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $07) and
            inmyip(p.DestIP) then
          begin
            k := 0;
            nick := gd.names[p.getbyte(i + 4)];
            if nick = lastAutoRefreshName then
              n := nil
            else begin
              // search for nick in current game table
              n := vtGame.GetFirst;
              while n <> nil do begin
                pgnd := vtGame.GetNodeData(n);
                if pgnd^.Nick = nick then begin
                  k := pgnd^.Slot - 1;
                  break;
                end;
                n := vtGame.GetNextSibling(n);
              end;
            end;
            // only play sound and set last leaver if nick is in current game table
            if Assigned(n) then
            begin
              AddGameEvent(nick + ' leaves.', nick);
              if not (gameState in [gsLobby, gsChat]) then
              begin
                gd.left[k] := true;
                Sound(SND_LEAVER);
                lastleaver := nick;
                if chkCloseOnLeaver.Checked and radAutoCloseHostAndClient.Checked
                  and (gameState = gsCountDown) then
                  LeaverWhileCountdown;
              end;
            end;
          end;
          job := 5;
          // You start hosting a game
          if (p.GetByte(i) = $FF) and (p.getbyte(i + 1) = $1C) and (p.GetByte(i
            + 4) in [$10, $11]) and (p.GetByte(i + 8) = 0) and inmyip(p.SrcIP)
              then
          begin
            NewGame;
            lastHostName := username.Caption;
            text := FindRealm(p.DestIP);
            if text <> '' then
              AddGameEvent('New game on ' + text + '.')
            else
              AddGameEvent('Unknown realm: ' + p.Dest);
            ishost := true;
            SetGameState(gsLobby);
          end;
          job := 6;
          // You're joining a game hosted by another
          if (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $1E) and
            inmyip(p.SrcIP) then
          begin
            // check packet
            chk := 0;
            ishost := false;
            SetGameState(gsLobby);
            for k := 5 to 12 do
              inc(chk, p.GetByte(i + k));
            if chk = 0 then
            begin
              LastHost := p.DestIP;
              NewGame;
              username.Caption := p.GetString(i + 19);
              username.Tag := 1;
            end;
          end;
          job := 7;
          // Record the ID of the just joined player
          if (gameState <> gsChat) and ishost and (p.GetByte(i) = $F7) and (p.GetByte(i + 1) =
            $04) and (size > $17) and inmyIP(p.SrcIP) then
          begin
            lw := p.DestIP;
            port := p.DestPort;
            pcon := nil;
            // searching pertinent connection entry
            for k := 0 to conlist.Count - 1 do
              if (PPlayerCon(conlist[k])^.ip = lw) and
                (PPlayerCon(conlist[k])^.port = port) then
              begin
                pcon := conlist[k];
                break;
              end;
            if (pcon <> nil) and (pcon^.id = $FF) then
            begin
              // offset of first slot + slotcount*slotlength + offset bedind last slot
              l := i + 7 + p.getByte(i + 6) * 9 + 6;
              gd.SetName(p.GetByte(l), pcon.name);
              pcon^.id := p.GetByte(l);
            end;
          end;
          job := 8;
          // Playerpositions
          if wc3open and (gameState = gsLobby) and (p.GetByte(i) = $F7) and
            (p.GetByte(i + 1) = $09) then
          begin
            gd.ScanPacket(@p.p.d^[i]);
            if todoSetHumanPlayerCountInParseExceptions then
            begin
              SetHumanPlayerCountForException(lastMapName, IntToStr(gd.GetHumanPlayerSlotCount));
              todoSetHumanPlayerCountInParseExceptions := false;
            end;
          end;
          job := 9;
          // Playernames
          if (gameState = gsLobby) and (p.GetByte(i) = $F7) and (p.getbyte(i + 1) = $06) then
          begin
            if ishost and (p.GetByte(i + 8) = 1) then
              username.Caption := p.GetString(i + 9);
            gd.SetName(p.GetByte(i + 8), p.GetString(i + 9));
          end;
          job := 10;
          // Someone enters a game, you're client
          if not ishost and (gameState = gsLobby) and (p.GetByte(i) = $F7) and (p.GetByte(i + 1)
            = $06) and inmyip(p.DestIP) then
          begin
            nick := p.GetString(i + 9);
            gd.SetName(p.GetByte(i + 8), nick);
            k := i + 9 + length(nick);
            if p.GetByte(i + 8) = 1 then
              lw := p.SrcIP
            else
              BytesToIP(p.GetByte(k + 7), p.GetByte(k + 8), p.GetByte(k + 9),
                p.GetByte(k + 10), @lw);
            if not (lw = $0100007F) then
            begin
              checkresult := '';
              li := TList.Create;
              pl.Add(nick, lw, li);
              b := false;
              Clip := '';
              checkresult := '';
              cr := checkspack(nick, true, autokick);
              if cr in [crBan, crNote, crVIP] then
              begin
                b := true;
                Clip := CheckResult + ' ';
              end;
              AddGameEvent(nick + ' joins.', nick);
              lastJoiner := nick;
              if chkMultipleIP.Checked and (li.Count > 0) then
              begin
                // Check whether same IP with other nick is already in list
                Sound(SND_SAMEIP);
                t := tstringlist.create;
                for k := 0 to li.Count - 1 do
                  t.add(PPlayerInfo(li[k])^.Nick);
                // Assemble the text if multiple IP usage occured
                if t.Count > 0 then
                begin
                  text := clip + nick + ' has the same IP like ' + t[0];
                  if t.count > 1 then
                  begin
                    for k := 1 to t.count - 2 do
                      text := text + ', ' + t[k];
                    text := text + ' and ' + t[t.count - 1];
                  end;
                  text := text + '.';
                  //if Clip='' then text:=text+' No information on '+nick+'.';
                  for k := 0 to t.count - 1 do
                  begin
                    checkresult := '';
                    cr := checkspack(t[k], false, autokick);
                    if cr in [crBan, crNote, crVIP] then
                      text := text + ' ' + checkresult;
                  end;
                  AddMessage(text, ICON_NOTE, nick);
                  b := false;
                end;
                t.free;
              end;
              if b then
                AddMessage(Clip, ICON_NOTE, nick);
              li.free;
              if not CheckNickNameSpelling(nick) then
                AddMessage('WARNING! ' + nick + ' uses a name spoofer.', ICON_MESSAGE, nick);
            end else
              lastAutoRefreshName := nick;
          end;
          job := 11;
          // Someone enters a game, you're host
          if (gameState = gsLobby) and ishost and (p.GetByte(i) = $F7) and
            (p.GetByte(i + 1) = $1E) and inmyIP(p.DestIP) then
          begin
            nick := p.GetString(i + 19);
            IP := p.Src;
            pcon := nil;
            // Add client connection information
            for k := 0 to conlist.Count - 1 do
              if lowercase(PPlayerCon(conlist[k])^.name) = lowercase(nick) then
                pcon := conlist[k];
            if pcon = nil then
            begin
              New(pcon);
              conlist.Add(pcon);
            end;
            pcon^.ip := p.SrcIP;
            pcon^.port := p.SrcPort;
            pcon^.id := $FF;
            pcon^.name := nick;
            pcon^.connected := true;
            if (gd.GetFreeSlots <> '0') then
            begin
              li := TList.Create;
              pl.Add(nick, p.SrcIP, li);
              AddGameEvent(nick + ' joins.', nick);
              lastJoiner := nick;
              // Check for reservations
              try
                k := StrToInt(gd.GetFreeSlots);
                if not Reserve.CanJoin(lowercase(pcon^.name), k) then
                  AddKickOrder(pcon, false)
                else
                  RefreshReservations;
              except
                on e: EConvertError do
                begin
                  AddMessage('Cannot get free slot count for /reserve. Check your settings at Prefs->Misc and edit the exception list.', ICON_ERROR);
                  Reserve.CanJoin(lowercase(nick), 99);
                end;
              end;
              // Check whether the guy is on blacklist or banlist
              Clip := '';
              checkresult := '';
              b := false;
              cr := checkspack(nick, true, autokick);
              if cr in [crBan, CrNote, crVIP] then
              begin
                b := true;
                Clip := CheckResult + ' ';
                // check whether he was leaver and autoblock, so he wont enter again
                if autokick and chkAutoKick.Checked then
                begin
                  kill(nick);
                end;
              end;
              if chkMultipleIP.Checked and (li.Count > 0) then
              begin
                // Check whether same IP with other nick is already in list
                Sound(SND_SAMEIP);
                t := tstringlist.create;
                for k := 0 to li.Count - 1 do
                  t.add(PPlayerInfo(li[k])^.Nick);
                // Assemble the text if multiple IP usage occured
                if t.Count > 0 then
                begin
                  text := clip + nick + ' has the same IP like ' + t[0];
                  if t.count > 1 then
                  begin
                    for k := 1 to t.count - 2 do
                      text := text + ', ' + t[k];
                    text := text + ' and ' + t[t.count - 1];
                  end;
                  text := text + '.';
                  //if Clip='' then text:=text+' No information on '+nick+'.';
                  for k := 0 to t.count - 1 do
                  begin
                    checkresult := '';
                    cr := checkspack(t[k], false, autokick);
                    if cr in [crBan, crNote, crVIP] then
                      text := text + ' ' + checkresult;
                  end;
                  AddMessage(text, ICON_NOTE, nick);
                  b := false;
                end;
                t.free;
              end;
              if b then
                AddMessage(Clip, ICON_NOTE, nick);
              li.free;
              if not CheckNickNameSpelling(nick) then
                AddMessage('WARNING! ' + nick + ' uses a name spoofer.', ICON_MESSAGE, nick);
            end;
          end;
          job := 12;
          // Server Command ( / )
          if (p.GetByte(i) = $FF) and (p.getbyte(i + 1) = $0E) and
            inmyip(p.SrcIP) then
          begin
            text := p.GetString(i + 4);
            text := Utf8ToAnsi(text);
            DoCommand(text);
          end;
          job := 13;
          // Login Data like nickname, BN-Server, local port of battle.net-connection
          if (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $53) and
            inmyip(p.SrcIP) then
          begin
            username.Caption := p.GetString(i + 36);
            my_ip := p.SrcIP;
            bn_ip := p.DestIP;
            bnip.Caption := p.Dest;
            lport.Caption := inttostr(p.GetByte(34) shl 8 + p.GetByte(35));
            loggedon := true;
          end;
          job := 14;
          job := 16;
          // someone is whispering you
          if (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $0F) and (p.GetByte(i
            + 4) = $04) and inmyip(p.DestIP) then
          begin
            k := i;
            inc(k, 28);
            nick := p.GetString(k);
            while p.GetByte(k) <> $0 do
              inc(k);
            inc(k);
            text := p.GetString(k);
            MessageCenter.AddChat(nick, text, wtIn);
            if chkSemiAutomaticJoin.Checked and (gameState in [gsChat, gsLobby]) then
              CheckFriendJoin(text);
            // set whispered state
            if (GameState <> gsChat) and gd.InGame(nick) then
            begin
              pl.SetWhispered(nick);
            end;
            lastWhisperSender := nick;
          end;
          job := 17;
          // game is starting
          if (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $0A) and (gameState = gsLobby) then
          begin
            AddGameEvent('Countdown started.');
            SetGameState(gsCountDown);
          end;
          if (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $0B) and (gameState = gsCountDown) then
          begin
            AddGameEvent('Map loading.');
            SetGameState(gsLoading);
          end;
          if (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $0C) and (gameState = gsLoading) then
          begin
            AddGameEvent('Game started.');
            SetGameState(gsInGame);
          end;
          job := 18;
          // game finished
          if (gameState <> gsChat) and (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $44) then begin
            if (gameState <> gsLobby) then
            begin
              AddGameEvent('Game over.');
              GameOver;
            end else
              AddGameEvent('Game aborted.');
            SetGameState(gsChat);
          end;
          job := 19;
          // get realm
          if (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $22) and
            inmyip(p.SrcIP) then
          begin
            text := FindRealm(p.DestIP);
            if text <> '' then
              AddGameEvent('New game on ' + text + '.')
            else
              AddGameEvent('Unknown realm: ' + p.Dest);
          end;
          // find realm while chatting (secures found realm in any case)
          if (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $0E) then
            FindRealm(p.DestIP);
          if (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $0F) then
            FindRealm(p.SrcIP);
          // get map name and game name
          if (p.GetByte(i) = $F7) and (p.GetByte(i + 1) = $3D) then
          begin
            lastMapName := p.GetString(i + 8);
            lastMapSize := p.GetCardinal(i + 8 + length(lastMapName) + 1);
            lastMapName := ExtractFileName(Utf8ToAnsi(lastMapName));
            lblMap.Caption := lastMapName;
            if not flagChannelChangedToGame then
            begin
              MessageCenter.ChangeGame(lastGameTitle, lastMapName);
              flagChannelChangedToGame := true;
            end;
          end;
          // client
          if (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $22) then
          begin
            lastGameTitle := Utf8ToAnsi(p.GetString(i + 12));
            lblGameTitle.Caption := lastGameTitle;
          end;
          // host
          if (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $1C) and (size > 24)
          then begin
            lastGameTitle := Utf8ToAnsi(p.GetString(i + 24));
            lblGameTitle.Caption := lastGameTitle;
            l := length(p.GetString(i + 24));
            lastGameCode := '';
            // only public games
            if (p.GetByte(i + 4) and 1 = 0) then
              for k := 0 to 7 do
                lastGameCode := lastGameCode + Chr(p.GetByte(i + k + l + 24 + 3));
            autorefresher.GameCode := lastGameCode;
            autorefresher.ResetTimer;
            lastAutoRefreshName := autorefresher.NickName;
            text := p.GetString(i + 24 + length(AnsiToUtf8(lastGameTitle)) + 11);
            text := DecryptString(text);
            delete(text, 1, 13);
            k := pos(#0, text);
            lastMapName := Copy(text, 1, k - 1);
            delete(text, 1, k);
            username.Caption := Copy(text, 1, pos(#0, text) - 1);
            // get mapinfo (free slots)
            if todoGetSlotCount then
            begin
              GetFreeSlotsDefaultValue(lastMapName);
              todoGetSlotCount := false;
            end;
            lastMapName := ExtractFileName(lastMapName);
          end;
          job := 20;
          // Chat out
          if btnChatMode.Down and (p.GetByte(i) = $FF) and (p.GetByte(i + 1) =
            $0E) then
          begin
            text := p.GetString(i + 4);
            if copy(text, 1, 1) <> '/' then
              MessageCenter.AddChat(username.Caption, text, wtChatOut);
          end;
          // Chat In
          if (p.GetByte(i) = $FF) and (p.GetByte(i + 1) = $0F) then
          begin
            case p.GetByte(i + 4) of
              01: AddChatter(p.GetString(i + 28));
              02: AddChatter(p.GetString(i + 28));
              03: RemoveChatter(p.GetString(i + 28));
              // ChatIn
              05: if btnChatMode.Down then
                begin
                  nick := p.GetString(i + 28);
                  text := p.GetString(i + 28 + length(nick) + 1);
                  MessageCenter.AddChat(nick, text, wtChatIn);
                  AddChatter(nick);
                end;
              // Change Channel
              07:
                begin
                  ClearChatters;
                  nick := p.GetString(i + 30);
                  username.Caption := nick;
                  text := Utf8ToAnsi(p.GetString(i + 30 + length(nick) + 1));
                  panChatHeader.Caption := text;
                  MessageCenter.ChangeChannel(text);
                end;
              // BnetInfo
              $12: if btnChatMode.Down then
                begin
                  nick := p.GetString(i + 30);
                  text := p.GetString(i + 30 + length(nick) + 1);
                  MessageCenter.AddInfo(text, wtBNetInfo);
                end;
              // BnetError
              $13: if btnChatMode.Down then
                begin
                  nick := p.GetString(i + 30);
                  text := p.GetString(i + 30 + length(nick) + 1);
                  MessageCenter.AddInfo(text, wtBNetError);
                end;
              // Emote
              $17: if btnChatMode.Down then
                begin
                  nick := p.GetString(i + 28);
                  text := p.GetString(i + 28 + length(nick) + 1);
                  MessageCenter.AddChat(nick, text, wtEmoteIn);
                  AddChatter(nick);
                end;
            end;
          end;
          // Warcraft Friend List
          job := 21;
          if (p.GetByte(i) = $FF) and (p.GetByte(i+1) = $65) and (p.GetByte(i+2) > 4) then begin
            l := p.GetByte(i+4);
            j := 5;
            lbWC3FriendList.Items.Clear;
            while l > 0 do begin
              nick := '';
              while(p.GetByte(i+j) <> 0) do
              begin
                nick := nick + chr(p.GetByte(i+j));
                inc(j);
              end;
              inc(j, 7);
              while(p.GetByte(i+j) <> 0) do inc(j);
              inc(j);
              lbWC3FriendList.Items.Add(nick);
              dec(l);
            end;
          end;
          //
          // Jump to next record in packet
          inc(i, size);
        end;
      p.Free;
    except
      on e: Exception do
      begin
        t := TStringlist.Create;
        pk.MakeText(pk.AddPacket(p.Where, p.Length), t);
        MessageCenter.AddError(e.Message, jobs[job], t.Text);
        t.Free;
        p.Free;
      end;
    end;
  end;
  pakettimer.Enabled := true;
end;


// EXPERIMENTAL

procedure TWC3Banlist_Main.SendChatCommand(a: string);
var
  b: array[0..1000] of byte;
  size: word;
  i: integer;
  msg: string;
begin
  fillchar(b, 0, sizeof(b));
  b[0] := $FF;
  b[1] := $0E;
  size := htons(length(a) + 5);
  copymemory(@b[2], @size, 2);
  copymemory(@b[4], @a[1], length(a));
  for i := 0 to length(a) + 3 do
    msg := msg + chr(b[i]);
  msg := msg + #0;
  // Last ACK and SEQ have to be exchanged
  sendtcppacket(IPtoStr(@my_ip), strtoint(lport.caption), Iptostr(@bn_ip),
    BATTLE_NET_PORT, msg, $08, lastack, 0);
  //sendtcppacket(IPtoStr(@bn_ip),BATTLE_NET_PORT,Iptostr(@my_ip),strtoint(lport.caption),'',$04,lastseq,lastack);
end;

procedure TWC3Banlist_Main.lvSoundsChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
  b: boolean;
begin
  b := (lvSounds.Selected <> nil);
  if change = ctstate then
  begin
    enableSound.Enabled := b and fileexists(item.subitems[1]) and
      (item.SubItems[0] = 'disabled');
    disableSound.Enabled := b and (item.SubItems[0] = 'enabled');
    hearSound.Enabled := b and fileexists(item.subitems[1]);
    openSound.Enabled := b;
  end;
end;

procedure TWC3Banlist_Main.OpenSoundClick(Sender: TObject);
var
  a: string;
begin
  if open1.Execute then
  begin
    chdir(pchar(inipath));
    a := open1.filename;
    if fileexists(a) then
      lvSounds.Selected.SubItems[1] := a;
    lvSounds.Selected.SubItems[0] := 'enabled';
    lvSoundsChange(nil, lvSounds.Selected, ctState);
  end;
end;

procedure TWC3Banlist_Main.EnableSoundClick(Sender: TObject);
begin
  lvSounds.Selected.SubItems[0] := 'enabled';
  lvSoundsChange(nil, lvSounds.Selected, ctState);
end;

procedure TWC3Banlist_Main.DisableSoundClick(Sender: TObject);
begin
  lvSounds.Selected.SubItems[0] := 'disabled';
  lvSoundsChange(nil, lvSounds.Selected, ctState);
end;

procedure TWC3Banlist_Main.HearSoundClick(Sender: TObject);
begin
  playsound(pchar(lvSounds.Selected.SubItems[1]), 0, SND_ASYNC);
end;

function TWC3Banlist_Main.SoundFile(i: integer): string;
begin
  result := lvSounds.Items[i].SubItems[1];
end;

function TWC3Banlist_Main.SoundState(i: integer): boolean;
begin
  result := lvSounds.Items[i].SubItems[0] = 'enabled';
end;

procedure TWC3Banlist_Main.Sound(snd: integer);
begin
  if soundstate(snd) then
    playsound(pchar(soundFile(snd)), 0, SND_ASYNC);
end;

procedure TWC3Banlist_Main.FormShow(Sender: TObject);
var
  i: integer;
begin
  // Cassette Images
  for i := 0 to lvSounds.items.count - 1 do
    lvSounds.Items[i].ImageIndex := 7;
  Activate;
  MiscTimer.Enabled := true;
end;

procedure TWC3Banlist_Main.btnSyncClick(Sender: TObject);
begin
  if exchangingBanlist then
  begin
    IniInfo('Banlist transfer already in progress!');
    exit;
  end;
  if assigned(banlist) then
  begin
    banlist.WaitFor;
    FreeAndNil(banlist);
  end;
  if pages.activepage = tabPreferences then
    pages.ActivePage := tabOnlineBanlists;
  banlist := TBanlistThread.Create(true);
  banlist.Priority := tpLowest;
  banlist.parent := WC3Banlist_Main.Handle;
  banlist.doBuddyBanlist := chkBuddiesList.Checked;
  banlist.URLLogin := edtURLLogin.Text;
  banlist.URLDownload := edtURLDownload.Text;
  banlist.URLUpload := edtURLUpload.Text;
  pgblBuddylist.TabVisible := chkBuddiesList.Checked;
  if chkBuddiesList.Checked then
  begin
    pgblbuddylist.caption := 'Buddies'' Banlists (...)';
    banlist.login := edtBlLogin.Text;
    banlist.pass := edtBlPassword.Text;
    vstBuddy.Clear;
  end;
  banlist.Resume;
end;


procedure TWC3Banlist_Main.tvOptionsChange(Sender: TObject; Node: TTreeNode);
var
  i: Integer;
begin
  if tvoptions.Selected = nil then
    exit;
  if tvoptions.Selected.HasChildren then
    exit;
  TGroupBox(tvoptions.Selected.Data).Visible := true;
  TGroupBox(tvoptions.Selected.Data).BringToFront;
  with tabPreferences do
    for i := 0 to tvOptions.Items.Count - 1 do
      if tvoptions.Items[i] <> tvOptions.Selected then
        TGroupBox(tvOptions.Items[i].Data).Visible := false;
end;

procedure TWC3Banlist_Main.lblBanlistNLClick(Sender: TObject);
begin
  ShellExecute(0, 'open', PChar(TLabel(Sender).Hint), nil, nil, sw_show);
end;

procedure TWC3Banlist_Main.AddMessage(s: string; ImageIndex: Integer; nick: String);
var
  t: ^tscreenentry;
  last: ^tscreenentry;
  d: TDX2DFont_Create;
  id: cardinal;
  lines: integer;
begin
  // truncate to max 254 characters
  s := copy(s, 1, 254);
  // save for /lm command
  lastMessage := s;
  if GetForeGroundWindow = FindWindow('Warcraft III', 'Warcraft III') then
  if chkRunningText.Checked and assigned(scr.entries)
    then
    with scr do
    begin
      new(t);
      with t^ do
      begin
        x := wx;
        // keep a border while in game
        if gameState <> gsInGame then
          y := 0
        else
          y := 130;
        if entries.Count > 0 then
        begin
          last := entries[entries.count - 1];
          if x < (last^.w + last^.x + 100) then
            x := (last^.w + last^.x + 100);
          y := last^.y + last^.h + 5;
        end;
        str := s;
        w := c.TextWidth(s);
        lines := (w div (wx - 5)) + 1;
        h := c.TextHeight(s) * lines;
        l := length(s);
        // create DirectX 2d Font Object
        FillChar(d.Text, sizeof(d.Text), #0);
        if l > 0 then Move(s[1], d.Text, l);
        d.TextLength := l;
        d.hFont := Marqueefont.Handle;
        d.Rect.Left := 5;
        d.Rect.Right := -2147483647;
        d.Rect.Top := y;
        d.Rect.Bottom := y + h;
        alpha := $FF;
        d.Color := MakeColor(alpha, marqueefont.Color and $FF, (marqueefont.Color
          and $FF00) shr 8, (marqueefont.Color and $FF0000) shr 16);
        if hookMode = 2 then
        begin
          id := SendMessage_DX2DFont_Create(d);
          f := DX2DFont_CreateToModify(d);
          f.ID := id;
        end
        else
          f.ID := 0;
      end;
      entries.Add(t);
      if not ping.Busy then
        FlickerTimer.Enabled := true;
    end;
  AddToLog(s, ImageIndex, nick);
  if chkClipboard.checked then
    ct.SetText(ansitoutf8(s));
end;

procedure TWC3Banlist_Main.WarcraftWindowTimerTimer(Sender: TObject);
var
  nfg: THandle;
  i: integer;
  p: string;
  l: TList;
  hotkey: PHotKeyData;
begin
  if StartupTime = 0 then
    StartupTime := GetTickCount;
  if hookMode = 1 then
    GetHookPointers;
  if (hookMode = 2) and (scr.loops = 0) then
    AddMessage('DirectX-API hook for WC3Banlist installed successfully.', ICON_DX);
  warcraftWindowTimer.Enabled := false;
  cc := false;
  nfg := findwindow('Warcraft III', 'Warcraft III');
  if nfg > 0 then
    inc(scr.loops)
  else
    scr.loops := 0;
  // install hook
  if (hookMode = 1) and (scr.loops > 0) and Inject then
  begin
    hookMode := 2;
    scr.loops := 0;
  end;
  with scr do
  begin
    // warcraft opened?
    if (nfg <> fg) and (c = nil) then
    begin
      // try to get it from process list
      WC3Path := ExtractFilePath(GetProcessNameFromWnd(nfg));
      // try to get it from registry
      if WC3Path = '' then
        WC3Path := GetInstallPathOfWC3;
      // retry to install hook if failed
      if hookTries = -1 then
        hookTries := -2;
      wc3open := true;
      fg := nfg;
      dc := getdc(fg);
      if dc <> 0 then
      begin
        c := tcanvas.Create;
        c.Handle := dc;
        c.Brush.Color := clBlack;
        c.Font.Assign(MarqueeFont);
        if chkTransparent.Checked then
          SetBkMode(c.Handle, TRANSPARENT);
        wx := GetDeviceCaps(dc, horzres);
        dx := 2;
        entries := tlist.Create;
        // determine if RoC or TFT is running
        GetWarcraftType(fg);
        case wc3Type of
          0: AddToLog('Type of Warcraft III could not be identified.', WC3IconIndex);
          1: AddToLog('Warcraft III - Reign Of Chaos found.', WC3IconIndex);
          2: AddToLog('Warcraft III - The Frozen Throne found.', WC3IconIndex);
        end;
        if WC3Path = '' then
          AddMessage('WC3Banlist was unable to retrieve the installation path of Warcraft III. Map parsing will not work.', ICON_ERROR);
      end else
        fg := 0;
    end
    // warcraft closed?
    else if (nfg <> fg) and (c <> nil) then
    begin
      wc3open := false;
      if hookMode = 2 then
        hookMode := 1;
      releasedc(fg, dc);
      c.Free;
      c := nil;
      fg := 0;
      for i := 0 to entries.Count - 1 do
        dispose(entries[i]);
      entries.Free;
      entries := nil;
      if gameState <> gsChat then
      begin
        if gameState <> gsLobby then
        begin
          AddGameEvent('Game over.');
          SetGameState(gsChat);
          GameOver;
        end else begin
          AddGameEvent('Game aborted.');
          SetGameState(gsChat);
        end;
      end;
    end;
    // handle hotkeys, when warcraft in foreground
    if Assigned(HKReceiver) then
    begin
      if (c <> nil) and (fg = getforegroundwindow) and (GetWindowState(fg) in
        [SW_SHOWNORMAL, SW_SHOWMAXIMIZED]) then
      begin
        l := HKReceiver.ThreadList.LockList;
        try
          for i := 0 to l.Count - 1 do
          begin
            hotkey := l[i];
            p := '';
            case hotkey^.Key of
              VK_F2: p := FindPhrase(2);
              VK_F3: p := FindPhrase(3);
              VK_F4: p := FindPhrase(4);
              VK_F5: p := FindPhrase(5);
              VK_F6: p := FindPhrase(6);
              VK_F7: p := FindPhrase(7);
              VK_F8: p := FindPhrase(8);
              VK_F9: p := FindPhrase(9);
              VK_SCROLL: PhraseKeeper1.Clear;
            end;
            if p <> '' then
              WriteChatLine(p);
            Dispose(hotkey);
          end;
          l.Clear;
        finally
          HKReceiver.ThreadList.UnlockList;
        end;
      end
      else
        HKReceiver.Clear;
    end;
  end;
  cc := true;
  warcraftWindowTimer.Enabled := true;
end;

procedure TWC3Banlist_Main.FlickerTimerTimer(Sender: TObject);
var
  i: integer;
  t: ^tscreenentry;
  deleted: boolean;
  modalpha: TDX2DFont_Modify_Alpha;
  alphadecrement: byte;
begin
  cc := false;
  with scr do
    if (c <> nil) and (fg = getforegroundwindow) then
    begin
      flickerTimer.Enabled := false;
      i := 0;
      while i < entries.Count do
      begin
        t := entries[i];
        deleted := false;
        with t^ do
        begin
          if f.ID > 0 then
          begin
            // delete new style messages when switched to gdi mode
            if hookMode = 0 then
              deleted := true
            else if l > 0 then
              dec(l)
            else
            begin
              if chkFade.Checked then
              begin
                alphadecrement := ((255 - alpha) div 3) + 2;
                if alpha > alphadecrement then
                  dec(alpha, alphadecrement)
                else
                  deleted := true;
              end
              else
                deleted := true;
            end;
          end
          else
          begin
            // delete old style messages when switched to directx mode
            if hookMode > 0 then
              deleted := true;
            dec(x, dx);
            // disappeared in left border?
            if x < -w then
              deleted := true
          end;
          // draw
          if not deleted then
            if f.id = 0 then
              c.TextOut(x, 0, str)
            else if (l = 0) and chkFade.Checked then
            begin
              modalpha.ID := f.ID;
              modalpha.Alpha := alpha;
              if (hookMode = 2)then
                SendMessage_DX2DFont_Modify_Alpha(modalpha);
            end;
          // make invisible
          if deleted and (f.id > 0) and chkFade.Checked then
          begin
            modalpha.ID := f.ID;
            modalpha.Alpha := 0;
            if (hookMode = 2) then
              SendMessage_DX2DFont_Modify_Alpha(modalpha);
          end;
        end;
        if deleted then
        begin
          if (t^.f.ID > 0) and (hookMode = 2) then
            SendMessage_DXObject_Delete(t^.f.ID);
          dispose(t);
          entries.Delete(i);
        end
        else
          inc(i);
      end;
      if entries.Count > 0 then
        FlickerTimer.Enabled := true;
    end;
  cc := true;
end;

procedure TWC3Banlist_Main.PingPlayer(n: string);
var
  a: string;
  pingResult: Integer;
  lw: cardinal;
begin
  a := n;
  lw := FindPlayerIP(n);
  if lw = 0 then
    AddMessage('Player ' + a + ' not found or IP address unknown.', ICON_MESSAGE, a)
  else
  begin
    pingResult := raw_ping.Ping(lw);
    if pingResult < 0 then
      AddMessage('Ping to ' + n + ' : timed out.', ICON_NETWORK, n)
    else
      AddMessage('Ping to ' + n + ' : ' + IntToStr(pingResult) + ' ms.', ICON_NETWORK, n);
    pl.SetPing(n, pingResult);
  end;
  Sound(SND_RESPONSE);
end;

procedure TWC3Banlist_Main.LoadSettingsPages;
var
  i: integer;
begin
  i := 0;
  SetLength(SettingsPages, 100);
  with SettingsPages[i] do
  begin
    caption := 'Online Lists';
    page := panSync;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Databases';
    page := panDatabases;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Phrases';
    page := panPhrases;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Anti Download';
    page := panAntiDownload;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Auto Kick';
    page := panAutoKick;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Network';
    page := panNICSettings;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Messaging';
    page := panMessaging;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Sounds';
    page := panSounds;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Custom Comments';
    page := panCustomComments;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Friends List';
    page := panFriendlist;
    inc(i);
  end;
  with SettingsPages[i] do
  begin
    caption := 'Miscellaneous';
    page := panMisc;
    inc(i);
  end;
  SetLength(SettingsPages, i);
end;

procedure TWC3Banlist_Main.InstallSettingsPages;
var
  i: integer;
begin
  tvOptions.Perform(TVM_SETITEMHEIGHT, 36, 0);
  for i := 0 to High(SettingsPages) do
    with SettingsPages[i] do
        with tvOptions.Items.AddChild(nil, caption) do
        begin
          ImageIndex := i;
          SelectedIndex := i;
          //SelectedIndex:=0;
          Data := page;
        end
end;

procedure TWC3Banlist_Main.btnAddPhraseClick(Sender: TObject);
var
  l: TListItem;
begin
  l := lvPhrases.Items.add;
  with l do
  begin
    Caption := 'New Phrase';
    Subitems.Add('');
    Subitems.add('');
    ImageIndex := 10;
  end;
  lvPhrases.Selected := l;
  edtPhraseName.SetFocus;
end;

procedure TWC3Banlist_Main.lvPhrasesChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  if lvPhrases.Selected = nil then
  begin
    edtPhraseName.Enabled := false;
    memoPhraseText.Enabled := false;
    edtPhraseName.text := '';
    memoPhraseText.Text := '';
  end
  else
  begin
    edtPhraseName.text := lvPhrases.Selected.Caption;
    memoPhraseText.Text := lvPhrases.Selected.SubItems[0];
    edtPhraseName.Enabled := true;
    memoPhraseText.Enabled := true;
  end;
  lblPhraseMessage.Caption := '';
end;

procedure TWC3Banlist_Main.edtPhraseNameChange(Sender: TObject);
var
  l, o: TListItem;
  i: integer;
begin
  if edtPhraseName.Enabled then
  begin
    l := lvPhrases.Selected;
    o := nil;
    for i := 0 to lvPhrases.items.count - 1 do
      if (lvPhrases.Items[i].Caption = l.Caption) and (l.index <> i) then
      begin
        o := lvPhrases.Items[i];
        break;
      end;
    l.Caption := edtPhraseName.Text;
    if (l.SubItems[1] <> '') and (o <> nil) then
    begin
      lblPhraseMessage.Caption :=
        'Renaming the phrase has caused it to lose its assigned hotkeys,' + cr +
        'since there is at least one other phrase, that has the old name and hotkeys.';
      l.SubItems[1] := '';
    end
    else
    begin
      o := nil;
      for i := 0 to lvPhrases.items.count - 1 do
        if (l.Caption = lvPhrases.Items[i].Caption) and (l.index <> i) then
        begin
          o := lvPhrases.Items[i];
          break;
        end;
      if (o <> nil) and (o.SubItems[1] <> l.SubItems[1]) then
      begin
        lblPhraseMessage.caption :=
          'The phrase you just created/edited has the same name like another phrase ' +
          'which has different hotkeys. The hotkeys of the other have been assigned to this one.';
        l.SubItems[1] := o.SubItems[1];
      end
      else
        lblPhraseMessage.Caption := '';
    end;
  end;
end;

procedure TWC3Banlist_Main.memoPhraseTextChange(Sender: TObject);
begin
  if memoPhraseText.Enabled then
    lvPhrases.Selected.SubItems[0] := memoPhraseText.Text;
end;

procedure TWC3Banlist_Main.btnDeletePhraseClick(Sender: TObject);
begin
  if lvPhrases.Selected <> nil then
    lvPhrases.Selected.Delete;
end;

procedure TWC3Banlist_Main.lvPhrasesMouseUp(Sender: TObject; Button:
  TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if lvPhrases.Selected <> nil then
  begin
    edtPhraseName.SelectAll;
    edtPhraseName.SetFocus;
  end;
end;

procedure TWC3Banlist_Main.WriteChatLine(s: string);
var
  commands: TStringlist;
  i: Integer;
begin
  Sound(SND_RESPONSE);
  // clear $wait semaphore before using it
  if pos('$wait', s) > 0 then
    WaitForSingleObject(phraseKeeper1.hWaitSemaphore, 0);
  // split phrase into commands and rest
  commands := TStringList.Create;
  try
    // separate commands from ordinary text
    if chkOptimizedPhrases.Checked then
      SplitPhrase(s, commands, s);
    phraseKeeper1.Add(s);
    // execute commands at once without sending them to WC3
    if chkOptimizedPhrases.Checked then
      for i := 0 to commands.Count - 1 do
        DoCommand(SubstPhraseBackwards(commands[i]));
  finally
    commands.Free;
  end;
end;

function TWC3Banlist_Main.FindPhrase(p: string): string;
var
  i: integer;
  r: string;
  t: tlist;
  l: Integer;
  phraseText: String;
begin
  result := '';
  t := tlist.create;
  for i := 0 to lvPhrases.Items.Count - 1 do
    if (pos(lvPhrases.Items[i].Caption + ' ', p) = 1)
      or (p = lvPhrases.Items[i].Caption) then
      t.add(lvPhrases.items[i]);
  // sort by length (descending)
  t.Sort(CompareListItemByLengthOfCaption);
  if t.count > 0 then
  begin
    l := Length(TListItem(t[0]).Caption);
    i := 0;
    while i < t.Count do
      if Length(TListItem(t[i]).Caption) < l then t.Delete(i) else inc(i);
    i := random(t.count);
    phraseText := TListItem(t[i]).SubItems[0];
    phraseText := StringReplace(phraseText, #255, #255#255, [rfReplaceAll]);
    r := SubstPhrase(phraseText, true);
    delete(p, 1, Length(TListItem(t[i]).Caption));
    // remove dividing space
    if p <> '' then delete(p, 1, 1);
    if pos('$param', r) > 0 then
      ReplaceAll(r, '$param', p)
    else
      r := r + p;
    r := SubstPhrase(r, true);
    result := RemoveErrorneousSubstitutions(r);
  end;
  t.free;
end;

function TWC3Banlist_Main.FindPhrase(hk: integer): string;
var
  i: integer;
  r, c: string;
  t: tlist;
begin
  c := inttostr(hk);
  t := tlist.Create;
  result := '';
  with lvPhrases do
    for i := 0 to items.count - 1 do
      if pos(c, items[i].subitems[1]) > 0 then
        t.add(items[i]);
  if t.count = 0 then
    exit;
  i := random(t.count);
  r := SubstPhrase(TListItem(t.Items[i]).SubItems[0], true);
  result := RemoveErrorneousSubstitutions(r);
  t.free;
end;

procedure TWC3Banlist_Main.btnGameRefreshClick(Sender: TObject);
var
  i, j, c, w: integer;
  b: byte;
  ip: dword;
  client: Boolean;
  n, child: PVirtualNode;
  p: PGameNodeData;
  pbi: PBanInfo;
  pi: PPlayerInfo;
  pcon: PPlayerCon;
  // fields
  slot: integer;
  nick: string;
  from: string;
  ping: integer;
  latency: Cardinal;
  deviation: Cardinal;
  score: double;
  rating: integer;
  slotColor: Integer;
  selectedNodeIndex: Cardinal;
  selectedNodeNick: String;
  selectedNodeLevel: Cardinal;
  selectedNodePIndex: Cardinal;
  ban: string;
  info: string;
  onlineban: string;
  hasLeft, hasWhispered, hasLostConnection, isFriend, isHost: boolean;
  latencyValues: TList;
begin
  if not loadComplete then exit;
  // remember selection
  n := vtGame.GetFirstSelected;
  if n <> nil then
  begin
    selectedNodePIndex := n.Parent.Index;
    selectedNodeIndex := n.Index;
    selectedNodeNick := PGameNodeData(vtGame.GetNodeData(n))^.Nick;
    selectedNodeLevel := vtGame.GetNodeLevel(n);
  end else
  begin
    selectedNodeLevel := 0;
    selectedNodeIndex := 0;
    selectedNodePIndex := 0;
    selectedNodeNick := '-';
  end;

  latencyValues := TList.Create;
  vtGame.BeginUpdate;
  vtGame.Clear;
  c := 0; // Slot count
  w := 0; // Whisper count
  for i := 0 to gd.slots - 1 do
  begin
    slot := i + 1;
    nick := '';
    from := '';
    ping := 0;
    score := 0;
    rating := 0;
    ban := '';
    info := '';
    latency := 0;
    deviation := 0;
    onlineban := '';
    hasLeft := false;
    hasWhispered := false;
    hasLostConnection := false;
    isFriend := false;
    // nick
    client := false;
    b := gd.Data[i][0];
    isHost := b = 1;
    slotColor := gd.Data[i][5];
    if (gd.data[i][3] = 0) then
    begin
      if (gd.data[i][2] = 0) then
      begin
        nick := 'Open';
        inc(c);
      end
      else if (gd.data[i][2] = 1) then
        nick := 'Closed'
      else
      begin // players
        nick := gd.names[b];
        if (nick = '<self>') and (username.caption <> '') then
          nick := username.caption
        else
        if (nick = lastAutoRefreshName) then
        begin
          nick := 'Closed';
        end else
        begin
          // not the own name
          if (gd.names[b] <> username.Caption) then
          begin
            inc(c);
            client := true;
          end;
        end;
      end
    end
    else
      nick := 'Computer';
    if client then begin
      pi := pl.GetPlayerInfo(nick);
      if assigned(pi) then begin
        // from
        if (nick <> username.Caption) then
        begin
          ip := pi^.IP;
          if ip <> 0 then
            from := CountryCache.Check(iptostr(@ip));
        end;
        // hasLeft
        if gd.left[i] then hasLeft := true;
        // hasLostConnection
        if gd.lostConnection[i] then hasLostConnection := true;
        if client and pi^.Whispered then
        begin
          hasWhispered := true;
          inc(w);
        end;
        // ping
        ping := pi^.lastPing;
        // latency
        latency := 0;
        deviation := 0;
        if assigned(latencyHandler) then
        begin
          pcon := FindConnection(nick);
          if pcon <> nil then
          begin
            if gameState = gsInGame then
              latency := latencyHandler.GetLatency(pcon^.ip, pcon^.port)
            else
              latency := latencyHandler.GetHSLatency(pcon^.ip, pcon^.port);
            deviation := latencyHandler.GetStandardDeviation(pcon^.ip, pcon^.port);
            if frmLatencyPlots.Visible and Unit1.isHost and (gameState = gsInGame) then
            begin
              latencyValues.Clear;
              latencyHandler.GetLastValues(pcon^.ip, pcon^.port, 50, latencyValues);
              if latencyPlotMapping[i] <> -1 then
                frmLatencyPlots.PlotDrawer.Data(latencyPlotMapping[i], latencyValues);
            end;
          end;
        end;
        // ban infos
        pbi := pi^.banInfo;
        if assigned(pbi) then begin
          info := pbi^.info;
          ban := pbi^.ban;
          onlineban := pbi^.onlineban;
        end;
        // score
        if listcontainer.scorelist.FindEntry(nick, j) then
          score := PScore(listcontainer.scorelist.list[j])^.points;
        // rating
        rating := gd.rating[i];
      end;
    end;
    // create slot nodes
    with vtGame do begin
      n := AddChild(nil);
      p := GetNodeData(n);
      p^.Slot := Slot;
      p^.Nick := Nick;
      p^.From := From;
      p^.Ping := Ping;
      p^.Score := Score;
      p^.Rating := Rating;
      p^.Ban := Ban;
      p^.Info := Info;
      p^.Online := OnlineBan;
      p^.HasLeft := hasLeft;
      p^.HasWhispered := hasWhispered;
      p^.HasLostConnection := hasLostConnection;
      p^.IsFriend := isFriend;
      p^.IsHost := isHost;
      p^.Color := slotColor;
      p^.Latency := latency;
      p^.Deviation := deviation;
      Include(n.States, vsExpanded);
      child := AddChild(n);
      IsVisible[child] := p^.Ban <> '';
      child := AddChild(n);
      IsVisible[child] := p^.Info <> '';
      child := AddChild(n);
      IsVisible[child] := p^.Online <> '';
    end;
    if isHost and (lastHostName = '') then
      lastHostName := Nick;
  end;
  vtGame.EndUpdate;
  // reselect selection
  if selectedNodeNick <> '-' then
  begin
    n := vtGame.GetFirst;
    while assigned(n) and not ((n.Index = selectedNodeIndex) and (vtGame.GetNodeLevel(n) = selectedNodeLevel) and (n.Parent.Index = selectedNodePIndex)) do
      n := vtGame.GetNext(n);
    if assigned(n) then
    begin
      vtGame.Selected[n] := True;
      vtGame.FocusedNode := n;
      if PGameNodeData(vtGame.GetNodeData(n))^.Nick <> selectedNodeNick then
        EndMenu;
    end;
  end;
  // all whispers received for the first time
  if (c - w <> missingWhispers) and (c > 0) then
  begin
    missingWhispers := c - w;
    if missingWhispers = 0 then
      AddMessage(NotWhispered, ICON_NOTE);
  end;
  latencyValues.Free;
  if frmLatencyPlots.Visible and unit1.isHost and (gameState = gsInGame) then
    frmLatencyPlots.PlotDrawer.Draw(frmLatencyPlots.Image.ClientRect);
end;

procedure TWC3Banlist_Main.btnPhraseInfoClick(Sender: TObject);
begin
  iniinfo('The following substitution strings are possible within phrases:' +
    crlf + crlf +
    '$param - the other text given behind the phrase keyword in the phrase command' + crlf +
    '$lastjoiner - nickname of the last person that has joined the game' + crlf
      +
    '$lastleaver - nickname of the last leaver' + crlf +
    '$lastbanned - nickname of the last banned player' + crlf +
    '$lastkicked - nickname of the last kicked player (anti-dl/autokick)' + crlf +
    '$bannedlist - nicknames of the players banned in the current game' + crlf +
    '$lastwhisperer - nickname of the last one you whispered to' + crlf +
    '$shiftenter - shift+enter at the same time (to write to all)' + crlf +
    '$gametitle - title of the game as it is found in the game list' + crlf +
    '$mapname - filename of the currently used map' + crlf +
    '$hostname - name of the host who created the game' + crlf +
    '$freeslots - amount of free slots (works only if at least 2 players are in game)' + crlf
      +
    '$numpadX - for item usage hotkeys, where X stands for the number to be pressed' + crlf
      +
    '$time - the current time of day (local format)' + crlf +
    '$day - the current day of month' + crlf +
    '$month - the current month as number' + crlf +
    '$year - the current year' + crlf +
    '$gametime - the current game time' + crlf +
    '$gamestart - the time of the game start' + crlf +
    '$nick - the nick with which you have logged on' + crlf +
    '$realm - the current realm name' + crlf +
    '$state - the current game state (player count of each team)' + crlf +
    '$clipboard - the current clipboard content' + crlf +
    '$wait - wait until a /from(all) or /ping(all) command has finished (max. 10 sec)' + crlf +

    crlf +

    'Color-nickname substitutions configured in colors.dat:' + crlf + crlf +
    ColorMapping.Help);
end;

procedure TWC3Banlist_Main.NewGame;
begin
  btnShowGameReview.Enabled := false;
  vtGame.Clear;
  lastBannedList.Clear;
  ClearGameEvents;
  gd.Clear;
  pl.ClearWhispered;
  lblGameTimer.caption := '00:00:00';
  // Clear connection infos
  while (conlist.Count > 0) do
  begin
    FreeMem(conlist.Items[0]);
    conlist.delete(0);
  end;
  ClearKickOrderList;
  flagChannelChangedToGame := false;
  lastJoiner := '';
  lastLeaver := '';
  lastHostName := '';
  lastScreenShots := '';
  lastGameID := edtNextGameID.Text;
  todoGetSlotCount := true;
  todoSetHumanPlayerCountInParseExceptions := false;
  missingWhispers := -1;
  if chkSwitchTabOnNewGame.Checked then
    pages.ActivePage := tabSnooping;
end;

function TWC3Banlist_Main.FindPlayerIP(var n: string): Cardinal;
var
  i: integer;
  name: string;
  ip: cardinal;
  p: pplayerinfo;
  li: tlist;
begin
  ip := 0;
  name := '';
  li := tlist.Create;
  pl.List(li);
  for i := 0 to li.count - 1 do
  begin
    p := li[i];
    if (lowercase(n) = lowercase(p^.Nick))
      and (p^.IP <> 0) then
    begin
      ip := p^.ip;
      name := n;
      break;
    end;
  end;

  // try for abbreviation
  if ip = 0 then
    for i := 0 to li.count - 1 do
    begin
      p := li[i];
      if (pos(lowercase(n), lowercase(p^.Nick)) <> 0) and (p^.IP <> 0) then
      begin
        if (name <> '') and (lowercase(name) <> lowercase(p^.Nick)) then
        begin
          result := 0;
          exit;
        end;
        ip := p^.ip;
        name := p^.Nick;
      end;
    end;
  n := name;
  result := ip;
  li.Free;
end;

procedure TWC3Banlist_Main.lblSetFontClick(Sender: TObject);
begin
  inistringasfont(edtFont.text, font1.font);
  if font1.Execute then
  begin
    edtFont.Text := IniFontAsString(font1.Font);
    MarqueeFont.Assign(font1.Font);
    if scr.c <> nil then
      scr.c.Font.Assign(MarqueeFont);
  end;
end;

function SendRSTPacket(ad: padapter; d: Pointer; FromIP: string; iFromPort:
  Word; ToIP: string;
  iToPort: Word; StrMessage: string; Flags: Byte; Sequ: DWORD; Ack: DWORD):
  boolean;
type
  tfinalbuf = record
    etherhead: array[0..13] of byte;
    rest: array[0..100] of byte;
  end;
var
  buf: TPacketBuffer;
  iSize: word;
  remote: TSockAddr;
  finalbuf: tfinalbuf;
  chk: word;
begin
  BuildHeaders(fromIP, iFromPort, toIP, itoPort, StrMessage, buf, remote, isize,
    flags, sequ, ack);
  copymemory(@finalbuf.etherhead, d, 14);
  copymemory(@finalbuf.rest, @buf, isize);
  chk := csum(finalbuf.rest, 10);
  finalbuf.rest[10] := chk and $FF;
  finalbuf.rest[11] := chk shr 8;
  result := pcap_sendpacket(ad, finalbuf, 14 + isize) = 0;
end;

procedure TWC3Banlist_Main.SetdaMethod;
begin
  if chkWinSock.Checked then
    daMethod := 0;
  if chkWinPcap.Checked then
    daMethod := 1;
  if chkWinAPI.Checked then
    daMethod := 2;
end;

procedure TWC3Banlist_Main.chkWinSockClick(Sender: TObject);
begin
  SetdaMethod;
end;

function FindConnection(ip: longword; port: word): PPlayerCon;
var
  i: integer;
  p: pplayercon;
begin
  result := nil;
  for i := 0 to conlist.Count - 1 do
  begin
    p := conlist[i];
    if (p^.ip = ip) and (p^.port = port) then
    begin
      result := p;
      break;
    end;
  end;
end;

function FindConnection(nick: String): PPlayerCon; overload;
var
  i: Integer;
  p: PPlayerCon;
begin
  result := nil;
  for i := 0 to conlist.Count - 1 do
  begin
    p := conlist[i];
    if lowercase(nick) = lowercase(p^.name) then
    begin
      result := p;
      break;
    end;
  end;
end;

procedure TWC3Banlist_Main.AddKickOrder(con: PPlayerCon; sendADLMessage:
  boolean);
var
  p: PKickCon;
  f: PPlayerCon;
  found: Boolean;
  i: Integer;
begin
  found := false;

  try
    with kickOrderList.LockList do
    begin
      // search for existing kick order on that connection
      for i := 0 to Count - 1 do
      begin
        f := PKickCon(Items[i])^.con;
        if (f^.ip = con^.ip) and (f^.port = con^.port) then
        begin
          found := true;
          break;
        end;
      end;
      // add kick order if it doesn't already exist
      if not found then
      begin
        New(p);
        p^.con := con;
        p^.sendADLMessage := sendADLMessage;
        Add(p);
        lastKicked := con^.name;
        AddGameEvent(con^.name + ' gets kicked.', con^.name);
      end;
    end;
  finally
    kickOrderList.UnlockList;
  end;
end;

function TWC3Banlist_Main.FindPlayer(s: string): PPlayerCon;
var
  i: integer;
  p: PPlayerCon;
begin
  // full name search
  result := nil;
  for i := 0 to conList.Count - 1 do
  begin
    p := conlist[i];
    if lowercase(p^.name) = lowercase(s) then
    begin
      result := p;
      break;
    end;
  end;
  // starts with search
  if result = nil then
  begin
    for i := 0 to conList.Count - 1 do
    begin
      p := conlist[i];
      if lowercase(copy(p^.name, 1, length(s))) = lowercase(s) then
      begin
        result := p;
        break;
      end;
    end;
  end;
end;

procedure TWC3Banlist_Main.lbXSLClick(Sender: TObject);
begin
  if cbXSL.ItemIndex <> -1 then
    edtXSL.Text := cbXSL.Items[cbXSL.itemindex];
  forceRefresh := true;
  MessageCenter.SetStyleSheet(edtXSL.Text);
end;

procedure TWC3Banlist_Main.lbXSLKeyPress(Sender: TObject; var Key: Char);
begin
  lbXSLCLick(nil);
end;

procedure TWC3Banlist_Main.BrowseForXSL;
var
  t: tstringlist;
  i: integer;
begin
  cbXSL.Items.Clear;
  t := tstringlist.create;
  inifindfiles(extractfilepath(xml_messages), '*.xsl', t, false, false);
  for i := 0 to t.count - 1 do
    cbXSL.items.Add(ExtractFileName(t[i]));
  cbXSL.Sorted := True;
  for i := 0 to cbXSL.Items.count - 1 do
    if cbXSL.Items[i] = edtXSL.Text then
    begin
      cbXSL.ItemIndex := i;
      break;
    end;
  if (cbXSL.Items.Count > 0) and (cbXSL.ItemIndex = -1) then
  begin
    cbXSL.ItemIndex := 0;
    edtXSL.Text := cbXSL.Items[0];
  end;
  t.Free;
end;

procedure TWC3Banlist_Main.SetFonts;
begin
  SetFormFont(self, defaultFont, defaultFontSize);
  vstBuddy.Header.Font.Name := defaultFont;
  if defaultFontSize <> -1 then
    vstBuddy.Header.Font.Size := defaultFontSize;
end;

function GetFileDateTime(const FileName: TFileName): TDateTime;
var
  FStruct: TOFSTRUCT;
  wndFile: Integer;
begin
  wndFile := OpenFile(PChar(FileName), FStruct, OF_SHARE_DENY_NONE);
  Result := FileDateToDateTime(FileGetDate(wndFile));
  CloseHandle(wndFile);
end;

procedure TWC3Banlist_Main.NavigateToWhisper;
begin
  if (gameState <> gsChat) and not chkRefreshEvenWhenInGame.Checked then
    exit;
  if windowstate = wsMinimized then
     exit;
  if tmChatRefresh.Enabled then
  begin
    tmChatRefresh.Tag := 1;
    exit;
  end;
  if not loadComplete then
    exit;
  if closing then
    exit;
  if not refreshEnable and not forceRefresh then
    exit;
  if (not navigating and (pages.ActivePage = tabMessages)) or forceRefresh then
  begin
    navigating := true;
    // wait til browser is ready but allow changes/new whispers at a time
    while webMsg.ReadyState <> READYSTATE_COMPLETE do
      application.ProcessMessages;

    if (not scrolling(webMsg)) or forceRefresh then
    begin
      if not forceRefresh then
        DisableDraw;
      try
        if webmsg.LocationURL = '' then
          webmsg.Navigate(xml_messages)
        else
          webmsg.Refresh;
      except
      end;
      if not forceRefresh then
      begin
        tmChatRefresh.Enabled := true;
        tmChatRefresh.Tag := 0;
      end;
    end;
    navigating := false;
  end;
end;

procedure TWC3Banlist_Main.memoBuddiesKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '|' then
  begin
    iniinfo('This character is not allowed here.');
    key := #0;
  end;
end;

function TWC3Banlist_Main.IsBuddy(s: string): boolean;
var
  i: integer;
begin
  result := false;
  s := LowerCase(s);
  with memoBuddies do
    for i := 0 to Lines.count - 1 do
      if MatchesPattern(s, lowercase(Lines[i])) then
      begin
        result := true;
        break;
      end;
  if chkAlwaysUseWC3Friendlist.Checked then
  with lbWC3FriendList do
    for i := 0 to Items.Count - 1 do
      if MatchesPattern(s, lowercase(Items[i])) then
      begin
        result := true;
        break;
      end;
end;

procedure TWC3Banlist_Main.WMRestore(var Message: TMessage);
begin
  ForceForeGroundWindow(self.Handle);
  if WindowState = wsMinimized then
    Restore;
end;

procedure TWC3Banlist_Main.LoadPlayerInfo(f: string);
begin
  pl.LoadFromFile(f);
end;

procedure TWC3Banlist_Main.AddToLog(s: string; imageIndex: Integer; nick: String);
var
  p: PLogEntry;
  n: PVirtualNode;
begin
  vtLog.BeginUpdate;
  n := vtLog.AddChild(nil);
  p := vtLog.GetNodeData(n);
  p^.text := s;
  p^.icon := imageIndex;
  p^.nick := nick;
  vtLog.EndUpdate;
  vtlog.ScrollIntoView(n, false);
end;

procedure TWC3Banlist_Main.btnImportClick(Sender: TObject);
var
  o: TopenDialog;
  i: integer;
  t: tstringlist;
begin
  o := Topendialog.Create(self);
  o.Title := StringReplace((Sender as TMenuItem).Caption, '&', '',
    [rfReplaceAll]);
  o.Filter := 'All Files (*.*)|*.*';
  try
    if o.Execute then
    begin
      t := tstringlist.create;
      try
        t.LoadFromFile(o.FileName);
        if messagedlg(inttostr(t.count) +
          ' items are about to be imported. Continue?', mtconfirmation, [mbyes,
          mbno], 0) = mryes then
          for i := 0 to t.count - 1 do
            ban(t[i], false, Boolean((Sender as TMenuItem).Tag));
      finally
        t.free;
      end;
    end;
  finally
    o.free;
  end;
end;

procedure TWC3Banlist_Main.Edit4KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  combokey := key;
end;

function TWC3Banlist_Main.DecodeIntArray(a: array of integer): string;
var
  r: string;
  i: integer;
begin
  for i := 0 to (length(a) - 1) div 2 do
    r := r + chr(a[i * 2] + a[i * 2 + 1]);
  result := r;
end;

procedure TWC3Banlist_Main.AddGameEvent(s: string; nick: String);
begin
  if (lvLastEvents.Items.Count > 0) and
    (lvLastEvents.Items[lvLastEvents.Items.Count - 1].Subitems[0] = s) then exit;
  with lvLastEvents.Items.Add do
  begin
    caption := lblGameTimer.Caption;
    subitems.add(s);
    subitems.add(nick);
  end;
  SendMessage(lvLastEvents.Handle, WM_VSCROLL, SB_PAGEDOWN, 0);
  Application.ProcessMessages;
  lvLastEventsResize(lvLastEvents);
  Application.ProcessMessages;
end;

procedure TWC3Banlist_Main.ClearGameEvents;
begin
  lvLastEvents.clear;
end;

function TWC3Banlist_Main.FindRealm(ip: dword): string;
var
  i: integer;
  l: TList;
begin
  result := '';
  l := realms.LockList;
  for i := 0 to l.count - 1 do
    if PRealm(l[i])^.ip = ip then
    begin
      result := PRealm(l[i])^.name;
      lastrealm := result;
      lblRealm.Caption := result;
      break;
    end;
  realms.UnlockList;
end;

procedure TWC3Banlist_Main.InitRealmThread;
begin
  RealmThread := Realmresolver.Create(true);
  RealmThread.Realms := Realms;
  with RealmThread do
  begin
    RealmList := TStringlist.create;
    try
      RealmList.LoadFromFile(inipath + 'realms.dat');
      Resume;
    except
      AddToLog('Could not get realm information because realms.dat is missing.', ICON_CONFIG);
      FreeAndNil(RealmThread);
    end;
  end;
end;

procedure TWC3Banlist_Main.lvCommentsChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
  if change = ctstate then
  begin
    edtComment.enabled := lvComments.Selected <> nil;
    if edtComment.enabled then
      edtComment.text := lvComments.Selected.SubItems[0]
    else
      edtComment.Text := '';
  end;
end;

procedure TWC3Banlist_Main.btnAddCommentClick(Sender: TObject);
var
  a: string;
  l: tlistitem;
  b: boolean;
begin
  b := false;
  while not b do
  begin
    if inputquery('Add a comment', 'Keyword:', a) then
    begin
      if pos(' ', a) = 0 then
      begin
        l := lvComments.Items.Add;
        l.Caption := a;
        l.SubItems.add('');
        lvComments.Selected := l;
        edtComment.Text := 'new custom comment';
        edtComment.SelectAll;
        edtComment.SetFocus;
        b := true;
      end
      else
        MessageDlg('As the word "keyword" says... it''s a word and not a sentence!'
          + cr + cr +
          'Enter a keyword without white spaces, please.', mtWarning, [mbOK], 0);
    end
    else
      b := true;
  end;
end;

procedure TWC3Banlist_Main.btnDeleteCommentClick(Sender: TObject);
var
  l: tlistitem;
begin
  l := lvComments.Selected;
  if l = nil then
    exit;
  l.Delete;
end;

procedure TWC3Banlist_Main.SubstituteComments(var c: string; pname: string);
var
  n: TDateTime;
  m, y, d: word;
  gs: string;
begin
  n := Date;
  DecodeDate(n, y, m, d);
  ReplaceAll(c, '$time', timetostr(now));
  ReplaceAll(c, '$gamestart', timetostr(now - (GetTickCount - GameStart) / 1000 / 60 / 60 / 24));
  ReplaceAll(c, '$day', nullen(d, 2));
  ReplaceAll(c, '$month', nullen(m, 2));
  ReplaceAll(c, '$year', format('%2d', [y]));
  ReplaceAll(c, '$mapname', lastMapName);
  ReplaceAll(c, '$hostname', lastHostName);
  ReplaceAll(c, '$gametitle', lastGameTitle);
  ReplaceAll(c, '$gametime', lblGameTimer.caption);
  ReplaceAll(c, '$nick', username.Caption);
  ReplaceAll(c, '$realm', lastrealm);
  gs := gd.GetPlayerDistribution;
  if gs = '' then
    gs := 'n/a';
  ReplaceAll(c, '$state', gs);
  if pname <> '' then
  begin
    gs := gd.GetTeamRatioOfPlayer(pname);
    if gs = '' then
      gs := 'n/a';
    ReplaceAll(c, '$ratio', gs);
  end;
end;

procedure TWC3Banlist_Main.edtCommentChange(Sender: TObject);
begin
  if edtComment.Enabled then
    lvComments.Selected.SubItems[0] := edtComment.text;
end;

function TWC3Banlist_Main.CurrentTitleOfWinAMP: string;
var
  buf: array[0..256] of char;
  title: string;
  waHandle: THandle;
  r: TRegExpr;
begin
  result := '';
  waHandle := Findwindow(PChar(edtMPWindowClassName.Text), nil);
  if waHandle = 0 then
    exit;
  if GetWindowText(waHandle, buf, 256) > 0 then
  begin
    r := TRegExpr.Create;
    try
      title := buf;
      r.Expression := edtMPRegExp.Text;
      if r.Exec(title) then
        result := r.Match[1]
      else
        AddMessage('No match. Check your regular expression for parsing the window title of your media player.', ICON_ERROR);
    except
      AddMessage('Your regular expression for parsing the player''s window title is faulty.', ICON_ERROR);
    end;
    r.free;
  end else
    AddMessage('No player found with window class name "' + edtMPWindowClassName.Text + '".', ICON_ERROR);
end;

procedure TWC3Banlist_Main.popPhrasesPopup(Sender: TObject);
var
  l: tlistitem;
  c: string;
  i: integer;
begin
  l := lvPhrases.Selected;
  AssignHotkey1.Visible := l <> nil;
  RemovePhrase1.Visible := l <> nil;
  if l = nil then
    exit;
  c := l.SubItems[1];
  for i := 0 to high(mnuShortcuts) do
    mnushortcuts[i].checked := pos(inttostr(mnushortcuts[i].Tag), c) > 0;
  RemoveHotkey1.Enabled := l.SubItems[1] <> '';
end;

procedure TWC3Banlist_Main.AssignHotKey(Sender: TObject);
var
  i: integer;
  a, n, c: string;
  l: tlistitem;
begin
  l := lvPhrases.Selected;
  if l = nil then
    exit;
  c := l.SubItems[1];
  n := inttostr((Sender as TMenuitem).Tag);
  // hotkey already set?
  if pos(n, c) > 0 then
    exit;
  // remove hotkey from all other items
  for i := 0 to lvPhrases.items.count - 1 do
    with lvPhrases.items[i] do
    begin
      a := subitems[1];
      if pos(n, a) > 0 then
        system.delete(a, pos(n, a), 1);
      subitems[1] := a;
    end;
  // set hotkey for all with the same name
  for i := 0 to lvPhrases.Items.Count - 1 do
    if lvPhrases.Items[i].caption = l.Caption then
      lvPhrases.items[i].SubItems[1] := lvPhrases.items[i].SubItems[1] + n;
end;

procedure TWC3Banlist_Main.PreparePhrases;
var
  i: integer;
begin
  with lvPhrases do
    for i := 0 to items.count - 1 do
      while items[i].SubItems.Count < 2 do
        items[i].SubItems.Add('');
end;

procedure TWC3Banlist_Main.lvPhrasesResize(Sender: TObject);
begin
  SendMessage(lvPhrases.Handle, LVM_ARRANGE, LVA_ALIGNLEFT, 0);
end;

function TWC3Banlist_Main.SubstPhrase(r: string; justInTime: Boolean): string;
begin
  r := ReplaceRegExpr('\$lastleaver', r, lastleaver);
  r := ReplaceRegExpr('\$lastkicked', r, lastkicked);
  r := ReplaceRegExpr('\$lastjoiner', r, lastjoiner);
  r := ReplaceRegExpr('\$freeslots', r, gd.GetFreeSlots);
  r := ReplaceRegExpr('\$lastwhisperer', r, lastwhisperer);
  if justInTime then
  begin
    r := ReplaceRegExpr('\$shiftenter', r, #255#1);
    r := ReplaceRegExpr('\$clipboard', r, #255#2);
    r := ReplaceRegExpr('\$lastbanned', r, #255#3);
    r := ReplaceRegExpr('\$bannedlist', r, #255#4);
    r := ReplaceRegExpr('\$wait', r, #255#5);
    r := ReplaceRegExpr('\$numpad0', r, #255#240);
    r := ReplaceRegExpr('\$numpad1', r, #255#241);
    r := ReplaceRegExpr('\$numpad2', r, #255#242);
    r := ReplaceRegExpr('\$numpad3', r, #255#243);
    r := ReplaceRegExpr('\$numpad4', r, #255#244);
    r := ReplaceRegExpr('\$numpad5', r, #255#245);
    r := ReplaceRegExpr('\$numpad6', r, #255#246);
    r := ReplaceRegExpr('\$numpad7', r, #255#247);
    r := ReplaceRegExpr('\$numpad8', r, #255#248);
    r := ReplaceRegExpr('\$numpad9', r, #255#249);
  end else
  begin
    r := ReplaceRegExpr('\$clipboard', r, ct.GetText);
    if lastBannedList.Count > 0 then
      r := ReplaceRegExpr('\$lastbanned', r, lastBannedList[lastBannedList.Count - 1]);
    r := ReplaceRegExpr('\$bannedlist', r, join(lastBannedList, ' '));
  end;
  ColorMapping.Replace(r);
  SubstituteComments(r, '');
  result := r;
end;

function TWC3Banlist_Main.SubstPhraseBackwards(r: String): String;
var
  slastBannedList, slastBanned: String;
begin
  if lastbannedList.Count > 0 then
  begin
    sLastBannedList := join(lastBannedList, ' ');
    sLastBanned := lastBannedList[lastBannedList.Count - 1];
  end else
  begin
    sLastBannedList := '';
    sLastBanned := '';
  end;
  r := StringReplace(r, #255#2, ct.GetText, [rfReplaceAll]);
  r := StringReplace(r, #255#3, sLastBanned, [rfReplaceAll]);
  r := StringReplace(r, #255#4, sLastBannedList, [rfReplaceAll]);
  result := r;
end;

procedure TWC3Banlist_Main.QueryBan(sender: TObject);
var
  nick, c, a: string;
  m: TMenuItem;
begin
  m := TMenuItem(Sender);
  nick := lastSelectedSpack;
  if m.tag = 0 then
  begin
    if m.Name = 'BanSubItemAddComment' then
    begin
      a := '';
      c := '';
      if inputquery('Ban with comment', 'Comment for ' + nick + ' :', a) then
      begin
        if (a <> '') then
        begin
          a := ' ' + a;
        end;
        ban(nick + a, false, false);
      end;
    end
    else if m.Name = 'BanSubItemNoComment' then
    begin
      ban(nick, false, false);
    end;
  end
  else
  begin
    ban(nick + ' ' + lvComments.items[m.Tag - 1].Caption, true, false);
  end;
end;

procedure TWC3Banlist_Main.CreateBanSubmenu(parent: TMenuitem);
var
  i: integer;
begin
  for i := 0 to high(mnuBanSubItems) do
    mnuBanSubItems[i].Free;
  SetLength(mnuBanSubitems, lvComments.Items.count + 4);
  mnuBanSubitems[0] := TMenuItem.create(parent);
  mnuBanSubitems[0].Name := 'BanSubItemAddComment';
  mnuBanSubitems[0].Caption := '&Add with comment';
  mnuBanSubitems[0].OnClick := QueryBan;
  mnuBanSubitems[1] := TMenuItem.create(parent);
  mnuBanSubitems[1].Name := 'BanSubItemNoComment';
  mnuBanSubitems[1].Caption := 'Add with&out comment';
  mnuBanSubitems[1].OnClick := QueryBan;
  mnuBanSubitems[2] := TMenuItem.create(parent);
  mnuBanSubitems[2].Name := 'BanSubItemDummy';
  mnuBanSubitems[2].Caption := '-';
  mnuBanSubitems[3] := TMenuItem.create(parent);
  mnuBanSubitems[3].Name := 'BanSubItemCustomHeadline';
  mnuBanSubitems[3].Caption := 'Use custom comment:';
  mnuBanSubitems[3].Default := true;
  mnuBanSubitems[3].Enabled := false;
  for i := 0 to lvComments.items.count - 1 do
    with lvComments.items[i] do
    begin
      mnuBanSubitems[i + 4] := TMenuItem.Create(parent);
      mnuBanSubitems[i + 4].Name := 'BanSubItem' + inttostr(i);
      mnuBanSubitems[i + 4].Caption := caption;
      mnuBanSubitems[i + 4].Tag := i + 1;
      mnuBanSubitems[i + 4].OnClick := QueryBan;
    end;
  parent.add(mnuBanSubitems);
end;

procedure TWC3Banlist_Main.lblClearMessagesMouseEnter(Sender: TObject);
begin
  IniUnderLine((Sender as TLabel).Font, true);
end;

procedure TWC3Banlist_Main.lblClearMessagesMouseLeave(Sender: TObject);
begin
  IniUnderLine((Sender as TLabel).Font, false);
end;

procedure TWC3Banlist_Main.lblClearMessagesClick(Sender: TObject);
begin
  pages.ActivePage := tabMessages;
  Application.ProcessMessages;
  ClearWhispers(false);
  forceRefresh := true;
  NavigateToWhisper;
end;

procedure TWC3Banlist_Main.ClearWhispers(addFirst: boolean);
begin
  MessageCenter.Clear;
  if addFirst then
    MessageCenter.AddFirstNote;
  if panChatHeader.Caption <> 'Channel' then
    MessageCenter.ChangeChannel(panChatHeader.Caption);
  MessageCenter.SaveToFile;
end;

procedure TWC3Banlist_Main.lblLinkClick(Sender: TObject);
begin
  ShellExecute(0, 'open', 'http://www.wc3banlist.de', nil, nil, 0);
end;

procedure TWC3Banlist_Main.PingAll;
var
  i: integer;
  b: byte; // id
  n: string;
  ip: Cardinal;
begin
  if ping.Busy then
  begin
    AddMessage('Ping already in progress!', ICON_MESSAGE);
    exit;
  end;
  // read the jobs
  for i := 0 to gd.slots - 1 do
  begin
    b := gd.Data[i][0];
    // human, not empty, not self
    if (gd.data[i][3] = 0) and (gd.data[i][1] <> $FF) and (gd.names[b] <>
      '<self>')
      and (gd.names[b] <> username.Caption) then
    begin
      n := gd.names[b];
      ip := pl.GetIP(n);
      if ip <> 0 then
        ping.AddJob(n, ip);
    end;
  end;
  // set callback routine
  ping.Done := PingAllDone;
  if ping.jobs.count > 0 then
  begin
    AddMessage('Pinging ' + inttostr(ping.jobs.Count) + ' players ...', ICON_NETWORK);
    // for more precision
    flickerTimer.Enabled := false;
    SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
    ping.PingAll;
  end
  else
  begin
    AddMessage('No one to be pinged.', ICON_MESSAGE);
    ReleaseSemaphore(phraseKeeper1.hWaitSemaphore, 1, nil);
  end;
end;

procedure TWC3Banlist_Main.PingAllDone;
var
  msg, text: string;
  i: integer;
  pj: PPingJob;
begin
  SetPriorityClass(GetCurrentProcess, NORMAL_PRIORITY_CLASS);
  flickertimer.Enabled := true;
  // display pingall result
  msg := '';
  for i := 0 to ping.jobs.count - 1 do
  begin
    pj := ping.jobs[i];
    if msg <> '' then
      msg := msg + ', ';
    if (pj^.ping = -1) or (pj^.ping > raw_ping.timeout) then
    begin
      pj^.ping := -1;
      text := 't/o';
    end else
      text := inttostr(pj^.ping) + ' ms';
    msg := msg + pj^.name + ': ' + text;
    pl.SetPing(pj^.name, pj^.ping);
  end;
  AddMessage(msg, ICON_NETWORK);
  ReleaseSemaphore(phraseKeeper1.hWaitSemaphore, 1, nil);
  ping.ClearJobs;
end;

function TWC3Banlist_Main.Buddy_addEntry: PBanBuddiesBanlist;
var
  p: PBanBuddiesBanlist;
  n: pvirtualnode;
begin
  n := vstBuddy.AddChild(nil);
  p := vstBuddy.GetNodeData(n);
  vstBuddy.ValidateNode(n, false);
  result := p;
end;

procedure TWC3Banlist_Main.vstBuddyGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  p: PBanBuddiesBanlist;
begin
  p := Sender.GetNodeData(Node);
  case Column of
    0: CellText := p^.nickname;
    1: CellText := p^.comment;
    2: CellText := p^.source;
  end;
end;

procedure TWC3Banlist_Main.vstBuddyCompareNodes(Sender: TBaseVirtualTree;
  Node1, Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  p1, p2: PBanBuddiesBanlist;
begin
  result := 0;
  p1 := Sender.GetNodeData(Node1);
  p2 := Sender.GetNodeData(Node2);
  case column of
    0: result := compareStr(lowercase(p1^.nickname), lowercase(p2^.nickname));
    1: result := compareStr(lowercase(p1^.comment), lowercase(p2^.comment));
    2: result := compareStr(lowercase(p1^.source), lowercase(p2^.source));
  end;
end;

procedure TWC3Banlist_Main.vstBuddyHeaderClick(Sender: TVTHeader;
  Column: TColumnIndex; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if Button = mbLeft then
  begin
    with Sender do
    begin
      if SortColumn <> Column then
      begin
        SortColumn := Column;
        SortDirection := sdAscending;
      end
      else if SortDirection = sdAscending then
        SortDirection := sdDescending
      else
        SortDirection := sdAscending;
    end;
  end;
end;

procedure TWC3Banlist_Main.vstBuddyGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
var
  p: PBanBuddiesBanlist;
begin
  p := sender.GetNodeData(Node);
  if Column = 0 then
    ImageIndex := p^.imageindex;
end;

procedure TWC3Banlist_Main.FromAll;
var
  i: integer;
  b: byte; // id
  ip: dword;
  s, n: TStringlist;
begin
  s := TStringList.Create;
  n := TStringlist.Create;
  // read the jobs
  for i := 0 to gd.slots - 1 do
  begin
    b := gd.Data[i][0];
    // human, not empty, not self
    if (gd.data[i][3] = 0) and (gd.data[i][1] <> $FF) and (gd.names[b] <>
      '<self>')
      and (gd.names[b] <> username.caption) then
    begin
      n.add(gd.names[b]);
      ip := pl.GetIP(gd.names[b]);
      if ip <> 0 then
        s.Add(iptostr(@ip))
      else
        s.Add('');
    end;
  end;

  if s.Count > 0 then
  begin
    AddMessage('Querying IP database...', ICON_WORLD);
    TIPToCountry.Create(CountryCache).ResolveList(s, n);
  end else
  begin
    AddMessage('No one there to determine the origin.', ICON_MESSAGE);
    ReleaseSemaphore(phraseKeeper1.hWaitSemaphore, 1, nil);
  end;

  Sound(SND_RESPONSE);
  s.free;
  n.free;
end;

procedure TWC3Banlist_Main.lvAutoKickChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
var
  l: TListItem;
  b: boolean;
begin
  b := (lvAutoKick.Selected <> nil);
  if (change <> ctState) then
    exit;
  edtAKKeyword.Enabled := b;
  chkAKLocal.Enabled := b;
  chkAKServerBanlists.Enabled := false;
  chkAKServerSafelists.Enabled := false;
  edtAKBB.Enabled := b;
  if b then
  begin
    l := lvAutoKick.Selected;
    edtAKKeyword.Text := l.Caption;
    chkAKLocal.Checked := l.SubItems[0] = 'x';
    chkAKServerBanlists.Checked := Pos('b', l.SubItems[1]) > 0;
    chkAKServerSafeLists.Checked := Pos('s', l.SubItems[1]) > 0;
    edtAKBB.Text := l.SubItems[2];
    chkAKServerBanlists.Enabled := true;
    chkAKServerSafelists.Enabled := true;
  end
  else
  begin
    edtAKKeyword.Text := '';
    chkAKLocal.Checked := false;
    chkAKServerBanlists.Checked := false;
    chkAKServerSafelists.Checked := false;
    edtAKBB.Text := '';
  end;
end;

procedure TWC3Banlist_Main.btnDelAutoKickRuleClick(Sender: TObject);
var
  l: TListItem;
begin
  l := lvAutoKick.Selected;
  if l = nil then
    exit;
  l.Delete;
end;

procedure TWC3Banlist_Main.btnAddAutoKickRuleClick(Sender: TObject);
var
  l: TListItem;
begin
  l := lvAutoKick.Items.Add;
  l.Caption := '';
  l.SubItems.Add('x');
  l.SubItems.Add('');
  l.SubItems.Add('');
  l.SubItems.Add('');
  lvAutoKick.Selected := l;
  edtAKKeyword.SetFocus;
end;

procedure TWC3Banlist_Main.edtAKKeywordChange(Sender: TObject);
begin
  if edtAKKEyword.Enabled then
    lvAutoKick.Selected.Caption := edtAKKeyWord.Text;
end;

procedure TWC3Banlist_Main.chkAKLocalClick(Sender: TObject);
const
  c: array[0..1] of string = ('', 'x');
begin
  if chkAKLocal.Enabled then
    lvAutoKick.Selected.Subitems[0] := c[Integer(chkAKLocal.Checked)];
end;

procedure TWC3Banlist_Main.chkAKServerBanlistsClick(Sender: TObject);
const
  cBanlists: array[0..1] of string = ('', 'b');
  cSafelists: array[0..1] of string = ('', 's');
begin
  if chkAKServerBanlists.Enabled then
    lvAutoKick.Selected.Subitems[1] :=
      cBanlists[Integer(chkAKServerBanlists.Checked)] +
      cSafelists[Integer(chkAKServerSafeLists.Checked)];
end;

procedure TWC3Banlist_Main.edtAKBBChange(Sender: TObject);
begin
  if edtAKBB.Enabled then
    lvAutoKick.Selected.Subitems[2] := edtAKBB.Text;
end;

procedure TWC3Banlist_Main.tabHotkeysShow(Sender: TObject);
var
  i, j: integer;
  a: string;
  t: tstringlist;
begin
  t := Tstringlist.Create;
  lvHotkeys.SortType := stNone;
  lvHotkeys.Items.BeginUpdate;
  lvHotkeys.Items.Clear;
  for i := 0 to lvPhrases.Items.count - 1 do
  begin
    a := lvPhrases.items[i].SubItems[1];
    for j := 1 to length(a) do
      if t.IndexOf(a[j]) = -1 then
      begin
        t.Add(a[j]);
        with lvHotkeys.Items.Add do
        begin
          Caption := 'F' + a[j];
          Subitems.Add(lvPhrases.items[i].caption);
        end;
      end;
  end;
  lvHotkeys.SortType := stText;
  lvHotkeys.Items.EndUpdate;
  t.free;
end;

procedure TWC3Banlist_Main.vstBuddyFreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
var
  p: PBanBuddiesBanlist;
begin
  p := Sender.GetNodeData(Node);
  p^.nickname := '';
  p^.comment := '';
  p^.source := '';
end;

procedure TWC3Banlist_Main.lvHotkeysDblClick(Sender: TObject);
var
  a, n: string;
  i: integer;
begin
  if lvHotkeys.Selected = nil then
    exit;
  n := Copy(lvHotkeys.selected.Caption, 2, 1);
  for i := 0 to lvPhrases.items.count - 1 do
    with lvPhrases.items[i] do
    begin
      a := subitems[1];
      if pos(n, a) > 0 then
        system.delete(a, pos(n, a), 1);
      subitems[1] := a;
    end;
  tabHotkeysShow(nil);

end;

procedure TWC3Banlist_Main.radDirectXClick(Sender: TObject);
var
  b: array[0..MAX_PATH - 1] of char;
begin
  if radDirectX.Tag <> 0 then
    exit;
  // prevent calls from within
  radDirectX.Tag := 1;
  if radDirectX.Checked then
  begin
    GetSystemDirectory(b, sizeof(b));
    copyfile(pchar(inipath + 'D3DX81ab.dll'), pchar(b + '\D3DX81ab.dll'),
      false);
    hookMode := 1;
    FlickerTimer.interval := 100;
  end
  else
  begin
    // prepare to unhook
    if hookMode > 0 then
      UnInject;
    hookMode := 0;
    FlickerTimer.interval := 10;
  end;
  radDirectX.Tag := 0;
end;

procedure TWC3Banlist_Main.DoTests;
begin
  // test code
end;

procedure TWC3Banlist_Main.lblMoreAboutDirectXClick(Sender: TObject);
begin
  IniInfo('DirectX API hooking library provided by DelphiFreak. THX!');
end;

procedure TWC3Banlist_Main.RemoveHotkey1Click(Sender: TObject);
var
  a: string;
  i: integer;
begin
  a := lvPhrases.selected.caption;
  for i := 0 to lvPhrases.items.count - 1 do
    if lvPhrases.Items[i].Caption = a then
      lvPhrases.items[i].SubItems[1] := '';
end;

procedure TWC3Banlist_Main.lvChatCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if item.caption = 'WC3Banlist:' then
    sender.Canvas.Brush.Color := $00EEEEEE
  else
    sender.Canvas.Brush.Color := clWindow;
end;

procedure TWC3Banlist_Main.banlistnlClick(Sender: TObject);
var
  b: boolean;
begin
  b := banlistnl.Checked;
  chkBuddiesList.Enabled := b;
  btnEnterLoginData.Enabled := b and chkBuddiesList.Checked;
  btnDoTransfers.Enabled := b and chkBuddiesList.Checked;
  edtBlLogin.Enabled := b;
  edtBlPassword.Enabled := b;
  if not b then
  begin
    chkBuddiesList.Checked := false;
  end;
end;

function TWC3Banlist_Main.PlayerName(n: integer): string;
var
  a: string;
  node: PVirtualNode;
  p: PGameNodeData;
begin
  result := #255#250;
  p := nil;
  node := vtGame.GetFirst;
  while node <> nil do begin
    p := vtGame.GetNodeData(node);
    if n = p^.Color then break;
    node := vtGame.GetNextSibling(node);
  end;
  if node = nil then exit;
  a := p^.Nick;
  if a = 'Computer' then
    a := #255#250;
  if pos(' ', a) > 0 then
    a := #255#250;
  if pos('Computer', a) > 0 then
    a := #255#250;
  result := a;
end;

function TWC3Banlist_Main.UnBan(n: string): boolean;
var
  found: boolean;
  p: PBan;
  pi: PPlayerInfo;
begin
  p := ExistsOnLocalBanList(n);
  found := assigned(p) and not p^.deleted;
  if found then
  begin
    p^.deleted := true;
    SetDatabaseVisibility;
    // maybe refresh current game view
    pi := pl.GetPlayerInfo(p^.nick);
    if assigned(pi) then
      pi^.banInfo^.ban := '';
  end;
  result := found;
end;

function TWC3Banlist_Main.UnInfo(n: string): boolean;
var
  found: boolean;
  p: PInfo;
  pi: PPlayerInfo;
begin
  p := ExistsOnLocalInfoList(n);
  found := assigned(p) and not p^.deleted;
  if found then
  begin
    p^.deleted := true;
    SetDatabaseVisibility;
    // maybe refresh current game view
    pi := pl.GetPlayerInfo(p^.nick);
    if assigned(pi) then
    begin
      pi^.banInfo^.info := '';
    end;
  end;
  result := found;
end;

function TWC3Banlist_Main.Inject: boolean;
var
  wh, pid: Cardinal;
  bInject, bSendMessage: boolean;
begin
  result := false;
  if hookTries < 0 then
    exit;
  if hookTries > 2 then
  begin
    hookTries := -1;
    AddToLog('DirectX-API hook could not be installed.', ICON_DX);
    AddToLog('Maybe another application like Fraps or X-Fire has hooked already.', ICON_DX);
  end
  else
  begin
    wh := findwindow('Warcraft III', 'Warcraft III');
    if wh <> 0 then
    begin
      inc(hookTries);
      GetWindowThreadProcessId(wh, @pid);
      // check if it can be installed at once
      bInject := InjectDLLbyPID(pid);
      if bInject then
      begin
        bSendMessage := SendMessage_HookFunctions;
        if bSendMessage then
          result := true
        else
        begin
          ForceForeGroundWindow(handle);
          UninjectDLLbyPID(pid);
          GetHookPointers;
        end;
      end
      else
      begin
        AddToLog('DLL injection failed. Tried ' + inttostr(hookTries) +
          ' time(s) so far.', ICON_DX);
      end;
    end;
  end;
end;

function TWC3Banlist_Main.Uninject: boolean;
var
  wh, pid: Cardinal;
begin
  result := false;
  wh := findwindow('Warcraft III', 'Warcraft III');
  if wh = 0 then
    exit;
  GetWindowThreadProcessId(wh, @pid);
  result := UninjectDLLbyPID(pid);
  if result then
    AddToLog('DirectX-API hook removed.', ICON_DX);
end;

procedure TWC3Banlist_Main.mnuShowMainClick(Sender: TObject);
begin
  Restore;
  SetForegroundWindow(Handle);
  cool.IconVisible := false;
end;

procedure TWC3Banlist_Main.chkMinToTrayClick(Sender: TObject);
begin
  cool.MinimizeToTray := chkMinToTray.Checked;
end;

procedure TWC3Banlist_Main.mnuCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TWC3Banlist_Main.btnLoadFromXMLClick(Sender: TObject);
var
  OpenDialog: TOpenDialog;
  x: IXmlDocument;
  nBanlist: IXmlNode;
  Title, Realm, BType, Data: string;
  lType: TListType;
begin
  OpenDialog := TOpenDialog.Create(self);
  OpenDialog.Title := 'Load Server List Information';
  OpenDialog.Filter := 'XML File (*.xml)|*.xml';
  if OpenDialog.Execute then
  begin
    try
      x := LoadXMLDocument(OpenDialog.FileName);
      nBanlist := x.DocumentElement;
      if nBanlist.NodeName <> 'serverlist' then
        raise Exception.Create('<serverlist> node not found in XML file.');
      Title := nBanlist.childNodes['title'].NodeValue;
      Realm := nBanlist.ChildNodes['realm'].NodeValue;
      BType := nBanlist.ChildNodes['type'].NodeValue;
      Data := nBanlist.ChildNodes['data'].NodeValue;
      if BType = 'banlist' then
        lType := ltBanlist
      else if BType = 'safelist' then
        lType := ltSafelist
      else if BType = 'viplist' then
        lType := ltVipList
      else
        raise Exception.Create('Unknown server list type.');
      addServerList(Title, Realm, Data, True, lType);
    except
      on e: Exception do
        MessageDlg('The XML file you''ve specified cannot be opened or is malformed.' + cr + cr + e.Message , mtError, [mbOK], 0);
    end;
  end;
end;

procedure TWC3Banlist_Main.addServerList(Title, Realm,
  Url: string; Active: Boolean; BType: TListType);
var
  l: TListItem;
begin
  lvOnlineLists.Items.BeginUpdate;
  l := lvOnlineLists.Items.Add;
  with l do
  begin
    Caption := Title;
    Subitems.Add(noyes[Integer(Active)]);
    Subitems.Add(sListType[Integer(BType)]);
    Subitems.Add(Realm);
    Subitems.Add(Url);
  end;
  lvOnlineLists.Items.EndUpdate;
  LoadServerList(l);
end;

procedure TWC3Banlist_Main.loadServerList(l: TListItem);
var
  sl: TServerList;
  lType: TListType;
  i: Integer;
begin
  if l.SubItems[0] = 'yes' then
    if l.Data = nil then
    begin
      lType := ltBanlist;
      for i := 0 to high(sListType) do
        if sListType[i] = l.SubItems[1] then
          lType := TListType(i);
      sl := TServerList.Create(pagesBanlist, memoError, lType, l.Caption,
        l.SubItems[2],
        l.SubItems[3], true);
      sl.OnError := OnServerListTransferError;
      sl.Backup := chkBackupOnlineLists.Checked;
      l.Data := sl;
      sl.Load;
    end;
end;

procedure TWC3Banlist_Main.btnDeleteServerListClick(Sender: TObject);
var
  l: TListItem;
  sl: TServerList;
begin
  l := lvOnlineLists.Selected;
  if l <> nil then
  begin
    if l.Data <> nil then
    begin
      sl := TServerList(l.Data);
      sl.Free;
    end;
    l.Delete;
  end;
end;

procedure TWC3Banlist_Main.btnEnableServerlistClick(Sender: TObject);
var
  l: TListItem;
  s: TServerList;
  i: Integer;
begin
  i := Integer(Sender = btnEnableServerList);
  l := lvOnlineLists.Selected;
  if l <> nil then
  begin
    l.SubItems[0] := noyes[i];
    s := l.Data;
    if Assigned(s) and (i = 0) then
    begin
      l.Data := nil;
      s.Free;
    end
    else if not Assigned(s) and (i = 1) then
    begin
      loadServerList(l);
    end
    else if Assigned(s) and (i = 1) then
    begin
      pages.ActivePage := tabOnlineBanlists;
      pagesBanlist.ActivePage := s.Tabsheet;
      s.Load;
    end;
  end;
  lvOnlineLists.Selected := nil;
end;

procedure TWC3Banlist_Main.lvOnlineListsCustomDrawItem(
  Sender: TCustomListView; Item: TListItem; State: TCustomDrawState;
  var DefaultDraw: Boolean);
var
  sl: TServerList;
begin
  if not LoadComplete then
    exit;
  sl := TServerList(Item.Data);
  if sl = nil then
    Sender.Canvas.Font.Color := clGray
  else if sl.UsingBackup then
    Sender.Canvas.Font.Color := clPurple
  else if sl.Ready then
    Sender.Canvas.Font.Color := clGreen
  else if sl.ErrorOccured then
    Sender.Canvas.Font.Color := clRed
  else
    Sender.Canvas.Font.Color := clBlack;
end;

procedure TWC3Banlist_Main.OnServerListTransferError(Sender: TObject);
begin
  if not TServerList(Sender).UsingBackup then
    pages.ActivePage := tabOnlineBanlists;
  panError.Visible := True;
end;

procedure TWC3Banlist_Main.InitializeServerLists;
var
  i: Integer;
begin
  with lvOnlineLists do
    for i := 0 to items.Count - 1 do
    begin
      items[i].Data := nil;
      loadServerList(items[i]);
    end;
end;

procedure TWC3Banlist_Main.btnCloseErrorPanelClick(Sender: TObject);
begin
  panError.Visible := false;
  memoError.Lines.Clear;
end;

procedure TWC3Banlist_Main.edtMessageKeyPress(Sender: TObject;
  var Key: Char);
var
  s: String;
begin
  if key = #27 then
    edtMessage.Text := ''
  else if key = #13 then
  begin
    s := SubstPhrase(edtMessage.Text, true);
    if pos(#250, s)>0 then begin
      edtMessage.Text := 'There''s no player with this color.';
      edtMessage.SelectAll;
    end else begin
      PhraseKeeper1.Add(s + #13);
      edtMessage.Text := '';
    end;
    key := #0;
  end;
end;

procedure TWC3Banlist_Main.AddChatter(n: string);
var
  node: TTreeNode;
  i: Integer;
begin
  // don't add duplicates
  for i := 0 to tvChannel.Items.Count - 1 do
    if tvChannel.Items[i].Text = n then
      exit;
  node := tvChannel.Items.Add(nil, n);
  node.ImageIndex := 0;
  node.SelectedIndex := 0;
end;

procedure TWC3Banlist_Main.ClearChatters;
begin
  tvChannel.Items.Clear;
  lastSelectedChannelPlayer := '';
end;

procedure TWC3Banlist_Main.RemoveChatter(n: string);
var
  i: Integer;
begin
  i := 0;
  while i < tvChannel.Items.Count do
    if tvChannel.Items[i].Text = n then
      tvChannel.Items[i].Delete
    else
      inc(i);
end;

procedure TWC3Banlist_Main.btnChatmodeClick(Sender: TObject);
begin
  panChannel.Visible := btnChatMode.Down;
  SplitterChannel.Left := webMsg.Width;
  if btnChatMode.Down then
    NavigateToWhisper;
end;

procedure TWC3Banlist_Main.tvChannelDblClick(Sender: TObject);
begin
  edtMessage.Text := '/w ' + lastSelectedChannelPlayer + ' ';
  edtMessage.SetFocus;
  edtMessage.SelStart := length(edtMessage.Text);
end;

procedure TWC3Banlist_Main.OnMessageChange(kind: TWhisperType);
begin
  MessageCenter.SaveToFile;
  if not loadComplete then
    Exit;
  if kind = wtIn then
    SOUND(SND_WHISPER);
  if (kind in [wtIn, wtError]) and
    chkBringToFront.Checked and
    (GetForeGroundWindow <> findwindow('Warcraft III', 'Warcraft III')) and
    (chkSwitchToMessages.Checked or (GetForeGroundWindow <> Handle))
  then
  begin
    SetForeGroundwindow(handle);
    pages.ActivePage := tabMessages;
  end;
  NavigateToWhisper;
end;


procedure TWC3Banlist_Main.CheckChannel;
var
  i: Integer;
  nicks: TStringlist;
begin
  Sound(SND_RESPONSE);
  nicks := TStringlist.Create;
  try
    for i := 0 to tvChannel.Items.Count - 1 do
      nicks.Add(tvChannel.Items[i].Text);
    if not CheckList(nicks) then
      AddMessage('No one in channel is banlisted or notated.', ICON_NOTE);
  finally
    nicks.Free;
  end;
end;

procedure TWC3Banlist_Main.btnDiagnosticsClick(Sender: TObject);
begin
  frmDiagnosis.Show;
end;

procedure TWC3Banlist_Main.SaveConfiguration;
begin
  pl.SaveToFile(inipath + 'pinfo.dat');

  ListContainer.SaveToFile(inipath + 'localdb.xml');
  SaveListViewToFile(lvComments, inipath + 'comments.dat');
  SaveListViewToFile(lvPhrases, inipath + 'phrases.dat');
  SaveListViewToFile(lvAutoKick, inipath + 'autokick.dat');
  SaveListViewToFile(lvOnlineLists, inipath + 'serverlists.dat');

  icd.ReadControlList(cl);
  icd.SaveControlData(self);
  icd.SaveCoords(self);

  f.Save;
end;

function TWC3Banlist_Main.CheckList(NickNames: TStringlist): boolean;
var
  i: Integer;
  autokick: boolean;
  found: boolean;
begin
  found := false;
  for i := 0 to NickNames.Count - 1 do
    if CheckSpack(NickNames[i], false, autokick) in [crBan, crNote, crVIP] then
    begin
      AddMessage(CheckResult, ICON_NOTE);
      found := true;
    end;
  result := found;
end;

procedure TWC3Banlist_Main.CheckAll;
var
  i: integer;
  b: byte; // id
  n: TStringlist;
begin
  Sound(SND_RESPONSE);
  n := TStringlist.Create;
  // read the jobs
  for i := 0 to gd.slots - 1 do
  begin
    b := gd.Data[i][0];
    // human, not empty, not self
    if (gd.data[i][3] = 0) and (gd.data[i][1] <> $FF) and (gd.names[b] <>
      '<self>') and (gd.names[b] <> username.Caption) then
      n.add(gd.names[b]);
  end;
  try
    if not CheckList(n) then
      AddMessage('No one here is banlisted or notated.', ICON_NOTE);
  finally
    n.Free;
  end;
end;

procedure TWC3Banlist_Main.lblServerListsClick(Sender: TObject);
begin
  ShellExecute(0, 'open', 'http://www.wc3banlist.de/xmlgen.php', nil, nil, sw_show);
end;

function TWC3Banlist_Main.GetWindowState(h: THandle): Integer;
var
  wp: TWindowPlacement;
begin
  wp.length := SizeOf(wp);
  if GetWindowPlacement(h, @wp) then
    result := wp.showCmd
  else
    result := -1;
end;

procedure TWC3Banlist_Main.LeaverWhileCountdown;
var
  h: THandle;
begin
  h := FindWindow('Warcraft III', 'Warcraft III');
  if h = 0 then exit;
  if (GetTickCount - GameStart) < 2500 then
  begin
    PostMessage(h, WM_KEYDOWN, VK_ESCAPE, 0);
    PostMessage(h, WM_KEYUP, VK_ESCAPE, 0);
  end else
  begin
    SendMessage(h, WM_SYSCOMMAND, SC_CLOSE, 0);
    ForceForegroundWindow(Handle);
    pages.ActivePage := tabSnooping;
    IniInfo(lastleaver +
      ' has left the game during countdown. Warcraft III has been closed to save the day. You might want to ban him.');
  end;
end;

procedure TWC3Banlist_Main.GetHookPointers;
var
  w: Word;
begin
  if hookTries = -2 then
  begin
    ForceForeGroundWindow(Handle);
    while getforegroundwindow <> handle do
      application.ProcessMessages;
    w := Get8087CW;
    if not HookFunctions_GetPtr(Handle) then
    begin
      AddToLog('Unable to get pointers for DirectX-API hook.', ICON_DX);
      hookTries := -1;
    end
    else
      hookTries := 0; // ready to hook
    Set8087CW(w);
  end;
end;

procedure TWC3Banlist_Main.chkCloseOnLeaverClick(Sender: TObject);
var
  b: Boolean;
begin
  b := chkCloseOnLeaver.Checked;
  radAutoCloseHostOnly.Enabled := b;
  radAutoCloseHostAndClient.Enabled := b;
end;

procedure TWC3Banlist_Main.GetWarcraftType(h: THandle);
var
  Icon: HIcon;
  b1, b2, b3: TBitmap;

  function equals(b1, b2: TBitmap): boolean;
  var
    x, y: Integer;
    same: boolean;
  begin
    same := true;
    for x := 0 to 31 do
      for y := 0 to 31 do
        if b1.Canvas.Pixels[x, y] <> b2.Canvas.Pixels[x, y] then
          same := false;
    result := same;
  end;

  procedure initBitmap(var b: TBitmap);
  begin
    b := TBitmap.Create;
    b.Width := 32;
    b.Height := 32;
  end;

begin
  Icon := GetClassLong(h, GCL_HICON);
  initBitmap(b1);
  initBitmap(b2);
  initBitmap(b3);
  DrawIcon(b1.Canvas.Handle, 0, 0, Icon);
  ilWarcraft.Draw(b2.Canvas, 0, 0, 0);
  ilWarcraft.Draw(b3.Canvas, 0, 0, 1);
  if equals(b1, b2) then
    wc3Type := 1
  else if equals(b1, b3) then
    wc3Type := 2
  else
    wc3Type := 0;
  b1.Free;
  b2.Free;
  b3.Free;
end;

procedure TWC3Banlist_Main.GetPlayerRank(PlayerName: string);
var
  t: TWebAccess;
begin
  t := TWebAccess.Create(true);
  t.PlayerName := PlayerName;
  t.FreeOnTerminate := True;
  t.Resume;
end;

procedure TWC3Banlist_Main.btnReplyClick(Sender: TObject);
var
  t: TRegExpr;
begin
  if lastWhisperer = '' then
    exit;
  t := TRegExpr.Create;
  t.Expression := '\/w (.+) (.*)';
  if t.Exec(edtMessage.Text) then
    edtMessage.Text := '/w ' + lastWhisperSender + ' ' + t.Match[2]
  else
    edtMessage.Text := '/w ' + lastWhisperSender + ' ' + edtMessage.Text;
  edtMessage.SelStart := length(edtMessage.text);
  t.Free;
end;

procedure TWC3Banlist_Main.webMsgBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
  if closing then
    Cancel := True
  else if (pos(extractfilename(html_help), URL) = 0)
    and (pos(extractfilename(xml_messages), URL) = 0) then
  begin
    Cancel := True;
    ShellExecute(0, 'open', PChar(string(URL)), nil, nil, sw_show);
  end;
end;

procedure TWC3Banlist_Main.webMsgDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  forceRefresh := false;

  webMsg.Align := alClient;
  Application.ProcessMessages;

  EnableDraw;
end;

function Scrolling(front: TWebBrowser): boolean;
var
  doc: IHTMLDocument2;
  body: IHTMLElement2;
begin
  result := false;
  doc := front.Document as IHTMLDocument2;
  if doc <> nil then
  begin
    body := doc.Body as IHTMLElement2;
    if body <> nil then
    scrolling :=
      (Body.ScrollHeight > Body.ClientHeight) and
      ((Body.ScrollHeight - Body.ScrollTop) <> Body.ClientHeight);
  end;
end;

procedure TWC3Banlist_Main.MiscTimerTimer(Sender: TObject);
var
  b: boolean;
begin
  MiscTimer.Interval := 500;
  b := scrolling(webMsg);
  if not b and not refreshEnable then
  begin
    refreshEnable := true;
    NavigateToWhisper;
  end
  else
    refreshEnable := not b;
  if showGameReview then
  begin
    showGameReview := false;
    mnuOpenGameReviewClick(nil);
  end;
  if chkFirstRun.Checked then
  begin
    chkFirstRun.Checked := false;
    btnShowWizard(nil);
  end;
end;

procedure TWC3Banlist_Main.FormActivate(Sender: TObject);
begin
  WarcraftWindowTimer.Enabled := true;
end;

procedure TWC3Banlist_Main.lblEnterLoginDataClick(Sender: TObject);
var
  t: TLoginData;
begin
  if not loadComplete then
    exit;
  if chkBuddiesList.Checked then
  begin
    t := TLoginData.Create(self);
    SetFormFont(t, defaultFont, defaultFontSize);
    t.edtLogin.Text := edtBlLogin.Text;
    t.edtPassword.Text := '';
    if t.ShowModal = mrOK then
    begin
      edtBlLogin.Text := t.edtLogin.Text;
      edtBlPassword.Text := MD5Print(MD5String(t.edtPassword.Text));
    end;
  end;
end;

procedure TWC3Banlist_Main.CheckFriendJoin(whisper: string);
var
  t: TStringlist;
  r: TRegExpr;
  i: Integer;
begin
  t := TStringlist.Create;
  r := TRegExpr.Create;
  try
    t.LoadFromFile(inipath + 'joined.dat');
    for i := 0 to t.Count - 1 do
    begin
      r.Expression := t[i];
      if r.Exec(whisper) and (r.Match[3] <> 'BNet') then
      begin
        Sound(SND_RESPONSE);
        Application.ProcessMessages;
        AddMessage('Your friend ' + r.Match[1] + ' has joined the game "' +
          Utf8ToAnsi(r.Match[3]) +
            '". Its title has been copied to the clipboard.', WC3IconIndex, r.Match[1]);
        Application.ProcessMessages;
        ct.Clear;
        Application.ProcessMessages;
        ct.SetText(r.Match[3]);
        Application.ProcessMessages;
        pl.SetWhispered(r.Match[1]);
      end;
    end;
  finally
    r.free;
    t.free;
  end;
end;

procedure TWC3Banlist_Main.WMNewVersion(var Message: TMessage);
var
  t: TfrmUpdate;
begin
  t := TfrmUpdate.Create(self);
  if defaultFont <> '' then
    SetFormFont(t, defaultFont, defaultFontSize);
  t.ShowModal;
  chkUpdate.Checked := t.chkCheck.Checked;
  t.free;
end;

procedure TWC3Banlist_Main.CheckForUpdates;
var
  UC: UpdateChecker;
begin
  UC := UpdateChecker.Create(true);
  UC.FreeOnTerminate := True;
  UC.Resume;
end;

procedure TWC3Banlist_Main.SetPingTimeout(ms: Integer);
begin
  if (ms <= 0) then
    raise Exception.Create('Not a valid value for ping timeout.');
  raw_ping.timeout := ms;
end;

procedure TWC3Banlist_Main.btnSetPingTimeoutClick(Sender: TObject);
begin
  try
    SetPingTimeout(StrToInt(edtPingTimeout.Text));
    btnSetPingTimeout.SetFocus;
  except
    IniInfo('This is not a valid value.');
    edtPingTimeout.SetFocus;
    edtPingTimeout.SelectAll;
  end;
end;

procedure TWC3Banlist_Main.chkBuddiesListClick(Sender: TObject);
begin
  btnEnterLoginData.Enabled := chkBuddiesList.Checked;
  btnDoTransfers.Enabled := chkBuddiesList.Checked;
end;

function TWC3Banlist_Main.FilterWhitespaces(a: string): string;
var
  i: integer;
begin
  for i := 1 to length(a) do
    if (i = 1) or (a[i - 1] <> ' ') or (a[i] <> ' ') then
      result := result + a[i];
end;

function TWC3Banlist_Main.NotWhispered: string;
var
  i, b: Integer;
  n: TStringlist;
begin
  n := tstringlist.create;
  // read the jobs
  for i := 0 to gd.slots - 1 do
  begin
    b := gd.Data[i][0];
    // human, not empty, not self
    if (gd.data[i][3] = 0) and (gd.data[i][1] <> $FF) and (gd.names[b] <>
      '<self>') and (gd.names[b] <> username.Caption) then
    begin
      if not pl.GetWhispered(gd.names[b]) then
        n.add(gd.names[b]);
    end;
  end;
  if n.Count = 0 then
    result := 'All present players have whispered to you.'
  else
  begin
    for i := 0 to n.Count - 1 do
    begin
      result := result + n[i];
      if i < n.Count - 2 then
        result := result + ', ';
      if i = n.Count - 2 then
        result := result + ' and ';
    end;
    if n.Count = 1 then
      result := result + ' still needs to whisper you.'
    else
      result := result + ' still need to whisper you.';
  end;
  n.Free;
end;

procedure TWC3Banlist_Main.webMsgImgClick(Sender: TObject);
begin
  webMsg.Show;
end;

procedure TWC3Banlist_Main.EnableDraw;
begin
  if chkPreventFlicker.Checked then
    LockWindowUpdate(0);
end;

procedure TWC3Banlist_Main.DisableDraw;
begin
  if chkPreventFlicker.Checked then
    LockWindowUpdate(Handle);
end;

procedure TWC3Banlist_Main.tmChatRefreshTimer(Sender: TObject);
begin
  tmChatRefresh.Enabled := false;
  if tmChatRefresh.Tag = 1 then
    NavigateToWhisper;
end;

procedure TWC3Banlist_Main.btnAutoExportSaveToClick(Sender: TObject);
var
  s: TSaveDialog;
begin
  s := TSaveDialog.Create(self);
  try
    s.Filter := 'Textfile (*.txt)|*.txt|All Files (*.*)|*.*';
    s.DefaultExt := 'txt';
    s.FileName := edAutoExportTarget.Text;
    if s.Execute then
      edAutoExportTarget.Text := s.Filename;
  finally
    s.Free;
  end;
end;

procedure TWC3Banlist_Main.btnAutoExportRunAfterwardsClick(
  Sender: TObject);
var
  o: TOpenDialog;
begin
  o := TOpenDialog.Create(Self);
  try
    o.Filter :=
      'Executables (*.exe, *.cmd, *.bat)|*.exe;*.cmd;*.bat|All Files (*.*)|*.*';
    o.FileName := edAutoExportCommand.Text;
    if o.Execute then
      edAutoExportCommand.Text := o.FileName;
  finally
    o.Free;
  end;
end;

procedure TWC3Banlist_Main.AutoExport;
var
  t: TStringlist;
  i: Integer;
  ban: PBan;
begin
  if edAutoExportTarget.Text <> '' then
  begin
    t := tstringlist.create;
    for i := 0 to ListContainer.banlist.list.Count - 1 do begin
      ban := ListContainer.banlist.list[i];
      if not ban^.deleted then
        t.Add(trim(ban^.nick + ' ' + ban^.comment));
    end;
    try
      try
        try
          ForceDirectories(ExtractFilePath(edAutoExportTarget.Text));
        except
        end;
        t.SaveToFile(edAutoExportTarget.Text);
      except
        on e: Exception do
          MessageDlg('Automated export failed.' + cr + e.Message, mtError,
            [mbOK], 0);
      end;
    finally
      t.free;
    end;
  end;
  if edAutoExportCommand.Text <> '' then
    if not ExecAndWait(edAutoExportCommand.Text, SW_SHOW, False) then
      MessageDlg('Automated export command failed...' + #13 + #10 + #13 + #10 +
        'Could not execute ' +
        edAutoExportCommand.Text, mtError, [mbOK], 0);
end;

procedure TWC3Banlist_Main.btnFileNamePatternClick(Sender: TObject);
begin
  IniInfo('You can also give additional text for the filename after the /screenshot command which will be added after the pattern.'
          + cr + cr + 'Examples:' + cr + cr +
          '      /ss second time' + cr +
          '      /ss $lastleaver');
end;

procedure TWC3Banlist_Main.btnScreenshotTargetClick(Sender: TObject);
var
  path: String;
begin
  Path := '';
  if SelectDirectoryEx(Handle, Path, 'Select the screenshot target folder...', '')
    then edScreenshotDBLocation.Text := path;
end;

function TWC3Banlist_Main.MakeScreenshot(comment: string): string;
const
  forbidden: string = '/\:*?"<>|';
var
  bmp: TBitmap;
  jpg: TJPEGImage;
  shortname, name: String;
  filename: String;
  i: Integer;
begin
  name := SubstPhrase(edScreenshotPattern.Text + comment, false);
  bmp := TBitmap.Create;
  jpg := TJPEGImage.Create;
  result := '';
  try
    ScreenShot(bmp);
    jpg.Assign(bmp);
    forceDirectories(edScreenshotDBLocation.Text);
    for i := 1 to length(name) do
      if pos(name[i], forbidden)>0 then name[i]:='_';
    filename := IniPreparePath(edScreenshotDBLocation.Text, '\') + name + '.jpg';
    i := 2;
    shortname := name;
    while fileexists(filename) do
    begin
      name := shortname + '(' + inttostr(i) + ')';
      filename := IniPreparePath(edScreenshotDBLocation.Text, '\') + name + '.jpg';
      inc(i);
    end;
    jpg.SaveToFile(filename);
    result := name + '.jpg';
    if lastScreenShots <> '' then lastScreenShots := lastScreenShots + '|';
    lastScreenShots := lastScreenShots + result;
  finally
    bmp.Free;
    jpg.Free;
  end;
end;

procedure TWC3Banlist_Main.lblScreenshotLocationClick(Sender: TObject);
begin
  ForceDirectories(edScreenshotDBLocation.Text);
  ShellExecute(0, 'open', PChar(edScreenshotDBLocation.Text), nil, nil, sw_show);
end;

procedure TWC3Banlist_Main.pbLogoPaint(Sender: TObject);
var
  p: TPNGObject;
begin
  p := TPNGObject.Create;
  try
    p.LoadFromStream(res.GetResource('logo.png'));
    p.Transparent := true;
    p.Draw(pbLogo.Canvas, Rect(0,0,pbLogo.Width, pbLogo.Height));
  except
  end;
  p.Free;
end;

procedure TWC3Banlist_Main.vtLogGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  p: PLogEntry;
begin
  p := vtLog.GetNodeData(Node);
  CellText := p^.text;
end;

procedure TWC3Banlist_Main.vtLogGetNodeDataSize(Sender: TBaseVirtualTree;
  var NodeDataSize: Integer);
begin
  NodeDataSize := sizeof(TLogEntry);
end;

procedure TWC3Banlist_Main.mnuLogCopyClick(Sender: TObject);
var
  p: PLogEntry;
  n: PVirtualNode;
begin
  n := vtLog.GetFirstSelected;
  if n = nil then exit;
  p := vtLog.GetNodeData(n);
  Clipboard.AsText := p^.text;
end;

procedure TWC3Banlist_Main.npDatabaseChange(Sender: TObject);
begin
  btnEmptyRecycleBin.Enabled := true;
  lblEmptyRecycleBin.Enabled := true;
  if npDatabase.ActivePage = panBans then
    vtBans.BringToFront else
  if npDatabase.ActivePage = panInfos then
    vtInfos.BringToFront else
  if npDatabase.ActivePage = panTools then
    pgTools.BringToFront;
  if npDatabase.ActivePage = panScores then
    vtScores.BringToFront;
  if npDatabase.ActivePage = panGames then
    vtGames.BringToFront;
  panFilter.Visible := npDataBase.ActivePage <> panTools;
end;

procedure TWC3Banlist_Main.CheckForImportOldDatabase;
var
  filenameNew, filenameOld: String;
  lv: TListView;
  lc: TListContainer;
  ban: PBan;
  info: PInfo;
  i: Integer;
begin
  filenameNew := IniPath + 'localdb.xml';
  filenameOld := IniPath + 'blacklist.dat';
  if fileexists(filenameOld) and not fileexists(filenameNew) then begin
    lv := TListView.Create(self);
    lv.Parent := self;
    lc := TListContainer.Create(self);
    try
      LoadListViewFromFile(lv, filenameOld);
      for i := 0 to lv.Items.Count - 1 do
      with lv.Items[i] do begin
        if ImageIndex in [0, 1] then begin
          new(ban);
          ban^.nick := Caption;
          ban^.comment := Subitems[0];
          ban^.deleted := Boolean(ImageIndex);
          ban^.lastChange := now;
          lc.banlist.list.Add(ban);
        end else if
        ImageIndex = 2 then begin
          new(info);
          info^.nick := Caption;
          info^.comment := Subitems[0];
          info^.deleted := false;
          info^.lastChange := now;
          lc.infolist.list.Add(info);
        end;
      end;
      lc.SaveToFile(filenameNew);
    finally
      lc.Free;
      lv.Free;
    end;
  end;
end;

procedure TWC3Banlist_Main.RefreshLocalDatabase;
var
  i: Integer;
begin
  with ListContainer do begin
    vtBans.BeginUpdate;
    vtBans.Clear;
    for i := 0 to banlist.list.Count - 1 do
       vtBans.AddChild(nil, banlist.list[i]);
    vtBans.EndUpdate;
    vtInfos.BeginUpdate;
    vtInfos.Clear;
    for i := 0 to infolist.list.Count - 1 do
       vtInfos.AddChild(nil, infolist.list[i]);
    vtInfos.EndUpdate;
    vtGames.BeginUpdate;
    vtGames.Clear;
    for i := 0 to gamelist.list.Count - 1 do
       vtGames.AddChild(nil, gamelist.list[i]);
    vtGames.EndUpdate;
    vtScores.BeginUpdate;
    vtScores.Clear;
    for i := 0 to scorelist.list.Count - 1 do
       vtScores.AddChild(nil, scorelist.list[i]);
    vtScores.EndUpdate;
  end;
  SetDatabaseVisibility;
end;

procedure TWC3Banlist_Main.vtBansGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
const
  truefalse: array[0..1] of string = ('no', 'yes');
var
  p: PBan;
  pp: ^Pointer;
begin
  pp := Sender.GetNodeData(node);
  p := pp^;
  case column of
    0: celltext := p^.nick;
    1: celltext := p^.comment;
    2: celltext := datetimetostr(p^.lastChange);
    3: celltext := truefalse[ord(p^.deleted)];
  end;
end;

procedure TWC3Banlist_Main.vtInfosGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
const
  truefalse: array[0..1] of string = ('no', 'yes');
var
  p: PInfo;
  pp: ^Pointer;
begin
  pp := Sender.GetNodeData(node);
  p := pp^;
  case column of
    0: celltext := p^.nick;
    1: celltext := p^.comment;
    2: celltext := datetimetostr(p^.lastChange);
    3: celltext := truefalse[ord(p^.deleted)];
  end;
end;

procedure TWC3Banlist_Main.vtBansCompareNodes(Sender: TBaseVirtualTree;
  Node1, Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  p1, p2: ^Pointer;
  i1, i2: PBan;
begin
  p1 := Sender.GetNodeData(Node1);
  p2 := Sender.GetNodeData(Node2);
  i1 := p1^;
  i2 := p2^;
  case column of
    0: result := comparetext(lowercase(i1^.nick), lowercase(i2^.nick));
    1: result := comparetext(lowercase(i1^.comment), lowercase(i2^.comment));
    2: result := trunc(i1^.lastChange * 24 * 3600) - trunc(i2^.lastChange * 24 * 3600);
    3: result := ord(i1^.deleted) - ord(i2^.deleted);
  end;
end;

procedure TWC3Banlist_Main.vtInfosCompareNodes(Sender: TBaseVirtualTree;
  Node1, Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  p1, p2: ^Pointer;
  i1, i2: PInfo;
begin
  p1 := Sender.GetNodeData(Node1);
  p2 := Sender.GetNodeData(Node2);
  i1 := p1^;
  i2 := p2^;
  case column of
    0: result := comparetext(lowercase(i1^.nick), lowercase(i2^.nick));
    1: result := comparetext(lowercase(i1^.comment), lowercase(i2^.comment));
    2: result := trunc(i1^.lastChange * 24 * 3600) - trunc(i2^.lastChange * 24 * 3600);
    3: result := ord(i1^.deleted) - ord(i2^.deleted);
  end;
end;

procedure TWC3Banlist_Main.CountDatabaseEntries;
var
  c, d, i: Integer;
begin
  with ListContainer do begin
    c := 0;
    d := 0;
    for i := 0 to banlist.list.count - 1 do
      if PBan(banlist.list[i])^.deleted = false then inc(c)
      else inc(d);
    lblBanCount.Caption := IntToStr(c) + ' bans. ' + IntToStr(d) + ' deleted bans.';
    c := 0;
    d := 0;
    for i := 0 to infolist.list.count - 1 do
      if PInfo(infolist.list[i])^.deleted = false then inc(c)
      else inc(d);
    lblInfoCount.Caption := IntToStr(c) + ' infos. ' + IntToStr(d) + ' deleted infos.';
    lblGameCount.Caption := IntToStr(vtGames.TotalCount) + ' games in database.';
    lblScoreCount.Caption := IntToStr(vtScores.TotalCount) + ' scores in database.';
  end;
end;

procedure TWC3Banlist_Main.FormDestroy(Sender: TObject);
begin
  ListContainer.Free;
  LastBannedList.Free;
  mapinfo.Free;
  StringCache.Free;
  Reserve.Free;
  res.Free;
  icd.Free;
  if assigned(HKReceiver) then
  begin
    HKReceiver.Terminate;
    HKReceiver.WaitFor;
    FreeAndNil(HKReceiver);
  end;
  if assigned(MessageCenter) then FreeAndNil(MessageCenter);
  if assigned(Banlist) then FreeAndNil(Banlist);
  if assigned(FZniffer) then FreeAndNil(FZniffer);
  if assigned(Unwanted) then FreeAndNil(Unwanted);
  if assigned(kickOrderList) then FreeAndNil(kickOrderList);
  if assigned(Whispers) then FreeAndNil(Whispers);
  if assigned(deletedDXTexts) then FreeAndNil(deletedDXTexts);
  if assigned(pk) then FreeAndNil(pk);
  if assigned(MarqueeFont) then FreeAndNil(MarqueeFont);
  if assigned(gd) then FreeAndNil(gd);
  if assigned(pl) then FreeAndNil(pl);
  if assigned(CountryCache) then FreeAndNil(countrycache);
  if assigned(ColorMapping) then FreeAndNil(ColorMapping);
  if assigned(f) then FreeAndNil(f);
  if assigned(phraseKeeper1) then FreeAndNil(phraseKeeper1);
  if assigned(ping) then FreeAndNil(ping);
  if assigned(realms) then FreeAndNil(realms);
  if assigned(scr.c) then FreeAndNil(scr.c);
  if assigned(conlist) then
  begin
    while conlist.Count > 0 do
    begin
      dispose(conlist[0]);
      conlist.Delete(0);
    end;
    FreeAndNil(conlist);
  end;
  DeInstallMutex;
end;

procedure TWC3Banlist_Main.chkShowDeletedInfosClick(Sender: TObject);
begin
  SetDatabaseVisibility;
end;

procedure TWC3Banlist_Main.chkShowDeletedBansClick(Sender: TObject);
begin
  SetDatabaseVisibility;
end;

procedure TWC3Banlist_Main.vtBansPaintText(Sender: TBaseVirtualTree;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);
var
  p: ^Pointer;
  i: PBan;
begin
  p := Sender.GetNodeData(Node);
  i := p^;
  if i^.deleted then
    TargetCanvas.Font.Color := clGray;
  if i^.deleted then
    TargetCanvas.Font.Style := TargetCanvas.Font.Style + [fsStrikeout]
  else
    TargetCanvas.Font.Style := TargetCanvas.Font.Style - [fsStrikeout]
end;

procedure TWC3Banlist_Main.vtInfosPaintText(Sender: TBaseVirtualTree;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);
var
  p: ^Pointer;
  i: PInfo;
begin
  p := Sender.GetNodeData(Node);
  i := p^;
  if i^.deleted then
    TargetCanvas.Font.Color := clGray;
  if i^.deleted then
    TargetCanvas.Font.Style := TargetCanvas.Font.Style + [fsStrikeout]
  else
    TargetCanvas.Font.Style := TargetCanvas.Font.Style - [fsStrikeout]
end;

procedure TWC3Banlist_Main.vtBansGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
var
  p: ^Pointer;
  i: PBan;
begin
  if Column = 0 then
  with Sender do begin
    p := GetNodeData(Node);
    i := p^;
    if i^.deleted then
      ImageIndex := 1
    else
      ImageIndex := 0;
  end;
end;

procedure TWC3Banlist_Main.vtInfosGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
var
  p: ^Pointer;
  i: PInfo;
begin
  if Column = 0 then
  with Sender do begin
    p := GetNodeData(Node);
    i := p^;
    if i^.deleted then
      ImageIndex := 3
    else
      ImageIndex := 2;
  end;
end;

function TWC3Banlist_Main.ExecuteEditAddBanDialog(oldBan: PBan): PVirtualNode;
var
  p: PBan;
  n: PVirtualNode;
  pi: PPlayerInfo;
begin
  result := nil;
  with frmEditAdd do
  if ShowModal = mrOK then begin
    new(p);
    p^.nick := edtNick.Text;
    p^.comment := edtComment.Text;
    p^.lastChange := now;
    p^.deleted := false;
    if oldBan <> nil then
    begin
      Dispose(oldBan);
      ListContainer.banlist.list.Remove(oldBan);
    end;
    ListContainer.banlist.AddEntry(p);
    RefreshLocalDatabase;
    n := GetNodeAt(vtBans, p);
    if n <> nil then begin
      vtBans.ScrollIntoView(n, false);
      vtBans.Selected[n] := true;
    end;
    result := n;
    // maybe refresh current game view
    pi := pl.GetPlayerInfo(p^.nick);
    if assigned(pi) then
    begin
      pi^.banInfo^.ban := p^.comment;
    end;
  end;
end;

procedure TWC3Banlist_Main.btnEditBanClick(Sender: TObject);
var
  n: PVirtualNode;
  p: ^Pointer;
  b: PBan;
begin
  n := vtBans.GetFirstSelected;
  if n <> nil then
  with frmEditAdd do begin
    p := vtBans.GetNodeData(n);
    b := p^;
    Caption := 'Edit Selected Ban';
    edtNick.Text := b^.nick;
    edtComment.Text := b^.comment;
    ExecuteEditAddBanDialog(b);
  end;
end;

procedure TWC3Banlist_Main.btnDeleteBanClick(Sender: TObject);
var
  n: PVirtualNode;
  p: ^Pointer;
  b: PBan;
  pi: PPlayerInfo;
  c: Integer;
begin
  c := 0;
  n := vtBans.GetFirstSelected;
  while n <> nil do begin
    p := vtBans.GetNodeData(n);
    b := p^;
    if not b^.deleted then inc(c);
    n := vtBans.GetNextSelected(n);
  end;
  if MessageDlg(Format(
    'Are you sure you want to delete %d ban(s)?'+#13+#10+''+#13+#10
    +'Once a ban is deleted you can revert it by editing the deleted ban.'
    +#13+#10+'It will obtain a new last modification date then.', [c]),
    mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;
  n := vtBans.GetFirstSelected;
  while n <> nil do begin
    p := vtBans.GetNodeData(n);
    b := p^;
    b^.deleted := true;
    pi := pl.GetPlayerInfo(b^.nick);
    if assigned(pi) then
      pi^.banInfo^.ban := '';
    n := vtBans.GetNextSelected(n);
  end;
  SetDatabaseVisibility;
end;

procedure TWC3Banlist_Main.btnAddInfoClick(Sender: TObject);
begin
  with frmEditAdd do begin
    Caption := 'Create New Info';
    edtNick.Text := '';
    edtComment.Text := '';
    ExecuteEditAddInfoDialog(nil);
  end;
end;

function TWC3Banlist_Main.ExecuteEditAddInfoDialog(
  oldInfo: PInfo): PVirtualNode;
var
  p: PInfo;
  n: PVirtualNode;
  pi: PPlayerInfo;
begin
  result := nil;
  with frmEditAdd do
  if ShowModal = mrOK then begin
    new(p);
    p^.nick := edtNick.Text;
    p^.comment := edtComment.Text;
    p^.lastChange := now;
    p^.deleted := false;
    if oldInfo <> nil then
    begin
      Dispose(oldInfo);
      ListContainer.infolist.list.Remove(oldInfo);
    end;
    ListContainer.infolist.AddEntry(p);
    RefreshLocalDatabase;
    n := GetNodeAt(vtInfos, p);
    if n <> nil then begin
      vtInfos.ScrollIntoView(n, false);
      vtInfos.Selected[n] := true;
    end;
    // maybe refresh current game view
    pi := pl.GetPlayerInfo(p^.nick);
    if assigned(pi) then
    begin
      pi^.banInfo^.info := p^.comment;
    end;
    result := n;
  end;
end;

procedure TWC3Banlist_Main.btnEditInfoClick(Sender: TObject);
var
  n: PVirtualNode;
  p: ^Pointer;
  i: PInfo;
begin
  n := vtInfos.GetFirstSelected;
  if n <> nil then
  with frmEditAdd do begin
    p := vtInfos.GetNodeData(n);
    i := p^;
    Caption := 'Edit Selected Info';
    edtNick.Text := i^.nick;
    edtComment.Text := i^.comment;
    ExecuteEditAddInfoDialog(i);
  end;
end;

procedure TWC3Banlist_Main.btnDeleteInfoClick(Sender: TObject);
var
  n: PVirtualNode;
  p: ^Pointer;
  i: PInfo;
  pi: PPlayerInfo;
  c: Integer;
begin
  c := 0;
  n := vtInfos.GetFirstSelected;
  while n <> nil do begin
    p := vtInfos.GetNodeData(n);
    i := p^;
    if not i^.deleted then inc(c);
    n := vtInfos.GetNextSelected(n);
  end;
  if MessageDlg(Format(
    'Are you sure you want to delete %d info(s)?'+#13+#10+''+#13+#10
    +'Once an info is deleted you can revert it by editing the deleted info.'
    +#13+#10+'It will obtain a new last modification date then.', [c]),
    mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;
  n := vtInfos.GetFirstSelected;
  while n <> nil do begin
    p := vtInfos.GetNodeData(n);
    i := p^;
    i^.deleted := true;
    pi := pl.GetPlayerInfo(i^.nick);
    if assigned(pi) then
      pi^.banInfo^.ban := '';
    n := vtInfos.GetNextSelected(n);
  end;
  SetDatabaseVisibility;
end;

procedure TWC3Banlist_Main.SetDatabaseVisibility;
var
  p: ^Pointer;
  ban: PBan;
  info: PInfo;
  score: PScore;
  game: PGame;
  n: PVirtualNode;
  filtered: Boolean;
  filterstr: String;
begin
  filtered := chkFiltered.Checked;
  filterstr := lowercase(edtFilter.Text);
  with vtBans do begin
    BeginUpdate;
    n := GetFirst;
    while n <> nil do
    begin
      p := GetNodeData(n);
      ban := p^;
      IsVisible[n] := (not filtered or (filtered and
        ((pos(filterstr, lowercase(ban^.nick)) > 0) or (pos(filterstr, lowercase(ban^.comment)) > 0)))) and
        (not ban^.deleted or chkShowDeletedBans.Checked);
      n := GetNext(n);
    end;
    if chkShowDeletedBans.Checked then
      Header.Columns[3].Options := Header.Columns[3].Options + [coVisible]
    else
      Header.Columns[3].Options := Header.Columns[3].Options - [coVisible];
    EndUpdate;
  end;
  with vtInfos do begin
    BeginUpdate;
    n := GetFirst;
    while n <> nil do
    begin
      p := GetNodeData(n);
      info := p^;
      IsVisible[n] := (not filtered or (filtered and
        ((pos(filterstr, lowercase(info^.nick)) > 0) or (pos(filterstr, lowercase(info^.comment)) > 0)))) and
        (not info^.deleted or chkShowDeletedInfos.Checked);
      n := GetNext(n);
    end;
    if chkShowDeletedInfos.Checked then
      Header.Columns[3].Options := Header.Columns[3].Options + [coVisible]
    else
      Header.Columns[3].Options := Header.Columns[3].Options - [coVisible];
    EndUpdate;
  end;
  with vtScores do begin
    BeginUpdate;
    n := GetFirst;
    while n <> nil do
    begin
      p := GetNodeData(n);
      score := p^;
      IsVisible[n] := not filtered or (filtered and
        (pos(filterstr, lowercase(score^.nick)) > 0));
      n := GetNext(n);
    end;
    EndUpdate;
  end;
  with vtGames do begin
    BeginUpdate;
    n := GetFirst;
    while n <> nil do
    begin
      p := GetNodeData(n);
      game := p^;
      IsVisible[n] := not filtered or (filtered and (
        (pos(filterstr, lowercase(game^.realm)) > 0) or
        (pos(filterstr, lowercase(game^.players)) > 0) or
        (pos(filterstr, lowercase(game^.ownNickName)) > 0) or
        (pos(filterstr, lowercase(game^.gameName)) > 0) or
        (pos(filterstr, lowercase(game^.screenShots)) > 0) or
        (pos(filterstr, lowercase(game^.replay)) > 0) or
        (pos(filterstr, lowercase(game^.mapName)) > 0) or
        (pos(filterstr, lowercase(game^.comment)) > 0)));
      n := GetNext(n);
    end;
    EndUpdate;
  end;
  CountDatabaseEntries;  
end;

procedure TWC3Banlist_Main.chkFilteredClick(Sender: TObject);
begin
  if chkFiltered.Checked and (edtFilter.Text = '') then
  begin
    chkFiltered.Checked := false;
    exit;
  end;
  SetDatabaseVisibility;
end;

function TWC3Banlist_Main.ExistsOnLocalBanlist(spack: String): PBan;
var
  i: Integer;
begin
  result := nil;
  if ListContainer.banlist.FindEntry(spack, i) then
    result := ListContainer.banlist.list[i];
end;

function TWC3Banlist_Main.ExistsOnLocalInfoList(spack: String): PInfo;
var
  i: Integer;
begin
  result := nil;
  if ListContainer.infolist.FindEntry(spack, i) then
    result := ListContainer.infolist.list[i];
end;

procedure TWC3Banlist_Main.btnRestoreLocalDatabaseClick(Sender: TObject);
begin
  frmRestore.Show;
  frmRestore.tmDownload.Enabled := true;
end;

procedure TWC3Banlist_Main.vtLogGetImageIndexEx(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer;
  var ImageList: TCustomImageList);
var
  p: PLogEntry;
begin
  ImageList := ilLog;
  Ghosted := false;
  p := vtLog.GetNodeData(Node);
  if column = 0 then
    ImageIndex := p^.icon;
end;

procedure TWC3Banlist_Main.vtGameGetNodeDataSize(Sender: TBaseVirtualTree;
  var NodeDataSize: Integer);
begin
  NodeDataSize := SizeOf(TGameNodeData);
end;

procedure TWC3Banlist_Main.vtGameBeforeCellPaint(Sender: TBaseVirtualTree;
  TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  CellRect: TRect);
var
  p: PGameNodeData;
begin
  if Sender.GetNodeLevel(node) = 0 then begin
    p := Sender.GetNodeData(node);
    if (column = 0) or (p^.Nick = 'Computer') then
      TargetCanvas.Brush.Color := lvGameColors[p^.Color]
    else
    begin
      if p^.HasLeft then
        TargetCanvas.Brush.Color := $00AAAAAA
      else if p^.HasLostConnection then
        TargetCanvas.Brush.Color := $0096B0E9
      else if p^.HasWhispered then
        TargetCanvas.Brush.Color := $00AAFFBB
      else
        TargetCanvas.Brush.Color := clWhite;
    end;
  end else begin
    p := Sender.GetNodeData(Node.Parent);
    if column = 0 then
      TargetCanvas.Brush.Color := lvGameColors[p^.Color]
    else
    begin
      if p^.HasLeft then
        TargetCanvas.Brush.Color := $00AAAAAA
      else if p^.HasLostConnection then
        TargetCanvas.Brush.Color := $0096B0E9
      else if p^.HasWhispered then
        TargetCanvas.Brush.Color := $00AAFFBB
      else
        TargetCanvas.Brush.Color := clWhite;
    end;
  end;
  targetcanvas.FillRect(cellrect);
end;

procedure TWC3Banlist_Main.vtGameGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
begin
  if Sender.GetNodeLevel(node) = 1 then
    if column = 1 then
      imageindex := node.Index * 2;
end;

procedure TWC3Banlist_Main.vtGameGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  p: PGameNodeData;
begin
  if Sender.GetNodeLevel(node) = 0 then begin
    p := Sender.GetNodeData(Node);
    if (p^.Nick = 'Computer') or (p^.Nick = 'Open') or (p^.Nick = 'Closed')
    then begin
      case Column of
        0: CellText := IntToStr(p^.Slot);
        1: CellText := p^.Nick;
      else
        CellText := '';
      end;
    end else
    case Column of
      0: CellText := IntToStr(p^.Slot);
      1: CellText := p^.Nick;
      2: CellText := p^.From;
      3:
        begin
          if p^.Ping > 0 then
            CellText := IntToStr(p^.Ping) + ' ms'
          else if p^.Ping = 0 then
            CellText := ''
          else
            CellText := 'timeout';
        end;
      4:
        if p^.Nick <> username.Caption then CellText := ScoreToStr(p^.Score)
        else CellText := '';
      5: CellText := RatingToStr(p^.Rating);
      6: begin
          if p^.Latency > 0 then
          begin
            if GameState = gsInGame then
              CellText := Format('%d %d ms', [p^.Latency, p^.Deviation])
            else
              CellText := Format('%d ms', [p^.Latency]);
          end else
            CellText := '';
         end;
    end;
  end else begin
    p := Sender.GetNodeData(Node.Parent);
    case Node.Index of
      0: begin
           case Column of
             1: CellText := 'Ban';
             2: CellText := p^.Ban;
           else
             Celltext := '';
           end;
         end;
      1: begin
           case Column of
             1: CellText := 'Info';
             2: CellText := p^.Info;
           else
             Celltext := '';
           end;
         end;
      2: begin
           case Column of
             1: CellText := 'Server List';
             2: CellText := p^.Online;
           else
             Celltext := '';
           end;
         end;    end;
  end;
end;

procedure TWC3Banlist_Main.vtGamePaintText(Sender: TBaseVirtualTree;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);
var
  p: PGameNodeData;
begin
  if Sender.GetNodeLevel(node) = 0 then
  begin
    if column = 1 then
    begin
      TargetCanvas.Font.Style := TargetCanvas.Font.Style + [fsBold];
      p := Sender.GetNodeData(node);
      if p^.IsHost then
        TargetCanvas.Font.Color := clBlue;
    end;
  end;
  if Sender.GetNodeLevel(node) = 1 then begin
    TargetCanvas.Font.Size := 7;
//    if column = 1 then
//      if node.Index = 0 then begin
//        TargetCanvas.Font.Color := clRed;
//      end;
//    if column = 2 then
//        TargetCanvas.Font.Color := clGray;
  end;
end;

procedure TWC3Banlist_Main.lvLastEventsResize(Sender: TObject);
var
  ListView : TListView;
  W : Integer;
  i : Integer;
begin
  if Sender is TListView then begin
    ListView := TListView(Sender);

    // verfgbar Breite
    W := ListView.ClientWidth;

    // Breite aller Spalten (bis auf letzte Spalte) abziehen
    for i := 0 to ListView.Columns.Count-2 do
    begin
    W := W - ListView.Columns[i].Width;
    end;

    // falls ein Rest brigblieben ist, die letzte Spalte anpassen
    if W > 0 then
      ListView.Columns[ListView.Columns.Count-1].Width := W - 1;
  end;
end;

procedure TWC3Banlist_Main.popGamePopup(Sender: TObject);
var
  n: PVirtualNode;
  b, bb, bi, v: boolean;
  p: PGameNodeData;
  ban: PBan;
  info: PInfo;
begin
  n := vtGame.GetFirstSelected;
  v := false;
  b := false;
  bb := false;
  bi := false;
  if assigned(n) then
  begin
    if vtGame.GetNodeLevel(n) = 1 then
    begin
      v := true;
      n := n.Parent;
    end;
    p := vtGame.GetNodeData(n);
    b := (p^.Nick <> username.Caption) and (p^.Nick <> 'Computer') and (p^.Nick <> 'Closed') and (p^.Nick <> 'Open');
    if b then begin
      ban := ExistsOnLocalBanlist(p^.Nick);
      bb := assigned(ban) and not ban^.deleted;
      info := ExistsOnLocalInfoList(p^.Nick);
      bi := assigned(info) and not info^.deleted;
    end;
  end;
  mnuCreateEditBan.Visible := b and (not v or bb);
  mnuDeleteBan.Visible := bb and v;
  mnuCreateEditInfo.Visible := b and (not v or bi);
  mnuDeleteInfo.Visible := bi and v;
  mnuPing.Enabled := b;
  mnuFrom.Enabled := b;
  mnuReserveSlot.Enabled := b;
  mnuAddToFriendList.Enabled := b and not chkAlwaysUseWC3Friendlist.Checked;
  if bb then
    mnuCreateEditBan.Caption := 'Edit Ban'
  else
    mnuCreateEditBan.Caption := 'Create Ban';
  if bi then
    mnuCreateEditInfo.Caption := 'Edit Info'
  else
    mnuCreateEditInfo.Caption := 'Create Info';
  mnuOpenGameReview.Enabled := (lastGameID <> '') and (GameState = gsChat);
  mnuShowLatencyPlots.Enabled := btnShowLatencyPlots.Enabled;
  mnuCopyNickname.Enabled := b;
end;

procedure TWC3Banlist_Main.mnuPingAllClick(Sender: TObject);
begin
  PingAll;
end;

procedure TWC3Banlist_Main.mnuFromAllClick(Sender: TObject);
begin
  FromAll;
end;

procedure TWC3Banlist_Main.mnuPingClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  PingPlayer(p^.Nick);
end;

procedure TWC3Banlist_Main.mnuFromClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
  ip: Cardinal;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  ip := FindPlayerIP(p^.nick);
  if ip <> 0 then
    TIPToCountry.Create(CountryCache).ResolveSingle(iptostr(@ip), p^.Nick);
end;

procedure TWC3Banlist_Main.mnuCreateEditBanClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
  ban: PBan;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  ban := ExistsOnLocalBanlist(p^.Nick);
  with frmEditAdd do begin
    if ban <> nil then begin
      Caption := 'Edit Ban';
      edtNick.Text := ban^.nick;
      edtComment.Text := ban^.comment;
    end else begin
      Caption := 'Create New Ban';
      edtNick.Text := p^.Nick;
      edtComment.Text := '';
    end;
    edtNick.Enabled := false;
  end;
  ExecuteEditAddBanDialog(nil);
end;

procedure TWC3Banlist_Main.mnuCreateEditInfoClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
  info: PInfo;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  info := ExistsOnLocalInfolist(p^.Nick);
  with frmEditAdd do begin
    if info <> nil then begin
      Caption := 'Edit Info';
      edtNick.Text := info^.nick;
      edtComment.Text := info^.comment;
    end else begin
      Caption := 'Create New Info';
      edtNick.Text := p^.Nick;
      edtComment.Text := '';
    end;
    edtNick.Enabled := false;
  end;
  ExecuteEditAddInfoDialog(nil);
end;

procedure TWC3Banlist_Main.vtGameDblClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
  info: PInfo;
  ban: PBan;
begin
  n := vtGame.GetFirstSelected;
  if vtGame.GetNodeLevel(n) = 1 then begin
    p := vtGame.GetNodeData(n.Parent);
    case n.Index of
    0:
      begin
        n := vtGame.GetFirstSelected;
        if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
        p := vtGame.GetNodeData(n);
        ban := ExistsOnLocalBanlist(p^.Nick);
        with frmEditAdd do begin
          if ban <> nil then begin
            Caption := 'Edit Ban';
            edtNick.Text := ban^.nick;
            edtComment.Text := ban^.comment;
          end else begin
            Caption := 'Create New Ban';
            edtNick.Text := p^.Nick;
            edtComment.Text := '';
          end;
          edtNick.Enabled := false;
        end;
        ExecuteEditAddBanDialog(nil);
      end;
    1:
      begin
        info := ExistsOnLocalInfolist(p^.Nick);
        with frmEditAdd do begin
          if info <> nil then begin
            Caption := 'Edit Info';
            edtNick.Text := info^.nick;
            edtComment.Text := info^.comment;
          end else begin
            Caption := 'Create New Info';
            edtNick.Text := p^.Nick;
            edtComment.Text := '';
          end;
          edtNick.Enabled := false;
        end;
        ExecuteEditAddInfoDialog(nil);
      end;
    end;
  end;
end;

function TWC3Banlist_Main.IsInCurrentGame(nick: String): PGameNodeData;
var
  n: PVirtualNode;
  p: PGameNodeData;
begin
  result := nil;
  n := vtGame.GetFirst;
  while n <> nil do
  begin
    p := vtGame.GetNodeData(n);
    if lowercase(p^.Nick) = lowercase(nick) then
    begin
      result := p;
      break;
    end;
    n := vtGame.GetNextSibling(n);
  end;
end;

procedure TWC3Banlist_Main.mnuDeleteBanClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  unban(p^.Nick);
end;

procedure TWC3Banlist_Main.mnuDeleteInfoClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  uninfo(p^.Nick);
end;

procedure TWC3Banlist_Main.RefreshReservations;
var
  l: TStringList;
  i: Integer;
begin
  l := Reserve.List;
  with lvReservations do begin
    Items.BeginUpdate;
    Clear;
    for i := 0 to l.Count - 1 do
    with Items.Add
    do begin
      Caption := '  ' + l[i];
      ImageIndex := 10;
    end;
    Items.EndUpdate;
  end;
  lvReservations.Columns[0].Width := lvReservations.ClientWidth;
end;

procedure TWC3Banlist_Main.mnuClearReservationsClick(Sender: TObject);
begin
  Reserve.Clear;
  RefreshReservations;
end;

procedure TWC3Banlist_Main.popReservePopup(Sender: TObject);
var
  i: Integer;
  m: TMenuItem;
  buddies: TStringlist;
begin
  mnuDeleteReservation.Visible := assigned(lvReservations.Selected);
  if mnuDeleteReservation.Visible then
    mnuDeleteReservation.Caption := '&Delete Reservation for ' + lvReservations.Selected.Caption;
  mnuAddPlayerInChannel.Clear;
  mnuAddFriend.Clear;
  for i := 0 to tvChannel.Items.Count - 1 do
  begin
    m := TMenuItem.Create(mnuAddPlayerInChannel);
    m.Name := 'mnuAddPlayer' + IntToStr(i);
    m.OnClick := AddReservationForChanneler;
    m.Caption := tvChannel.Items[i].Text;
    mnuAddPlayerInChannel.Add(m);
  end;
  mnuAddPlayerInChannel.Enabled := mnuAddPlayerInChannel.Count > 0;
  buddies := TStringlist.Create;
  buddies.CaseSensitive := false;
  buddies.Duplicates := dupIgnore;
  buddies.Sorted := true;
  buddies.AddStrings(memoBuddies.Lines);
  buddies.AddStrings(lbWC3FriendList.Items);
  try
    for i := 0 to buddies.Count - 1 do
    if trim(buddies[i]) <> '' then begin
      m := TMenuItem.Create(mnuAddFriend);
      m.Name := 'mnuAddFriend' + IntToStr(i);
      m.OnClick := AddReservationForChanneler;
      m.Caption := trim(buddies[i]);
      mnuAddFriend.Add(m);
    end;
  finally
    buddies.Free;
  end;
  mnuAddFriend.Enabled := mnuAddFriend.Count > 0;
end;

procedure TWC3Banlist_Main.mnuDeleteReservationClick(Sender: TObject);
begin
  Reserve.List.Delete(Reserve.List.IndexOf(Trim(lvReservations.Selected.Caption)));
  lvReservations.Selected.Delete;
end;

procedure TWC3Banlist_Main.AddReservationForChanneler(Sender: TObject);
begin
  Reserve.Reserve((Sender as TMenuItem).Caption);
  RefreshReservations;
end;

procedure TWC3Banlist_Main.mnuAddWholeChannelClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to tvChannel.Items.Count - 1 do
    if lowercase(tvChannel.Items[i].Text) <> lowercase(UserName.Caption) then
      Reserve.Reserve(tvChannel.Items[i].Text);
  RefreshReservations;
end;

procedure TWC3Banlist_Main.mnuAddTheWholeFriendListClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to memoBuddies.Lines.Count - 1 do
    if memoBuddies.lines[i] <> '' then
      Reserve.Reserve(memoBuddies.Lines[i]);
  RefreshReservations;
end;

procedure TWC3Banlist_Main.lvReservationsColumnClick(Sender: TObject;
  Column: TListColumn);
var
  p: TPoint;
begin
  GetCursorPos(p);
  popReserve.Popup(p.X, p.Y);
end;

procedure TWC3Banlist_Main.lvReservationsKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if key = VK_DELETE then begin
    if not assigned(lvReservations.Selected) then exit;
    Reserve.List.Delete(Reserve.List.IndexOf(Trim(lvReservations.Selected.Caption)));
    lvReservations.Selected.Delete;
  end;
end;

procedure TWC3Banlist_Main.mnuReserveSlotForChannelerClick(
  Sender: TObject);
var
  i: Integer;
  count: Integer;
begin
  count := 0;
  for i := 0 to tvChannel.items.count - 1 do begin
    if tvChannel.items[i].Selected then
    begin
      inc(count);
      Reserve.Reserve(tvChannel.items[i].Text);
    end;
  end;
  if (count = 0) and (lastSelectedChannelPlayer <> '') then
    Reserve.Reserve(lastSelectedChannelPlayer);
  pages.ActivePage := tabSnooping;
  RefreshReservations;
end;

procedure TWC3Banlist_Main.popChannelPopup(Sender: TObject);
begin
  if (tvChannel.Selected <> nil) then
    lastSelectedChannelPlayer := tvChannel.Selected.Text;
  application.ProcessMessages;
  mnuWhisperTo.Enabled := lastSelectedChannelPlayer <> '';
  if mnuWhisperTo.Enabled then
    mnuWhisperTo.Caption := '&Whisper to ' + lastSelectedChannelPlayer
  else
    mnuWhisperTo.Caption := '&Whisper';
  mnuReserveSlotForChanneler.Enabled := lastSelectedChannelPlayer <> '';
  mnuChannelToFriend.Enabled := not chkAlwaysUseWC3Friendlist.Checked;
end;

procedure TWC3Banlist_Main.mnuShowColorExplanationsClick(Sender: TObject);
begin
  frmcolorexplanations.show;
end;

procedure TWC3Banlist_Main.mnuAddToFriendListClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  memoBuddies.Lines.Add(p^.Nick);
  AddMessage(p^.Nick + ' has been added to your friendlist.', ICON_STAR, p^.Nick);
end;

procedure TWC3Banlist_Main.mnuReserveSlotClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  Reserve.Reserve(p^.Nick);
  RefreshReservations;
end;

function TWC3Banlist_Main.WC3IconIndex: Integer;
begin
  case wc3Type of
    1: result := ICON_WC3;
    2: result := ICON_TFT;
    else
      result := ICON_WC3;
  end;
end;

procedure TWC3Banlist_Main.lbWC3FriendListEndDrag(Sender, Target: TObject;
  X, Y: Integer);
var
  i: Integer;
begin
  if Target = memoBuddies then
  for i := 0 to lbWC3FriendList.Items.Count - 1 do
    if lbWC3FriendList.Selected[i] then
      memoBuddies.Lines.Add(lbWC3FriendList.Items[i]);
end;

procedure TWC3Banlist_Main.FormResize(Sender: TObject);
begin
  if panTable.height < 300 then
    vtLog.Height := tabSnooping.Height - 41 - 300;
  if tabSnooping.Width - panSnoopingLeft.Width < 470 then
    panSnoopingLeft.Width := tabSnooping.Width - 470;
end;

procedure TWC3Banlist_Main.splGameVertMoved(Sender: TObject);
begin
  FormResize(nil);
end;

procedure TWC3Banlist_Main.memoBuddiesDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if Source = lbWC3FriendList then accept := true;
end;

procedure TWC3Banlist_Main.mnuChannelToFriendClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to tvChannel.items.count - 1 do begin
    if tvChannel.items[i].Selected then
      memoBuddies.Lines.Add(tvChannel.items[i].Text);
  end;
  pages.ActivePage := tabPreferences;
  panFriendList.BringToFront;
end;

procedure TWC3Banlist_Main.chkPreventFlickerClick(Sender: TObject);
begin
  if not chkPreventFlicker.Enabled then
  begin
    chkPreventFlicker.OnClick := nil;
    chkPreventFlicker.Enabled := true;
    EnableDraw;
    chkPreventFlicker.Enabled := false;
    chkPreventFlicker.OnClick := chkPreventFlickerClick;
  end;
end;

procedure TWC3Banlist_Main.CancelServerListTransfers;
var
  i: Integer;
  s: TServerList;
begin
  for i := 0 to lvOnlineLists.Items.Count - 1 do
  begin
    s := lvOnlineLists.Items[i].Data;
    s.Free;
    lvOnlineLists.Items[i].Data := nil;
  end;
end;

procedure TWC3Banlist_Main.btnNICDetectorClick(Sender: TObject);
var
  d: TfrmNICDetector;
begin
  d := TfrmNICDetector.Create(self);
  try
    d.ShowModal;
  finally
    d.free;
  end;
end;

procedure TWC3Banlist_Main.vtGamesCompareNodes(Sender: TBaseVirtualTree;
  Node1, Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  p1, p2: ^Pointer;
  i1, i2: PGame;
begin
  p1 := Sender.GetNodeData(Node1);
  p2 := Sender.GetNodeData(Node2);
  i1 := p1^;
  i2 := p2^;
  case column of
    0: result := trunc(i1^.gameStart * 24 * 3600) - trunc(i2^.gameStart * 24 * 3600);
    1: result := comparetext(lowercase(i1^.gameName), lowercase(i2^.gameName));
    2: result := comparetext(lowercase(i1^.mapName), lowercase(i2^.mapName));
    3: result := comparetext(lowercase(i1^.duration), lowercase(i2^.duration));
  end;
end;

procedure TWC3Banlist_Main.vtGamesGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
var
  pp: ^Pointer;
  pg: PGame;
begin
  if Column = 0 then
  begin
    pp := Sender.GetNodeData(node);
    pg := pp^;
    if pos(pg^.mapName, '.w3x') > 0 then
      ImageIndex := ICON_TFT
    else
      ImageIndex := ICON_WC3;
  end;
end;

procedure TWC3Banlist_Main.vtGamesGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  pp: ^Pointer;
  pg: PGame;
begin
  pp := Sender.GetNodeData(Node);
  pg := pp^;
  case Column of
    0: CellText := DateTimeToStr(pg^.gameStart);
    1: CellText := pg^.gameName;
    2: CellText := pg^.mapName;
    3: CellText := pg^.duration;
  end;
end;

procedure TWC3Banlist_Main.vtScoresGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  pp: ^Pointer;
  ps: PScore;
begin
  pp := Sender.GetNodeData(Node);
  ps := pp^;
  case Column of
    0: CellText := ps^.nick;
    1: CellText := IntToStr(ps^.gamesPlayed);
    2: CellText := IntToStr(ps^.gamesRated);
    3: CellText := ScoreToStr(ps^.points);
    4: CellText := DateTimeToStr(ps^.lastSeen);
  end;
end;

procedure TWC3Banlist_Main.vtScoresCompareNodes(Sender: TBaseVirtualTree;
  Node1, Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  p1, p2: ^Pointer;
  i1, i2: PScore;
begin
  p1 := Sender.GetNodeData(Node1);
  p2 := Sender.GetNodeData(Node2);
  i1 := p1^;
  i2 := p2^;
  case column of
    0: result := comparetext(lowercase(i1^.nick), lowercase(i2^.nick));
    1: result := i1^.gamesPlayed - i2^.gamesPlayed;
    2: result := i1^.gamesRated - i2^.gamesRated;
    3: result := trunc(i1^.points * 100) - trunc(i2^.points * 100);
    4: result := trunc(i1^.lastSeen * 24 * 3600) - trunc(i2^.lastSeen * 24 * 3600);
  end;
end;

procedure TWC3Banlist_Main.GameOver;
var
  pg: PGame;
  pgnd: PGameNodeData;
  n: PVirtualNode;
  lastReplay: String;
begin
  autorefresher.GameCode := '';
  // move last replay
  if chkManageReplays.Checked and
    (not chkOnlySaveReplayWhenBanned.Checked or (lastBannedList.Count > 0)) then
    lastReplay := MoveLastReplay
  else
    lastReplay := '';
  // create game data
  new(pg);
  pg^.id := lastGameID;
  pg^.ownNickName := username.Caption;
  pg^.realm := lastRealm;
  pg^.host := lastHostName;
  pg^.players := '';
  pg^.givenPoints := '';
  n := vtGame.GetFirst;
  while n <> nil do
  begin
    pgnd := vtGame.GetNodeData(n);
    if pg^.players <> '' then pg^.players := pg^.players + '|';
    if pg^.givenPoints <> '' then pg^.givenPoints := pg^.givenPoints + '|';
    pg^.players := pg^.players + pgnd^.Nick;
    pg^.givenPoints := pg^.givenPoints + inttostr(pgnd^.Rating);
    n := vtGame.GetNextSibling(n);
  end;
  pg^.screenShots := lastScreenShots;
  pg^.mapName := lastMapName;
  pg^.gameName := lastGameTitle;
  pg^.replay := lastReplay;
  pg^.duration := lblGameTimer.Caption;
  pg^.gameStart := now - (GetTickCount - gamestart) / 1000 / 3600 / 24;
  listcontainer.gamelist.AddEntry(pg);
  RefreshLocalDatabase;
  // prepare for new game
  GameStart := 0;
  edtNextGameID.Text := IntToStr(StrToInt(edtNextGameID.Text) + 1);
  SaveConfiguration;
  // open game review
  if chkOpenReviewAfterGame.Checked then
    showGameReview := true;
end;

procedure TWC3Banlist_Main.vtGamesDblClick(Sender: TObject);
var
  p: ^Pointer;
  pg: PGame;
  n: PVirtualNode;
  f: TfrmGameReview;
begin
  n := vtGames.GetFirstSelected;
  if assigned(n) then
  begin
    p := vtGames.GetNodeData(n);
    pg := p^;
    f := frmGameReview;
    f.game := pg;
    f.RefreshReview;
    f.Show;
  end;
end;

procedure TWC3Banlist_Main.vtScoresDblClick(Sender: TObject);
var
  n: PVirtualNode;
  p: ^Pointer;
  ps: PScore;
begin
  n := vtScores.GetFirstSelected;
  if assigned(n) then
  begin
    p := vtScores.GetNodeData(n);
    ps := p^;
    edtFilter.Text := ps^.nick;
    npDatabase.ActivePage := panGames;
  end;
end;

procedure TWC3Banlist_Main.RatePlayer(nick: String; rating: Integer);
var
  n: PVirtualNode;
  pgnd: PGameNodeData;
begin
  n := vtGame.GetFirst;
  pgnd := nil;
  while n <> nil do begin
    pgnd := vtGame.GetNodeData(n);
    if lowercase(pgnd^.Nick) = lowercase(nick) then
      break;
    n := vtGame.GetNextSibling(n);
  end;
  if pgnd = nil then
    raise Exception.Create('Player ' + nick + ' cannot be found in the current game.')
  else if (pgnd^.Nick = username.caption) then
    raise Exception.Create('You cannot rate yourself.')
  else if (pgnd^.Nick = 'Computer') or (pgnd^.Nick = 'Open') or (pgnd^.Nick = 'Closed') then
    raise Exception.Create('You have to give the name of a player in the current game.')
  else
    AddRating(nick, rating, pgnd^.Rating, lastGameID);
end;

procedure TWC3Banlist_Main.OnGameStart;
var
  n: PVirtualNode;
  pgnd: PGameNodeData;
  ps: PScore;
  i: Integer;
begin
  // refresh last seen
  n := vtGame.GetFirst;
  while n <> nil do
  begin
    pgnd := vtGame.GetNodeData(n);
    if (pgnd^.Nick <> 'Computer') and
      (pgnd^.Nick <> 'Open') and
      (pgnd^.Nick <> 'Closed') and
      (pgnd^.Nick <> username.Caption) then
    begin
      if listcontainer.scorelist.FindEntry(pgnd^.Nick, i)
      then
        ps := listContainer.scorelist.list[i]
      else
      begin
        new(ps);
        ps^.gamesPlayed := 0;
        ps^.gamesRated := 0;
        ps^.nick := pgnd^.Nick;
        ps^.points := 0;
        listcontainer.scorelist.AddEntry(ps);
      end;
      ps^.lastSeen := now - (GetTickCount - gamestart) / 1000 / 3600 / 24;
      inc(ps^.gamesPlayed);
    end;
    n := vtGame.GetNextSibling(n);
  end;
  // deactivate autorefresher
  autorefresher.GameCode := '';
end;

procedure TWC3Banlist_Main.AddRating(nick: String; rating: Integer; previousScore: Integer; gameID: string);
var
  oldScore: Double;
  oldCount: Integer;
  ps: PScore;
  pg: PGame;
  i: Integer;
  n: PVirtualNode;
  pgnd: PGameNodeData;
  scores, nicks: TStringlist;
begin
  if not listcontainer.scorelist.FindEntry(nick, i) then exit;
  ps := listcontainer.scorelist.list[i];
  // remove previous rating
  if previousScore <> 0 then begin
    oldCount := ps^.gamesRated - 1;
    if oldCount = 0 then
      oldScore := 0
    else
      oldScore := (ps^.gamesRated * ps^.points - previousScore) / oldCount;
  end else begin
    oldCount := ps^.gamesRated;
    oldScore := ps^.points;
  end;
  // set new score
  if rating <> 0 then begin
    ps^.gamesRated := oldCount + 1;
    ps^.points := (oldScore * oldCount + rating) / ps^.gamesRated;
  end else begin
    ps^.gamesRated := oldCount;
    ps^.points := oldScore;
  end;
  // refresh game table
  if gameID = lastGameID then begin
    n := vtGame.GetFirst;
    while n <> nil do
    begin
      pgnd := vtGame.GetNodeData(n);
      if lowercase(pgnd^.Nick) = lowercase(nick) then
        break;
      n := vtGame.GetNextSibling(n);
    end;
    if assigned(n) then
    begin
      gd.rating[n.Index] := rating;
    end;
  end;
  // refresh game database
  if (gameID <> '') and listcontainer.gamelist.FindEntry(gameID, i) then
  begin
    pg := listcontainer.gamelist.list[i];
    scores := TStringlist.Create;
    nicks := TStringlist.Create;
    try
      split(pg^.players, '|', nicks);
      split(pg^.givenPoints, '|', scores);
      for i := 0 to nicks.count - 1 do
        if lowercase(nicks[i]) = lowercase(nick)
          then scores[i] := inttostr(rating);
      pg^.players := join(nicks, '|');
      pg^.givenPoints := join(scores, '|');
    finally
      nicks.free;
      scores.free;
    end;
  end;
end;

procedure TWC3Banlist_Main.mnuOpenGameReviewClick(Sender: TObject);
var
  i: Integer;
  f: TfrmGameReview;
begin
  if listcontainer.gamelist.findentry(lastGameID, i) then
  begin
    f := frmGameReview;
    f.game := listcontainer.gamelist.list[i];
    f.RefreshReview;
    f.Show;
  end;
end;

procedure TWC3Banlist_Main.lblReplayDataBaseLocationClick(Sender: TObject);
begin
  ForceDirectories(edtReplayDatabase.Text);
  ShellExecute(0, 'open', PChar(edtReplayDatabase.Text), nil, nil, sw_show);
end;

procedure TWC3Banlist_Main.btnBrowseForReplayTargetClick(Sender: TObject);
var
  path: String;
begin
  Path := '';
  if SelectDirectoryEx(Handle, Path, 'Select the replay target folder...', '')
    then edtReplayDatabase.Text := path;
end;

procedure TWC3Banlist_Main.btnBrowseForLastReplayRoCClick(Sender: TObject);
var
  o: TOpenDialog;
begin
  o := TOpenDialog.Create(Self);
  try
    o.Filter :=
      'LastReplay.w3g|LastReplay.w3g';
    o.FileName := edtLastReplay.Text;
    if o.Execute then
      edtLastReplay.Text := o.FileName;
  finally
    o.Free;
  end;
end;

function TWC3Banlist_Main.MoveLastReplay: String;
const
  forbidden: string = '/\:*?"<>|';
var
  source, target: String;
  shortname, filename: String;
  i: Integer;
begin
  target := inipreparepath(edtReplayDatabase.Text, '\');
  filename := Trim(SubstPhrase(edtReplayFileNamePattern.Text, false));
  for i := 1 to length(filename) do
    if pos(filename[i], forbidden)>0 then filename[i]:='_';
  source := edtLastReplay.Text;
  ForceDirectories(target);
  i := 2;
  shortname := filename;
  while fileexists(target + filename + '.w3g') do
  begin
    filename := shortname + '(' + inttostr(i) + ')';
    inc(i);
  end;
  if MoveFile(PChar(source), PChar(target + filename + '.w3g')) then begin
    result := filename + '.w3g';
    AddToLog('The last replay has been archived as ' + result +'.', WC3IconIndex);
  end else begin
    result := '';
    AddToLog('Moving the last replay to the specified destination failed. Check your settings!', ICON_MESSAGE);
  end;
end;

procedure TWC3Banlist_Main.btnExportSelectedBansClick(Sender: TObject);
var
  l: TList;
  p: ^Pointer;
  t: TSaveDialog;
  asXML: boolean;
  n: PVirtualNode;
  pb: PBan;
  all: boolean;
begin
  all := (Sender = btnExportBans) or (Sender = lblExportBans) or (Sender = mnuExportBans);
  if not all and (vtBans.GetFirstSelected = nil) then exit;
  t := TSaveDialog.Create(self);
  try
    t.Title := 'Export Bans';
    t.Filter := 'XML Format (*.xml)|*.xml|Text Format for Export only (*.txt)|*.txt';
    t.DefaultExt := 'xml|txt';
    if t.Execute then begin
      asXML := t.FilterIndex = 1;
      l := TList.Create;
      try
        with vtBans do begin
          if all then
            n := vtBans.GetFirst
          else
            n := vtBans.GetFirstSelected;
          while n <> nil do
          begin
            p := vtBans.GetNodeData(n);
            pb := p^;
            if (not pb^.deleted) or asXML then
              l.Add(pb);
            if all then
              n := vtBans.GetNext(n)
            else
              n := vtBans.GetNextSelected(n);
          end;
        end;
        ExportBans(l, t.FileName, asXML);
      finally
        l.free;
      end;
    end;
  finally
    t.Free;
  end;
end;

procedure TWC3Banlist_Main.btnExportSelectedInfosClick(Sender: TObject);
var
  l: TList;
  p: ^Pointer;
  t: TSaveDialog;
  asXML: boolean;
  n: PVirtualNode;
  pi: PInfo;
  all: boolean;
begin
  all := (Sender = btnExportInfos) or (Sender = lblExportInfos) or (Sender = mnuExportInfos);
  if not all and (vtInfos.GetFirstSelected = nil) then exit;
  t := TSaveDialog.Create(self);
  try
    t.Title := 'Export Infos';
    t.Filter := 'XML Format (*.xml)|*.xml|Text Format for Export only (*.txt)|*.txt';
    t.DefaultExt := 'xml|txt';
    if t.Execute then begin
      asXML := t.FilterIndex = 1;
      l := TList.Create;
      try
        with vtInfos do begin
          if all then
            n := GetFirst
          else
            n := GetFirstSelected;
          while n <> nil do
          begin
            p := GetNodeData(n);
            pi := p^;
            if (not pi^.deleted) or asXML then
              l.Add(pi);
            if all then
              n := GetNext(n)
            else
              n := GetNextSelected(n);
          end;
        end;
        ExportInfos(l, t.FileName, asXML);
      finally
        l.free;
      end;
    end;
  finally
    t.Free;
  end;
end;

procedure TWC3Banlist_Main.btnImportBansClick(Sender: TObject);
var
  t: TOpenDialog;
begin
  t := TOpenDialog.Create(self);
  try
    try
      t.Title := 'Import Bans';
      t.Filter := 'XML Format (*.xml)|*.xml';
      if t.Execute then
        ListContainer.banlist.ImportFromXML(t.FileName);
    finally
      t.free;
    end;
    RefreshLocalDatabase;
  except
    MessageDlg('WC3Banlist cannot read this file.'+#13+#10+''+#13+#10+'Make sure it has the proper format.', mtError, [mbOK], 0);
  end;
end;

procedure TWC3Banlist_Main.btnImportInfosClick(Sender: TObject);
var
  t: TOpenDialog;
begin
  t := TOpenDialog.Create(self);
  try
    try
      t.Title := 'Import Infos';
      t.Filter := 'XML Format (*.xml)|*.xml';
      if t.Execute then
        ListContainer.infolist.ImportFromXML(t.FileName);
    finally
      t.free;
    end;
    RefreshLocalDatabase;
  except
    MessageDlg('WC3Banlist cannot read this file.'+#13+#10+''+#13+#10+'Make sure it has the proper format.', mtError, [mbOK], 0);
  end;
end;

procedure TWC3Banlist_Main.btnShowWizard(Sender: TObject);
var
  w: TWizard;
  i: Integer;
  wc3dir: String;
begin
  w := TWizard.Create;
  with w.Input do
  begin
    SetLength(NICs, cbNIC.Items.Count);
    for i := 0 to cbNIC.Items.Count - 1  do
      NICs[i] := cbNIC.Items[i];
    AutoDetectNicMethod := CallNICDetector;
    BrowseForWar3DirMethod := BrowseForWarcraftIIIDirectoy;
  end;
  if w.Execute = mrOk then
  with w.Output do begin
    // set NIC
    cbNIC.ItemIndex := NICIndex;
    cbNICChange(nil);
    // buddies' banlists
    if UseBanlistnl then begin
      banlistnl.Checked := true;
      chkBuddiesList.Checked := true;
      edtBlLogin.Text := BanlistnlUser;
      edtBlPassword.Text := MD5Print(MD5String(BanlistnlPass));
      btnSyncClick(nil);
    end;
    wc3Dir := IniPreparePath(WarcraftDir, '\');
    edtLastReplay.Text := wc3Dir + 'replay\LastReplay.w3g';
    if PlaysNorthrendPubs then
      addServerList('Approved Bans Northrend', 'Europe (Northrend)',
        'http://www.banlist.nl/approved.php?realm=northrend', true, ltBanlist);
    if PlaysAzerothPubs then
      addServerList('Approved Bans Azeroth', 'US East (Azeroth)',
        'http://www.banlist.nl/approved.php?realm=azeroth', true, ltBanlist);
    if PlaysLordaeronPubs then
      addServerList('Approved Bans Lordaeron', 'US West (Lordaeron)',
        'http://www.banlist.nl/approved.php?realm=lordaeron', true, ltBanlist);
    if PlaysKalimdorPubs then
      addServerList('Approved Bans Kalimdor', 'Asia (Kalimdor)',
        'http://www.banlist.nl/approved.php?realm=kalimdor', true, ltBanlist);
  end;
  w.Free;
end;

function TWC3Banlist_Main.BrowseForWarcraftIIIDirectoy(
  var s: String): boolean;
begin
  result := SelectDirectoryEx(FindWindow('TWizardForm', nil), s,
    'Select the directory of your Warcraft III installation...', '');
end;

procedure TWC3Banlist_Main.CallNICDetector;
begin
  btnNICDetectorClick(nil);
end;

function TWC3Banlist_Main.RemoveErrorneousSubstitutions(
  phrase: String): String;
var
  s: TStringlist;
  j: Integer;
  b: boolean;
begin
  s := TStringlist.Create;
  try
    s.Text := phrase;
    b := StrRight(phrase, 2) = crlf;
    j := 0;
    // remove all lines that contain errorneous substitutions
    while j < s.Count do
      if pos(#255#250, s[j]) > 0 then
        s.Delete(j)
      else
        inc(j);
    phrase := s.Text;
    if not b and (StrRight(phrase, 2) = crlf) then
      phrase := Copy(phrase, 1, length(phrase) - 2);
    result := phrase;
  finally
    s.Free;
  end;
end;

procedure TWC3Banlist_Main.SplitPhrase(p: String; commands: TStringlist;
  var phrase: String);
var
  s: String;
  t: TStringlist;
  words: TStringlist;
  i: Integer;
  crlfAtEnd, se: boolean;
begin
  commands.Clear;
  t := TStringlist.create;
  words := TStringlist.create;
  try
    t.Text := p;
    crlfAtEnd := StrRight(p, 2) = crlf;
    i := 0;
    while i < t.Count do
    begin
      words.Clear;
      se := false;
      // remove ~
      s := t[i];
      StrReplace(s, '~', '', [rfReplaceAll]);
      split(s, ' ', words);
      if words.Count > 0 then
        if pos(#255#1, words[0]) = 1 then
        begin
          se := true;
          words[0] := copy(words[0], 3, 1000);
        end;
        if chkDoubleSlash.Checked and (copy(words[0], 1, 1) = '/') then
          words[0] := copy(words[0], 2, 1000);
        if pos('|'+words[0]+'|', WC3BANLISTCOMMANDS) > 0 then
        begin
          s := join(words, ' ');
          if chkDoubleSlash.Checked then
            s := '/' + s;
          commands.Add(s);
          if (i > 0) and (t[i - 1] = '') and not se then begin
            t.Delete(i-1);
            dec(i);
          end;
          t.Delete(i);
        end else begin
          inc(i);
        end;
    end;
    phrase := t.Text;
    if not crlfAtEnd then
      phrase := copy(phrase, 1, length(phrase) - 2);
  finally
    t.free;
    words.free;
  end;
end;

procedure TWC3Banlist_Main.btnEmptyRecycleBinClick(Sender: TObject);
var
  reg: TRegistry;
  s: String;
begin
  if MessageDlg('Are you sure you want to finally delete all entries that have been flagged as deleted?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    reg := TRegistry.Create;
    try
      reg.RootKey := HKEY_CURRENT_USER;
      if reg.OpenKey('AppEvents\Schemes\Apps\Explorer\EmptyRecycleBin\.Current', false) then
      begin
        s := lowercase(reg.ReadString(''));
        ReplaceAll(s, '%systemroot%', iniwinpath);
        PlaySound(PChar(s), 0, SND_ASYNC);
      end;
    finally
      reg.Free;
    end;
    btnEmptyRecycleBin.Enabled := false;
    lblEmptyRecycleBin.Enabled := false;
    EmptyRecycleBin;
    RefreshLocalDatabase;
  end;
end;

procedure TWC3Banlist_Main.btnAddBanClick(Sender: TObject);
begin
  with frmEditAdd do begin
    Caption := 'Create New Ban';
    edtNick.Text := '';
    edtComment.Text := '';
    ExecuteEditAddBanDialog(nil);
  end;
end;

procedure TWC3Banlist_Main.btnEditMapListClick(Sender: TObject);
begin
  ShellExecute(handle, 'open', 'notepad.exe', PChar(IniPath + 'ParseExceptions.xml'), nil, sw_show);
end;

procedure TWC3Banlist_Main.GetFreeSlotsDefaultValue(map: String);
var
  xml: IXMLDocument;
  n, m: IXMLNode;
  i: Integer;
begin
  if radReservationsParse.Checked then begin
    try
      xml := LoadXMLDocument(IniPath + 'ParseExceptions.xml');
      n := xml.DocumentElement;
      if n.NodeName <> 'parseexceptions' then raise Exception.Create('Illegal root node.');
      for i := 0 to n.ChildNodes.Count - 1 do
      begin
        m := n.ChildNodes[i];
        if m.NodeName = 'map' then
        if lowercase(extractfilename(map)) = lowercase(m.Attributes['filename']) then
        begin
          try
            gd.freeSlotsDefaultValue := IntToStr(StrToInt(m.Attributes['humanplayers'])-1);
          except
            gd.freeSlotsDefaultValue := 'unknown';
          end;
          exit;
        end;
      end;
    except
      AddMessage('The file ParseExceptions.xml is missing or damaged. Please reinstall WC3Banlist.', ICON_ERROR);
      gd.freeSlotsDefaultValue := 'unknown';
      exit;
    end;
    if mapinfo.ReadMap(
      IniPreparepath(WC3Path, '\') +
      map) then
    begin
      if mapinfo.playercount > 0 then
      begin
        gd.freeSlotsDefaultValue := IntToStr(mapinfo.playerCount - 1);
      end;
      if mapinfo.colorsOK then
      begin
        // map colors - not needed, most maps leave it alone
      end;
    end else
    begin
      AddMessage('The map ' + map + ' could not be parsed. An exception has been added to ParseExceptions.xml.', ICON_ERROR);
      m := n.AddChild('map');
      m.Attributes['filename'] := lowercase(extractfilename(map));
      m.Attributes['humanplayers'] := edtHumanPlayerCount.Text;
      xml.Encoding := 'UTF-8';
      xml.Options := xml.Options + [doNodeAutoIndent];
      xml.NodeIndentStr := ' ';
      xml.SaveToFile(IniPath + 'ParseExceptions.xml');
      gd.freeSlotsDefaultValue := edtHumanPlayerCount.Text;
      todoSetHumanPlayerCountInParseExceptions := true;
    end;
  end else
  try
    gd.freeSlotsDefaultValue := IntToStr(StrToInt(edtHumanPlayerCount.Text) - 1);
  except
    gd.freeSlotsDefaultValue := 'unknown';
  end;
end;

procedure TWC3Banlist_Main.SetHumanPlayerCountForException(mapname,
  humanPlayers: String);
var
  xml: IXMLDocument;
  n, m: IXMLNode;
  i: Integer;
begin
  try
    xml := LoadXMLDocument(IniPath + 'ParseExceptions.xml');
    n := xml.DocumentElement;
    if n.NodeName <> 'parseexceptions' then raise Exception.Create('Illegal root node.');
    for i := 0 to n.ChildNodes.Count - 1 do
    begin
      m := n.ChildNodes[i];
      if m.NodeName = 'map' then
      if lowercase(mapname) = lowercase(m.Attributes['filename']) then
        m.Attributes['humanplayers'] := humanPlayers;
    end;
    xml.Encoding := 'UTF-8';
    xml.Options := xml.Options + [doNodeAutoIndent];
    xml.NodeIndentStr := ' ';
    xml.SaveToFile(IniPath + 'ParseExceptions.xml');
  except
    AddMessage('Could not update ParseExceptions.xml! Please reinstall WC3Banlist.', ICON_ERROR);
  end;
end;

procedure TWC3Banlist_Main.mnuCopyNicknameClick(Sender: TObject);
var
  n: PVirtualNode;
  p: PGameNodeData;
begin
  n := vtGame.GetFirstSelected;
  if not assigned(n) then exit;
  if vtGame.GetNodeLevel(n) = 1 then n := n.Parent;
  p := vtGame.GetNodeData(n);
  ct.SetText(p^.Nick);
end;

procedure TWC3Banlist_Main.edtFilterChange(Sender: TObject);
begin
  if Sender = btnResetFilter then
    edtFilter.Text := '';
  chkFiltered.Checked := edtFilter.Text <> '';
  SetDatabaseVisibility;
end;

procedure TWC3Banlist_Main.vtScoresKeyPress(Sender: TObject;
  var Key: Char);
begin
  if ord(key) > 32 then
  begin
    edtFilter.SetFocus;
    edtFilter.Text := key;
    edtFilter.SelStart := length(edtFilter.Text);
  end;
end;

procedure TWC3Banlist_Main.btnResetFilterClick(Sender: TObject);
begin
  edtFilter.Text := '';
end;

procedure TWC3Banlist_Main.btnCopyOnlineListsErrorClick(Sender: TObject);
begin
  memoError.CopyToClipboard;
end;

procedure TWC3Banlist_Main.CleanUpLocalDatabase(silent: boolean);
var
  maxDate: TDateTime;
  ps: PScore;
  pg: PGame;
  i: Integer;
begin
  try
    maxDate := Now - StrToFloat(edtCleanUpDays.Text);
  except
    if not silent then
      MessageDlg('Cleanup of the local database has failed.' + cr +cr + 'This is no valid number of days. Check your input.', mtError, [mbOK], 0);
    exit;
  end;
  if not silent and (MessageDlg(Format('Are you sure you want to delete all games and scores older than %s days?', [edtCleanUpDays.Text]), mtConfirmation, [mbYes, mbNo], 0) = mrNo) then exit;
  i := 0;
  while i < ListContainer.scorelist.list.Count do
  begin
    ps := ListContainer.scorelist.list[i];
    if ps^.lastSeen < maxDate then
    begin
      Dispose(ps);
      ListContainer.scorelist.list.Delete(i);
    end
    else inc(i);
  end;
  i := 0;
  while i < Listcontainer.gamelist.list.Count do
  begin
    pg := Listcontainer.gamelist.list[i];
    if pg^.gameStart < maxDate then
    begin
      Dispose(pg);
      Listcontainer.gamelist.list.Delete(i);
    end
    else
      inc(i);
  end;
  RefreshLocalDatabase;
  if not silent then
    MessageDlg('All games and scores older than ' + edtCleanUpDays.Text +
      ' days have been removed from your local database.',
      mtInformation, [mbOK], 0);
end;

procedure TWC3Banlist_Main.EmptyRecycleBin;
var
  i: Integer;
  pi: PInfo;
  pb: PBan;
begin
  i := 0;
  while i < ListContainer.banlist.list.Count do
  begin
    pb := ListContainer.banlist.list[i];
    if pb^.deleted then
    begin
      Dispose(pb);
      ListContainer.banlist.list.Delete(i);
    end
    else inc(i);
  end;
  i := 0;
  while i < Listcontainer.infolist.list.Count do
  begin
    pi := Listcontainer.infolist.list[i];
    if pi^.deleted then
    begin
      Dispose(pi);
      Listcontainer.infolist.list.Delete(i);
    end
    else
      inc(i);
  end;
end;

procedure TWC3Banlist_Main.btnCleanUpScoresAndGamesClick(Sender: TObject);
begin
  CleanUpLocalDatabase(false);
end;

procedure TWC3Banlist_Main.SetNewURLforServerList(newURL: String;
  ServerList: TServerList);
var
  i: Integer;
begin
  for i := 0 to lvOnlineLists.Items.Count - 1 do
    if lvOnlineLists.Items[i].Data = ServerList then
    begin
      lvOnlineLists.Items[i].SubItems[3] := newURL;
      AddToLog(Format('The URL of the %s "%s" has been permanently changed to %s.',
        [lowercase(lvOnlineLists.Items[i].SubItems[1]), lvOnlineLists.Items[i].Caption, newURL]), ICON_CONFIG);
      break;
    end;
end;

procedure TWC3Banlist_Main.chkCollectMessagesClick(Sender: TObject);
begin
  if chkCollectMessages.Checked then
    ct.TimeThreshold := 400
  else
    ct.TimeThreshold := 0;
end;

procedure TWC3Banlist_Main.lvLastEventsChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
  with lvLastEvents do
  begin
    if assigned(Selected) then
    begin
      PopUpMenu := popGameEvent;
      mnuEventCopyNick.Enabled := length(Selected.SubItems[1]) > 0;
    end else
      PopupMenu := nil;
  end;
end;

procedure TWC3Banlist_Main.mnuEventCopyClick(Sender: TObject);
begin
  if assigned(lvLastEvents.Selected) then
    Clipboard.AsText := lvLastEvents.Selected.SubItems[0];
end;

procedure TWC3Banlist_Main.mnuEventCopyNickClick(Sender: TObject);
begin
  if assigned(lvLastEvents.Selected) then
    Clipboard.AsText := lvLastEvents.Selected.SubItems[1];
end;

procedure TWC3Banlist_Main.lvLastEventsKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #3 then
    mnuEventCopyNickClick(nil);
end;

procedure TWC3Banlist_Main.mnuLogcopyNickNameClick(Sender: TObject);
var
  p: PLogEntry;
  n: PVirtualNode;
begin
  n := vtLog.GetFirstSelected;
  if n = nil then exit;
  p := vtLog.GetNodeData(n);
  Clipboard.AsText := p^.nick;
end;

procedure TWC3Banlist_Main.popLogPopup(Sender: TObject);
var
  p: PLogEntry;
  n: PVirtualNode;
begin
  n := vtLog.GetFirstSelected;
  mnuLogCopyNickName.Enabled := false;
  mnuLogCopy.Enabled := false;
  if n = nil then exit;
  p := vtLog.GetNodeData(n);
  mnuLogCopy.Enabled := true;
  mnuLogCopyNickName.Enabled := p^.nick <> '';
end;

procedure TWC3Banlist_Main.tbARIntervalChange(Sender: TObject);
begin
  if Sender = tbARInterval then
  begin
    edtARInterval.Text := IntToStr(tbARInterval.Position);
    SetAutoRefreshInterval;
  end;
end;

procedure TWC3Banlist_Main.SetAutoRefreshInterval;
begin
  if Assigned(autorefresher) then
  begin
    if chkAutomaticGameRefresh.Checked then
      autorefresher.Interval := StrToInt(edtARInterval.Text) * 1000;
    autorefresher.Enabled := chkAutomaticGameRefresh.Checked;
    autorefresher.ResetTimer;
  end;
end;

procedure TWC3Banlist_Main.chkAutomaticGameRefreshClick(Sender: TObject);
begin
  SetAutoRefreshInterval;
end;

procedure TWC3Banlist_Main.edtFileChange(Sender: TObject);
var
  editBox: TEdit;
begin
  if sender is TEdit then
  begin
    editBox := Sender as TEdit;
    if FileExists(editBox.Text) then
      editBox.Font.Color := clBlack
    else
      editBox.Font.Color := clRed;
  end;
end;

procedure TWC3Banlist_Main.edtDirChange(Sender: TObject);
var
  editBox: TEdit;
begin
  if sender is TEdit then
  begin
    editBox := Sender as TEdit;
    if DirExists(editBox.Text) then
      editBox.Font.Color := clBlack
    else
      editBox.Font.Color := clRed;
  end;
end;
       
procedure TWC3Banlist_Main.Restore;
begin
  if wasMaximized then
    ShowWindow(Handle, SW_MAXIMIZE)
  else
    ShowWindow(Handle, SW_RESTORE);
end;

procedure TWC3Banlist_Main.tvChannelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i: Integer;
  node: TTreeNode;
begin
  node := tvChannel.GetNodeAt(x, y);
  if assigned(node) and not node.Selected then
  begin
    for i := 0 to tvChannel.Items.Count - 1 do
      if tvChannel.Items[i] <> node then
        tvChannel.Items[i].Selected := false;
    tvChannel.Selected := node;
  end;
end;

procedure TWC3Banlist_Main.tvOptionsKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #9 then
    TGroupBox(tvOptions.Selected.Data).SetFocus;
end;

procedure TWC3Banlist_Main.SnoopingRefreshTimer(Sender: TObject);
begin
  btnGameRefreshClick(nil);
end;

procedure TWC3Banlist_Main.LatAll;
var
  i: integer;
  b: byte; // id
  n, a, a0, a1, a2: string;
  lat, dev: Cardinal;
  pcon: PPlayerCon;
  first: boolean;
begin
  if not assigned(latencyHandler) then exit;
  if ishost then
  begin
    first := true;
    a0 := 'Latency: '; a1 := ''; a2 := ''; a := '';
    // read the jobs
    for i := 0 to gd.slots - 1 do
    begin
      b := gd.Data[i][0];
      // human, not empty, not self
      if (gd.data[i][3] = 0) and (gd.data[i][1] <> $FF) and (gd.names[b] <>
        '<self>')
        and (gd.names[b] <> username.caption) then
      begin
        n := gd.names[b];
        pcon := FindConnection(n);
        if pcon <> nil then
        begin
          if GameState = gsInGame then
            lat := latencyHandler.GetLatency(pcon^.ip, pcon^.port)
          else
            lat := latencyHandler.GetHSLatency(pcon^.ip, pcon^.port);
          dev := latencyHandler.GetStandardDeviation(pcon^.ip, pcon^.port);
          if not first then
          begin
            a0 := a0 + ', ';
            a1 := a1 + ', ';
            a2 := a2 + ',';
          end;
          first := false;
          if gameState = gsInGame then
          begin
            a0 := a0 + n + ': ' + inttostr(lat) + '' + inttostr(dev) + ' ms';
            a1 := a1 + n + ': ' + inttostr(lat) + '' + inttostr(dev);
            a2 := a2 + n + ' ' + inttostr(lat) + '' + inttostr(dev);
          end else
          begin
            a0 := a0 + n + ': ' + inttostr(lat) + ' ms';
            a1 := a1 + n + ': ' + inttostr(lat);
            a2 := a2 + n + ' ' + inttostr(lat);
          end;
        end;
      end;
    end;
    a := a0;
    if Length(AnsiToUtf8(a)) > 254 then
    begin
      a := a1;
      if Length(AnsiToUtf8(a)) > 254 then
        a := a2;
    end;
    if a <> '' then
      AddMessage(a, ICON_NETWORK)
    else
      AddMessage('No one there to display the latency of.', ICON_MESSAGE);
  end else
    AddMessage('Displaying the latency is only possible if you''re host.', ICON_MESSAGE);
end;

procedure TWC3Banlist_Main.SetGameState(gs: TGameState);
function isTransition(gsOld, gsNew: TGameState): boolean; begin result := (gamestate = gsOld) and (gs = gsNew); end;
begin
  if not loadComplete then exit;
  if isTransition(gsLobby, gsCountDown) then
  begin
    gameStart := GetTickCount;
  end;
  if isTransition(gsLoading, gsInGame) then
  begin
    if Assigned(latencyHandler) then begin
      latencyHandler.ClearConnectionList;
      latencyHandler.Enabled := chkLatencyInGame.Checked;
    end;
    gameStart := GetTickCount;
    Sound(SND_GAMESTART);
    if isHost then
    begin
      btnShowLatencyPlots.Enabled := true;
      if chkAutoLatencyPlots.Checked and chkLatencyInGame.Checked then
        InitAndShowLatencyPlots;
    end;
  end;
  if isTransition(gsLobby, gsCountDown) then
  begin
    gd.SetTeamRatiosFirst;
    OnGameStart;
  end;
  if gs = gsChat then
  begin
    ClearKickOrderList;
    if (lastGameID <> '') then btnShowGameReview.Enabled := true;
    frmLatencyPlots.Hide;
    btnShowLatencyPlots.Enabled := false;
    if assigned(latencyHandler) then
      latencyHandler.Enabled := true;
  end;
  // set new gameState
  gameState := gs;
end;

procedure TWC3Banlist_Main.ClearKickOrderList;
begin
  if assigned(kickOrderList) then
  begin
    with kickOrderList.LockList do
    begin
      while Count > 0 do
      begin
        Dispose(items[0]);
        Delete(0);
      end;
    end;
    kickOrderList.UnlockList;
  end;
end;

procedure TWC3Banlist_Main.chkAntiDownloadClick(Sender: TObject);
begin
  // remove existing kick orders if anti dl is disabled
  if not chkAntiDownload.Checked then ClearKickOrderList;
end;

procedure TWC3Banlist_Main.InitAndShowLatencyPlots;
var
  p: PGameNodeData;
  n: PVirtualNode;
  Players: TPingPlotPlayers;
  i, j: Integer;
begin
  with vtGame do
  begin
    n := GetFirst;
    setlength(players, 0);
    i := 0;
    j := 0;
    while n <> nil do
    begin
      latencyPlotMapping[i] := -1;
      p := GetNodeData(n);
      if (p^.Latency <> 0) and not (p^.HasLeft or p^.HasLostConnection) then
      begin
        setlength(players, length(Players) + 1);
        Players[High(Players)].Name := p^.Nick;
        Players[High(Players)].Color := lvGameColors[p^.Color];
        latencyPlotMapping[i] := j;
        inc(j);
      end;
      n := GetNextSibling(n);
      inc(i);
    end;
  end;
  frmLatencyPlots.Constraints.MinWidth := 600;
  frmLatencyPlots.Constraints.MinHeight := 60 + 20 * length(Players);
  if radSimplePlots.Checked then
    frmLatencyPlots.PlotDrawer.Initialize(Players, pmSimple)
  else
    frmLatencyPlots.PlotDrawer.Initialize(Players, pmNormal);
  frmLatencyPlots.Show;
end;

procedure TWC3Banlist_Main.btnShowLatencyPlotsClick(Sender: TObject);
begin
  if not chkLatencyInGame.Checked then
    MessageDlg('The calculation of in-game latency is disabled by a user setting.'+#13+#10+''+#13+#10+'To enable it go to Preferences --> Network.', mtWarning, [mbOK], 0)
  else
  if assigned(latencyHandler) then
    InitAndShowLatencyPlots;
end;

procedure TWC3Banlist_Main.chkLatencyInGameClick(Sender: TObject);
var
  b: Boolean;
begin
  b := chkLatencyInGame.Checked;
  chkAutoLatencyPlots.Enabled := b;
  radSimplePlots.Enabled := b;
  radDetailedPlots.Enabled := b;
  if assigned(latencyHandler) then
  begin
    if GameState = gsInGame then
      latencyHandler.Enabled := b
    else
      latencyHandler.Enabled := true;
  end;
  if not b and loadComplete then
    frmLatencyPlots.Hide;
end;

procedure TWC3Banlist_Main.radSimplePlotsClick(Sender: TObject);
begin
  if not loadComplete then exit;
  if frmLatencyPlots.Visible then
    InitAndShowLatencyPlots;
end;

procedure TWC3Banlist_Main.Button1Click(Sender: TObject);
begin
  showmessage(lastBannedList[123]);
end;

initialization
  if not InstallMutex2('WC3Banlist OneInst', 'TWC3Banlist_Main', WM_RESTORE)
    then halt;

  OleInitialize(nil);

finalization

  OleUninitialize;

end.

